unit NeoS0M_Commands;

interface

uses NeoS0M_Types;

const LOCAL_VARIABLE_INDEX_FLAG=$80000000; //       
const _ERROR_:array [1..6] of WideChar=('E','R','R','O','R',#0);
const SHELL32='shell32.dll';
      SEE_MASK_DOENVSUBST = $00000200;
      SEE_MASK_NOCLOSEPROCESS = $00000040;
      
      OFN_EXPLORER = $00080000;

//    (.  Compiler/NeoS0M.cmd)

// ---    ---
// #="  DWORD"
// !=" "
// +="64- "
// *="   "

// ---    ---
// d="   "
// e="     "
// n="    " (    )

// ---    ---
//var = 
//hwnd = 
//txt =    Unicode
//signed? = "(1)/(0)"
//msec = 
//exe =  
//dir = 
//exe-flags =  CreateProcess
//sw-params =     ShowWindow

{$INCLUDE NeoS0M_Commands.inc}
procedure DestroyAllVariables(var context:TScriptContext);

implementation

uses
     Windows, NeoS0M_Executor, NeoS0M_Variables, NeoS0M_UnifiedArray,
     NeoS0M_VarManager,NeoS0M_StdParamLoaders,
     NeoS0M_Common,NeoS0M_Constants,NeoS0M_Math,NeoS0M_WindowOperations,
     NeoS0M_SearchWnds,NeoS0M_SysVars, NeoS0M_Menus,
     Hashes,NeoS0M_USTR, NeoS0M_BBL,NeoS0M_xL,NeoS0M_USTRL,
     NeoS0M_BB, NeoS0M_BinParser, NeoS0M_UStrParser;

const INIT_WND_GETTEXT_BUFFER_SIZE=1024;
      _MINUS_ONE=$FFFFFFFF;
      MAX_FILESYSTEM_SCAN_DEPTH=255;
      MAX_REGISTRY_SCAN_DEPTH=255;

var str_to_i_conv_table:packed array[0..255] of Byte;

type TDWORDOperation=function(var operand:Cardinal; operand2:Cardinal):Integer;
     TIntOperation=function(var operand:int64; operand2:int64):Integer;
     TExtOperation=function(var operand:Extended; operand2:Extended):Integer;
     TIsWNDx=function(wnd:Cardinal):LongBool;stdcall;

     TMenuOperation=(moSetActivity,moFindSubmenu,moExecuteItem,moRemoveItem,moDeleteItem,moItemCount,moItemGetText,moItemSetText);
     TTwoStringOperation=(tsoCompare,tsoFindSubstr);
     TMouseEmulate=(meClick,meDown,meUp);
     TKeyboardEmulation=(keClick,keDown,keUp);
     TSectionOp=(soJump,soCall);

     TRegValueOperation=(rvoDelete,rvoStoreD,rvoStoreB,rvoReadD,rvoReadB,rvoReadUStr,rvoStoreUStr,rvoReadType);

     TGetWhat=(gwParent=0,gwOwner=1,gwFirstChild=2,gwNext=3,gwPrev=4);
     TGetOpDescr=record
                  GetWhat:TGetWhat; //  ?
                  ToPtr:PCardinal; //   HWND,      
                  Counter,MaxCount:Cardinal; //   .  
                 end;
     PGetOpDescr=^TGetOpDescr;
     TOneSysFolder=record
                    Name:PWideChar;
                    csidl:Integer;
                   end;
     {$IFDEF Win32}
          HANDLE=Cardinal;
     {$ENDIF}
     {$IFDEF Win64}
          HANDLE=Int64;
     {$ENDIF}

type TCaseConvTable=array[AnsiChar] of AnsiChar;

var ToUpperTable,ToLowerTable,CharCase:TCaseConvTable;
// CharCase: 0 -  , 1 -    , 2 -    

type TUStrComparator=function (s1:PWideChar; l1:Integer; s2:PWideChar; l2:Integer):Integer;
     TUStrFinder=function (str1:PWideChar; len1:Integer; str2:PWideChar; len2:Integer; startpos:Integer):Integer;
const UStrComparator:array [Boolean] of TUStrComparator=(_USTR_Compare,_USTR_CompareI);
      UStrFinder:array [Boolean] of TUStrFinder=(_UStr_PosEx,_UStr_PosExI);

const sysGetWhat:array[gwOwner..gwPrev] of Cardinal=(GW_OWNER,GW_CHILD,GW_HWNDNEXT,GW_HWNDPREV);
      HexDigits:array[0..15] of AnsiChar=('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f');


      SysFolders:packed array[0..63] of TOneSysFolder=
        ( (Name:'WINDOWS';csidl:$0024),
          // ,    Windows
          (Name:'WINDIR';csidl:$0024),
          // ,    WINDIR
          (Name:'SYSTEM ROOT';csidl:$0024),
          // ,    SYSTEMROOT
          (Name:'SYSTEM';csidl:$0025),
          //    Windows (../Windows/System32)
          (Name:'SYSTEM X86';csidl:$0029),
          //   32-    64-  Windows
          (Name:'PROGRAM FILES';csidl:$0026),
          //  Program Files
          (Name:'PROGRAM FILES X86';csidl:$002A),
          //  Program Files  32-   64-  Windows
          (Name:'COMMON PROGRAM FILES';csidl:$002B),
          //        Program Files
          (Name:'COMMON PROGRAM FILES X86';csidl:$002C),
          //        Program Files  32-   64-  Windows
          (Name:'RESOURCES';csidl:$0038),
          //    
          (Name:'RESOURCES LOCALIZED';csidl:$0039),
          //     
          (Name:'STARTUP';csidl:$0007),
          // ,      ""  
          (Name:'COMMON STARTUP';csidl:$0018),
          // ,       "",    
          (Name:'ALT STARTUP';csidl:$001D),
          // ,       ""  
          (Name:'COMMON ALT STARTUP';csidl:$001E),
          // ,       "",    
          (Name:'DESKTOP';csidl:$0000),
          //  ,    Windows
          (Name:'DESKTOP DIRECTORY';csidl:$0010),
          // ,      Windows (C:\Documents and Settings\_\Desktop)
          (Name:'COMMON DESKTOP DIRECTORY';csidl:$0019),
          // ,      Windows,     (C:\Documents and Settings\All Users\Desktop)
          (Name:'FONTS';csidl:$0014),
          //  ,   
          (Name:'BIT BUCKET';csidl:$000A),
          //   ""
          (Name:'CD BURN AREA';csidl:$003B),
          // ,    ,     CD/DVD
          (Name:'ADMIN TOOLS';csidl:$0030),
          // ,        
          (Name:'COMMON ADMIN TOOLS';csidl:$002F),
          // ,     ,    
          (Name:'DRIVES';csidl:$0011),
          //  ,     " "
          (Name:'COMPUTERS NEAR ME';csidl:$003D),
          // ,            
          (Name:'CONNECTIONS';csidl:$0031),
          //  ,        
          (Name:'NETHOOD';csidl:$0013),
          // ,        
          (Name:'NETWORK';csidl:$0012),
          //  ,   
          (Name:'PRINTERS';csidl:$0004),
          //  ,     
          (Name:'PRINTHOOD';csidl:$001B),
          // ,       

          (Name:'PROFILE';csidl:$0028),
          //   ( - ../Documents and Settings/_)
          (Name:'APPDATA';csidl:$001A),
          //      ( - ../Documents and Settings/_/Application Data)
          (Name:'LOCAL APPDATA';csidl:$001C),
          //          ( - ../Documents and Settings/_/Local Settings/Application Data)
          (Name:'COMMON APPDATA';csidl:$0023),
          //     ,     ( - ../Documents and Settings/All Users/Application Data)
          (Name:'HISTORY';csidl:$0022),
          //        (  IE)
          (Name:'INTERNET';csidl:$0001),
          //   Internet Expolrer' (   )
          (Name:'INTERNET CACHE';csidl:$0020),
          //     ,    ( ..\Documents and Settings\_\Local Settings\Temporary Internet Files)
          (Name:'COOKIES';csidl:$0021),
          //     cookie Internet Explorer ( ..\Documents and Settings\_\Cookies)

          (Name:'PERSONAL';csidl:$0005),
          //  " "
          (Name:'MY DOCUMENTS';csidl:$000C),
          //  ,   " "   
          (Name:'COMMON DOCUMENTS';csidl:$002E),
          //  ,   " "   
          (Name:'PROGRAMS';csidl:$0002),
          // ,    "|"   .  ...\Documents and Settings\_\Start Menu\Programs
          (Name:'COMMON PROGRAMS';csidl:$0017),
          // ,    "|",    .  ...\Documents and Settings\All Users\Start Menu\Programs
          (Name:'START MENU';csidl:$000B),
          // ,    ""  .  C:\Documents and Settings\_\Start Menu
          (Name:'COMMON START MENU';csidl:$0016),
          // ,    "",    .  C:\Documents and Settings\_\Start Menu
          (Name:'RECENT';csidl:$0008),
          // ,      
          (Name:'FAVORITES';csidl:$0006),
          // ,      .  ..\Documents and Settings\username\Favorites
          (Name:'COMMON FAVORITES';csidl:$001F),
          // ,     ,    .    Windows NT-
          (Name:'CONTROLS';csidl:$0003),
          //  ,     


          (Name:'TEMPLATES';csidl:$0015),
          // ,       
          (Name:'COMMON TEMPLATES';csidl:$002D),
          // ,     ,    
          (Name:'MY MUSIC';csidl:$000D),
          // ,      
          (Name:'COMMON MUSIC';csidl:$0035),
          // ,    ,    
          (Name:'SAMPLE MUSIC';csidl:$0040),
          // ,    ,    
          (Name:'MY PICTURES';csidl:$0027),
          // ,      
          (Name:'COMMON PICTURES';csidl:$0036),
          // ,    ,    
          (Name:'SAMPLE PICTURES';csidl:$0042),
          // ,    (..\My Music\Sample Playlists, Windows Vista  )
          (Name:'MY VIDEO';csidl:$000E),
          // ,      
          (Name:'COMMON VIDEO';csidl:$0037),
          // ,    ,    
          (Name:'SAMPLE VIDEO';csidl:$0043),
          // ,    (..\My Music\Sample Playlists, Windows Vista  )
          (Name:'PHOTO ALBUMS';csidl:$0045),
          //  ,      (..\My Pictures\Photo Albums, Windows Vista  )
          (Name:'PLAYLISTS';csidl:$003F),
          //  ,      (..\My Pictures\Playlists, Windows Vista  )
          (Name:'SAMPLE PLAYLISTS';csidl:$0041),
          // ,    (..\My Music\Sample Playlists, Windows Vista  )
          (Name:'SEND TO';csidl:$0009)
          // ,    "..."
          { DONE :     MSDN }
        );

type  _SHELLEXECUTEINFOW = record
        cbSize: DWORD;
        fMask: ULONG;
        Wnd: HWND;
        lpVerb: PWideChar;
        lpFile: PWideChar;
        lpParameters: PWideChar;
        lpDirectory: PWideChar;
        nShow: Integer;
        hInstApp: HINST;
        { Optional fields }
        lpIDList: Pointer;
        lpClass: PWideChar;
        hkeyClass: HKEY;
        dwHotKey: DWORD;
        case Integer of
          0: (
            hIcon: THandle);
          1: (
            hMonitor: THandle;
            hProcess: THandle;);
  end;

  PShellExecuteInfoW = ^_SHELLEXECUTEINFOW;

  //   , ..  ShlObj  50
function SHGetSpecialFolderPathW(hwndOwner: HWND; lpszPath: PWideChar; nFolder: Integer; fCreate: BOOL): BOOL; stdcall; external SHELL32 name 'SHGetSpecialFolderPathW';
function ShellExecuteExW(lpExecInfo: PShellExecuteInfoW):BOOL; stdcall; external SHELL32 name 'ShellExecuteExW';

type  tagOFNW = packed record
        lStructSize: DWORD;
        hWndOwner: HWND;
        hInstance: HINST;
        lpstrFilter: PWideChar;
        lpstrCustomFilter: PWideChar;
        nMaxCustFilter: DWORD;
        nFilterIndex: DWORD;
        lpstrFile: PWideChar;
        nMaxFile: DWORD;
        lpstrFileTitle: PWideChar;
        nMaxFileTitle: DWORD;
        lpstrInitialDir: PWideChar;
        lpstrTitle: PWideChar;
        Flags: DWORD;
        nFileOffset: Word;
        nFileExtension: Word;
        lpstrDefExt: PWideChar;
        lCustData: LPARAM;
        lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
        lpTemplateName: PWideChar;
        pvReserved: Pointer;
        dwReserved: DWORD;
        FlagsEx: DWORD;
      end;

function GetOpenFileNameW(var OpenFile: tagOFNW): Bool; stdcall; external 'comdlg32.dll' name 'GetOpenFileNameW';
function GetSaveFileNameW(var OpenFile: tagOFNW): Bool; stdcall; external 'comdlg32.dll' name 'GetSaveFileNameW';
function CommDlgExtendedError:Cardinal; stdcall; external 'comdlg32.dll' name 'CommDlgExtendedError';

type TQueryFullProcessImageName=function(hProcess:Handle; flags:DWORD; EXEName:PChar; var Size:DWORD):BOOL; stdcall;
var QueryFullProcessImageName:TQueryFullProcessImageName=nil;

function C__ERROR_(var context:TScriptContext):integer;
var b:array[1..17] of WideChar;
//    
begin
  Int64ToW(Cardinal(context.IP)-4-Cardinal(context.ScriptStart),@b,16,False);
  MessageBoxW(0,PWideChar('Zero cmdcode at offs='+b),@_ERROR_,MB_ICONERROR);
  Result:=CMD_INVALID_COMMAND;
end;

procedure DestroyAllVariables(var context:TScriptContext);
begin
 //      
 repeat
 until C_LFRAME_DROP(context)<>CMD_OK;
 //     
 UA_Destroy(PArrayHeader(context.StackFrames));
end;

function C_EOS(var context:TScriptContext):integer;
var state:TParamState;
begin
with context do
begin
 result:=LoadParameter_DWORD(context,state,CMD_OK);
 { DONE :       }
 DestroyAllVariables(context);
 RestoreDateTime;
 case state of
  PARAM_OK: ExitFlag:=True;
  PARAM_DEFAULT,PARAM_END:
    begin
     ExitFlag:=True;
     Result:=CMD_OK;
    end;
  else result:=CMD_PARAM_ERROR;
 end;//case
end;//with
end;

function C_BEEP(var context:TScriptContext):integer;
var val:Cardinal;
    state:TParamState;
begin
with context do
begin
 result:=CMD_OK;
 val:=LoadParameter_DWORD(context,state,_MINUS_ONE);
 if state<>PARAM_INVALID
  then begin MessageBeep(val); LastWindowsError:=GetLastError; end;
end;//with
end;

function sub_AllocateVariables(var context:TScriptContext; IsGlobal:Boolean):integer;
//         (.  IsGlobal) 
var var_count,storage_index,first_allocated_var:Cardinal;
    state:TParamState;
    write_to_storage:Boolean;
begin
 result:=CMD_OK;
 storage_index:=0;
 write_to_storage:=False;
 var_count:=LoadParameter_DWORD(context,state,1);
 if state=PARAM_INVALID then
  begin
    Result:=CMD_PARAM_ERROR;
    Exit;
  end;

 if state<>PARAM_END then
 //     -    -
  begin
   storage_index:=LoadParameter_DWORD(context,state,0);
   case state of
    PARAM_OK:       write_to_storage:=True;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      Exit;
                    end;
   end;//case
  end;// state<>PARAM_END

 //     0 ,   "  "
 if var_count=0
  then Result:=CMD_INVALID_VARIABLE_COUNT
  else
  begin
    //    
    first_allocated_var:=Variables_Allocate(context,var_count,IsGlobal);
    //     -  
    if not IsGlobal
      then first_allocated_var:=first_allocated_var or LOCAL_VARIABLE_INDEX_FLAG;
    //       -  
    if write_to_storage
      then Result:=Variable_qStoreDWORD(context,storage_index,first_allocated_var);
  end;//else
end;

function C_LFRAME_ADD(var context:TScriptContext):integer;
begin
 result:=StackFrame_Add(context);
end;

function C_LFRAME_DROP(var context:TScriptContext):integer;
begin
 result:=StackFrame_Drop(context);
end;

function C_GALLOC(var context:TScriptContext):integer;
//       
begin
 Result:=sub_AllocateVariables(context,True);
end;

function C_LALLOC(var context:TScriptContext):integer;
//         
begin
 result:=sub_AllocateVariables(context,False);
end;

function C_STO_D(var context:TScriptContext):integer;
//    DWORD     
var var_idx,value_to_write:Cardinal;
    state:TParamState;
begin
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK
  then result:=CMD_PARAM_ERROR
  else
   begin
   value_to_write:=LoadParameter_DWORD(context,state,0);
   if state=PARAM_INVALID
    then result:=CMD_PARAM_ERROR
    else result:=Variable_qStoreDWORD(context,var_idx,value_to_write);
  end;//else
end;

function C_MBOX(var context:TScriptContext):integer;
//  UNICODE  MessageBox'
label ExecCmdNow,_Exit;
var HdrPtr,TxtPtr:PWideChar;
    state:TParamState;
    MessageText,MessageHeader:PUA_UnicodeString;
    tmp_dw,hwnd,options:Cardinal;
    store_result:Boolean;
begin
  hwnd:=0;
  tmp_dw:=0;
  options:=MB_APPLMODAL;
  HdrPtr:=PChar(KernelName);
  store_result:=False;
  MessageHeader:=nil;
  //   
  MessageText:=LoadParameter_UnicodeString(context,state);
  if state in [PARAM_DEFAULT,PARAM_END,PARAM_INVALID] then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;
  TxtPtr:=@(MessageText^.Arr);

  //   
  MessageHeader:=LoadParameter_UnicodeString(context,state);
 case state of
  PARAM_OK:                HdrPtr:=@(MessageHeader^.Arr);
  PARAM_END:               goto ExecCmdNow;
  PARAM_INVALID:           begin
                            Result:=CMD_PARAM_ERROR;
                            goto _Exit;
                           end;
 end; //case

 //   
 tmp_dw:=LoadParameter_DWORD(context,state,MB_APPLMODAL);
 case state of
  PARAM_OK:       options:=tmp_dw;
  PARAM_END:      goto ExecCmdNow;
  PARAM_INVALID:  begin
                    result:=CMD_PARAM_ERROR;
                    goto _Exit;
                  end;
 end; //case

 //   
 tmp_dw:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:       hwnd:=tmp_dw;
  PARAM_END:      goto ExecCmdNow;
  PARAM_INVALID:  begin
                    Result:=CMD_PARAM_ERROR;
                    goto _Exit;
                  end;
 end; //case

 //   
 tmp_dw:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:       begin store_result:=true; end;
  PARAM_INVALID:  begin
                    Result:=CMD_PARAM_ERROR;
                    goto _Exit;
                  end;
 end; //case

ExecCmdNow:
 options:=MessageBoxW(hwnd,TxtPtr,HdrPtr,options);
 if store_result
  then Result:=Variable_qStoreDWORD(context,tmp_dw,options)
  else Result:=CMD_OK;

_Exit:
 //   ,    
 UA_Destroy(PArrayHeader(MessageText));
 UA_Destroy(PArrayHeader(MessageHeader));
end;

function C_STO_B(var context:TScriptContext):integer;
var var_idx:Cardinal;
    state:TParamState;
    bb:PUA_BinaryBlock;
begin
 { TODO : ,          }
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK
  then result:=CMD_PARAM_ERROR
  else
   begin
    bb:=LoadParameter_BinBlock(context,state);
    case state of
     PARAM_DEFAULT,PARAM_END: bb:=@EmptyBinaryBlock;
     PARAM_INVALID:           begin
                                Result:=CMD_PARAM_ERROR;
                                Exit;
                              end;
    end;//case
    result:=Variable_qStoreBinary(context,var_idx,bb);
   end;//else
end;

function C_I_TO_xSTR(var context:TScriptContext; UnicodeFunction:Boolean):integer;
label ExecIt;
var var_idx,var_to,is_signed,base,tmp_dw:Cardinal;
    VarPtr:PNeoS0MVariable;
    state:TParamState;
    i64:Int64;
    buffer:array[0..64] of WideChar;
begin
with context do
begin
 is_signed:=1; Base:=10;
 //    
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then
  begin
    Result:=CMD_PARAM_ERROR;
    Exit;
  end;

 //  ,     
 var_to:=LoadParameter_DWORD(context,state,var_idx);
 case state of
  PARAM_END:      goto ExecIt;
  PARAM_INVALID:  begin
                    Result:=CMD_PARAM_ERROR;
                    Exit;
                  end;
 end; //case

 //    
 tmp_dw:=LoadParameter_DWORD(context,state,1);
 case state of
  PARAM_OK:       is_signed:=tmp_dw;
  PARAM_END:      goto ExecIt;
  PARAM_INVALID:  begin
                    Result:=CMD_PARAM_ERROR;
                    Exit;
                  end;
 end; //case

 //   
 Base:=LoadParameter_DWORD(context,state,10);
 if state=PARAM_INVALID then
  begin
    Result:=CMD_PARAM_ERROR;
    Exit;
  end;

ExecIt:
 VarPtr:=Variable_GetAddress(context,var_idx);
 if VarPtr<>nil then
  begin
   case VarPtr^.VarType of
    vtInteger: i64:=VarPtr^.AsInteger;
    vtDWORD:   begin
                if (base=10) and (is_signed<>0)
                 then i64:=Integer(VarPtr^.AsDWORD)
                 else i64:=VarPtr^.AsDWORD;
               end;
    else
      begin
        Result:=CMD_TYPECAST_IMPOSSIBLE;
        Exit;
      end;
   end;//case

   if (base>=2) and (base<=36) then
    begin
      if UnicodeFunction then
        begin
          Int64ToW(i64,@buffer,Base,Is_Signed<>0);
          result:=Variable_qWriteUnicodeString(context,var_to,@buffer,lstrlenW(@buffer));
        end
      else
        begin
          Int64ToA(i64,PAnsiChar(@buffer),Base,Is_Signed<>0);
          result:=Variable_qWriteBinary(context,var_to,@buffer,lstrlenA(@buffer));
        end;
    end
   else Result:=CMD_INVALID_PARAM_VALUE;

  end//if VarPtr<>nil
 else Result:=CMD_INVALID_VARIABLE_INDEX;
end;//with
end;

function C_I_TO_STR(var context:TScriptContext):Integer;
begin
  Result:=C_I_TO_xSTR(context,False);
end;


function C_STO_I (var context:TScriptContext):Integer;
//    INYEGER     
var var_idx:Cardinal;
    value_to_write:Int64;
    state:TParamState;
begin
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK
  then result:=CMD_PARAM_ERROR
  else
   begin
    value_to_write:=LoadParameter_INTEGER(context,state,0);
    if state=PARAM_INVALID
     then Result:=CMD_PARAM_ERROR
     else Result:=Variable_qStoreINTEGER(context,var_idx,value_to_write);
   end;
end;

function C_SLEEP (var context:TScriptContext):integer;
var time:Cardinal;
    state:TParamState;
begin
 time:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_INVALID then
  begin
    Result:=CMD_PARAM_ERROR;
    Exit;
  end;

 Sleep(time);
 Result:=CMD_OK;
end;

function C_RUN_EXE (var context:TScriptContext):integer;
label ExecIt,Finish;
var File_Name,Command_Line,Command_Line2,Start_Dir:PUA_UnicodeString;
    state:TParamState;
    _StartDir:PWideChar;
    Creation_Flags:Cardinal;
    s_i:TStartupInfoW;
begin
  Command_Line2:=nil;
  Start_Dir:=nil;
  Creation_Flags:=0;

  //   STARTUPINFO
  ZeroMemory(@s_i,SizeOf(s_i));
  s_i.cb:=SizeOf(s_i);

  //   -  
  File_Name:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then begin result:=CMD_PARAM_ERROR; goto Finish; end;

  //       ,   
  Command_Line:=UStr_Duplicate(File_Name);
  UStr_Quote(Command_Line);

  //   -  
  Command_Line2:=LoadParameter_UnicodeString(context,state);
  case state of
    //       
    PARAM_OK:       begin
                      UStr_Concat(Command_Line,@SpaceUnicodeString,Command_Line2);
                      UA_Destroy(PArrayHeader(Command_Line2));
                    end;
    PARAM_END:
                    goto ExecIt;
    PARAM_INVALID:  begin
                      result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end
  end;//case

  //   -  
  Start_Dir:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:
                    goto ExecIt;
    PARAM_INVALID:  begin
                      result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end
  end;//case

  //   -   
  creation_flags:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:       begin
                      s_i.dwFlags:=STARTF_USESHOWWINDOW;
                      s_i.wShowWindow:=creation_flags;
                    end;
    PARAM_END:      goto ExecIt;
    PARAM_INVALID:  begin
                      result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end
  end;//case

  //   -  
  creation_flags:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_INVALID
    then begin result:=CMD_PARAM_ERROR; goto Finish; end;

ExecIt:
  if Start_Dir=nil
    then _StartDir:=nil
    else _StartDir:=@Start_Dir^.Arr;

 with context do
 begin
  if CreateProcessW(@File_Name^.Arr,
                    @Command_Line^.Arr,
                    SecurityAttributes,SecurityAttributes,
                    False,creation_flags,nil,
                    _StartDir,
                    s_i,LastStartedProcess)
  then Result:=CMD_OK
  else Result:=CMD_CANT_RUN_FILE_OR_CMD;
  LastWindowsError:=GetLastError;
 end;
Finish:
  UA_Destroy(PArrayHeader(File_Name));
  UA_Destroy(PArrayHeader(Command_Line));
  UA_Destroy(PArrayHeader(Command_Line2));
  UA_Destroy(PArrayHeader(Start_Dir));
end;

function C_PROCESS_KILL(var context:TScriptContext):integer;
label ExecIt;
var phandle,_ExitCode:Cardinal;
begin
with context do
begin
 Result:=_hashDEreadvar_hashDNE(context,phandle,LastStartedProcess.hProcess,_ExitCode,0);
 if Result=CMD_OK then
  begin
   if not TerminateProcess(phandle,_ExitCode)
    then Result:=CMD_CANT_KILL_PROCESS_OR_THREAD;
   LastWindowsError:=GetLastError;
  end;//if Result=CMD_OK
end;//with
end;

function C_THREAD_KILL(var context:TScriptContext):integer;
var thandle,_ExitCode:Cardinal;
begin
with context do
begin
 Result:=_hashDEreadvar_hashDNE(context,thandle,LastStartedProcess.hThread,_ExitCode,0);
 if Result=CMD_OK then
  begin
   if not TerminateThread(thandle,_ExitCode)
    then Result:=CMD_CANT_KILL_PROCESS_OR_THREAD;
   LastWindowsError:=GetLastError;
  end;//if Result=CMD_OK
end;//with
end;

function sub_GET_xx_H_ID(var context:TScriptContext; h,id:Cardinal):Integer;
var h_var,id_var:Cardinal;
    state,state1:TParamState;
begin
 h_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_INVALID then result:=CMD_PARAM_ERROR
 else
  begin
   Result:=CMD_OK;
   id_var:=LoadParameter_DWORD(context,state1,0);
   if state1=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

   if state=PARAM_OK
    then Result:=Variable_qStoreDWORD(context,h_var,h);
   if (Result=CMD_OK) and (state1=PARAM_OK)
    then Result:=Variable_qStoreDWORD(context,id_var,id);
  end;
end;

function C_PROCESS_GET_H_ID(var context:TScriptContext):integer;
begin
with context.LastStartedProcess do
 Result:=sub_GET_xx_H_ID(context,hProcess,dwProcessId);
end;

function C_THREAD_GET_H_ID(var context:TScriptContext):integer;
begin
with context.LastStartedProcess do
 Result:=sub_GET_xx_H_ID(context,hThread,dwThreadId);
end;

function C_RUN_CMD (var context:TScriptContext):integer;
label ExecIt,Finish;
var sei:_SHELLEXECUTEINFOW;
    File_Name,Command_Line,Start_Dir,Verb:PUA_UnicodeString;
    state:TParamState;
begin
  Command_Line:=nil;
  Start_Dir:=nil;
  Verb:=nil;
 //   SHELLEXECUTEINFOW
 ZeroMemory(@sei,SizeOf(sei));
 with sei do
  begin
   cbSize:=SizeOf(sei);
   fMask:=SEE_MASK_DOENVSUBST+SEE_MASK_NOCLOSEPROCESS;
   nShow:=SW_SHOW;
  end;

  //   -  /
  File_Name:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK then
    begin
      result:=CMD_PARAM_ERROR;
      goto Finish;
    end
  else sei.lpFile:=File_Name^.Arr;
  //    
  UStr_Quote(File_Name);

  //  
  Command_Line:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:      goto ExecIt;
    PARAM_INVALID:  begin
                      result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;//case

  //  
  Start_Dir:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:      goto ExecIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end
  end;//case

  //  
  sei.nShow:=LoadParameter_DWORD(context,state,SW_SHOW);
  case state of
    PARAM_END:      goto ExecIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end
  end;//case

  //  "-" (lpVerb)
  Verb:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_OK:       sei.lpVerb:=@Verb^.Arr;
    PARAM_END:      goto ExecIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end
  end;//case

ExecIt:
  if Command_Line=nil  //         
    then Command_Line:=UStr_Duplicate(File_Name);
  sei.lpParameters:=Command_Line^.Arr;
  //     - .     nil
  if Start_Dir<>nil
    then sei.lpDirectory:=Start_Dir^.Arr;

  with sei, context do
  begin
    if ShellExecuteExW(@sei) then
      begin
        Result:=CMD_OK;
        LastStartedProcess.hProcess:=hProcess;
      end
    else Result:=CMD_CANT_RUN_FILE_OR_CMD;
    LastWindowsError:=GetLastError;
  end;//with

  Finish:
    UA_Destroy(PArrayHeader(File_Name));
    UA_Destroy(PArrayHeader(Command_Line));
    UA_Destroy(PArrayHeader(Start_Dir));
    UA_Destroy(PArrayHeader(Verb));
end;

function FindWindowEnumerator(hwnd:Cardinal;wsd:PWndSearchDescriptor):Boolean;stdcall;
var ec:Integer;
begin
  with wsd^ do
  begin
    if wndlist=nil
      then ec:=0
      else ec:=wndlist.Header.ElemCount;
    if ec<MaxItemCount then
      begin
        //    ?
        if IsGoodWindow(hwnd,wsd)
          then _AddDWORDToArray(wsd^.wndlist,hwnd,1);
        Result:=True;// 
      end
    else Result:=False; //      -  
  end;//with
end;

function FIND_xWNDS(var context:TScriptContext; FindInChild:Boolean):integer;
label DoIt, Finish;
var wsd:TWndSearchDescriptor;
    hwnd_list_var,parent_wnd:Cardinal;
    state:TParamState;
begin
//      
  with wsd do
  begin
    ClassNameCompare.StringComparsionMethod:=scmDontCompare;
    ClassNameCompare.CompareWith:=nil;
    WndTextCompare.StringComparsionMethod:=scmDontCompare;
    WndTextCompare.CompareWith:=nil;
    WndTxtBufSize:=INIT_WND_GETTEXT_BUFFER_SIZE;
    MaxTextLen:=INIT_WND_GETTEXT_BUFFER_SIZE-1;
    MaxItemCount:=MaxInt;
    wndlist:=nil;
    Timeout:=context.SendMsgTimeout;
  end;

  //   
  //  ,     
  hwnd_list_var:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

  //   -   ,      
  if FindInChild then
  begin
    parent_wnd:=LoadParameter_DWORD(context,state,hwnd_list_var);
    case state of
      PARAM_END:      goto DoIt;
      PARAM_INVALID:  begin
                        Result:=CMD_PARAM_ERROR;
                        goto Finish;
                      end;
    end;//case
  end;

with wsd.ClassNameCompare do
begin
  //   ,   
  CompareWith:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;//case

  //     
  StringComparsionMethod:=TStringComparsionMethod(LoadParameter_DWORD(context,state,Cardinal(scmDontCompare)));
  //     -   
  if StringComparsionMethod>scmIsSubstringWOCase
    then StringComparsionMethod:=scmDontCompare;
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; goto Finish; end;
  end;//case
end;//with

with wsd.WndTextCompare do
begin
  //   ,   
  CompareWith:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; goto Finish end;
  end;//case

  //     
  StringComparsionMethod:=TStringComparsionMethod(LoadParameter_DWORD(context,state,Cardinal(scmDontCompare)));
  //     -   
  if StringComparsionMethod>scmIsSubstringWOCase
    then StringComparsionMethod:=scmDontCompare;
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; goto Finish end;
  end;//case
end;//with

  // .   
  wsd.MaxTextLen:=LoadParameter_DWORD(context,state,INIT_WND_GETTEXT_BUFFER_SIZE-1);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; goto Finish end;
  end;//case

  // .   
  wsd.MaxItemCount:=LoadParameter_DWORD(context,state,MaxInt);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;

DoIt:
  //            ,  .    " "
  with wsd.ClassNameCompare
    do if CompareWith=nil
        then StringComparsionMethod:=scmDontCompare;
  with wsd.WndTextCompare
    do if CompareWith=nil
        then StringComparsionMethod:=scmDontCompare;

  with wsd do
  begin
    GetMem(Buffer,WndTxtBufSize+WndTxtBufSize); //       Unicode-

    Result:=CMD_OK;
    if FindInChild then
      begin
        if VariableOrArray_qLoadDWORD(context,parent_wnd,parent_wnd)=CMD_OK
          then EnumChildWindows(parent_wnd,@FindWindowEnumerator,Integer(@wsd)) //   
          else Result:=CMD_NOT_WND_LIST;
      end
    else EnumWindows(@FindWindowEnumerator,Integer(@wsd)); //    

    FreeMem(Buffer); //  ,   
    if Result=CMD_OK
      then Result:=Variable_AssignArray(context,hwnd_list_var,PArrayHeader(wndlist),vtDWORDArray);
      //            (. -   ),
      //    ,     
    if Result<>CMD_OK then UA_Destroy(PArrayHeader(wndlist));
  end;//with

Finish:
  //   Unicode-
  with wsd do
    begin
      UA_Destroy(PArrayHeader(ClassNameCompare.CompareWith));
      UA_Destroy(PArrayHeader(WndTextCompare.CompareWith));
    end;

end;

function C_WND_FIND(var context:TScriptContext):integer;
begin
 Result:=FIND_xWNDS(context,False);
end;

function C_WND_FIND_CHILD(var context:TScriptContext):integer;
begin
 Result:=FIND_xWNDS(context,True);
end;

function C_JUMP(var context:TScriptContext):integer;
var jump_to:Cardinal;
    state:TParamState;
begin
 jump_to:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK
  then begin Context.IP:=Pointer(jump_to); Result:=CMD_OK; end
  else Result:=CMD_PARAM_ERROR;
end;

function C_VAR_CLEAR(var context:TScriptContext):Integer;
var var_idx,var_count,direction:Int64;
    tmp_dw:Cardinal;
    state:TParamState;
    varptr:PNeoS0MVariable;
begin
  //   -   
  tmp_dw:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK
    then var_idx:=tmp_dw
    else
      begin
        Result:=CMD_PARAM_ERROR;
        Exit;
      end;

  //   -  ,   (  )
  var_count:=LoadParameter_INTEGER(context,state,1);
  if state<>PARAM_INVALID then
  begin
    //    0 ,  
    if var_count=0
      then Result:=CMD_INVALID_VARIABLE_COUNT
      else Result:=CMD_OK;
    //    
    if var_count>0
      then direction:=-1
      else direction:=1;
    while (var_count<>0) and (Result=CMD_OK) do
      begin
        if var_idx>=0 then
          begin
            varptr:=Variable_GetAddress(context,var_idx);
            if varptr=nil
              then Result:=CMD_INVALID_VARIABLE_INDEX
              else Variable_Deinitialize(varptr);
            end
        else Result:=CMD_INVALID_VARIABLE_INDEX;
        //     
        Inc(var_count,direction);
        //   .     
        Dec(var_idx,direction);
      end;//while
  end//if state<>PARAM_INVALID
 else Result:=CMD_PARAM_ERROR;
end;

function C_xBRANCH(var context:TScriptContext;DoCall:Boolean):integer;
var var_idx,p_count,jmp_to:Cardinal;
    var_value,p_value,def_value:int64;
    state:TParamState;
    NextCommand:Pointer;
    is_odd_count:Boolean;
begin
 var_idx:=LoadParameter_DWORD(context,state,0);
with context do
begin
 if state=PARAM_OK then
  begin
   Result:=Variable_qLoadINTEGER(context,var_idx,var_value);
   if Result=CMD_OK then
    begin
     def_value:=0;
     p_count:=GetParamCount(IP,NextCommand);
     // ,      .
     //   ,   -     ;
     //   -      (,      )
     is_odd_count:=Odd(p_count);
     while p_count>0 do
      begin
       if p_count>1 then //      
        begin
         //  ,     
         p_value:=LoadParameter_INTEGER(context,state,def_value);
         if state=PARAM_INVALID
          then
            begin
              Result:=CMD_PARAM_ERROR;
              Exit;
            end
          else
            begin
              Dec(p_count);
              if state=PARAM_OK
                then def_value:=p_value;
              Inc(def_value);
            end;
        end;

       // ,    
       jmp_to:=LoadParameter_DWORD(context,state,Cardinal(NextCommand));
       if state=PARAM_INVALID then
          //    -  
          begin
            Result:=CMD_PARAM_ERROR;
            Exit;
          end
        else //    
         begin
{$WARNINGS OFF}
          if (p_count=1) and is_odd_count then //    - ,    - 
            begin
              if DoCall
                then if state<>PARAM_DEFAULT //         -   ,   
                      then PushRetAddr(context,NextCommand); //     
              IP:=Pointer(jmp_to);
              Exit;
            end
           else
            //      ,   
            if var_value=p_value then
              begin
                if DoCall
                  then if state<>PARAM_DEFAULT
                        then PushRetAddr(context,NextCommand); //     
                IP:=Pointer(jmp_to);
                Exit;
              end;
          Dec(p_count); //    
         end;
      end;//while
    end;//if Result=CMD_OK
  end//if state=PARAM_OK
  else Result:=CMD_PARAM_ERROR;
  IP:=NextCommand;
end;//with
end;
{$WARNINGS ON}

function C_BRANCH(var context:TScriptContext):integer;
begin
  Result:=C_xBRANCH(context,False);
end;

function C_LENGTH(var context:TScriptContext):integer;
var length_of,write_to:Cardinal;
    var_addr:PNeoS0MVariable;
    state:TParamState;
begin
 length_of:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   write_to:=LoadParameter_DWORD(context,state,length_of);
   if state=PARAM_INVALID
    then Result:=CMD_PARAM_ERROR
    else
     //    
     begin
      var_addr:=Variable_GetAddress(context,length_of);
      if var_addr=nil
        then Result:=CMD_INVALID_VARIABLE_INDEX
        else
          begin
            if IsArray[var_addr^.VarType]
              then Result:=Variable_qStoreDWORD(context,write_to,_GetArrayLength(var_addr))
              else Result:=CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE;
        end;//else
     end//else
  end//if state=PARAM_OK
 else Result:=CMD_PARAM_ERROR;
end;

{$WARNINGS OFF}
function SingleDWORDOperation(var context:TScriptContext; DWORDOp:TDWORDOperation; IntOp:TIntOperation; ExtOp:TExtOperation):Integer;
var var_idx,p_count:Cardinal;
    var_dword_value,add_dword_val:Cardinal;
    var_int64_value,add_int64_val:Int64;
    var_ext_value,add_ext_val:Extended;
    i:Integer;
    state:TParamState;
    NextCommand:Pointer;
    var_type:TVarType;
begin
with context do
begin
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Result:=CMD_PARAM_ERROR
  else
   begin
    //   
    var_type:=Variable_GetType(context,var_idx);
    //       ;   - ,  -  
    case var_type of
     vtDWORD:    Result:=Variable_qLoadDWORD(context,var_idx,var_dword_value);
     vtINTEGER:  Result:=Variable_qLoadINTEGER(context,var_idx,var_int64_value);
     vtExtended: Result:=Variable_qLoadFLOAT(context,var_idx,var_ext_value);
     else Result:=CMD_TYPECAST_IMPOSSIBLE;
    end;//case
    if Result=CMD_OK then
     begin
      p_count:=GetParamCount(IP,NextCommand);
      for i:=1 to p_count do
       begin
        //  ,   //  ..  
        case var_type of
         vtDWORD:    add_dword_val:=LoadParameter_DWORD(context,state,1);
         vtINTEGER:  add_int64_val:=LoadParameter_INTEGER(context,state,1);
         vtExtended: add_ext_val:=LoadParameter_FLOAT(context,state,1);
         else state:=PARAM_INVALID;
        end;//case

        if state=PARAM_INVALID
         //   -     
         then begin Result:=CMD_TYPECAST_IMPOSSIBLE; Break; end
         else begin
                case var_type of
                 vtDWORD:    Result:=DWORDOp(var_dword_value,add_dword_val);
                 vtInteger:  Result:=INTOp(var_int64_value,add_int64_val);
                 vtExtended: begin
                              try
                               Result:=EXTOp(var_ext_value,add_ext_val);
                              except
                               Result:=CMD_FLOATPOINT_OVERFLOW;
                              end;
                             end;
                 else Result:=CMD_TYPECAST_IMPOSSIBLE;
                end;//case

                 if Result<>CMD_OK then Break;
              end;
       end;//for
      if Result=CMD_OK then
      begin
       //  :      (CMD_D _ .).     
       if p_count=0 then
        begin
         case var_type of
           vtDWORD:    Result:=DWORDOp(var_dword_value,1);
           vtInteger:  Result:=INTOp(var_int64_value,1);
           vtExtended: begin
                        try
                         Result:=EXTOp(var_ext_value,1);
                        except
                         Result:=CMD_FLOATPOINT_OVERFLOW;
                        end;
                       end;
           else Result:=CMD_TYPECAST_IMPOSSIBLE;
         end;//case
        end;//if p_count=0
       if Result=CMD_OK then
        begin
         case var_type of
           vtDWORD:    Result:=Variable_qStoreDWORD(context,var_idx,var_dword_value);
           vtInteger:  Result:=Variable_qStoreINTEGER(context,var_idx,var_int64_value);
           vtExtended: Result:=Variable_qStoreFLOAT(context,var_idx,var_ext_value);
         end;//case
        end;
     end;//if Result=CMD_OK
    end;//if Result=CMD_OK
   end;//else
 IP:=NextCommand;
end;//with
end;
{$WARNINGS ON}

function opAddDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 Inc(operand,operand2);
 Result:=CMD_OK;
end;

function opSubDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 Dec(operand,operand2);
 Result:=CMD_OK;
end;

function opMulDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 operand:=operand*operand2;
 Result:=CMD_OK;
end;

function opDivDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 try
  operand:=operand div operand2;
  Result:=CMD_OK;
 except
  Result:=CMD_INTEGER_OVERFLOW;
 end;
end;

function opModDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 try
  operand:=operand mod operand2;
  Result:=CMD_OK;
 except
  Result:=CMD_INTEGER_OVERFLOW;
 end;
end;

function opAndDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 operand:=operand and operand2;
 Result:=CMD_OK;
end;

function opOrDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 operand:=operand or operand2;
 Result:=CMD_OK;
end;

function opXorDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 operand:=operand xor operand2;
 Result:=CMD_OK;
end;

function opShrDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 operand:=operand shr operand2;
 Result:=CMD_OK;
end;

function opShlDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
 operand:=operand shl operand2;
 Result:=CMD_OK;
end;

function opMaxDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
  if operand<operand2
    then operand:=operand2;
  Result:=CMD_OK;
end;

function opMinDWORD(var operand:Cardinal; operand2:Cardinal):Integer;
begin
  if operand>operand2
    then operand:=operand2;
  Result:=CMD_OK;
end;

function opAddInt(var operand:Int64; operand2:Int64):Integer;
begin
 operand:=operand+operand2;
 Result:=CMD_OK;
end;

function opSubInt(var operand:Int64; operand2:Int64):Integer;
begin
 operand:=operand-operand2;
 Result:=CMD_OK;
end;

function opMulInt(var operand:Int64; operand2:Int64):Integer;
begin
 operand:=operand*operand2;
 Result:=CMD_OK;
end;

function opDivInt(var operand:Int64; operand2:Int64):Integer;
begin
 try
  operand:=operand div operand2;
  Result:=CMD_OK;
 except
  Result:=CMD_INTEGER_OVERFLOW;
 end;
end;

function opModInt(var operand:Int64; operand2:Int64):Integer;
begin
 try
  operand:=operand mod operand2;
  Result:=CMD_OK;
 except
  Result:=CMD_INTEGER_OVERFLOW;
 end;
end;

function opAndInt(var operand:Int64; operand2:Int64):Integer;
begin
 operand:=operand and operand2;
 Result:=CMD_OK;
end;

function opOrInt(var operand:Int64; operand2:Int64):Integer;
begin
 operand:=operand or operand2;
 Result:=CMD_OK;
end;

function opXorInt(var operand:Int64; operand2:Int64):Integer;
begin
 operand:=operand xor operand2;
 Result:=CMD_OK;
end;

function opShrInt(var operand:Int64; operand2:Int64):Integer;
begin
 operand:=operand shr operand2;
 Result:=CMD_OK;
end;

function opShlInt(var operand:Int64; operand2:Int64):Integer;
begin
 operand:=operand shl operand2;
 Result:=CMD_OK;
end;

function opMaxInt(var operand:Int64; operand2:Int64):Integer;
begin
  if operand<operand2
    then operand:=operand2;
  Result:=CMD_OK;
end;

function opMinInt(var operand:Int64; operand2:Int64):Integer;
begin
  if operand>operand2
    then operand:=operand2;
  Result:=CMD_OK;
end;

function opAddExt(var operand:Extended; operand2:Extended):Integer;
begin
 operand:=operand+operand2;
 Result:=CMD_OK;
end;

function opSubExt(var operand:Extended; operand2:Extended):Integer;
begin
 operand:=operand-operand2;
 Result:=CMD_OK;
end;

function opMulExt(var operand:Extended; operand2:Extended):Integer;
begin
 operand:=operand*operand2;
 Result:=CMD_OK;
end;

function opDivExt(var operand:Extended; operand2:Extended):Integer;
begin
  operand:=operand/operand2;
  Result:=CMD_OK;
end;

function OpNotExistsExt(var operand:Extended; operand2:Extended):Integer;
begin
 Result:=CMD_TYPECAST_IMPOSSIBLE;
end;

function opMaxExt(var operand:Extended; operand2:Extended):Integer;
begin
  if operand<operand2
    then operand:=operand2;
  Result:=CMD_OK;
end;

function opMinExt(var operand:Extended; operand2:Extended):Integer;
begin
  if operand>operand2
    then operand:=operand2;
  Result:=CMD_OK;
end;

function C_ADD(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opAddDWORD,opAddInt,opAddExt);
end;

function C_SUB(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opSubDWORD,opSubInt,opSubExt);
end;

function C_MUL(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opMulDWORD,opMulInt,opMulExt);
end;

function C_DIV(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opDivDWORD,opDivInt,opDivExt);
end;

function C_MOD(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opModDWORD,opModInt,OpNotExistsExt);
end;

function C_AND(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opAndDWORD,opAndInt,OpNotExistsExt);
end;

function C_OR(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opOrDWORD,opOrInt,OpNotExistsExt);
end;

function C_XOR(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opXorDWORD,opXorInt,OpNotExistsExt);
end;

function C_SHL(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opShlDWORD,opShlInt,OpNotExistsExt);
end;

function C_SHR(var context:TScriptContext):integer;
begin
 Result:=SingleDWORDOperation(context,opShrDWORD,opShrInt,OpNotExistsExt);
end;

function C_MOUSE_GET_POS(var context:TScriptContext):integer;
var x_v,y_v:Cardinal;
    x_pres,y_pres:Boolean;
    coords:TPoint;
begin
 Result:=_hashD_hashDE(context,x_v,x_pres,0,y_v,y_pres,0);
 if (Result=CMD_OK) and (x_pres or y_pres) then
  begin
   if GetCursorPos(coords) then
    begin
     if x_pres then Result:=Variable_qStoreDWORD(context,x_v,coords.X);
     if (Result=CMD_OK) and y_pres then Result:=Variable_qStoreDWORD(context,y_v,coords.Y);
    end//if GetCursorPos...
   else
    begin
     Result:=CMD_API_ERROR;
     context.LastWindowsError:=GetLastError;
    end;
  end;//Result=CMD_OK and ...
end;

function C_MOUSE_SET_POS(var context:TScriptContext):integer;
var x_v,y_v:Cardinal;
    x_pres,y_pres:Boolean;
    coords:TPoint;
begin
 Result:=_hashD_hashDE(context,x_v,x_pres,0,y_v,y_pres,0);
 if (Result=CMD_OK) and (x_pres or y_pres) then
  begin
   if not (x_pres and y_pres) then GetCursorPos(coords); //        -    
   with coords do
    begin
     if x_pres then X:=x_v;
     if y_pres then Y:=y_v;
     if Result=CMD_OK then
      begin
       if SetCursorPos(X,Y)
        then Result:=CMD_OK
        else begin Result:=CMD_API_ERROR; context.LastWindowsError:=GetLastError; end;
      end;
    end;//with
  end;//if (Result=CMD_OK) and ...
end;

function C_MOUSE_GET_BTNS(var context:TScriptContext):integer;
label ExecIt;
var store_lb,store_mb,store_rb:Cardinal;
    lb_present,mb_present,rb_present:Boolean;
    state:TParamState;
begin
 Result:=CMD_OK;
 lb_present:=False;mb_present:=False;rb_present:=False;
 store_lb:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK: lb_present:=True;
  PARAM_END: Exit;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 store_mb:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK: mb_present:=True;
  PARAM_END: goto ExecIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 store_rb:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK: rb_present:=True;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

ExecIt:
 if lb_present then Result:=Variable_qStoreDWORD(context,store_lb,(GetAsyncKeyState(VK_LBUTTON) shr 15) and 1);
 if mb_present then Result:=Max(Result,Variable_qStoreDWORD(context,store_mb,(GetAsyncKeyState(VK_MBUTTON) shr 15) and 1));
{$WARNINGS OFF}
 if rb_present then Result:=Max(Result,Variable_qStoreDWORD(context,store_rb,(GetAsyncKeyState(VK_RBUTTON) shr 15) and 1));
end;
{$WARNINGS ON}

function C_IS_KEYS_PRESSED(var context:TScriptContext):integer;
label _Exit;
var write_to,param_count,IsPressed,Key:Cardinal;
    state:TParamState;
    NextCommand:Pointer;
    i:Integer;
begin
 write_to:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
  param_count:=GetParamCount(context.IP,NextCommand);
  IsPressed:=1;
  //       
  for i:=1 to param_count do
   begin
    Key:=LoadParameter_DWORD(context,state,0);
    if state<>PARAM_OK
     then begin Result:=CMD_INVALID_PARAM_VALUE; goto _Exit; end
     else begin
           //   16-  -   
           if (GetAsyncKeyState(Key) and $8000)=0
            then begin IsPressed:=0; Break; end;
          end;
   end;//for
  Result:=Variable_qStoreDWORD(context,write_to,IsPressed);
_Exit:
  context.IP:=NextCommand;
  end//if state=PARAM_OK
 else Result:=CMD_PARAM_ERROR;
end;

function EMULATE_KEYx(var context:TScriptContext;KeyboardEmulation:TKeyboardEmulation):integer;
 label _Exit;
 const STATIC_KEYBUFFER_SIZE=8;
       ExtKeys:set of Byte=[VK_Up,VK_Down,VK_Left,VK_Right,VK_Home,VK_End,
       VK_Prior,VK_Next,VK_Insert,VK_Delete];
 type TArrayOfByte=array [1..$FFFFFF] of Byte;
      PArrayOfByte=^TArrayOfByte;
 var param_count:Cardinal;
     state:TParamState;
     NextCommand:Pointer;
     i:Integer;
     StaticKeyBuf:array [1..STATIC_KEYBUFFER_SIZE] of Byte;
     KeyBufPtr:PArrayOfByte;
     PressedKey:Byte;
     ScanCode,ExtFlag:Cardinal;
begin
 Result:=CMD_OK;
 param_count:=GetParamCount(context.IP,NextCommand);
 if param_count>STATIC_KEYBUFFER_SIZE
  then GetMem(KeyBufPtr,param_count*SizeOf(Cardinal))
  else KeyBufPtr:=@StaticKeyBuf;
 //     
 for i:=1 to param_count do
  begin
   KeyBufPtr^[i]:=LoadParameter_DWORD(context,state,0) and $FF;
   if state<>PARAM_OK then begin Result:=CMD_PARAM_TYPE_MISMATCH; Break; end;
  end;//for

 if Result=CMD_OK then //    
  begin
   //  "" 
   if KeyboardEmulation<>keUp
    then begin for i:=1 to param_count do
     begin
      PressedKey:=KeyBufPtr^[i];
      ScanCode:=Lo(MapVirtualKeyA(PressedKey,0));
      ExtFlag:=IfThen(PressedKey in ExtKeys,KEYEVENTF_EXTENDEDKEY,0);
      keybd_event(PressedKey,ScanCode,ExtFlag,0); end;
     end;
   //    -,  
   if KeyboardEmulation=keClick
    then Sleep(context.KeyPressTime);
   //  "" 
   if KeyboardEmulation<>keDown
    then begin for i:=param_count downto 1 do
     begin
      PressedKey:=KeyBufPtr^[i];
      ScanCode:=Lo(MapVirtualKeyA(PressedKey,0));
      ExtFlag:=IfThen(PressedKey in ExtKeys,KEYEVENTF_EXTENDEDKEY,0);
      keybd_event(PressedKey,ScanCode,ExtFlag or KEYEVENTF_KEYUP,0); end;
     end;
  end;//if Result=CMD_OK

 if param_count>STATIC_KEYBUFFER_SIZE //     -  
  then FreeMem(KeyBufPtr);
 context.IP:=NextCommand;
end;

function C_EMULATE_KEYPRESS(var context:TScriptContext):integer;
begin
  Result:=EMULATE_KEYx(context,keClick);
end;

function INIT_xA(var context:TScriptContext; t:TVarType):integer;
var var_idx,arr_size,init_value_d,elem_size:Cardinal;
    init_value_i:int64;
    init_value_f:Extended;
    init_value_present:Boolean;
    state:TParamState;
    NewArr:PArrayHeader;
    i:Integer;
begin
  Result:=CMD_OK;
  arr_size:=0;
  init_value_d:=0;
  init_value_i:=0;
  init_value_f:=0;
  init_value_present:=False;
  case t of
    vtIntArray:      elem_size:=SizeOf(Int64);
    vtDWORDArray:    elem_size:=SizeOf(Cardinal);
    vtExtArray:      elem_size:=SizeOf(Extended);
    else elem_size:=MaxInt;
  end;//case

  //   -  
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
  begin
    //    -  
    arr_size:=LoadParameter_DWORD(context,state,0);
    case state of
      PARAM_OK,PARAM_DEFAULT: begin
                  //    -  
                  case t of
                    vtDWORDArray: init_value_d:=LoadParameter_DWORD(context,state,0);
                    vtIntArray:   init_value_i:=LoadParameter_Integer(context,state,0);
                    vtExtArray:   init_value_f:=LoadParameter_Float(context,state,0);
                  end;//case t
                  case state of
                    PARAM_OK:       init_value_present:=True;
                    PARAM_INVALID:  Result:=CMD_PARAM_ERROR;
                  end;//case state
               end;//PARAM_OK
     PARAM_INVALID: Result:=CMD_PARAM_ERROR;
    end;
    end;//case
    //   
    if Result=CMD_OK then
      begin
        //    
        NewArr:=UA_CreateR(arr_size,elem_size);
        if NewArr=nil
          then Result:=CMD_OUT_OF_MEMORY
          else
            begin
              //    
              Result:=Variable_AssignArray(context,var_idx,NewArr,t);
              if Result=CMD_OK then
                begin
                  //  ,  
                  if init_value_present then
                  for i:=0 to arr_size-1 do
                    begin
                      case t of
                        vtDWORDArray: PUA_DWORD(NewArr)^.Arr[i]:=init_value_d;
                        vtIntArray:   PUA_INTEGER(NewArr)^.Arr[i]:=init_value_i;
                        vtExtArray:   PUA_EXTENDED(NewArr)^.Arr[i]:=init_value_f;
                      end;//case
                    end;//for
                end
              //      -  
              else UA_Destroy(PArrayHeader(NewArr));
            end;//else
      end//if Result=CMD_OK
    else Result:=CMD_PARAM_ERROR;
end;

function C_INIT_DA(var context:TScriptContext):integer;
begin
 Result:=INIT_xA(context,vtDWORDArray);
end;

function C_INIT_IA(var context:TScriptContext):integer;
begin
 Result:=INIT_xA(context,vtIntArray);
end;

function C_INIT_FA(var context:TScriptContext):integer;
begin
 Result:=INIT_xA(context,vtExtArray);
end;

function C_STO_F(var context:TScriptContext):integer;
var var_idx:Cardinal;
    value_to_write:Extended;
    state:TParamState;
begin
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK
  then result:=CMD_PARAM_ERROR
  else
   begin
   value_to_write:=LoadParameter_FLOAT(context,state,0);
   if state=PARAM_INVALID
    then result:=CMD_PARAM_ERROR
    else result:=Variable_qStoreFLOAT(context,var_idx,value_to_write);
  end;//else
end;

function STO_xA(var context:TScriptContext; t:TVarType):integer;
var var_idx,item_idx,val_d:Cardinal;
    val_i:Int64;
    val_f:Extended;
    item_ptr:Pointer;
    state:TParamState;
begin
 val_d:=0;val_i:=0;val_f:=0;
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   Result:=CMD_OK;
   //    
   item_idx:=LoadParameter_DWORD(context,state,0);
   case state of
    PARAM_OK,PARAM_DEFAULT:
      begin
      //  ,     ,  -  
       case t of
        vtDWORDArray,vtBinBlock,vtUnicodeString:
                       val_d:=LoadParameter_DWORD(context,state,0);
        vtIntArray:    val_i:=LoadParameter_INTEGER(context,state,0);
        vtExtArray:    val_f:=LoadParameter_FLOAT(context,state,0);
       end;//case
       if state=PARAM_INVALID then Result:=CMD_PARAM_ERROR;
      end;
    else Result:=CMD_PARAM_ERROR;
   end;//case

   // ,    
   if Result=CMD_OK
    then Result:=IfThen(Variable_GetType(context,var_idx)=t,CMD_OK,CMD_TYPECAST_IMPOSSIBLE);

   if Result=CMD_OK then
   begin
     //   ,    
     if not Variable_DuplicateIfStatic(context,var_idx) then
      begin
        Result:=CMD_OUT_OF_MEMORY;
        Exit;
      end;
     //     
     item_ptr:=Variable_GetArrayItemPtr(context,var_idx,item_idx);
     if item_ptr<>nil then
      begin
       Result:=CMD_OK;
       case t of
        vtBinBlock:   PByte(item_ptr)^:=val_d and $FF;
        vtUnicodeString:
                      PWord(item_ptr)^:=val_d and $FFFF;
        vtDWORDArray: PCardinal(item_ptr)^:=val_d;
        vtIntArray:   PInt64(item_ptr)^:=val_i;
        vtExtArray:   PExtended(item_ptr)^:=val_f;
       end;//case
    end//if Result=CMD_OK
   else Result:=CMD_INVALID_ARRAY_ITEM_INDEX;
   end;
  end//if state=PARAM_OK
 else Result:=CMD_PARAM_ERROR;
end;

function C_STO_DA(var context:TScriptContext):integer;
begin
 Result:=STO_xA(context,vtDWORDArray);
end;

function C_STO_IA(var context:TScriptContext):integer;
begin
 Result:=STO_xA(context,vtIntArray);
end;

function C_STO_FA(var context:TScriptContext):integer;
begin
 Result:=STO_xA(context,vtExtArray);
end;

function READ_xA(var context:TScriptContext; t:TVarType):integer;
var var_idx,item_idx,write_to,data_len:Cardinal;
    state:TParamState;
    item_ptr:Pointer;
begin
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   Result:=CMD_OK;
   write_to:=var_idx;
   //    
   item_idx:=LoadParameter_DWORD(context,state,0);
   case state of
    PARAM_OK,PARAM_DEFAULT:
      begin
       //  ,   ,  -  
       write_to:=LoadParameter_DWORD(context,state,var_idx);
       if state=PARAM_INVALID
        then Result:=CMD_PARAM_ERROR
      end;
    PARAM_INVALID: Result:=CMD_PARAM_ERROR
   end;//case

   // ,    
   if Result=CMD_OK
    then Result:=IfThen(Variable_GetType(context,var_idx)=t,CMD_OK,CMD_TYPECAST_IMPOSSIBLE);

   //      -    
   if Result=CMD_OK then
    begin
     item_ptr:=Variable_GetArrayItemPtr(context,var_idx,item_idx);
     if item_ptr<>nil then
      begin
       //     
{$WARNINGS OFF}
       case t of
        vtBinBlock:   Result:=Variable_qStoreDWORD(context,write_to,PByte(item_ptr)^);
        vtUnicodeString:
                      Result:=Variable_qStoreDWORD(context,write_to,PWord(item_ptr)^);
        vtDWORDArray: Result:=Variable_qStoreDWORD(context,write_to,PCardinal(item_ptr)^);
        vtIntArray:   Result:=Variable_qStoreINTEGER(context,write_to,PInt64(item_ptr)^);
        vtExtArray:   Result:=Variable_qStoreFLOAT(context,write_to,PExtended(item_ptr)^);
        vtBinBlockList: begin
                          item_ptr:=Variable_GetBBLItem(context,var_idx,item_idx,data_len);
                          Result:=Variable_qWriteBinary(context,write_to,item_ptr,data_len);
                        end;
        { DONE -c BinBlock :     "  ",     }
        vtUnicodeStringList:
                        begin
                          item_ptr:=Variable_GetUStrLItem(context,var_idx,item_idx,data_len);
                          Result:=Variable_qWriteUnicodeString(context,write_to,item_ptr,data_len);
                        end;
       end;//case
      end
     else Result:=CMD_INVALID_ARRAY_ITEM_INDEX;
    end;
  end//if state=PARAM_OK
 else Result:=CMD_PARAM_ERROR;
end;
{$WARNINGS ON}

function C_READ_DA(var context:TScriptContext):integer;
begin
 Result:=READ_xA(context,vtDWORDArray);
end;

function C_READ_IA(var context:TScriptContext):integer;
begin
 Result:=READ_xA(context,vtIntArray);
end;

function C_READ_FA(var context:TScriptContext):integer;
begin
 Result:=READ_xA(context,vtExtArray);
end;

function x_SET_THREAD_PRIOR(var context:TScriptContext; ByTID:Boolean):integer;
var t_h,new_t_prior:Cardinal;
    t_h_present,new_t_present:Boolean;
begin
 Result:=_hashD_hashDE(context,t_h,t_h_present,0,new_t_prior,new_t_present,THREAD_PRIORITY_NORMAL);
 if Result=CMD_OK then
 begin
   Result:=IfThen(t_h_present,Variable_qLoadDWORD(context,t_h,t_h),CMD_OK);
   if Result=CMD_OK then
    begin
     //      ThreadID -   
     if ByTID and t_h_present then t_h:=OpenThread(THREAD_SET_INFORMATION,False,t_h);
     with context do
     begin
       // -  
       if not SetThreadPriority(IfThen(t_h_present,t_h,LastStartedProcess.hThread),new_t_prior)
        then begin Result:=CMD_CANT_CHANGE_THREAD_PRIORITY; LastWindowsError:=GetLastError; end;
     end;//with
     //      ThreadID -   
     if ByTID and t_h_present then CloseHandle(t_h);
    end;//if Result=CMD_OK
 end;//if Result=CMD_OK
end;

function x_SET_PROCESS_PRIOR(var context:TScriptContext; ByPID:Boolean):integer;
var p_h,new_p_prior:Cardinal;
    p_h_present,new_p_present:Boolean;
begin
 Result:=_hashD_hashDE(context,p_h,p_h_present,0,new_p_prior,new_p_present,NORMAL_PRIORITY_CLASS);
 if Result=CMD_OK then
 begin
   //        -   
   Result:=IfThen(p_h_present,Variable_qLoadDWORD(context,p_h,p_h),CMD_OK);
   if Result=CMD_OK then
    begin
     //      ProcessID -   
     if ByPID and p_h_present then p_h:=OpenProcess(PROCESS_SET_INFORMATION,False,p_h);
     with context do
     begin
       //    
       case new_p_prior of
        0:  new_p_prior:=IDLE_PRIORITY_CLASS;
        1:  new_p_prior:=BELOW_NORMAL_PRIORITY_CLASS;
        2:  new_p_prior:=NORMAL_PRIORITY_CLASS;
        3:  new_p_prior:=ABOVE_NORMAL_PRIORITY_CLASS;
        4:  new_p_prior:=HIGH_PRIORITY_CLASS;
        5:  new_p_prior:=REALTIME_PRIORITY_CLASS;
       end;//case
       // -  
       if not SetPriorityClass(IfThen(p_h_present,p_h,LastStartedProcess.hProcess),new_p_prior)
        then begin Result:=CMD_CANT_CHANGE_PROC_PRIORITY; LastWindowsError:=GetLastError; end;
     end;//with
     //      ThreadID -   
     if ByPID and p_h_present then CloseHandle(p_h);
    end;//if Result=CMD_OK
 end;//if Result=CMD_OK
end;

function C_THREAD_SET_PRIOR(var context:TScriptContext):integer;
begin
 Result:=x_SET_THREAD_PRIOR(context,False);
end;

function C_PROCESS_SET_PRIOR(var context:TScriptContext):integer;
begin
 Result:=x_SET_PROCESS_PRIOR(context,False);
end;

function C_THREAD_SET_PRIOR_BY_TID(var context:TScriptContext):integer;
begin
 Result:=x_SET_THREAD_PRIOR(context,True);
end;

function C_PROCESS_SET_PRIOR_BY_PID(var context:TScriptContext):integer;
begin
 Result:=x_SET_PROCESS_PRIOR(context,True);
end;

const OPERATION_COPY_FILE=0;
      OPERATION_MOVE_FILE=1;

function x_FILE(var context:TScriptContext; _MoveFile:Boolean):integer;
var file_from,file_to:PUA_UnicodeString;
    force_copy:Cardinal;
    state:TParamState;
    Res:Boolean;
    fn:PWideChar;
begin
  file_from:=LoadParameter_UnicodeString(context,state);
  file_to:=nil;
  if state=PARAM_OK then
  begin
    file_to:=LoadParameter_UnicodeString(context,state);
    if state=PARAM_OK then
    begin
      force_copy:=LoadParameter_DWORD(context,state,1);
      if state=PARAM_INVALID
        then Result:=CMD_PARAM_ERROR
        else
          begin
            fn:=@file_from^.Arr;
            //       
            Res:=CopyFileW(fn,@file_to^.Arr,force_copy=0);
            //    , ,   ,     
            if Res and _MoveFile then
              begin
                if not DeleteFileW(fn) then
                begin
                  //     (  Read-only?),     FILE_ATTRIBUTE_NORMAL
                  SetFileAttributesW(@file_to^.Arr,FILE_ATTRIBUTE_NORMAL);
                  //     
                  Res:=DeleteFileW(@file_to^.Arr);
                end;//if not DeleteFileW...
              end;
            //     / 
            if Res
              then Result:=CMD_OK
              else
                begin
                  Result:=CMD_CANT_COPY_MOVE_FILE;
                  context.LastWindowsError:=GetLastError;
                end;
          end;//else
    end//if state=PARAM_OK
    else Result:=CMD_PARAM_ERROR;
  end//if state=PARAM_OK
  else Result:=CMD_PARAM_ERROR;
  UA_Destroy(PArrayHeader(file_from));
  UA_Destroy(PArrayHeader(file_to));
end;

function C_FILE_COPY(var context:TScriptContext):integer;
begin
 Result:=x_FILE(context,False);
end;

function C_FILE_MOVE(var context:TScriptContext):integer;
begin
 Result:=x_FILE(context,True);
end;

function C_FILE_DELETE(var context:TScriptContext):integer;
var fname:PUA_UnicodeString;
    force_delete:Cardinal;
    state:TParamState;
begin
  fname:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_OK then
    begin
      force_delete:=LoadParameter_DWORD(context,state,0);
      if state<>PARAM_INVALID then
        begin
          //     ,     FILE_ATTRIBUTE_NORMAL
          if force_delete<>0
            then SetFileAttributesW(@fname^.Arr,FILE_ATTRIBUTE_NORMAL);
          //   
          if DeleteFileW(@fname^.Arr)
            then Result:=CMD_OK
            else
              begin
                Result:=CMD_CANT_DELETE_FILE;
                context.LastWindowsError:=GetLastError;
              end;
        end//if state<>PARAM_INVALID
      else Result:=CMD_PARAM_ERROR;
    end
  else Result:=CMD_PARAM_ERROR;
  UA_Destroy(PArrayHeader(fname));
end;

function FIND_x_WND(var context:TScriptContext; wnd_code:Cardinal):integer;
var write_to,found_wnd,c_tid,t_tid:Cardinal;
    state:TParamState;
begin
 write_to:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   found_wnd:=0;
   case wnd_code of
    0: found_wnd:=GetForegroundWindow;
    1: begin
         found_wnd:=GetForegroundWindow;
         c_tid:=GetCurrentThreadId;
         t_tid:=GetWindowThreadProcessId(found_wnd,nil);
         if AttachThreadInput(t_tid,c_tid,True) then
          begin
           found_wnd:=GetFocus;
           context.LastWindowsError:=GetLastError;
           AttachThreadInput(t_tid,c_tid,False);
          end//if AttachThreadInput...
       end;
    2: found_wnd:=GetDesktopWindow;
   end;//case

   Result:=Variable_qStoreDWORD(context,write_to,found_wnd);
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_WND_FIND_FOREGROUND(var context:TScriptContext):integer;
begin
 Result:=FIND_x_WND(context,0);
end;

function C_WND_FIND_FOCUS(var context:TScriptContext):integer;
begin
 Result:=FIND_x_WND(context,1);
end;

function C_WND_GET_TEXT(var context:TScriptContext):integer;
var wnd,write_to,buf_len,res:Cardinal;
    Buffer:PUA_UnicodeString;
begin
 Result:=_hashReadvar_hashDE(context,wnd,True,write_to);
 if Result=CMD_OK then
  begin
    //    
    Result:=_SendAnyMessageW(wnd,WM_GETTEXTLENGTH,0,0,context.SendMsgTimeout,buf_len);
    if Result<>CMD_OK
      then buf_len:=$1000; //        -   4096 
    //  Unicode   
    Buffer:=UStr_Allocate(buf_len);
    //       
    Result:=_SendAnyMessageW(wnd,WM_GETTEXT,buf_len+1,TLParam(@Buffer^.Arr),context.SendMsgTimeout,res);
    if Result=CMD_OK then
      begin
        //            -    
        if Res<buf_len
          then UStr_Resize(Buffer,res);
        //       -  
        if Variable_AssignArray(context,write_to,PArrayHeader(Buffer),vtUnicodeString)<>CMD_OK
          then UA_Destroy(PArrayHeader(Buffer));
      end
    else
      begin
        //      -  ,    
        UA_Destroy(PArrayHeader(Buffer));
        if IsWindow(wnd) //   ,    ,    
           then Result:=Variable_AssignArray(context,write_to,@EmptyUnicodeString,vtUnicodeString);
      end;
  end;//if Result=CMD_OK
end;

function C_WND_CLOSE(var context:TScriptContext):integer;
var CloseIt:Cardinal;
    state:TParamState;
begin
 CloseIt:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK
  then Result:=ApplyOperationToWindows(context,CloseIt,woSimpleMessageCommand,Pointer(WM_CLOSE))
  else Result:=CMD_PARAM_ERROR;
end;

function C_WND_CLICK(var context:TScriptContext):integer;
var CloseIt:Cardinal;
    state:TParamState;
begin
 CloseIt:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK
  then Result:=ApplyOperationToWindows(context,CloseIt,woSimpleMessageCommand,Pointer(BM_CLICK))
  else Result:=CMD_PARAM_ERROR;
end;

function C_WND_GET_CLASS(var context:TScriptContext):integer;
const MAX_CLASS_LENGTH=1022;
var wnd,write_to,len:Cardinal;
    buffer:PUA_UnicodeString;
begin
 Result:=_hashReadvar_hashDE(context,wnd,True,write_to);
 if Result=CMD_OK then
  begin
   buffer:=UStr_Allocate(MAX_CLASS_LENGTH);
   len:=GetClassNameW(wnd,@buffer^.Arr,MAX_CLASS_LENGTH+1);
   context.LastWindowsError:=GetLastError;
   if len=0 then
    begin
      UA_Destroy(PArrayHeader(buffer));
      Result:=CMD_SOME_WINDOW_OPERATIONS_FAILED;
    end
   else
    begin
      UStr_Resize(buffer,len+1);
      Variable_AssignArray(context,write_to,PArrayHeader(buffer),vtUnicodeString);
    end;
  end;
end;

function C_WND_SET_TEXT(var context:TScriptContext):integer;
var wnd_var:Cardinal;
    wnd_txt:PUA_UnicodeString;
    state:TParamState;
begin
  wnd_var:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      wnd_txt:=LoadParameter_UnicodeString(context,state);
      case state of
        PARAM_DEFAULT,PARAM_END:
          wnd_txt:=@EmptyUnicodeString;
        PARAM_INVALID:
          begin
            Result:=CMD_PARAM_ERROR;
            Exit;
          end;
      end;//case
      Result:=ApplyOperationToWindows(context,wnd_var,woSetWndText,wnd_txt);
      //      Unicode-
      UA_Destroy(PArrayHeader(wnd_txt));
    end
 else Result:=CMD_PARAM_ERROR;
end;

function C_WND_GET_STATE(var context:TScriptContext):integer;
var wnd,wnd_state,write_to:Cardinal;
begin
 Result:=_hashReadvar_hashDE(context,wnd,True,write_to);
 if Result=CMD_OK then
  begin
   if IsIconic(wnd) then wnd_state:=1
    else wnd_state:=IfThen(IsZoomed(wnd),2,0);
   Result:=Variable_qStoreDWORD(context,write_to,wnd_state);
  end;
end;

function SET_WND_x(var context:TScriptContext; operation:TWindowOperation):Integer;
var wnd_var,wnd_state:Cardinal;
    state:TParamState;
begin
 wnd_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   wnd_state:=LoadParameter_DWORD(context,state,1);
   if state=PARAM_INVALID
    then Result:=CMD_PARAM_ERROR
    else Result:=ApplyOperationToWindows(context,wnd_var,operation,@wnd_state);
  end//if state=PARAM_OK
 else Result:=CMD_PARAM_ERROR;
end;

function C_WND_SET_STATE(var context:TScriptContext):integer;
begin
 Result:=SET_WND_x(context,woSetWndState);
end;

function IS_WND_x(var context:TScriptContext; fnc:TIsWNDx):integer;
var wnd,write_to:Cardinal;
begin
 Result:=_hashReadvar_hashDE(context,wnd,True,write_to);
 if Result=CMD_OK
  then Result:=Variable_qStoreDWORD(context,write_to,IfThen(fnc(wnd),1,0));
end;

function C_IS_WND_EXISTS(var context:TScriptContext):integer;
begin
 Result:=IS_WND_x(Context,@IsWindow);
end;

function C_IS_WND_VISIBLE(var context:TScriptContext):integer;
begin
 Result:=IS_WND_x(Context,@IsWindowVisible);
end;

function C_IS_WND_ACTIVE(var context:TScriptContext):integer;
begin
 Result:=IS_WND_x(Context,@IsWindowEnabled);
end;

function IsWindowTopmost(wnd:HWND):LongBool;stdcall;
begin
 result:=(GetWindowLongA(wnd,GWL_EXSTYLE) and WS_EX_TOPMOST)=WS_EX_TOPMOST;
end;

function C_IS_WND_TOPMOST(var context:TScriptContext):integer;
begin
 Result:=IS_WND_x(Context,@IsWindowTopmost);
end;

function C_WND_SET_VISIBILITY(var context:TScriptContext):integer;
begin
 Result:=SET_WND_x(context,woSetWndVisibility);
end;

function C_WND_SET_ACTIVITY(var context:TScriptContext):integer;
begin
 Result:=SET_WND_x(context,woSetWndActivity);
end;

function C_WND_SET_TOPMOST_ATTR(var context:TScriptContext):integer;
begin
 Result:=SET_WND_x(context,woSetWndTopmostAttr);
end;

function C_WND_FIND_DESKTOP(var context:TScriptContext):integer;
begin
 Result:=FIND_x_WND(context,2);
end;


function MOUSE_EMULATE_x(var context:TScriptContext;MouseEmulate:TMouseEmulate):integer;
label DoIt;
var i,clicktime:Cardinal;
    state:TParamState;
    Btns:array [0..5] of Cardinal;
begin
 clicktime:=context.KeyPressTime;
 FillChar(Btns,SizeOf(Btns),0);
 //  
 if LoadParameter_DWORD(context,state,0)<>0
  then begin Btns[0]:=MOUSEEVENTF_LEFTDOWN; Btns[1]:=MOUSEEVENTF_LEFTUP; end;
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 //  
 if LoadParameter_DWORD(context,state,0)<>0
  then begin Btns[2]:=MOUSEEVENTF_MIDDLEDOWN; Btns[3]:=MOUSEEVENTF_MIDDLEUP; end;
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 //  
 if LoadParameter_DWORD(context,state,0)<>0
  then begin Btns[4]:=MOUSEEVENTF_RIGHTDOWN; Btns[5]:=MOUSEEVENTF_RIGHTUP; end;
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 if MouseEmulate=meClick then
  begin
 //  
 clicktime:=LoadParameter_DWORD(context,state,clicktime);
 if state=PARAM_INVALID then begin Result:=CMD_PARAM_ERROR; Exit; end;
  end;//if MouseEmulate

DoIt:
 if MouseEmulate<>meUp   //      - ""  
  then for i:=0 to 2 do mouse_event(Btns[i+i],0,0,0,0);
 if MouseEmulate=meClick //    -      
  then Sleep(clicktime);
 if MouseEmulate<>meDown //      - ""  
  then for i:=0 to 2 do mouse_event(Btns[i+i+1],0,0,0,0);
 Result:=CMD_OK;
end;

function C_MOUSE_EMULATE_CLICK(var context:TScriptContext):integer;
begin
 Result:=MOUSE_EMULATE_x(context,meClick);
end;

{$WARNINGS OFF}
function C_WND_SEND_MESSAGE(var context:TScriptContext):integer;
label DoIt;
var MsgDescr:TCustomMessageDescr;
    state:TParamState;
    wnd_var,write_to:Cardinal;
    store_result:Boolean;
begin
with MsgDescr do
begin
 wParam:=0; lParam:=0; Timeout:=context.SendMsgTimeout;
 store_result:=False;
 //    / 
 wnd_var:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;
 //  
 MessageCode:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;
 // wParam
 wParam:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 // lParam
 lParam:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 // ,       
 write_to:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      store_result:=True;
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 // -
 Timeout:=LoadParameter_DWORD(context,state,Timeout);
 if state=PARAM_INVALID then begin Result:=CMD_PARAM_ERROR; Exit; end;

DoIt:
 Result:=CMD_OK;
 if store_result
  then begin
        ResVar:=Variable_GetAddress(context,write_to);
        if ResVar=nil then Result:=CMD_INVALID_VARIABLE_INDEX;
       end
  else ResVar:=nil;
 if Result=CMD_OK
  then Result:=ApplyOperationToWindows(context,wnd_var,@woSendAnyMessage,@MsgDescr);
end;//with
end;
{$WARNINGS ON}

function C_READ_B_BYTE(var context:TScriptContext):integer;
begin
 Result:=READ_xA(context,vtBinBlock);
end;

function C_STO_B_BYTE(var context:TScriptContext):integer;
begin
 Result:=STO_xA(context,vtBinBlock);
end;

function UStr_GetCurrentDirectory:PUA_UnicodeString;
var sz:Integer;
begin
  //      
  sz:=GetCurrentDirectoryW(0,nil);
  if sz=0
    then Result:=nil
    else
      begin
        //  Unicode-  
        Result:=UStr_Allocate(Max(sz-1,0));
        //      
        sz:=GetCurrentDirectoryW(sz,@Result^.Arr);
        //      
        if sz=0
          //   -
          then UA_Destroy(PArrayHeader(Result));
      end;
end;

function C_DIR_GET_CURRENT(var context:TScriptContext):integer;
var write_to:DWORD;
    state:TParamState;
    CurrentDir:PUA_UnicodeString;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      CurrentDir:=UStr_GetCurrentDirectory;
      context.LastWindowsError:=GetLastError;
      //      
      if CurrentDir=nil
        then Result:=CMD_CANT_GET_CURRENT_DIR
        else
          begin
            Result:=Variable_AssignArray(context,write_to,PArrayHeader(CurrentDir),vtUnicodeString);
            if Result<>CMD_OK
              //    ,    
              then UA_Destroy(PArrayHeader(CurrentDir));
          end;
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_DIR_SET_CURRENT(var context:TScriptContext):integer;
var new_dir:PUA_UnicodeString;
    state:TParamState;
begin
  new_dir:=LoadParameter_UnicodeString(context,state);
  if new_dir=nil
    then Result:=CMD_INVALID_DIRECTORY_NAME
    else
      begin
        if SetCurrentDirectoryW(@new_dir^.Arr)
          then Result:=CMD_OK
          else
            begin
              Result:=CMD_INVALID_DIRECTORY_NAME;
              context.LastWindowsError:=GetLastError;
            end;
   end;//if new_dir=nil
   UA_Destroy(PArrayHeader(new_dir));
end;

function x_THREAD(var context:TScriptContext; op:Cardinal):integer;
label DoIt;
var th_var,write_to,counter:Cardinal;
    store_it:Boolean;
    state:TParamState;
begin
 store_it:=False;
 th_var:=LoadParameter_DWORD(context,state,context.LastStartedProcess.hThread);
 case state of
  PARAM_OK:  begin
              Result:=Variable_qLoadDWORD(context,th_var,th_var);
              if Result<>CMD_OK then Exit;
             end;
  PARAM_END: goto DoIt;
  PARAM_INVALID:
             begin
              Result:=CMD_PARAM_ERROR;
              Exit;
             end;
 end;//case

 write_to:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      store_it:=True;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

DoIt:
  case op of
   0:     counter:=SuspendThread(th_var);
   else   counter:=ResumeThread(th_var);
  end;//case
{$WARNINGS OFF}
  if counter=_MINUS_ONE
   then Result:=CMD_THREAD_SUSPEND_RESUME_FAILED
   else begin
         if store_it
          then Result:=Variable_qStoreDWORD(context,write_to,counter)
          else Result:=CMD_OK;
        end;
end;
{$WARNINGS ON}

function C_THREAD_SUSPEND(var context:TScriptContext):integer;
begin
 Result:=x_THREAD(context,0);
end;

function C_THREAD_RESUME(var context:TScriptContext):integer;
begin
 Result:=x_THREAD(context,1);
end;

function C_WND_GET_PROC_TH(var context:TScriptContext):integer;
var wnd_var,pid_var,tid_var,pid,tid:Cardinal;
    store_pid,store_tid:Boolean;
    state:TParamState;
begin
 store_pid:=False;
 store_tid:=False;
 wnd_var:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;

 pid_var:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK: store_pid:=True;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 tid_var:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK: store_tid:=True;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 Result:=VariableOrArray_qLoadDWORD(context,wnd_var,wnd_var);
 if Result=CMD_OK then
  begin
   tid:=GetWindowThreadProcessId(wnd_var,pid);
   if store_pid then Result:=Variable_qStoreDWORD(context,pid_var,pid);
   if (Result=CMD_OK) and store_tid then Result:=Variable_qStoreDWORD(context,tid_var,tid);
  end//if Result=CMD_OK
 else Result:=CMD_NOT_WND_LIST;
end;

const  myFILE_READ_ATTRIBUTES=$80;
       myFILE_READ_DATA=1;
       myFILE_READ_EA=8;
       mySTANDARD_RIGHTS_READ=$20000;

       myFILE_WRITE_ATTRIBUTES=$100;
       myFILE_WRITE_DATA=2;
       myFILE_WRITE_EA=$10;
       mySTANDARD_RIGHTS_WRITE=$20000;

       mySYNCHRONIZE=$100000;


function C_FILE_OPEN(var context:TScriptContext):integer;
label DoIt,Finish;
var fname:PUA_UnicodeString;
    hfile,write_to,dispos,sharing,attrib,access:Cardinal;
    state:TParamState;
    pwrite_to:PNeoS0MVariable;
begin
  sharing:=FILE_SHARE_READ;
  attrib:=FILE_ATTRIBUTE_NORMAL;
// access:=myFILE_READ_ATTRIBUTES or myFILE_READ_DATA or myFILE_READ_EA or mySTANDARD_RIGHTS_READ
//         or myFILE_WRITE_ATTRIBUTES or myFILE_WRITE_DATA or myFILE_WRITE_EA
//         or mySYNCHRONIZE;
  access:=GENERIC_READ or GENERIC_WRITE;

  //   -  
  fname:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

  //   -   
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
  begin
    Result:=CMD_PARAM_ERROR;
    goto Finish;
  end;

  //   -  / 
  dispos:=LoadParameter_DWORD(context,state,OPEN_EXISTING);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;//case

  //   -   
  sharing:=LoadParameter_DWORD(context,state,FILE_SHARE_READ);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;//case

  //   -  
  attrib:=LoadParameter_DWORD(context,state,FILE_ATTRIBUTE_NORMAL);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;//case

  //   -  
  access:=LoadParameter_DWORD(context,state,GENERIC_READ or GENERIC_WRITE);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;

DoIt:
  pwrite_to:=Variable_GetAddress(context,write_to);
  if pwrite_to=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
  else
    begin
      hfile:=CreateFileW(@fname^.Arr,access,sharing,context.SecurityAttributes,dispos,attrib,0);
      Variable_StoreDWORD(pwrite_to,hfile);
      if hfile=INVALID_HANDLE_VALUE then
      begin
        context.LastWindowsError:=GetLastError;
        Result:=CMD_CANT_OPEN_FILE;
      end
      else Result:=CMD_OK;
    end;
Finish:
  UA_Destroy(PArrayHeader(fname));
end;

function C_CLOSE_OBJECT(var context:TScriptContext):integer;
var handle_var:Cardinal;
    state:TParamState;
begin
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   Result:=Variable_qLoadDWORD(context,handle_var,handle_var);
   if Result=CMD_OK then
    begin
     if CloseHandle(handle_var)
      then Result:=CMD_OK
      else
       begin
        context.LastWindowsError:=GetLastError;
        Result:=CMD_INVALID_HANDLE;
       end;
    end;
  end
 else Result:=CMD_PARAM_ERROR;
end;

procedure SetFilePointerInt64(hfile:Cardinal; offset:Int64; method:Cardinal);
var lo_dword,hi_dword:Cardinal;
begin
 Int64ToDWORDs(offset,hi_dword,lo_dword);
 SetFilePointer(hfile,lo_dword,@hi_dword,method);
end;

function C_FILE_SET_POS(var context:TScriptContext):integer;
label DoIt;
var handle_var,seek_method:Cardinal;
    new_pos:Int64;
    state:TParamState;
begin
 seek_method:=FILE_BEGIN;
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   new_pos:=LoadParameter_INTEGER(context,state,0);
   case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      Exit;
                    end;
   end;

   seek_method:=LoadParameter_DWORD(context,state,FILE_BEGIN);
   if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

DoIt:
  Result:=Variable_qLoadDWORD(context,handle_var,handle_var);
  if Result=CMD_OK then
   begin
    SetFilePointerInt64(handle_var,new_pos,seek_method);
    context.LastWindowsError:=GetLastError;
   end;
  end//if state=PARAM_OK
 else Result:=CMD_PARAM_ERROR;
end;

function C_FILE_WRITE_BYTE(var context:TScriptContext):integer;
var handle_var,written:Cardinal;
    byte_val:Byte;
    state:TParamState;
begin
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   byte_val:=LoadParameter_DWORD(context,state,0);
   if state=PARAM_INVALID
    then Result:=CMD_PARAM_ERROR
    else
     begin
      Result:=Variable_qLoadDWORD(context,handle_var,handle_var);
      if Result=CMD_OK then
       begin
        if WriteFile(handle_var,byte_val,1,written,nil)
         then Result:=CMD_OK
         else Result:=CMD_WRITE_FILE_FAILED;
        context.LastWindowsError:=GetLastError;
       end;//if Result=CMD_OK
     end;
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_FILE_WRITE_B(var context:TScriptContext):integer;
var handle_var,len,written:Cardinal;
    BinBlock:PUA_BinaryBlock;
    state:TParamState;
begin
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   BinBlock:=LoadParameter_BinBlock(context,state);
   if state=PARAM_INVALID then Result:=CMD_PARAM_ERROR
    else
     begin
      Result:=Variable_qLoadDWORD(context,handle_var,handle_var);
      if (Result=CMD_OK) and (BinBlock<>nil) then
      begin
        len:=BB_Length(BinBlock);
        if WriteFile(handle_var,BinBlock^.Arr,len,written,nil)
         then Result:=CMD_OK
         else Result:=CMD_WRITE_FILE_FAILED;
        context.LastWindowsError:=GetLastError;
      end;//if (Result=CMD_OK) and (BinBlock<>nil)
     end;//else
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_FILE_WRITE_VAR(var context:TScriptContext):integer;
const CRLF:WORD=$0A0D;
      UNICODE_CRLF:DWORD=$000A000D;
var handle_var,var_idx,buf_size,written,data_len:Cardinal;
    var_addr:PNeoS0MVariable;
    buf:Pointer;
    i:Integer;
begin
 Result:=_hashReadvar_hashDE(context,handle_var,False,var_idx);
 if Result=CMD_OK then
  begin
   var_addr:=Variable_GetAddress(context,var_idx);
   if var_addr=nil then Result:=CMD_INVALID_VARIABLE_INDEX
    else
     begin
       with var_addr^ do
        begin
        buf:=nil;
        buf_size:=0;
        case VarType of
         vtDWORD:    begin
                      buf:=@AsDWORD;
                      buf_size:=SizeOf(AsDWORD);
                     end;
         vtInteger:  begin
                      buf:=@AsInteger;
                      buf_size:=SizeOf(AsInteger);
                     end;
         vtExtended: begin
                      buf:=@AsExtended;
                      buf_size:=SizeOf(AsExtended);
                     end;
         vtBinBlock,vtDWORDArray,vtIntArray,vtExtArray,vtUnicodeString:
                     begin
                      if UA<>nil then
                       begin
                        buf:=@(PUA_BinaryBlock(UA)^.Arr);
                        buf_size:=_GetArrayLength(var_addr)*UA^.ElemSize;
                       end;
                     end;
          { DONE :         ,    }
         vtBinBlockList:
                     begin
                      Result:=CMD_OK;
                      for i:=0 to UA^.ElemCount-1 do
                        begin
                          //    ,  ,   CR/LF
                          if i<>0 then
                            begin
                              if not WriteFile(handle_var,CRLF,SizeOf(CRLF),written,nil)
                                then begin Result:=CMD_WRITE_FILE_FAILED; Break; end;
                              context.LastWindowsError:=GetLastError;
                            end;//if i<>0
                          buf:=Variable_GetBBLItem(context,var_idx,i,data_len);
                          if data_len>0 then //   >0,     
                            begin
                              if not WriteFile(handle_var,buf^,data_len,written,nil)
                                then begin Result:=CMD_WRITE_FILE_FAILED; Break; end;
                              context.LastWindowsError:=GetLastError;
                            end;//if data_len>0
                        end;//for
                     end;
         { DONE :     Unicode-,    }
         vtUnicodeStringList:
                     begin
                      Result:=CMD_OK;
                      //    
                      for i:=0 to UA^.ElemCount-1 do
                        begin
                          //   ,  ,   CR/LF
                          if i<>0 then
                            begin
                              if not WriteFile(handle_var,UNICODE_CRLF,SizeOf(UNICODE_CRLF),written,nil) then
                                begin
                                  Result:=CMD_WRITE_FILE_FAILED;
                                  Break;
                                end
                            end;//if i<>0
                          //    
                          buf:=Variable_GetUStrLItem(context,var_idx,i,data_len);
                          if buf<>nil then
                            begin
                              if data_len>0 then //   >0,     
                                begin
                                  if not WriteFile(handle_var,buf^,data_len shl 1,written,nil) then
                                    begin
                                      Result:=CMD_WRITE_FILE_FAILED;
                                      Break;
                                    end;
                                end;//if data_len>0
                            end//if buf<>nil
                          else Break;
                        end;//for
                      context.LastWindowsError:=GetLastError;
                     end
         else Result:=CMD_TYPECAST_IMPOSSIBLE;
        end;//case
        if (Result=CMD_OK) and (buf<>nil) and (VarType<>vtBinBlockList) and (VarType<>vtUnicodeStringList) then
         begin
          if WriteFile(handle_var,buf^,buf_size,written,nil)
           then Result:=CMD_OK
           else Result:=CMD_WRITE_FILE_FAILED;
          context.LastWindowsError:=GetLastError;
         end;//(Result=CMD_OK) and (buf<>nil)
        end;//with
     end;//else
 end//Result=CMD_OK
end;

{$WARNINGS OFF}
function x_x_BYTES(var context:TScriptContext; operation:Cardinal):integer;
var handle_var,store_var,param_count,readed:Cardinal;
    NUIreaded:NativeUInt;
    state:TParamState;
    NextCommand:Pointer;
    pstore_var:PNeoS0MVariable;
    cur_pos,new_pos:Int64;
    FirstStep:Boolean;
    byte_val,readed_byte:Byte;
    Counter:Cardinal;
    check_result:Cardinal;
begin
 Result:=CMD_OK;
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   //   -   ,      
   //     (  -   )
   if Odd(operation) then
    begin
     store_var:=LoadParameter_DWORD(context,state,0);
     if state=PARAM_OK then
      begin
       pstore_var:=Variable_GetAddress(context,store_var);
       if pstore_var=nil then Result:=CMD_INVALID_VARIABLE_INDEX;
      end
     else Result:=CMD_PARAM_ERROR;
    end;

   check_result:=1;
   param_count:=GetParamCount(context.IP,NextCommand);
   if Result=CMD_OK then Result:=Variable_qLoadDWORD(context,handle_var,handle_var);
   if Result=CMD_OK then
    begin
     cur_pos:=0;
     if Odd(param_count) then Result:=CMD_INVALID_PATCH_PARAM_COUNT
      else
       begin
         FirstStep:=True;
         param_count:=param_count shr 1; //     2 -   
         //       "-"
         for counter:=1 to param_count do
          begin
            //  
            new_pos:=LoadParameter_INTEGER(context,state,cur_pos);
            if state=PARAM_INVALID then begin Result:=CMD_PARAM_ERROR; Break; end
             else
              begin
                if (operation=0) or (operation=1) then
                //      -       
                 begin
                    //       ,
                    //       ,
                    //       
                    if (new_pos<>cur_pos) or FirstStep then
                     begin
                       SetFilePointerInt64(handle_var,new_pos,FILE_BEGIN);
                       cur_pos:=new_pos+1;
                       FirstStep:=False;
                     end;//if (new_pos<>cur_pos) or FirstStep
                 end//if (operation=0) or ...
                //       -   
                else cur_pos:=new_pos;
              end;//else

            //  ,   /    
            byte_val:=LoadParameter_DWORD(context,state,0);
            if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Break; end
             else
              begin
               case operation of
                0: //    
                 begin
                   if not WriteFile(handle_var,byte_val,SizeOf(byte_val),readed,nil)
                    then begin Result:=CMD_WRITE_FILE_FAILED; Break; end;
                 end;//0:
                1: //    
                 begin
                  ReadFile(handle_var,readed_byte,SizeOf(readed_byte),readed,nil);
                  context.LastWindowsError:=GetLastError;
                  if readed=SizeOf(readed_byte) then //   
                    begin
                     if readed_byte<>byte_val
                     //       ,  ,
                     //  False (0)    , ..    
                      then begin check_result:=0; Break; end;
                    end
                   else begin Result:=CMD_READ_FILE_FAILED; Break; end;
                 end;//1:
                2: //     
                 begin
                  if not WriteProcessMemory(handle_var,Pointer(cur_pos and $FFFFFFFF),@byte_val,SizeOf(byte_val),NUIreaded)
                   then Result:=CMD_CANT_WRITE_PROCCESS_MEM;
                  //   1    ,  
                  //       . 
                  Inc(cur_pos);
                 end;//2:
                3: //     
                 begin
                  ReadProcessMemory(handle_var,Pointer(cur_pos and $FFFFFFFF),@readed_byte,SizeOf(readed_byte),NUIreaded);
                  context.LastWindowsError:=GetLastError;
                  if readed=SizeOf(readed_byte) then //   
                    begin
                     if readed_byte<>byte_val then
                     //       ,  ,
                     //  False (0)    , ..    
                      begin
                        check_result:=0;
                        Break;
                      end;
                    end
                   else begin Result:=CMD_CANT_READ_PROCCESS_MEM; Break; end;
                  //   1    ,  
                  //       . 
                  Inc(cur_pos);
                 end;//3:
               end;//case
              end;
          end//for
       end;//else
    end;//if Result=CMD_OK
    context.IP:=NextCommand;
    if Odd(operation) and (pstore_var<>nil)
     then Variable_StoreDWORD(pstore_var,check_result);
  end//if state=PARAM_OK
 else Result:=CMD_PARAM_ERROR;
end;
{$WARNINGS ON}

function C_FILE_PATCH_BYTES(var context:TScriptContext):integer;
begin
 Result:=x_x_BYTES(context,0);
end;

function C_FILE_CHECK_BYTES(var context:TScriptContext):integer;
begin
 Result:=x_x_BYTES(context,1);
end;

function C_FILE_GET_SIZE(var context:TScriptContext):integer;
var fhandle,write_to:Cardinal;
    hi_dword,lo_dword:Cardinal;
begin
 Result:=_hashReadvar_hashDE(context,fhandle,False,write_to);
 if Result=CMD_OK then
  begin
   lo_dword:=GetFileSize(fhandle,@hi_dword);
   context.LastWindowsError:=GetLastError;
   Result:=Variable_qStoreINTEGER(context,write_to,DWORDsToInt64(hi_dword,lo_dword))
  end
end;

function C_FILE_SET_SIZE(var context:TScriptContext):integer;
var handle_var:Cardinal;
    new_size:Int64;
    state:TParamState;
begin
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK
  then result:=CMD_PARAM_ERROR
  else
   begin
    new_size:=LoadParameter_INTEGER(context,state,0);
    if state=PARAM_INVALID
     then Result:=CMD_PARAM_ERROR
     else
      begin
       Result:=Variable_qLoadDWORD(context,handle_var,handle_var);
       if Result=CMD_OK then
        begin
         //  :          
         SetFilePointerInt64(handle_var,new_size,FILE_BEGIN);
         SetEndOfFile(handle_var);
        end;//if Result=CMD_OK
      end;
   end;//Result=CMD_OK
end;

function FILE_READ_x(var context:TScriptContext; VarType:TVarType):integer;
var fhandle,write_to,size,readed:Cardinal;
    byte_val:Byte;
    DWORD_val:Cardinal;
    INT_val:Int64;
    EXT_val:Extended;
    buf:Pointer;
begin
 Result:=_hashReadvar_hashDE(context,fhandle,False,write_to);
 if Result=CMD_OK then
  begin
    case VarType of
     vtDWORD:         begin buf:=@DWORD_val; size:=SizeOf(DWORD_val); end;
     vtInteger:       begin buf:=@INT_val; size:=SizeOf(INT_val); end;
     vtExtended:      begin buf:=@EXT_val; size:=SizeOf(EXT_val); end;
     else begin buf:=@byte_val; size:=SizeOf(byte_val); end;
    end;//case

    ReadFile(fhandle,buf^,size,readed,nil);
    context.LastWindowsError:=GetLastError;
    if readed=size then
     begin
      case VarType of
       vtDWORD:         Result:=Variable_qStoreDWORD(context,write_to,DWORD_val);
       vtInteger:       Result:=Variable_qStoreINTEGER(context,write_to,INT_val);
       vtExtended:      Result:=Variable_qStoreFLOAT(context,write_to,EXT_val);
       else Result:=Variable_qStoreDWORD(context,write_to,byte_val);
      end;//case
     end//if readed=size
    else Result:=CMD_READ_FILE_FAILED;
   end//if Result=CMD_OK
  else Result:=CMD_READ_FILE_FAILED
end;

function C_FILE_READ_BYTE(var context:TScriptContext):integer;
begin
 Result:=FILE_READ_x(context,vtUninitialized); //      
end;

function C_FILE_READ_D(var context:TScriptContext):integer;
begin
 Result:=FILE_READ_x(context,vtDWORD);
end;

function C_FILE_READ_I(var context:TScriptContext):integer;
begin
 Result:=FILE_READ_x(context,vtInteger);
end;

function C_FILE_READ_F(var context:TScriptContext):integer;
begin
 Result:=FILE_READ_x(context,vtExtended);
end;

function x_OPEN(var context:TScriptContext;IsProcess:Boolean):integer;
label DoIt;
var x_id,write_to,access_attr:Cardinal;
    state:TParamState;
begin
 if IsProcess
  then access_attr:=PROCESS_QUERY_INFORMATION or PROCESS_SET_INFORMATION or PROCESS_TERMINATE
                    or PROCESS_VM_OPERATION or PROCESS_VM_READ or PROCESS_VM_WRITE
  else access_attr:=THREAD_SET_INFORMATION or THREAD_TERMINATE or THREAD_SUSPEND_RESUME
                    or THREAD_QUERY_INFORMATION;
 x_id:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   //   ,  
   write_to:=LoadParameter_DWORD(context,state,x_id);
   case state of
    PARAM_END:     goto DoIt;
    PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
   end;//case
   //   ,    /
   access_attr:=LoadParameter_DWORD(context,state,access_attr);
   if state=PARAM_INVALID then begin Result:=CMD_PARAM_ERROR; Exit; end;

DoIt:
   Result:=Variable_qLoadDWORD(context,x_id,x_id);
   if Result=CMD_OK then // PID/TID   -  
    begin
     if IsProcess then
       begin
        with context.LastStartedProcess do
         begin
          dwProcessId:=x_id;
          x_id:=OpenProcess(access_attr,False,x_id);
          hProcess:=x_id;
          context.LastWindowsError:=GetLastError;
         end;//with
        if x_id=0 then Result:=CMD_CANT_OPEN_PROCESS;
       end//if IsProcess
      else
       begin
        with context.LastStartedProcess do
         begin
          dwThreadId:=x_id;
          x_id:=OpenThread(access_attr,False,x_id);
          hThread:=x_id;
          context.LastWindowsError:=GetLastError;
         end;//with
        if x_id=0 then Result:=CMD_CANT_OPEN_THREAD;
       end;
     if Result=CMD_OK then Result:=Variable_qStoreDWORD(context,write_to,x_id);
    end;//if Result=CMD_OK
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_PROCESS_OPEN(var context:TScriptContext):integer;
begin
 Result:=x_OPEN(context,True);
end;

function C_THREAD_OPEN(var context:TScriptContext):integer;
begin
 Result:=x_OPEN(context,False);
end;

function IsDirExists(const Directory:PWideChar; FollowLink:Boolean):Boolean;
const INVALID_FILE_ATTRIBUTES=$FFFFFFFF;
var
  Code: Cardinal;
  Handle: THandle;
begin
  Result:=False;
  //    ,    ,   /
  Code:=GetFileAttributesW(Directory);
  if Code<>INVALID_FILE_ATTRIBUTES then
  begin
    //      FILE_ATTRIBUTE_DIRECTORY    FILE_ATTRIBUTE_REPARSE_POINT -     
    if (Code and FILE_ATTRIBUTE_REPARSE_POINT)=0
      then Result:=(Code and FILE_ATTRIBUTE_DIRECTORY)<>0
    else
    begin
      //     FILE_ATTRIBUTE_REPARSE_POINT
      if FollowLink then
      begin
        Handle:=CreateFileW(Directory,GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS,0);
        if Handle<>INVALID_HANDLE_VALUE then
        begin
          CloseHandle(Handle);
          Result:=(Code and FILE_ATTRIBUTE_DIRECTORY)<>0;
        end;
      end//if FollowLink
      else if (Code and FILE_ATTRIBUTE_DIRECTORY)<>0
            then Result:=True
            else
              begin
                Handle:=CreateFileW(Directory, GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, 0);
                if Handle<>INVALID_HANDLE_VALUE
                  then CloseHandle(Handle)
                  else Result:=True;
              end;//else
    end;//else
  end;
end;

function IS_FILE_DIR_EXISTS(var context:TScriptContext;CheckFile:Boolean):integer;
label DontSearch;

var fname:PUA_UnicodeString;
    f_h,write_to,res:Cardinal;
    state:TParamState;
    f_d:WIN32_FIND_DATAW;
    fname_char:PWideChar;
begin
  Res:=0;
  Result:=CMD_PARAM_ERROR;
  fname:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_OK then
    begin
      write_to:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_OK then
        begin
          if fname<>nil then //    .     NIL
            begin
              fname_char:=@fname^.Arr;
              //      *  ?
              while True do
              case fname_char^ of
                #0:   Break;
                '?','*':
                      goto DontSearch;
                else Inc(fname_char)
              end;//case
              //   
              if CheckFile then //    
                begin
                  f_h:=Windows.FindFirstFileW(@fname^.Arr,f_d);
                  if f_h<>INVALID_HANDLE_VALUE then
                    begin
                      //        -  
                      if (f_d.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY)=0 then Res:=1;
                      Windows.FindClose(f_h);
                    end//if f_h<>...
                end// if CheckFile
              //    
              else Res:=Ord(IsDirExists(@fname^.Arr,Context.IgnoreSymlinks=0));
        end;//if fname<>nil
DontSearch:
        Result:=Variable_qStoreDWORD(context,write_to,res);
        end//state=PARAM_OK
    end;//state=PARAM_OK
  UA_Destroy(PArrayHeader(fname));
end;

function C_IS_FILE_EXISTS(var context:TScriptContext):integer;
begin
  Result:=IS_FILE_DIR_EXISTS(context,True);
end;

function MEM_WRITE_x(var context:TScriptContext; val_type:TParamType):integer;
var handle,offset,len,DWORD_val:Cardinal;
    written:NativeUInt;
    state:TParamState;
    INT_val:Int64;
    EXT_val:Extended;
    start_ofs:Pointer;
    byte_val:Byte;
    Bin_val:PUA_BinaryBlock;
    UStr_val:PUA_UnicodeString;
begin
 Result:=CMD_PARAM_ERROR;
 handle:=LoadParameter_DWORD(context,state,0);
 UStr_val:=nil;
 if state=PARAM_OK then
  begin
   offset:=LoadParameter_DWORD(context,state,0);
   if state=PARAM_OK then
    begin
     case val_type of
      ptDefault:  begin
                   byte_val:=LoadParameter_DWORD(context,state,0);
                   start_ofs:=@byte_val; len:=SizeOf(byte_val);
                  end;
      ptWORD:     begin
                   DWORD_val:=LoadParameter_DWORD(context,state,0);
                   start_ofs:=@DWORD_val; len:=SizeOf(Word);
                  end;
      ptDWORD:    begin
                   DWORD_val:=LoadParameter_DWORD(context,state,0);
                   start_ofs:=@DWORD_val; len:=SizeOf(DWORD_val);
                  end;
      ptINTEGER:  begin
                   INT_val:=LoadParameter_DWORD(context,state,0);
                   start_ofs:=@INT_val; len:=SizeOf(INT_val);
                  end;
      ptExtended: begin
                   EXT_val:=LoadParameter_DWORD(context,state,0);
                   start_ofs:=@EXT_val; len:=SizeOf(EXT_val);
                  end;
      ptBinBlock: begin
                    Bin_val:=LoadParameter_BinBlock(context,state);
                    if Bin_val=nil //  ,  state=PARAM_DEFAULT, PARAM_END  PARAM_INVALID.    
                      then Bin_val:=@EmptyBinaryBlock;
                    start_ofs:=@Bin_val^.Arr;
                    len:=BB_Length(Bin_val);
                  end;
      ptUnicodeString:
                  begin
                    UStr_val:=LoadParameter_UnicodeString(context,state);
                    if UStr_val=nil //  ,  state=PARAM_DEFAULT, PARAM_END  PARAM_INVALID.    
                      then UStr_val:=@EmptyUnicodeString;
                    start_ofs:=@UStr_val^.Arr;
                    len:=UStr_Length(UStr_val) shl 1;
                  end;
      //     - 
      else Exit;
     end;//case

     if state<>PARAM_INVALID then //    
      begin
        Result:=Variable_qLoadDWORD(context,handle,handle);
        if Result=CMD_OK then // ,  ,  -      
          begin
            WriteProcessMemory(handle,Pointer(offset),start_ofs,len,written);
            context.LastWindowsError:=GetLastError;
            if written<>len
              then Result:=CMD_CANT_WRITE_PROCCESS_MEM;
          end;//if Result=CMD_OK
        //    Unicode (   nil)
        UA_Destroy(PArrayHeader(UStr_val));
      end;//state<>PARAM_INVALID
    end//state=PARAM_OK
  end//state=PARAM_OK
end;

function C_MEM_WRITE_BYTE(var context:TScriptContext):integer;
begin
 Result:=MEM_WRITE_x(context,ptDefault);
end;

function C_MEM_WRITE_B(var context:TScriptContext):integer;
begin
 Result:=MEM_WRITE_x(context,ptBinBlock);
end;

function C_MEM_WRITE_D(var context:TScriptContext):integer;
begin
 Result:=MEM_WRITE_x(context,ptDWORD);
end;

function C_MEM_WRITE_I(var context:TScriptContext):integer;
begin
 Result:=MEM_WRITE_x(context,ptInteger);
end;

function C_MEM_WRITE_F(var context:TScriptContext):integer;
begin
 Result:=MEM_WRITE_x(context,ptExtended);
end;

function C_MEM_PATCH_BYTES(var context:TScriptContext):integer;
begin
 Result:=x_x_BYTES(context,2);
end;

function C_MEM_CHECK_BYTES(var context:TScriptContext):integer;
begin
 Result:=x_x_BYTES(context,3);
end;

function MEM_READ_x(var context:TScriptContext; pt:TParamType):integer;
var buffer:array [0..9] of Byte;
    handle,offset,write_to,data_size:Cardinal;
    readed:NativeUInt;
    state:TParamState;
    pbuf:Pointer;
begin
 Result:=CMD_PARAM_ERROR;
 handle:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   offset:=LoadParameter_DWORD(context,state,0);
   if state=PARAM_OK then
    begin
     write_to:=LoadParameter_DWORD(context,state,handle);
     if state=PARAM_OK then
      begin
       Result:=Variable_qLoadDWORD(context,handle,handle);
       if Result=CMD_OK then
        begin
         //  ,   
         data_size:=IfThen(pt=ptDefault,1,ParamTypeSize[pt]);
         pbuf:=@buffer;
         //      
         if ReadProcessMemory(handle,Pointer(offset),pbuf,data_size,readed) then
          begin
           case pt of
            ptDefault:  Result:=Variable_qStoreDWORD(context,write_to,PByte(pbuf)^);
            ptDWORD:    Result:=Variable_qStoreDWORD(context,write_to,PCardinal(pbuf)^);
            ptInteger:  Result:=Variable_qStoreINTEGER(context,write_to,PInt64(pbuf)^);
            ptExtended: Result:=Variable_qStoreFLOAT(context,write_to,PExtended(pbuf)^);
           end;//case
          end//if ReadProcessMemory...
         else Result:=CMD_CANT_READ_PROCCESS_MEM;
         context.LastWindowsError:=GetLastError;
        end;//if Result=CMD_OK
      end;//state=PARAM_OK
    end;//state=PARAM_OK
  end;//state=PARAM_OK
end;

function C_MEM_READ_BYTE(var context:TScriptContext):integer;
begin
 Result:=MEM_READ_x(context,ptDefault); // ptDefault ,    
end;

function C_MEM_READ_D(var context:TScriptContext):integer;
begin
 Result:=MEM_READ_x(context,ptDWORD); // ptDefault ,    
end;

function C_MEM_READ_I(var context:TScriptContext):integer;
begin
 Result:=MEM_READ_x(context,ptInteger); // ptDefault ,    
end;

function C_MEM_READ_F(var context:TScriptContext):integer;
begin
 Result:=MEM_READ_x(context,ptExtended); // ptDefault ,    
end;

function IS_x_EXISTS (var context:TScriptContext; IsProcess:Boolean):integer;
var handle,write_to,res,exitcode:Cardinal;
    b:Boolean;
begin
 Result:=_hashReadvar_hashDE(context,handle,False,write_to);
 if Result=CMD_OK then
  begin
   res:=0;
   if IsProcess
    then b:=GetExitCodeProcess(handle,exitcode)
    else b:=GetExitCodeThread(handle,exitcode);
   if b then begin if exitcode=STILL_ACTIVE then res:=1; end;
   Result:=Variable_qStoreDWORD(context,write_to,res);
  end;
end;

function C_IS_PROCESS_EXISTS(var context:TScriptContext):integer;
begin
 Result:=IS_x_EXISTS(context,True);
end;

function C_IS_THREAD_EXISTS(var context:TScriptContext):integer;
begin
 Result:=IS_x_EXISTS(context,False);
end;

function DATE_GET_x(var context:TScriptContext;IsLocal:Boolean):integer;
var write_to:Cardinal;
    st:SYSTEMTIME;
    ft:FILETIME;
    state:TParamState;
begin
 write_to:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   if IsLocal
    then GetLocalTime(st)
    else GetSystemTime(st);
   SystemTimeToFileTime(st,ft);
   Result:=Variable_qStoreINTEGER(context,write_to,PInt64(@ft)^);
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_DATE_GET(var context:TScriptContext):integer;
begin
 Result:=DATE_GET_x(context,True);
end;

function C_DATE_GET_SYSTEM(var context:TScriptContext):integer;
begin
 Result:=DATE_GET_x(context,False);
end;

function C_DATE_xCODE(var context:TScriptContext; IsDecode:Boolean):integer;
label DoIt;
var sYear,sMonth,sDay,sHour,sMin,sSec,sDSec:Boolean;
    read_from,w_Year,w_Month,w_Day,w_Hour,w_Min,w_Sec,w_DSec:Cardinal;
    res:Int64;
    ft:FILETIME;
    st:SYSTEMTIME;
    state:TParamState;
begin
 sYear:=False; sMonth:=False; sDay:=False;
 sHour:=False; sMin:=False; sSec:=False; sDSec:=False;
 // ,        
 read_from:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;

 // - 
 w_Day:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      sDay:=True;
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 // - 
 w_Month:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      sMonth:=True;
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 // - 
 w_Year:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      sYear:=True;
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 // - 
 w_Hour:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      sHour:=True;
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 // - 
 w_Min:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      sMin:=True;
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 // - 
 w_Sec:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      sSec:=True;
  PARAM_END:     goto DoIt;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

 // - 
 w_DSec:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      sDSec:=True;
  PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
{$WARNINGS OFF}
DoIt:
  if IsDecode then //        
   begin
    Result:=Variable_qLoadINTEGER(context,read_from,res);
    if Result=CMD_OK then //   
     begin
      Move(res,ft,SizeOf(ft));
      FileTimeToSystemTime(ft,st);
      //   -     
      with st do
       begin
        if sDay then Result:=Variable_qStoreDWORD(context,w_Day,wDay);
        if sMonth and (Result=CMD_OK) then Result:=Variable_qStoreDWORD(context,w_Month,wMonth);
        if sYear  and (Result=CMD_OK) then Result:=Variable_qStoreDWORD(context,w_Year,wYear);
        if sHour  and (Result=CMD_OK) then Result:=Variable_qStoreDWORD(context,w_Hour,wHour);
        if sMin   and (Result=CMD_OK) then Result:=Variable_qStoreDWORD(context,w_Min,wMinute);
        if sSec   and (Result=CMD_OK) then Result:=Variable_qStoreDWORD(context,w_Sec,wSecond);
        if sDSec  and (Result=CMD_OK) then Result:=Variable_qStoreDWORD(context,w_DSec,wMilliseconds);
       end;//with
     end;//if Result=CMD_OK
   end
  else //       
   begin
    GetLocalTime(st);
    with st do
     begin
      if sDay   then wDay:=w_Day;
      if sMonth then wMonth:=w_Month;
      if sYear  then wYear:=w_Year;
      if sHour  then wHour:=w_Hour;
      if sMin   then wMinute:=w_Min;
      if sSec   then wSecond:=w_Sec;
      if sDSec  then wMilliseconds:=w_DSec;
     end;//with
    SystemTimeToFileTime(st,ft);
    Result:=Variable_qStoreINTEGER(context,read_from,PInt64(@ft)^);
   end;
end;
{$WARNINGS ON}

function C_DATE_DECODE(var context:TScriptContext):integer;
begin
 Result:=C_DATE_xCODE(context,True);
end;

function C_DATE_ENCODE(var context:TScriptContext):integer;
begin
 Result:=C_DATE_xCODE(context,False);
end;

function C_CALL(var context:TScriptContext):integer;
var CallAddr:Cardinal;
    state:TParamState;
begin
 CallAddr:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   //     ,  
   makeCALL(context,Pointer(CallAddr));
   Result:=CMD_OK;
  end
 else Result:=CMD_PARAM_ERROR;
end;

function RemoveCallFromStack(var Stack:TCallStack; var ret_addr:Pointer):Boolean;
var l:Integer;
begin
  l:=Length(Stack);
  if l=0
    then Result:=False
    else
      begin
        Result:=True;
        ret_addr:=Stack[l-1];
        SetLength(Stack,l-1);
      end;
end;

function RETURN_or_DROP(var context:TScriptContext;IsReturn:Boolean):integer;
var write_to:Cardinal;
    RetAddr:Pointer;
    state:TParamState;
begin
with context do
begin
 if RemoveCallFromStack(CallStack,RetAddr) then
  begin
   Result:=CMD_OK;
   if IsReturn
    then IP:=Pointer(RetAddr)
    else
     begin
      write_to:=LoadParameter_DWORD(context,state,0);
      case state of
       PARAM_OK:      Result:=Variable_qStoreDWORD(context,write_to,Cardinal(RetAddr));
       PARAM_INVALID: Result:=CMD_PARAM_ERROR;
      end;//case
     end;
  end//if _RemoveDWORDFromArray(CallStack,RetAddr)
  else Result:=CMD_RET_STACK_EMPTY;
end;//with
end;

function C_RETURN(var context:TScriptContext):integer;
begin
 Result:=RETURN_or_DROP(context,True);
end;

function C_DROP_RET(var context:TScriptContext):integer;
begin
 Result:=RETURN_or_DROP(context,False);
end;

function DATE_SET_x(var context:TScriptContext; IsLocalTime:Boolean):integer;
var new_time:Int64;
    st:SYSTEMTIME;
    state:TParamState;
begin
 new_time:=LoadParameter_INTEGER(context,state,0);
 Result:=CMD_OK;
 if state=PARAM_OK then
  begin
   FileTimeToSystemTime(FILETIME(new_time),st);
   if not DateTimeChanged then //  /    -    
    begin
     DateTimeChanged:=True;
     BaseTickCount:=GetTickCount;
     GetSystemTimeAsFileTime(BaseTimeToRestore);
    end;
   ForceTimeChangePrivilege; //   -       
   if IsLocalTime
    then begin if not SetLocalTime(st) then Result:=CMD_CANT_CHANGE_TIME end
    else begin if not SetSystemTime(st) then Result:=CMD_CANT_CHANGE_TIME end;
    context.LastWindowsError:=GetLastError;
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_DATE_SET(var context:TScriptContext):integer;
begin
 Result:=DATE_SET_x(context,True);
end;

function C_DATE_SET_SYSTEM(var context:TScriptContext):integer;
begin
 Result:=DATE_SET_x(context,False);
end;

function C_DATE_RESTORE(var context:TScriptContext):integer;
begin
 RestoreDateTime;
 Result:=CMD_OK;
end;

function JOIN_x(var context:TScriptContext; ArrayType:TParamType):integer;
type TOneJoinedItem=packed record
      CopyFrom:   Pointer;  //  
      CopyBytes:  Cardinal; //   
     end;
     //      "" JOIN   ,     - 
     TJoinedItemArray=packed array[0..15] of TOneJoinedItem;
     PJoinedArray=^TJoinedItemArray;
label Force_End;
var write_to,param_count,sum_len,elem_sz:Cardinal;
    state:TParamState;
    NextCommand:Pointer;
    NewArr:PArrayHeader;
    i:Integer;
    StaticBuffer: TJoinedItemArray;
    DynamicBuffer:PJoinedArray;
begin
  //         
  elem_sz:=VarArrayItemSize[CompatibleVarType[ArrayType]];
  //   -  ,      
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
  begin
    param_count:=GetParamCount(context.IP,NextCommand);
    sum_len:=0;
    //      
    if param_count<High(StaticBuffer)
      //    -   
      then DynamicBuffer:=@StaticBuffer
      //   -  
      else GetMem(DynamicBuffer,SizeOf(TOneJoinedItem)*param_count);
    //      ,   ,
    //         
    for i:=0 to param_count-1 do
      begin
        //    
        NewArr:=LoadParameter_xArray(context,state,ArrayType);
        //   
        if (state=PARAM_OK) and (NewArr<>nil) then
          begin
            with DynamicBuffer^[i],PUA_BinaryBlock(NewArr)^ do
            begin
              //      
              CopyFrom:=@Arr;
              //      
              CopyBytes:=_ArrayLength(NewArr,CompatibleVarType[ArrayType])*elem_sz;
              //    
              Inc(sum_len,CopyBytes);
            end;//with
          end//if state=PARAM_OK
        else
          begin
            Result:=CMD_PARAM_TYPE_MISMATCH;
            goto Force_End;
          end;
    end;//for

    //  param_count -    
    i:=sum_len div elem_sz;
    //    . 
    case ArrayType of
      ptBinBlock:       NewArr:=PArrayHeader(BB_Allocate(i));
      ptUnicodeString:  NewArr:=PArrayHeader(UStr_Allocate(i));
      else NewArr:=UA_CreateR(i,elem_sz);
    end;//case

    //    ?
    if NewArr<>nil then
      begin
        //  sum_len     ,    
        sum_len:=0;
        //    
        for i:=0 to param_count-1 do
          begin
            with DynamicBuffer^[i], PUA_BinaryBlock(NewArr)^ do
              begin
                Move(CopyFrom^,Arr[sum_len],CopyBytes);
                Inc(sum_len,CopyBytes);
              end;//with
          end;//for
          //    
          Result:=Variable_AssignArray(context,write_to,NewArr,CompatibleVarType[ArrayType]);
          //       -  , ..   
          if Result<>CMD_OK
            then UA_Destroy(NewArr);
      end//
    else Result:=CMD_OUT_OF_MEMORY;

Force_End:
    //    
    context.IP:=NextCommand;
    //  ,     
    if DynamicBuffer<>@StaticBuffer
      then FreeMem(DynamicBuffer);
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_JOIN_B(var context:TScriptContext):integer;
begin
 Result:=JOIN_x(context,ptBinBlock);
end;

function C_JOIN_DA(var context:TScriptContext):integer;
begin
 Result:=JOIN_x(context,ptDWORDArray);
end;

function C_JOIN_IA(var context:TScriptContext):integer;
begin
 Result:=JOIN_x(context,ptIntArray);
end;

function C_JOIN_FA(var context:TScriptContext):integer;
begin
 Result:=JOIN_x(context,ptExtArray);
end;

function C_FILE_SET_DATE(var context:TScriptContext):integer;
label DoIt;
var creat_time,ct,mod_time,mt,acc_time,at:Int64;
    change_ct,change_mt,change_at:Boolean;
    handle_var,hFile:Cardinal;
    state:TParamState;
begin
 change_ct:=False;change_mt:=False;change_at:=False;
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;
 //  
 creat_time:=LoadParameter_INTEGER(context,state,0);
 case state of
  PARAM_OK:       change_ct:=True;
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 //  
 mod_time:=LoadParameter_INTEGER(context,state,0);
 case state of
  PARAM_OK:       change_mt:=True;
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 //   
 acc_time:=LoadParameter_INTEGER(context,state,0);
 case state of
  PARAM_OK:       change_at:=True;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

DoIt:
 Result:=Variable_qLoadDWORD(context,handle_var,hFile);
 if Result=CMD_OK then
   begin
    if change_ct
      then CorrectLocalFileTimeToFileTime(FILETIME(creat_time),FILETIME(ct));
    if change_at
      then CorrectLocalFileTimeToFileTime(FILETIME(acc_time),FILETIME(at));
    if change_mt
      then CorrectLocalFileTimeToFileTime(FILETIME(mod_time),FILETIME(mt));
    if not SetFileTime(hFile,IfThen(change_ct,@ct,nil),IfThen(change_at,@at,nil),IfThen(change_mt,@mt,nil))
      then Result:=CMD_CANT_CHANGE_FILE_TIME;
    context.LastWindowsError:=GetLastError;
   end
end;

function C_FILE_GET_DATE(var context:TScriptContext):Integer;
label DoIt;
var store_ct,store_mt,store_at:Boolean;
    c_time,m_time,a_time,local_time:FILETIME;
    ct_var,mt_var,at_var,handle_var,hFile:Cardinal;
    state:TParamState;
begin
 store_ct:=False;
 store_mt:=False;
 store_at:=False;
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then
  begin
    Result:=CMD_PARAM_ERROR;
    Exit;
  end;
 //  
 ct_var:=LoadParameter_INTEGER(context,state,0);
 case state of
  PARAM_OK:       store_ct:=True;
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 //  
 mt_var:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:       store_mt:=True;
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case
 //   
 at_var:=LoadParameter_INTEGER(context,state,0);
 case state of
  PARAM_OK:       store_at:=True;
  PARAM_INVALID:  begin Result:=CMD_PARAM_ERROR; Exit; end;
 end;//case

{$WARNINGS OFF}
DoIt:
 Result:=Variable_qLoadDWORD(context,handle_var,hFile);
 if Result=CMD_OK then
   begin
    if GetFileTime(hFile,@c_time,@a_time,@m_time) then
    begin
      if store_ct then
       begin
        CorrectFileTimeToLocalFileTime(c_time,local_time);
        Result:=Variable_qStoreINTEGER(context,ct_var,Int64(local_time));
       end;
      if store_mt then
       begin
        CorrectFileTimeToLocalFileTime(m_time,local_time);
        Result:=Variable_qStoreINTEGER(context,mt_var,Int64(local_time));
       end;
      if store_at then
       begin
        CorrectFileTimeToLocalFileTime(a_time,local_time);
        Result:=Variable_qStoreINTEGER(context,at_var,Int64(local_time));
       end;
      context.LastWindowsError:=GetLastError;
    end//if GetFileTime
    else Result:=CMD_CANT_GET_FILE_TIME;
   end;//if Result=CMD_OK
end;
{$WARNINGS ON}

function WND_GET_x(var context:TScriptContext;Method:TWndPosAndSizeMethod):integer;
var hwnd,write_x,write_y:Cardinal;
    x,y,empty:Integer;
    x_present,y_present:Boolean;
begin
  Result:=_hashReadVar_hashDE_hashDNE(context,hwnd,write_x,x_present,write_y,y_present);
  if Result=CMD_OK then
   begin
     if (Method=wpasmAbsoluteSize) or (Method=wpasmClientSize)
      then Result:=WndGetPosAndSize(hwnd,empty,empty,x,y,Method)
      else Result:=WndGetPosAndSize(hwnd,x,y,empty,empty,Method);
     if (Result=CMD_OK) and (x_present) then Result:=Variable_qStoreDWORD(context,write_x,x);
     if (Result=CMD_OK) and (y_present) then Result:=Variable_qStoreDWORD(context,write_y,y);
   end;
end;

function C_WND_GET_POS(var context:TScriptContext):integer;
begin
  Result:=WND_GET_x(context,wpasmInParentPos);
end;

function C_WND_GET_SIZE(var context:TScriptContext):integer;
begin
  Result:=WND_GET_x(context,wpasmAbsoluteSize);
end;

function C_WND_GET_CLIENT_SIZE(var context:TScriptContext):integer;
begin
  Result:=WND_GET_x(context,wpasmClientSize);
end;

function C_WND_GET_SCREEN_POS(var context:TScriptContext):integer;
begin
  Result:=WND_GET_x(context,wpasmAbsolute);
end;

function WND_SET_x(var context:TScriptContext; ChangeCoords:Boolean):Integer;
label DoIt;
var var_idx:Cardinal;
    state:TParamState;
    PosStruct:TWndChangePosDescriptor;
begin
 Result:=CMD_PARAM_ERROR;
 with PosStruct do
 begin
  x_present:=False;
  y_present:=False;
  SetCoord:=ChangeCoords;
  var_idx:=LoadParameter_DWORD(context,state,0);

  if state=PARAM_OK then
  begin
    new_x:=LoadParameter_DWORD(context,state,0);
    case state of
     PARAM_OK: x_present:=True;
     PARAM_END: goto DoIt;
     PARAM_INVALID: Exit;
    end;//case

    new_y:=LoadParameter_DWORD(context,state,0);
    case state of
     PARAM_OK: y_present:=True;
     PARAM_INVALID: Exit;
    end;//case

  DoIt:
    Result:=ApplyOperationToWindows(context,var_idx,woSetWndPosOrSize,@PosStruct);
  end;//if state=PARAM_OK
 end;//with
end;

function C_WND_SET_POS(var context:TScriptContext):integer;
begin
  Result:=WND_SET_x(context,True);
end;

function C_WND_SET_SIZE(var context:TScriptContext):integer;
begin
  Result:=WND_SET_x(context,False);
end;

function C_PROCESS_GET_PRIOR(var context:TScriptContext):integer;
var hproc,write_to:Cardinal;
begin
  Result:=_hashReadvar_hashDE(context,hproc,False,write_to);
  if Result=CMD_OK then
   begin
    hproc:=GetPriorityClass(hproc);
    context.LastWindowsError:=GetLastError;
    if hproc=0
     then Result:=CMD_CANT_GET_PROCESS_PRIOR
     else Result:=Variable_qStoreDWORD(context,write_to,hproc);
   end;
end;

function C_THREAD_GET_PRIOR(var context:TScriptContext):integer;
var hproc,write_to:Cardinal;
begin
  Result:=_hashReadvar_hashDE(context,hproc,False,write_to);
  if Result=CMD_OK then
   begin
    hproc:=GetThreadPriority(hproc);
    context.LastWindowsError:=GetLastError;
    if hproc=0
     then Result:=CMD_CANT_GET_PROCESS_PRIOR
     else Result:=Variable_qStoreDWORD(context,write_to,hproc);
   end;
end;

function SYSVAR_x(var context:TScriptContext; IsGet:Boolean):Integer;
var sysvar_idx,second:Cardinal;
    state:TParamState;
    p:PCardinal;
begin
 Result:=CMD_PARAM_ERROR;
 sysvar_idx:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
    second:=LoadParameter_DWORD(context,state,0);
    if state=PARAM_OK then
     begin
       p:=GetSysVarAddr(context,sysvar_idx);
       if p<>nil then
        begin
         if IsGet
          then Result:=Variable_qStoreDWORD(context,second,p^)
          else begin p^:=second; Result:=CMD_OK end;
        end//p<>nil
       else Result:=CMD_INVALID_SYSVAR_INDEX;
     end;//state=PARAM_OK
  end;//state=PARAM_OK
end;

function C_SYSVAR_GET(var context:TScriptContext):Integer;
begin
  Result:=SYSVAR_x(context,True);
end;

function C_SYSVAR_SET(var context:TScriptContext):Integer;
begin
  Result:=SYSVAR_x(context,False);
end;

function C_ON_ERROR(var context:TScriptContext):Integer;
var state:TParamState;
    oeg:Cardinal;
begin
 oeg:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_INVALID
  then Result:=CMD_PARAM_ERROR
  else begin context.OnErrorGoto:=Pointer(oeg); Result:=CMD_OK; end;
end;

function C_WND_GET_MENU(var context:TScriptContext):integer;
var wnd,write_to:Cardinal;
begin
 Result:=_hashReadvar_hashDE(context,wnd,True,write_to);
 if Result=CMD_OK
  then Result:=Variable_qStoreDWORD(context,write_to,GetMenu(wnd));
end;

function MENU_x_x_x(var context:TScriptContext; WhatToDo:TMenuOperation):integer;
var m_h,activity,MnuItemLength:Cardinal;
    state:TParamState;
    MnuHandle,MnuPos,MnuID:Cardinal;
    MsgDescr:TCustomMessageDescr;
    txt_param:PUA_UnicodeString;
    Buffer:Pointer;
begin
 Result:=CMD_PARAM_ERROR;
 txt_param:=nil;
 //   ,     
 m_h:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   //    ,  ;
   //  -   state=PARAM_OK,     
   case WhatToDo of
    moSetActivity: //   -            0
      activity:=LoadParameter_DWORD(context,state,0);
    moFindSubmenu,moItemCount,moItemGetText: //      
     begin
      activity:=LoadParameter_DWORD(context,state,m_h);
      if state=PARAM_END
        then state:=PARAM_INVALID;
     end;
    moExecuteItem: //          
      begin
       activity:=LoadParameter_DWORD(context,state,0);
       if state<>PARAM_OK
        then state:=PARAM_INVALID;
      end;
    moItemSetText: //   - 
     begin
       txt_param:=LoadParameter_UnicodeString(context,state);
       if state<>PARAM_OK then
        state:=PARAM_INVALID;
     end;
    else state:=PARAM_OK; //   ,     
   end;//case
   if state in [PARAM_OK,PARAM_DEFAULT] then
    begin
     //     ,    
     Result:=Variable_qLoadDWORD(context,m_h,m_h);
     if Result=CMD_OK then
      begin
       //       ,    
       Result:=GetMenuItem(context,m_h,MnuHandle,MnuPos,MnuID,WhatToDo in [moFindSubmenu,moItemCount]);
       if Result=CMD_OK then
        begin
         //    ,      ,  
         case WhatToDo of
          moSetActivity: //   
           begin
            if Cardinal(EnableMenuItem(MnuHandle,MnuPos,MF_BYPOSITION or activity))=$FFFFFFFF then
             begin
              context.LastWindowsError:=GetLastError;
              Result:=CMD_MENU_ITEM_NOT_EXISTS;
             end;
           end;
          moRemoveItem: //     ( )
           begin
             if RemoveMenu(MnuHandle,MnuPos,MF_BYPOSITION)
              then Result:=CMD_OK
              else Result:=CMD_CANT_CHANGE_MENU_ITEM_STATE;
             context.LastWindowsError:=GetLastError;
           end;
          moDeleteItem: //       
           begin
             if DeleteMenu(MnuHandle,MnuPos,MF_BYPOSITION)
              then Result:=CMD_OK
              else Result:=CMD_CANT_CHANGE_MENU_ITEM_STATE;
             context.LastWindowsError:=GetLastError;
           end;
          moFindSubmenu: //  
           begin
             Result:=Variable_qStoreDWORD(context,activity,MnuHandle);
           end;
          moItemCount:   //     ()
           begin
             Result:=Variable_qStoreDWORD(context,activity,GetMenuItemCount(MnuHandle));
             context.LastWindowsError:=GetLastError;
           end;
          moItemGetText: //   
           begin
             //     
             MnuItemLength:=GetMenuStringW(MnuHandle,MnuPos,nil,0,MF_BYPOSITION);
             if MnuItemLength>0 then //     
              begin
                //     
                GetMem(Buffer,(MnuItemLength shl 1)+2);
                //   
                if GetMenuStringW(MnuHandle,MnuPos,Buffer,MnuItemLength+1,MF_BYPOSITION)>0
                 //     
                 then Result:=Variable_qWriteUnicodeString(context,activity,Buffer,lstrlenW(Buffer))
                 else Result:=CMD_CANT_READ_MENU_ITEM_INFO;
                context.LastWindowsError:=GetLastError;
                FreeMem(Buffer);
              end //if MnuItemLength>0
              else Result:=Variable_AssignArray(context,activity,@EmptyUnicodeString,vtUnicodeString); //   
           end;
          moItemSetText: //    
           begin
             if ModifyMenuW(MnuHandle,MnuPos,MF_BYPOSITION,MnuID,@(txt_param^.Arr))
              then Result:=CMD_OK
              else Result:=CMD_CANT_CHANGE_MENU_ITEM_STATE;
             context.LastWindowsError:=GetLastError;
           end;
          moExecuteItem: //    
           begin
             with MsgDescr do
              begin
                MessageCode:=WM_COMMAND;
                wParam:=MnuID;
                lParam:=MnuHandle;
                Timeout:=context.SendMsgTimeout;
                ResVar:=nil;
              end;
             ApplyOperationToWindows(context,activity,@woSendAnyMessage,@MsgDescr);
             Result:=CMD_OK; //  ,    
           end;
         end;//case
        end;//if Result=CMD_OK
      end;//if Result=CMD_OK
    end;//if state in [PARAM_OK,PARAM_DEFAULT]
    UA_Destroy(PArrayHeader(txt_Param));
  end;//if state=PARAM_OK
end;

function C_MENU_ITEM_SET_ACTIVITY(var context:TScriptContext):integer;
begin
 Result:=MENU_x_x_x(context,moSetActivity);
end;

function C_MENU_FIND_SUBMENU(var context:TScriptContext):integer;
begin
 Result:=MENU_x_x_x(context,moFindSubmenu);
end;

function C_MENU_ITEM_EXECUTE(var context:TScriptContext):integer;
begin
 Result:=MENU_x_x_x(context,moExecuteItem);
end;

function C_MENU_ITEM_REMOVE(var context:TScriptContext):integer;
begin
 Result:=MENU_x_x_x(context,moRemoveItem);
end;

function C_MENU_ITEM_DELETE(var context:TScriptContext):integer;
begin
 Result:=MENU_x_x_x(context,moDeleteItem);
end;

function C_MENU_ITEM_COUNT(var context:TScriptContext):integer;
begin
 Result:=MENU_x_x_x(context,moItemCount);
end;

function C_MENU_ITEM_GET_TEXT(var context:TScriptContext):integer;
begin
 Result:=MENU_x_x_x(context,moItemGetText);
end;

function C_MENU_ITEM_SET_TEXT(var context:TScriptContext):integer;
begin
 Result:=MENU_x_x_x(context,moItemSetText);
end;

function TwoStringOp(var context:TScriptContext; Operation:TTwoStringOperation):integer;
label DoIt;
var var4res,start_pos,tmp:Cardinal;
    str1,str2:PUA_BinaryBlock;
    IgnoreCase:LongBool;
    state:TParamState;
    l1,l2:Integer;
begin
 Result:=CMD_PARAM_ERROR;
 tmp:=0;start_pos:=0;
 var4res:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;

 str1:=LoadParameter_BinBlock(context,state);
 if state<>PARAM_OK then Exit;

 str2:=LoadParameter_BinBlock(context,state);
 if state<>PARAM_OK then Exit;

 if Operation=tsoFindSubstr then  //       -   
  begin
    start_pos:=LoadParameter_DWORD(context,state,0);
    case state of
      PARAM_INVALID: Exit;
      PARAM_END:     goto DoIt;
    end;//case
  end;
 //  ? 0 -  " ",  -  
 tmp:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_INVALID then Exit;

DoIt:
  //   
   IgnoreCase:=tmp=1;
   l1:=BB_Length(str1);
   l2:=BB_Length(str2);
   case Operation of
    tsoCompare:     tmp:=_StrBBComp(@str1^.Arr,l1,@str2^.Arr,l2,IgnoreCase);
    tsoFindSubstr:  tmp:=_StrPosEx(@(str2^.Arr),l2,@(str1^.Arr),l1,start_pos,IgnoreCase);
   end;//case
   Result:=Variable_qStoreDWORD(context,var4res,tmp);
end;

function C_SUBSTR_POS(var context:TScriptContext):integer;
begin
  Result:=TwoStringOp(context,tsoFindSubstr)
end;

function C_CMP_B(var context:TScriptContext):integer;
begin
  Result:=TwoStringOp(context,tsoCompare);
end;

function CMP_x(var context:TScriptContext; pt:TParamType):Integer;
var write_to,d1,d2:Cardinal;
    i1,i2:Int64;
    f1,f2:Extended;
    state:TParamState;

begin
  Result:=CMD_PARAM_ERROR;
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then Exit;
  //   
  case pt of
   ptDWORD:    begin
                d1:=LoadParameter_DWORD(context,state,0);
                if state in [PARAM_INVALID,PARAM_END] then Exit;
                d2:=LoadParameter_DWORD(context,state,0);
                if state=PARAM_INVALID then Exit;

                if d1>d2 then d1:=1
                 else begin
                        if d1=d2 then d1:=0 else d1:=$FFFFFFFF;
                      end;
               end;
   ptInteger:  begin
                i1:=LoadParameter_INTEGER(context,state,0);
                if state in [PARAM_INVALID,PARAM_END] then Exit;
                i2:=LoadParameter_INTEGER(context,state,0);
                if state=PARAM_INVALID then Exit;

                if i1>i2 then d1:=1
                 else begin
                        if i1=i2 then d1:=0 else d1:=$FFFFFFFF;
                      end;
               end;
   else        begin //   FLOAT
                f1:=LoadParameter_FLOAT(context,state,0);
                if state in [PARAM_INVALID,PARAM_END] then Exit;
                f2:=LoadParameter_FLOAT(context,state,0);
                if state=PARAM_INVALID then Exit;
                if f1>f2 then d1:=1
                 else begin
                        if f1=f2 then d1:=0 else d1:=$FFFFFFFF;
                      end;
               end;
  end;//case
  Result:=Variable_qStoreDWORD(context,write_to,d1);
end;

function C_CMP_D(var context:TScriptContext):Integer;
begin
  Result:=CMP_x(context,ptDWORD);
end;

function C_CMP_I(var context:TScriptContext):Integer;
begin
  Result:=CMP_x(context,ptInteger);
end;

function C_CMP_F(var context:TScriptContext):Integer;
begin
  Result:=CMP_x(context,ptExtended);
end;

function C_WND_GET_PIXEL(var context:TScriptContext):Integer;
label DoIt;
var write_to,wnd,dc:Cardinal;
    wnd_default:Boolean;
    state:TParamState;
    p:TPoint;
begin
  Result:=CMD_PARAM_ERROR;
  wnd_default:=True;
  p.X:=0;p.Y:=0;
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then Exit;

  wnd:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_OK:      wnd_default:=False;
   PARAM_END:     goto DoIt;
   PARAM_INVALID: Exit;
  end;//case

  p.X:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_END:     goto DoIt;
   PARAM_INVALID: Exit;
  end;//case

  p.Y:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_INVALID then Exit;

DoIt:
  if wnd_default //      "  " (.. )
   then begin wnd:=0; Result:=CMD_OK; end
   else Result:=VariableOrArray_qLoadDWORD(context,wnd,wnd);
  if Result=CMD_OK then //    
   begin
     dc:=GetDC(0);
     if dc<>0 then //    
      begin
       if not wnd_default //       
        then ClientToScreen(wnd,p);
       Result:=Variable_qStoreDWORD(context,write_to,GetPixel(dc,p.X,p.Y));
       ReleaseDC(0,dc);
      end
     else Result:=CMD_CANT_GET_PIXEL;
   end;
end;

function C_FILE_READ_B(var context:TScriptContext):Integer;
var fhandle,write_to,b_count,readed:Cardinal;
    state:TParamState;
    bblock:PUA_BinaryBlock;
begin
 Result:=CMD_PARAM_ERROR;
 fhandle:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;

 write_to:=LoadParameter_DWORD(context,state,fhandle);
 if state in [PARAM_INVALID, PARAM_END] then Exit;

 b_count:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;

 Result:=Variable_qLoadDWORD(context,fhandle,fhandle); //   
 if Result=CMD_OK then
  begin
    bblock:=BB_Allocate(b_count);
    if bblock<>nil then
     begin
       ReadFile(fhandle,bblock^.Arr[0],b_count,readed,nil);
       context.LastWindowsError:=GetLastError;
       if readed<>b_count
        then BB_Resize(bblock,readed); //    ,   -   
       Result:=Variable_AssignArray(context,write_to,PArrayHeader(bblock),vtBinBlock);
       if Result<>CMD_OK then UA_Destroy(PArrayHeader(bblock));
     end
     else Result:=CMD_OUT_OF_MEMORY;
  end;
end;

function ExtractKeyNameAndBranch(s:PUA_UnicodeString; var Root:HKey; var _KeyName:UnicodeString):Boolean;
var i,KeyLen:Integer;
    KeyName:PChar;
begin
  Result:=False;
  Root:=0;
  _KeyName:='';
  KeyName:=@s^.Arr;
  KeyLen:=UStr_Length(s);
  for i:=Low(RegRoots) to High(RegRoots) do
    begin
      if _UStr_PosExI(RegRoots[i].Name,RegRoots[i].NameLen,KeyName,KeyLen,0)=0 then
        begin
          Result:=True;
          Inc(KeyName,RegRoots[i].NameLen);
          _KeyName:=KeyName;
          Root:=RegRoots[i].val;
          Break;
        end;
    end;
end;

function C_REG_KEY_CREATE(var context:TScriptContext):Integer;
var KeyName:PUA_UnicodeString;
    key:string;
    state:TParamState;
    branch,Res_Key:HKey;
begin
 KeyName:=LoadParameter_UnicodeString(context,state);
 if state=PARAM_OK then
  begin
    if ExtractKeyNameAndBranch(KeyName,branch,key) then
      begin
        if RegCreateKeyExW(branch,PChar(key),0,nil,0,KEY_CREATE_SUB_KEY,context.SecurityAttributes,Res_Key,nil)=ERROR_SUCCESS then
          begin
            RegCloseKey(Res_Key);
            Result:=CMD_OK;
          end
        else Result:=CMD_CANT_OPEN_CREATE_REG_KEY;
        context.LastWindowsError:=GetLastError;
      end
    else Result:=CMD_INVALID_REG_KEY_NAME;
    UA_Destroy(PArrayHeader(KeyName));
  end
 else Result:=CMD_PARAM_ERROR;
end;

function RegGetFullInfo(root:HKEY;Key:PWideChar; var SubkeyCount,ValueCount,MaxSubkeyLen,MaxValueNameLen:Cardinal; var LastWrite:FILETIME):Boolean;
var k:HKEY;
    var lvtime:FILETIME;
begin
  Result:=RegOpenKeyExW(root,Key,0,KEY_QUERY_VALUE,k)=ERROR_SUCCESS;
  if Result then
    begin
      Result:=RegQueryInfoKeyW(k,nil,nil,nil,@SubkeyCount,@MaxSubKeyLen,nil,@ValueCount,@MaxValueNameLen,nil,nil,@lvtime)=ERROR_SUCCESS;
      CorrectFileTimeToLocalFileTime(lvtime,LastWrite);
      RegCloseKey(k);
    end;
end;

function RegDelSubkeyRecursive(root:HKEY; SubKey:UnicodeString):Boolean;
var key:HKEY;
    lResult,Size,BufferSize:Cardinal;
    _Name:array[0..MAX_PATH] of WideChar;
    pName:PWideChar;
    ftWrite:FILETIME;
begin
  //     
  lResult:=RegDeleteKeyW(root,PWideChar(SubKey));
  if lResult=ERROR_SUCCESS then
    begin
      Result:=True;
      Exit;
    end;

  //    - ,    .
  //   ,  True (  )
  lResult:=RegOpenKeyExW(root,PWideChar(SubKey),0,KEY_READ or KEY_WRITE,key);
  if lResult<>ERROR_SUCCESS then
    begin
      Result:=lResult=ERROR_FILE_NOT_FOUND;
      Exit;
    end;
  //     (  .   )
  lResult:=RegQueryInfoKeyW(key,nil,nil,nil,nil,@Size,nil,nil,nil,nil,nil,nil);
  if lResult=ERROR_SUCCESS then
    begin
      //   
      Inc(Size);
      //    .     + 
      BufferSize:=SizeOf(_Name) div SizeOf(WideChar);
      //   ,   
      if BufferSize<Size
        then GetMem(pName,BufferSize)
        else
          begin
            pName:=@_Name;
            Size:=BufferSize;
          end;
    end
  //      .   
  else Size:=SizeOf(_Name) div SizeOf(WideChar);

  //       -    
  if SubKey[Length(SubKey)]<>'\'
    then SubKey:=SubKey+'\';

  BufferSize:=Size;
  //   
  lResult:=RegEnumKeyExW(key,0,pName,BufferSize,nil,nil,nil,@ftWrite);
  if lResult=ERROR_SUCCESS then
    begin
      repeat
        //        
        if not RegDelSubkeyRecursive(root,SubKey+pName)
          then Break;
        //   , ..    
        BufferSize:=Size;
        lResult:=RegEnumKeyExW(key,0,pName,BufferSize,nil,nil,nil,@ftWrite);
      until lResult<>ERROR_SUCCESS;
    end;
  RegCloseKey(key);
  //    
  Result:=RegDeleteKeyW(root,PWideChar(SubKey))=ERROR_SUCCESS;
  //   ,   
  if pName<>@_Name
    then FreeMem(pName);
end;

function RegDeleteKeyNonRecursive(branch:HKEY; key:PWideChar):Boolean;
//  ,       
var RegKey:HKEY;
    Subkeys:Cardinal;
begin
  //   
  Result:=RegOpenKeyExW(branch,key,0,KEY_QUERY_VALUE,RegKey)=ERROR_SUCCESS;
  if Result then
    begin
      //     
      RegQueryInfoKeyW(RegKey,nil,nil,nil,@Subkeys,nil,nil,nil,nil,nil,nil,nil);
      RegCloseKey(RegKey);
      //    - ,  -    
      // ,   ,   
      if Subkeys=0
       then Result:=RegDeleteKeyW(branch,key)=ERROR_SUCCESS
       else Result:=False;
    end;
end;

function C_REG_KEY_DELETE(var context:TScriptContext):Integer;
var KeyName:PUA_UnicodeString;
    RecursiveDelete:Cardinal;
    state:TParamState;
    branch:HKEY;
    key:string;
    r:Boolean;
begin
 Result:=CMD_PARAM_ERROR;
 KeyName:=LoadParameter_UnicodeString(context,state);
 if state=PARAM_OK then
  begin
   RecursiveDelete:=LoadParameter_DWORD(context,state,0);
   if state<>PARAM_INVALID then
    begin
      if ExtractKeyNameAndBranch(KeyName,branch,key) then
        begin
          if RecursiveDelete=0
           then r:=RegDeleteKeyNonRecursive(branch,PChar(key))
           else r:=RegDelSubkeyRecursive(branch,key);
          Result:=IfThen(r,CMD_OK,CMD_CANT_DELETE_REG_KEY);
        end
      else Result:=CMD_INVALID_REG_KEY_NAME;
    end;//if state<>PARAM_INVALID
    //  ,  
    UA_Destroy(PArrayHeader(KeyName));
  end;//if state=PARAM_OK
end;

function ReadRegValue(key:HKEY; val:PWideChar; var PBuffer:Pointer; var DataSize, DataType:Cardinal):Boolean;
label ReadRegData;
var res:Integer;
    first_time:Boolean;
begin
  first_time:=True;
ReadRegData:
  res:=RegQueryValueExW(key,val,nil,@DataType,PBuffer,@DataSize);
  if res=ERROR_MORE_DATA then
    begin
      if first_time
        then first_time:=False
        else FreeMem(PBuffer);
      GetMem(PBuffer,DataSize);
      goto ReadRegData;
    end;
  Result:=res=ERROR_SUCCESS;
  //   ,    -    
  if Result then
    begin
      //   
      case DataType of
        //   Unicode-    
        REG_SZ,REG_EXPAND_SZ: Dec(DataSize,2);
        //  REG_MULTI_SZ - 
        REG_MULTI_SZ:         Dec(DataSize,4);
      end;//case
    end;
end;

{$WARNINGS OFF}
function REG_READ_x(var context:TScriptContext; Operation:TRegValueOperation):Integer;
label Finish;
var KeyName,ValueName:PUA_UnicodeString;
    DWORD_val,ForType,DataType,DataSize:Cardinal;
    state:TParamState;
    branch,Res_Key:HKEY;
    key:string;
    StartBuf:packed array[0..1024] of Byte;
    PData:Pointer;
    ReadSuccess:Boolean;
begin
  Result:=CMD_PARAM_ERROR;
  ValueName:=nil;
  KeyName:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then Exit;
  ValueName:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then goto Finish;
  DWORD_val:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then goto Finish;
  //  rvoReadB       ,     
  if Operation=rvoReadB then
    begin
      ForType:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_INVALID
        then goto Finish;
    end;

 if ExtractKeyNameAndBranch(KeyName,branch,key) then
   begin
    if RegOpenKeyExW(branch,PChar(key),0,KEY_QUERY_VALUE,Res_Key)=ERROR_SUCCESS then
      begin
        if Operation=rvoReadType then
          begin
            PData:=nil;
            DataSize:=0;
          end
        else
          begin
            PData:=@StartBuf;
            DataSize:=SizeOf(StartBuf);
          end;

        ReadSuccess:=ReadRegValue(Res_Key,@ValueName^.Arr,PData,DataSize,DataType);
        if ReadSuccess then
          begin
            case Operation of
             rvoReadD: begin
                        if (DataType=REG_DWORD) and (DataSize=4)
                         then Result:=Variable_qStoreDWORD(context,DWORD_val,(PCardinal(PData))^)
                         else Result:=CMD_TYPECAST_IMPOSSIBLE;
                       end;
             rvoReadB: begin
                        Result:=Variable_qWriteBinary(context,DWORD_val,PData,DataSize);
                        //    -     
                        if (Result=CMD_OK) and (state=PARAM_OK)
                         then Result:=Variable_qStoreDWORD(context,ForType,DataType);
                       end;
             rvoReadUStr:
                       begin
                        { TODO :    Uncode-   }
                        //    
                        if (DataType=REG_SZ) or (DataType=REG_EXPAND_SZ)
                          then Result:=Variable_qWriteUnicodeString(context,DWORD_val,PData,DataSize shr 1)
                          else Result:=CMD_TYPECAST_IMPOSSIBLE;
                       end;
             rvoReadType:
                       begin
                        Result:=Variable_qStoreDWORD(context,DWORD_val,DataType);
                       end;
            end;//case
          end//if ReadSuccess
        else Result:=CMD_CANT_READ_REG_VALUE;
        //   
        RegCloseKey(Res_Key);
        //        .  -  
        if PData<>@StartBuf
          then FreeMem(PData);
      end//if RegOpenKeyExA...
    else
      begin
       context.LastWindowsError:=GetLastError;
       Result:=CMD_CANT_OPEN_CREATE_REG_KEY;
      end;
   end
  else Result:=CMD_INVALID_REG_KEY_NAME;
Finish:
  UA_Destroy(PArrayHeader(KeyName));
  UA_Destroy(PArrayHeader(ValueName));
end;

function REG_VALUE_x(var context:TScriptContext; Operation:TRegValueOperation):Integer;
label Finish;
var KeyName,ValueName,ValueUStrData:PUA_UnicodeString;
    ValueBBData,tmp_bb:PUA_BinaryBlock;
    state:TParamState;
    branch,Res_Key:HKEY;
    key:string;
    DWORD_val,l:Cardinal;
begin
  Result:=CMD_PARAM_ERROR;
  ValueName:=nil;
  ValueUStrData:=nil;
  //   -  
  KeyName:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then Exit;
  //   -  
  ValueName:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then goto Finish;

 case Operation of
  rvoStoreD:
              begin
                //   -      
                DWORD_val:=LoadParameter_DWORD(context,state,0);
                if state=PARAM_INVALID
                  then goto Finish;
              end;
  rvoStoreB:  begin
                //   -      
                ValueBBData:=LoadParameter_BinBlock(context,state);
                case state of
                  PARAM_DEFAULT, PARAM_END:
                                  ValueBBData:=@EmptyBinaryBlock;
                  PARAM_INVALID:  goto Finish
                end;
                //   - ,       
                DWORD_val:=LoadParameter_DWORD(context,state,REG_SZ);
                if state=PARAM_INVALID
                  then goto Finish;
              end;
  rvoStoreUStr:
              begin
                //   -     
                ValueUStrData:=LoadParameter_UnicodeString(context,state);
                case state of
                  PARAM_DEFAULT, PARAM_END:
                                  ValueUStrData:=@EmptyUnicodeString;
                  PARAM_INVALID:  goto Finish
                end;
              end;
 end;//case

 //   
 if ExtractKeyNameAndBranch(KeyName,branch,key) then
   begin
    if RegOpenKeyExW(branch,PChar(key),0,KEY_SET_VALUE,Res_Key)=ERROR_SUCCESS then
       begin
         case Operation of
           rvoDelete:   begin
                          if Windows.RegDeleteValueW(Res_Key,@ValueName^.Arr)=ERROR_SUCCESS
                            then Result:=CMD_OK
                            else Result:=CMD_CANT_DELETE_REG_VALUE;
                        end;
           rvoStoreD:   begin
                          if RegSetValueExW(Res_Key,@ValueName^.Arr,0,REG_DWORD,@DWORD_val,SizeOf(DWORD))=ERROR_SUCCESS
                            then Result:=CMD_OK
                            else Result:=CMD_CANT_STORE_REG_VALUE;
                        end;
           rvoStoreB:   begin
                          l:=BB_Length(ValueBBData);
                          //  REG_MULTI_SZ       ,  Unicode
                          //       
                          if DWORD_val=REG_MULTI_SZ then
                          begin
                            tmp_bb:=BB_Allocate(l+2);
                            tmp_bb^.Arr[l]:=0;
                            tmp_bb^.Arr[l+1]:=0;
                            Move(ValueBBData^.Arr,tmp_bb.Arr,l);
                          end
                          else tmp_bb:=ValueBBData;

                          //   
                          case DWORD_val of
                            //       2    
                            REG_SZ,REG_EXPAND_SZ: Inc(l,2);
                            //       4    
                            REG_MULTI_SZ:         Inc(l,4);
                          end;//case

                          //     
                          if RegSetValueExW(Res_Key,@ValueName^.Arr,0,DWORD_val,@tmp_bb^.Arr,l)=ERROR_SUCCESS
                            then Result:=CMD_OK
                            else Result:=CMD_CANT_STORE_REG_VALUE;
                          //       REG_MULTI_SZ-  
                          if DWORD_val=REG_MULTI_SZ
                            then UA_Destroy(PArrayHeader(tmp_bb));
                        end;
           rvoStoreUStr:begin
                          { DONE :    Unicode-   }
                          l:=ValueUStrData^.Header.ElemCount shl 1;
                          if RegSetValueExW(Res_Key,@ValueName^.Arr,0,REG_SZ,@ValueUStrData^.Arr,l)=ERROR_SUCCESS
                            then Result:=CMD_OK
                            else Result:=CMD_CANT_STORE_REG_VALUE;
                        end;
         end;//case
         context.LastWindowsError:=GetLastError;
         RegCloseKey(Res_Key);
       end
      else
       begin
        context.LastWindowsError:=GetLastError;
        Result:=CMD_CANT_OPEN_CREATE_REG_KEY;
       end;
   end
  else Result:=CMD_INVALID_REG_KEY_NAME;
Finish:
  UA_Destroy(PArrayHeader(KeyName));
  UA_Destroy(PArrayHeader(ValueName));
  UA_Destroy(PArrayHeader(ValueUStrData));
end;
{$WARNINGS ON}

function C_REG_STORE_D(var context:TScriptContext):Integer;
begin
  Result:=REG_VALUE_x(context,rvoStoreD)
end;

function C_REG_STORE_B(var context:TScriptContext):Integer;
begin
  Result:=REG_VALUE_x(context,rvoStoreB)
end;

function C_REG_VALUE_DELETE(var context:TScriptContext):Integer;
begin
  Result:=REG_VALUE_x(context,rvoDelete)
end;

function C_REG_READ_D(var context:TScriptContext):Integer;
begin
  Result:=REG_READ_x(context,rvoReadD);
end;

function C_REG_READ_B(var context:TScriptContext):Integer;
begin
  Result:=REG_READ_x(context,rvoReadB);
end;

{$WARNINGS OFF}
function C_REG_KEY_GET_INFO(var context:TScriptContext):Integer;
label DoIt,Finish;
var KeyName:PUA_UnicodeString;
    KeyCountVar,ValueCountVar,LastWriteVar:Cardinal;
    state:TParamState;
    UseKC,UseVC,UseLW:Boolean;
    branch:HKEY;
    key:string;
    SubkeyCount,ValueCount,MaxSubkeyLen,MaxValueNameLen:Cardinal;
    LastWrite:FILETIME;
begin
  Result:=CMD_PARAM_ERROR;
  UseKC:=False;
  UseVC:=False;
  UseLW:=False;
  //   -  
  KeyName:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then Exit;
  //   -     
  KeyCountVar:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:       UseKC:=True;
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  goto Finish;
  end;//case
  //   -     
  ValueCountVar:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:       UseVC:=True;
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  goto Finish;
  end;//case
  //   -      
  LastWriteVar:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:       UseLW:=True;
    PARAM_INVALID:  goto Finish;
  end;//case

DoIt:
  if ExtractKeyNameAndBranch(KeyName,branch,key) then
  begin
    if RegGetFullInfo(branch,PChar(key),SubKeyCount,ValueCount,MaxSubkeyLen,MaxValueNameLen,LastWrite) then
      begin
        Result:=CMD_OK;
        if UseKC
          then Result:=Variable_qStoreDWORD(context,KeyCountVar,SubkeyCount);
        if (Result=CMD_OK) and UseVC
          then Result:=Variable_qStoreDWORD(context,ValueCountVar,ValueCount);
        if (Result=CMD_OK) and UseLW
          then Result:=Variable_qStoreINTEGER(context,LastWriteVar,Int64(LastWrite))
      end
    else Result:=CMD_CANT_GET_REG_KEY_INFO;
  end
  else Result:=CMD_INVALID_REG_KEY_NAME;
Finish:
  UA_Destroy(PArrayHeader(KeyName));
end;
{$WARNINGS ON}

function IS_REG_x_x(var context:TScriptContext; IsValue:Boolean):Integer;
label Finish;
var var_idx,DataType:Cardinal;
    RegKey,RegValue:PUA_UnicodeString;
    state:TParamState;
    IsExists:Boolean;
    branch,OpenedKey:HKEY;
    key:string;

begin
  RegValue:=nil;
  Result:=CMD_PARAM_ERROR;
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then Exit;

  RegKey:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then Exit;

  if IsValue then
  begin
    RegValue:=LoadParameter_UnicodeString(context,state);
    if state<>PARAM_OK
      then goto Finish;
  end;

  if ExtractKeyNameAndBranch(RegKey,branch,key) then
    begin
      Result:=CMD_OK;
      IsExists:=RegOpenKeyExW(branch,PChar(key),0,KEY_QUERY_VALUE,OpenedKey)=ERROR_SUCCESS;
      context.LastWindowsError:=GetLastError;
      //     - ,  
      if IsExists then
        begin
          if IsValue then //  ,   
            begin
              IsExists:=RegQueryValueExW(OpenedKey,@(RegValue^.Arr),nil,@DataType,nil,nil)=ERROR_SUCCESS;
              context.LastWindowsError:=GetLastError;
            end;
          RegCloseKey(OpenedKey);
        end;//if IsExists
    end
  else Result:=CMD_INVALID_REG_KEY_NAME;
{$WARNINGS OFF}
  if Result=CMD_OK
    then Result:=Variable_qStoreDWORD(context,var_idx,IfThen(IsExists,1,0));
Finish:
  UA_Destroy(PArrayHeader(RegKey));
  UA_Destroy(PArrayHeader(RegValue));
end;
{$WARNINGS ON}

function C_IS_REG_KEY_EXISTS(var context:TScriptContext):Integer;
begin
  Result:=IS_REG_x_x(context,False);
end;

function C_IS_REG_VALUE_EXISTS(var context:TScriptContext):Integer;
begin
  Result:=IS_REG_x_x(context,True);
end;

function C_MOUSE_EMULATE_BUTTON_DOWN(var context:TScriptContext):integer;
begin
 Result:=MOUSE_EMULATE_x(context,meDown);
end;

function C_MOUSE_EMULATE_BUTTON_UP(var context:TScriptContext):integer;
begin
 Result:=MOUSE_EMULATE_x(context,meUp);
end;

function C_EMULATE_KEYDOWN(var context:TScriptContext):integer;
begin
  Result:=EMULATE_KEYx(context,keDown);
end;

function C_EMULATE_KEYUP(var context:TScriptContext):integer;
begin
  Result:=EMULATE_KEYx(context,keUp);
end;

function SetClipbrdText(Text:PUA_BinaryBlock; Locale:Cardinal; UseLocale:Boolean):Boolean;
var hTextMem,hLocaleMem,textlen:Cardinal;
    pLocale:PCardinal;
    pText:PAnsiChar;
begin
  Result:=False;
    begin
      if UseLocale then //    Clipboard
      begin
       if OpenClipboard(0) then
        EmptyClipboard; //   Clipboard  
        hLocaleMem:=GlobalAlloc(GMEM_MOVEABLE+GMEM_ZEROINIT,SizeOf(Cardinal));
        if hLocaleMem=0 then
          begin
            CloseClipboard;
            Exit;
          end
        else
          begin
            pLocale:=GlobalLock(hLocaleMem);
            if pLocale=nil then
              begin
                CloseClipboard;
                Exit;
              end
            else pLocale^:=Locale;
            if SetClipboardData(CF_LOCALE,hLocaleMem)=0 then
              begin
                CloseClipboard;
                LocalUnlock(hLocaleMem);
                GlobalFree(hLocaleMem);
                Exit;
              end;
          end;//else
       end;//if OpenClipboard
      end;//if UseLocale

     //    Clipboard
     if OpenClipboard(0) then
      begin
        //     -   Clipboard
        if not UseLocale
          then EmptyClipboard;
        textlen:=Text^.Header.ElemCount-1;
        //  0     , ..  ASCIIZ-
        hTextMem:=GlobalAlloc(GMEM_MOVEABLE+GMEM_ZEROINIT,textlen);
        if hTextMem<>0 then
          begin
            pText:=GlobalLock(hTextMem);
            if pText=nil then
              begin
                CloseClipboard;
                GlobalUnlock(hTextMem);
              end //if pText=nil
            else
              begin
                Move(Text^.Arr[0],pText^,textlen);
                if SetClipboardData(CF_TEXT,hTextMem)=0 then
                  begin
                   CloseClipboard;
                   GlobalUnlock(hTextMem);
                   GlobalFree(hTextMem);
                   Exit;
                  end;
                CloseClipboard;
                GlobalUnlock(hTextMem);
                Result:=True;
              end; //else
          end
        else CloseClipboard;
      end;//if OpenClipboard(0)
end;

function C_CLIPBOARD_SET_ANSI_TEXT(var context:TScriptContext):integer;
var _text:PUA_BinaryBlock;
    LangID:Cardinal;
    state:TParamState;
    UseLocale:Boolean;
begin
 Result:=CMD_PARAM_ERROR;
 UseLocale:=False;
 _text:=LoadParameter_BinBlock(context,state);
 if state<>PARAM_OK
  then Exit;

 LangID:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:       UseLocale:=True;
  PARAM_INVALID:  Exit;
 end;//case

 if SetClipbrdText(_text,LangID,UseLocale)
  then Result:=CMD_OK
  else Result:=CMD_CANT_SET_CLIPBOARD_TEXT;
end;

function C_CLIPBOARD_GET_TEXT(var context:TScriptContext):integer;
var write_to,hMem:Cardinal;
    state:TParamState;
    txt:PWideChar;
begin
 write_to:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
    Result:=CMD_CANT_GET_CLIPBOARD_TEXT;
    if OpenClipboard(0) then
      begin
        hMem:=GetClipboardData(CF_UNICODETEXT);
        if hMem<>0 then
          begin
            txt:=GlobalLock(hMem);
            if txt<>nil
             then Result:=Variable_qWriteUnicodeString(context,write_to,txt,lstrlenW(txt))
             else Variable_AssignArray(context,write_to,@EmptyUnicodeString,vtUnicodeString);
          end
        else context.LastWindowsError:=GetLastError;
        CloseClipboard;
      end//if OpenClipboard(0)
    else context.LastWindowsError:=GetLastError;
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_DISK_GET_INFO(var context:TScriptContext):integer;
label DoIt,Finish;
var StoreUserSpace,StoreFreeSpace,StoreDiskSize:Boolean;
    UserSpace,FreeSpace,DiskSize:Int64;
    UserSpaceVar,FreeSpaceVar,DiskSizeVar:Cardinal;
    Drive:PUA_UnicodeString;
    state:TParamState;
begin
  StoreUserSpace:=False;
  StoreFreeSpace:=False;
  StoreDiskSize:=False;
  Result:=CMD_PARAM_ERROR;

  Drive:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then Exit;

  // ,         
  UserSpaceVar:=LoadParameter_DWORD(context,state,0);
  case State of
    PARAM_OK:       StoreUserSpace:=True;
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  goto Finish;
  end;//case

  // ,      
  DiskSizeVar:=LoadParameter_DWORD(context,state,0);
  case State of
    PARAM_OK:       StoreDiskSize:=True;
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  goto Finish;
  end;//case

  // ,        
  FreeSpaceVar:=LoadParameter_DWORD(context,state,0);
  case State of
    PARAM_OK:       StoreFreeSpace:=True;
    PARAM_INVALID:  goto Finish;
  end;//case

{$WARNINGS OFF}
DoIt:
  if GetDiskFreeSpaceExW(@Drive^.Arr,UserSpace,DiskSize,@FreeSpace) then
    begin
      Result:=CMD_OK;
      if StoreUserSpace
        then Result:=Max(Result,Variable_qStoreINTEGER(context,UserSpaceVar,UserSpace));
      if StoreFreeSpace
        then Result:=Max(Result,Variable_qStoreINTEGER(context,FreeSpaceVar,FreeSpace));
      if StoreDiskSize
        then Result:=Max(Result,Variable_qStoreINTEGER(context,DiskSizeVar,DiskSize));
    end
  else
    begin
      context.LastWindowsError:=GetLastError;
      Result:=CMD_CANT_GET_DRIVE_INFO;
    end;
Finish:
  UA_Destroy(PArrayHeader(Drive));
end;
{$WARNINGS ON}

function C_INIT_BA(var context:TScriptContext):integer;
label _Failure;
var var_idx,read_from,i,j,p_count,repeat_count:Cardinal;
    state:TParamState;
    NextCommand:Pointer;
    bb:PUA_BinaryBlock;
begin
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      p_count:=GetParamCount(context.IP,NextCommand);
      repeat_count:=1;
      Result:=Variable_InitBBL(context,var_idx);
      if result<>CMD_OK then goto _Failure;
      for i:=1 to p_count do
        begin
          case TParamType(PByte(context.IP)^) of
            ptByte,ptWord,ptDWORD,ptInteger,ptDefault:
              begin
                repeat_count:=LoadParameter_DWORD(context,state,1);
              end;
            ptBinBlock:
              begin
                bb:=LoadParameter_BinBlock(context,state);
                //     -  
                for j:=1 to repeat_count do
                  begin
                    Result:=Variable_AddItemBBL(context,var_idx,@(bb^.Arr),BB_Length(bb));
                    if Result<>CMD_OK then goto _Failure;
                  end;//for
                repeat_count:=1;
              end;
            ptVariable:
              begin
                //  4 ,   
                read_from:=PCardinal(Cardinal(context.IP)+1)^;
                //   IP  5 
                Inc(NativeUInt(context.IP),ParamTypeSize[ptVariable]+1);
                { DONE :       .     }
                case Variable_GetType(context,read_from) of
                  vtDWORD,vtInteger:  Variable_qLoadDWORD(context,read_from,repeat_count);
                  vtBinBlock:         begin
                                        Variable_qLoadBinary(context,read_from,bb);
                                        //     -  
                                        for j:=1 to repeat_count do
                                          begin
                                           Result:=Variable_AddItemBBL(context,var_idx,@(bb^.Arr),BB_Length(bb));
                                           if Result<>CMD_OK then goto _Failure;
                                          end;//for
                                          repeat_count:=1;
                                      end;
                end;//case
              end;
            else begin Result:=CMD_TYPECAST_IMPOSSIBLE; goto _Failure; end;
          end;//case
        end;//for
      Result:=CMD_OK;
    end
  else Result:=CMD_PARAM_ERROR;
_Failure:
  context.IP:=NextCommand;
end;

function C_STO_xA(var context:TScriptContext; IsUStrL:Boolean):integer;
label DoIt;
var var_idx,item_idx:Cardinal;
    value:PArrayHeader;
    state:TParamState;
begin
  Result:=CMD_PARAM_ERROR;
  value:=nil;
  //   -  ,  
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;
  //   -    
  item_idx:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  Exit;
  end;//case

  //   - ,   
  if IsUStrL
    then value:=PArrayHeader(LoadParameter_UnicodeString(context,state))
    else value:=PArrayHeader(LoadParameter_BinBlock(context,state));
  if state=PARAM_INVALID
    then Exit;

DoIt:
  //    Unicode-
  if IsUStrL then
    begin
      if value=nil
        then value:=@EmptyUnicodeString;
      //     
      Result:=Variable_AssignItemUStrL(context,var_idx,item_idx,PUA_UnicodeString(value));
      //     -    (  )
      if Result<>CMD_OK
        then UA_Destroy(value);
    end
  else
  //     
    begin
      if value=nil
        then value:=@EmptyBinaryBlock
        //      ,    
        else value:=PArrayHeader(BB_Duplicate(PUA_BinaryBlock(value)));
      //      
      Result:=Variable_AssignItemBBL(context,var_idx,item_idx,PUA_BinaryBlock(value));
      //    ,     (  )
      if Result<>CMD_OK
        then UA_Destroy(value);
    end;
end;

function C_STO_BA(var context:TScriptContext):integer;
begin
  Result:=C_STO_xA(context,False);
end;

function FindSection(var context:TScriptContext; name:PUA_BinaryBlock):Integer;
var i:Integer;
begin
 Result:=-1;
 with context do
 begin
  for i:=1 to SectionCount do
    begin
      if lstrcmpA(@(name^.Arr),SectionIndex[i].Name)=0
        then
          begin
            Result:=i;
            Break;
          end;
    end;//for
 end;//with
end;

function x_SECTION(var context:TScriptContext; section_op:TSectionOp):integer;
var s_name:PUA_BinaryBlock;
    state:TParamState;
    i:Integer;
    NewIP:Pointer;
begin
with context do
begin
  s_name:=LoadParameter_BinBlock(context,state);
  if state=PARAM_INVALID then Result:=CMD_PARAM_ERROR
    else
      begin
        i:=FindSection(context,s_name);
        if i=-1
          then Result:=CMD_SECTION_NOT_FOUND
          else
            begin
              if SectionIndex[i].SectionFlag=CODE_SECTION
                then begin NewIP:=SectionIndex[i].SectionPtr; Result:=CMD_OK; end
                else Result:=CMD_INVALID_SECTION_ATTR;
            end;//else

        {for i:=1 to SectionCount do
          begin
            if lstrcmp(@(s_name^.Arr),SectionIndex[i].Name)=0 then
              begin
                if SectionIndex[i].SectionFlag=CODE_SECTION
                  then begin NewIP:=SectionIndex[i].SectionPtr; Result:=CMD_OK; end
                  else Result:=CMD_INVALID_SECTION_ATTR;
              end;
          end;}
      end;
end;//with
{$WARNINGS OFF}
  //     
  if Result=CMD_OK then
    begin
     case section_op of
      soJump: context.IP:=NewIP;
      soCall: makeCALL(context,NewIP);
     end;//case
    end;
end;
{$WARNINGS ON}

function C_SECTION_JUMP(var context:TScriptContext):integer;
begin
  Result:=x_SECTION(context,soJump);
end;

function C_SECTION_CALL(var context:TScriptContext):integer;
begin
  Result:=x_SECTION(context,soCall);
end;

function C_READ_BA(var context:TScriptContext):integer;
begin
 Result:=READ_xA(context,vtBinBlockList);
end;

function C_SECTION_GET_LIST(var context:TScriptContext):integer;
var write_to,section_param,i:Cardinal;
    dont_use_section_param:Boolean;
    state:TParamState;
    p:PAnsiChar;
begin
 Result:=CMD_PARAM_ERROR;
 dont_use_section_param:=True;
 write_to:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK
  then Exit;
 section_param:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:      dont_use_section_param:=False;
  PARAM_INVALID: Exit;
 end;//case
//    
with context do
begin
  //  
  Result:=Variable_InitBBL(context,write_to);
  if Result=CMD_OK then
    begin
      //     
      for i:=1 to SectionCount do
        begin
          if dont_use_section_param or (SectionIndex^[i].SectionFlag=section_param) then
          //         
            begin
             p:=SectionIndex^[i].Name;
             Result:=Variable_AddItemBBL(context,write_to,p,lstrlenA(p));
             if Result<>CMD_OK then Break;
            end;
        end;//for
    end;//if
end;//with
end;

function C_STR_EXTRACT(var context:TScriptContext):integer;
label DoIt;
var bb_var,write_to:Cardinal;
    delim,quote:PUA_BinaryBlock;
    state:TParamState;
    dont_use_delim,dont_use_quote:Boolean;
    AddEmptyLines:Cardinal;
    VarPtr:PNeoS0MVariable;

    res_bbl:PUA_BinBlockList;
begin
 Result:=CMD_PARAM_ERROR;
 dont_use_delim:=True;
 dont_use_quote:=True;
 AddEmptyLines:=0;
 // ,     .    
 bb_var:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK
  then Exit;
 // ,     
 write_to:=LoadParameter_DWORD(context,state,bb_var);
 case state of
  PARAM_END:     goto DoIt;
  PARAM_INVALID: Exit;
 end;//case
 // -
 delim:=LoadParameter_BinBlock(context,state);
 case state of
  PARAM_OK:  dont_use_delim:=False;
  PARAM_END: goto DoIt;
  PARAM_INVALID:  Exit;
 end;
 // -"" (/ )
 quote:=LoadParameter_BinBlock(context,state);
 case state of
  PARAM_OK:      dont_use_quote:=False;
  PARAM_END: goto DoIt;
  PARAM_INVALID: Exit;
 end;
 //   ?
 AddEmptyLines:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_INVALID then Exit;

DoIt:
 VarPtr:=Variable_GetAddress(context,bb_var);
 if VarPtr=nil then //  -   -  
  begin Result:=CMD_INVALID_VARIABLE_INDEX; Exit end;
 if VarPtr^.VarType=vtBinBlock then //  -   
  begin
   res_bbl:=nil;
   case IfThen(dont_use_delim,2,0)+IfThen(dont_use_quote,1,0) of
    0: //   
       begin
        Result:=ParseDandQBB(res_bbl,PUA_BinaryBlock(VarPtr^.UA),delim,quote,AddEmptyLines<>0);
       end;
    1: //   
       begin
         Result:=ParseDelimitedBB(res_bbl,PUA_BinaryBlock(VarPtr^.UA),delim,AddEmptyLines<>0);
       end;
    2: //   
       begin
         Result:=ParseQuotedBB(res_bbl,PUA_BinaryBlock(VarPtr^.UA),quote,AddEmptyLines<>0);
       end;
    3: //   
       Result:=CMD_OK;
   end;//case
   if (Result=CMD_OK) and (res_bbl<>nil) then //     
    begin
     //   -  
     Result:=Variable_AssignArray(context,write_to,PArrayHeader(res_bbl),vtBinBlockList);
     if Result<>CMD_OK //       -   ,     
      then BBL_Destroy(res_bbl);
    end
  end
 else Result:=CMD_TYPECAST_IMPOSSIBLE;
end;

function C_COMMAND_LINE(var context:TScriptContext):integer;
var var_idx:Cardinal;
    state:TParamState;
    CommandLine:PUA_UnicodeString;
begin
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
  begin
    CommandLine:=UStr_From_PChar(GetCommandLineW);
    Result:=Variable_AssignArray(context,var_idx,PArrayHeader(CommandLine),vtUnicodeString);
    //      ,  
    if Result<>CMD_OK
      then UA_Destroy(PArrayHeader(CommandLine));
  end
  else Result:=CMD_PARAM_ERROR;
end;

type TxCase=(cUpper,cLower,cWUpper,cWLower);
const CaseCompatTypes:packed array [TxCase] of TVarType=(vtBinBlock,vtBinBlock,vtUnicodeString,vtUnicodeString);

function C_xCASE(var context:TScriptContext; xCase:TxCase):integer;
var var_idx:Cardinal;
    arr_data:Pointer;
    arr_len: Cardinal;
    state:TParamState;
    varptr:PNeoS0MVariable;
begin
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      varptr:=Variable_GetAddress(context,var_idx);
      if varptr=nil
        then Result:=CMD_INVALID_VARIABLE_INDEX
        else
          begin
            //       ,     
            if varptr^.VarType=CaseCompatTypes[xCase] then
            begin
              //   ,    
              if not Variable_DuplicateIfStatic(context,var_idx) then
              begin
                Result:=CMD_OUT_OF_MEMORY;
                Exit;
              end;
              //   ,  ANSI,  Unicode
              arr_data:=@PUA_BinaryBlock(varptr^.UA)^.Arr;
              //  Unicode  ( Ansi -   )
              arr_len:=varptr^.UA.ElemCount-1;
              case xCase of
                cUpper:   CharUpperBuffA(arr_data,arr_len-1);
                cLower:   CharLowerBuffA(arr_data,arr_len-1);
                cWUpper:  CharUpperBuffW(arr_data,arr_len);
                cWLower:  CharLowerBuffW(arr_data,arr_len);
              end;//case
              Result:=CMD_OK;
          end
        else Result:=CMD_TYPECAST_IMPOSSIBLE;
    end;//if state=PARAM_OK
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_STR_UPPERCASE(var context:TScriptContext):integer;
begin
 Result:=C_xCASE(context,cUpper);
end;

function C_STR_LOWERCASE(var context:TScriptContext):integer;
begin
 Result:=C_xCASE(context,cLower);
end;

function C_VAR_GET_TYPE(var context:TScriptContext):integer;
var var_idx,write_to:Cardinal;
    state:TParamState;
    v:PNeoS0MVariable;
    code:Cardinal;
begin
 var_idx:=LoadParameter_DWORD(context,state,0);
 Result:=CMD_PARAM_ERROR;
 if state=PARAM_OK then
    begin
      write_to:=LoadParameter_DWORD(context,state,var_idx);
      if state<>PARAM_INVALID then
         begin
           v:=Variable_GetAddress(context,var_idx);
           if v=nil
              then code:=_MINUS_ONE
              else code:=Ord(v^.VarType);
           Result:=Variable_qStoreDWORD(context,write_to,code);
         end;
    end;
end;

function C_xSTR_TO_I(var context:TScriptContext; IsUnicode:Boolean):Integer;
label DoIt;
var read_from,write_to,base:Cardinal;
    MinusPresent:Boolean;
    state:TParamState;
    varptr:PNeoS0MVariable;
    i,str_len:Integer;
    v:Byte;
    value:Int64;
    c:WideChar;
begin
  base:=10;
  Result:=CMD_PARAM_ERROR;

  read_from:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;

  write_to:=LoadParameter_DWORD(context,state,read_from);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  Exit;
  end;//case

  base:=LoadParameter_DWORD(context,state,10);
  if state=PARAM_INVALID
    then Exit;

DoIt:
  //     
  if (base>=2) and (base<=36) then
  begin
    varptr:=Variable_GetAddress(context,read_from);
    if varptr<>nil then
      begin
      with varptr^ do
      begin
        //      -   Unicode   ANSI,
        //    - Unicode
        if VarType=vtBinBlock
          then IsUnicode:=False;
        // ,      
        if (IsUnicode and (VarType=vtUnicodeString)) or ((not IsUnicode) and (VarType=vtBinBlock)) then
          begin
            Result:=CMD_NOT_INTEGER_NUMBER;
            Value:=0;
            MinusPresent:=False;
            //    /Unicode-
            str_len:=_ArrayLength(UA,VarType);
            //     
            for i:=0 to str_len-1 do
              begin
                //         
                //  $FF,    
                if IsUnicode then
                  begin
                    c:=PUA_UnicodeString(UA)^.Arr[i];
                    //     -          
                    if c>#255
                      then v:=$FF
                      else v:=str_to_i_conv_table[Ord(c)];
                  end
                  else v:=str_to_i_conv_table[PUA_BinaryBlock(UA)^.Arr[i]];

               if v>=base then //       
                begin
                  if v=$FE then //   ""
                    begin
                      if MinusPresent or (i>0)
                      //         -     ,
                      //   
                        then Exit
                        else MinusPresent:=True;
                    end// if v=$FE
                  //     ""
                  else Exit;
                end
               else value:=value*base+v;  //   - 
              end;//for

            //     -   
            if MinusPresent
              then value:=-value;
            Result:=Variable_qStoreINTEGER(context,write_to,value);
          end
        else Result:=CMD_TYPECAST_IMPOSSIBLE;
      end;//with
      end//if varptr<>nil
    else Result:=CMD_INVALID_VARIABLE_INDEX
  end
  else Result:=CMD_INVALID_BASE;
end;

function C_STR_TO_I(var context:TScriptContext):Integer;
begin
  Result:=C_xSTR_TO_I(context,False);
end;

procedure sub_swap(VarType:TVarType; p1,p2:Pointer);
var Byte1:Byte;
    Char2:WideChar;
    Byte4:Cardinal;
    Byte8:Int64;
    Byte10:Extended;
begin
    case VarType of
      vtDWORDArray,vtBinBlockList,vtUnicodeStringList:
                  begin
                    Byte4:=PCardinal(p1)^;
                    PCardinal(p1)^:=PCardinal(p2)^;
                    PCardinal(p2)^:=Byte4;
                  end;
      vtIntArray: begin
                    Byte8:=PInt64(p1)^;
                    PInt64(p1)^:=PInt64(p2)^;
                    PInt64(p2)^:=Byte8;
                  end;
      vtBinBlock: begin
                    Byte1:=PByte(p1)^;
                    PByte(p1)^:=PByte(p2)^;
                    PByte(p2)^:=Byte1;
                  end;
      vtUnicodeString:
                  begin
                    Char2:=PWideChar(p1)^;
                    PWideChar(p1)^:=PWideChar(p2)^;
                    PWideChar(p2)^:=Char2;
                  end;
      vtExtArray: begin
                    Byte10:=PExtended(p1)^;
                    PExtended(p1)^:=PExtended(p2)^;
                    PExtended(p2)^:=Byte10;
                  end;
    end;//case
end;

const SORT_REVERSE_ORDER=1;
      SORT_NO_CASE=2;
      SORT_LENGTH_AND_DATA=4;

   function Compare2ItemsD(p1,p2:PCardinal;f:Cardinal):Integer;
   begin
     if p1^>p2^
      then Result:=1
      else if p1^<p2^ then Result:=-1
                      else Result:=0;
     if f<>0 then Result:=-Result;
   end;
   function Compare2ItemsI(p1,p2:PInt64;f:Cardinal):Integer;
   begin
     if p1^>p2^
      then Result:=1
      else if p1^<p2^ then Result:=-1
                      else Result:=0;
     if f<>0 then Result:=-Result;
   end;
   function Compare2ItemsB(p1,p2:PByte;f:Cardinal):Integer;
   begin
     if p1^>p2^
      then Result:=1
      else if p1^<p2^ then Result:=-1
                      else Result:=0;
     if f<>0 then Result:=-Result;
   end;
   function Compare2ItemsE(p1,p2:PExtended;f:Cardinal):Integer;
   begin
     if p1^>p2^
      then Result:=1
      else if p1^<p2^ then Result:=-1
                      else Result:=0;
     if f<>0 then Result:=-Result;
   end;

   function Compare2ItemsBB(p1,p2:PUA_BinaryBlock;f:Cardinal):Integer;
   var p1l,p2l:Cardinal;
   begin
     if p1=nil
      then p1:=@EmptyBinaryBlock
      else p1:=PPointer(p1)^;
     if p2=nil
      then p2:=@EmptyBinaryBlock
      else p2:=PPointer(p2)^;
     p1l:=BB_Length(p1);
     p2l:=BB_Length(p2);
     if (f and SORT_LENGTH_AND_DATA)<>0 then
        begin
          if p1l>p2l
           then Result:=1
           else if p1l<p2l
                  then Result:=-1
                  else Result:=_StrBBComp(@p1^.Arr,p1l,@p2^.Arr,p2l,(f and SORT_NO_CASE)<>0);
        end
      else Result:=_StrBBComp(@p1^.Arr,p1l,@p2^.Arr,p2l,(f and SORT_NO_CASE)<>0);
     if (f and SORT_REVERSE_ORDER)<>0 then Result:=-Result;
   end;

   function Compare2ItemsUStr(p1,p2:PWideChar;f:Cardinal):Integer;
   begin
     if p1^>p2^
      then Result:=1
      else if p1^<p2^ then Result:=-1
                      else Result:=0;
     if f<>0
      then Result:=-Result;
   end;
   function Compare2ItemsUStrL(p1,p2:PUA_UnicodeString;f:Cardinal):Integer;
   var p1l,p2l:Cardinal;
   begin
     if p1=nil
      then p1:=@EmptyUnicodeString
      else p1:=PPointer(p1)^;
     if p2=nil
      then p2:=@EmptyUnicodeString
      else p2:=PPointer(p2)^;
     p1l:=UStr_Length(p1);
     p2l:=UStr_Length(p2);
     if (f and SORT_LENGTH_AND_DATA)<>0 then
        begin
          if p1l>p2l
           then Result:=1
           else if p1l<p2l
                  then Result:=-1
                  else Result:=UStrComparator[(f and SORT_NO_CASE)<>0](@p1^.Arr,p1l,@p2^.Arr,p2l);
        end
      else Result:=UStrComparator[(f and SORT_NO_CASE)<>0](@p1^.Arr,p1l,@p2^.Arr,p2l);
     if (f and SORT_REVERSE_ORDER)<>0
      then Result:=-Result;
   end;

function C_SORT(var context:TScriptContext):integer;
label LastParamHere,Leave;
type TOneArrDescr=record
      ArrType:TVarType;
      StartPosPtr:Pointer;
      ItemSz:Cardinal;
     end;
     TOneArrDescrArray=packed array [0..$FFFFFF] of TOneArrDescr;
     POneArrDescrArray=^TOneArrDescrArray;
     TCompFunction=function (p1,p2:Pointer;f:Cardinal):Integer;

var ArrCount,_i:Integer;
    MainVar,cur_var,SortFlags,ItemsInArray,BaseElemSize:Cardinal;
    PBaseData:NativeUInt;
    state:TParamState;
    PArrs:POneArrDescrArray;
    NextCommand:Pointer;
    CmpFunc:TCompFunction;

   function IsGoodVariable(var_idx:Cardinal;idx_in_arr:Integer):Boolean;
   //  ,    var_idx     
   //        idx_in_arr
   // ( idx=0, ..   ,     ,
   //       ,
   //    ItemsInArray  )
   var pv:PNeoS0MVariable;
       ia:Cardinal;
   begin
    Result:=False;
    pv:=Variable_GetAddress(context,var_idx);
    if pv=nil then Exit; //    - ,   
with PArrs^[idx_in_arr],pv^ do
begin
    //  
    ArrType:=VarType;
//    ItemSz:=ParamTypeArraySize[VarType];
    Result:=IsArray[VarType];
    if Result then
      begin
        //  -   
        ia:=_ArrayLength(UA,VarType);
        //       
        StartPosPtr:=_GetArrayItemPtr(pv,0);
        Result:=(StartPosPtr<>nil) or (ia=0);
        if Result then //     -     -  
          begin
           ItemSz:=VarArrayItemSize[VarType];
           if idx_in_arr=0
            then ItemsInArray:=ia
            else Result:=ItemsInArray=ia;
          end;
      end;//if Result
end;//with
   end;

procedure QuickSort(Left,Right: Integer;f:Cardinal);
var
  PivotData:array[1..10] of Byte;
  PivotPtr:Pointer;
  I,J,n: Integer;
begin
  repeat
    I := Left; J := Right;
     Move(Pointer(PBaseData+(Cardinal(Left+Right) shr 1)*BaseElemSize)^,
          PivotData,BaseElemSize);
     PivotPtr:=@PivotData;
    repeat
      while CmpFunc(Pointer(PBaseData+Cardinal(I)*BaseElemSize),PivotPtr,f)<0 do
        Inc(I);
      while CmpFunc(Pointer(PBaseData+Cardinal(J)*BaseElemSize),PivotPtr,f)>0 do
        Dec(J);
      if I <= J then
      begin
          for n:=0 to ArrCount-1 do
            begin
             with PArrs^[n]
              do sub_swap(ArrType,
                          Pointer(Cardinal(StartPosPtr)+ItemSz*Cardinal(i)),
                          Pointer(Cardinal(StartPosPtr)+ItemSz*Cardinal(j)));
            end;//for
        Inc(I);
        Dec(J);
      end;
    until I > J;
    if Left < J then
      QuickSort(Left, J,f);
    Left := I;
  until I >= Right;
end;

begin
 PArrs:=nil;
 ArrCount:=1; //     
 Result:=CMD_PARAM_ERROR;
 //   ,     
 MainVar:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;
 //  ,   
 SortFlags:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_INVALID:  Exit;
  PARAM_END:      begin NextCommand:=context.IP; goto LastParamHere; end;
 end;//case
 //   
 ArrCount:=GetParamCount(context.IP,NextCommand)+1;

LastParamHere:
 //       
 GetMem(PArrs,SizeOf(TOneArrDescr)*ArrCount);
 //    -  ,  
 cur_var:=MainVar;
 Result:=CMD_SORTING_IMPOSSIBLE;
 if not IsGoodVariable(MainVar,0) then goto Leave;
 for _i:=1 to ArrCount-1 do
  begin
   //     
   Inc(cur_var);
   MainVar:=LoadParameter_DWORD(context,state,cur_var);
   // ,   ,   ,  
   if not IsGoodVariable(MainVar,_i) then goto Leave;
  end;//for
  //  
   //    ,   -    
   case PArrs^[0].ArrType of
    vtDWORDArray: CmpFunc:=@Compare2ItemsD;
    vtIntArray:   CmpFunc:=@Compare2ItemsI;
    vtBinBlock:   CmpFunc:=@Compare2ItemsB;
    vtExtArray:   CmpFunc:=@Compare2ItemsE;
    vtBinBlockList:  CmpFunc:=@Compare2ItemsBB;
    { TODO :      Uncode-   Unicode  }
    vtUnicodeString: CmpFunc:=@Compare2ItemsUSTR;
    vtUnicodeStringList: CmpFunc:=@Compare2ItemsUSTRL;
   end;//case
   //    
   with PArrs^[0] do
    begin
      PBaseData:=NativeUInt(StartPosPtr);
      BaseElemSize:=ItemSz
    end;//with
   //  
   if ItemsInArray>0
    then QuickSort(0,ItemsInArray-1,SortFlags);
   Result:=CMD_OK;
Leave:
  //  ,   c 
  if PArrs<>nil
    then FreeMem(PArrs);
  context.IP:=NextCommand;
end;

function C_SWAP(var context:TScriptContext):integer;
label DoIt;
var var_idx,idx1,idx2:Cardinal;
    state:TParamState;
    vp:PNeoS0MVariable;
    p1,p2:Pointer;
begin
 Result:=CMD_PARAM_ERROR;
 idx2:=1;

 var_idx:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;

 idx1:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  Exit;
 end;//case

 idx2:=LoadParameter_DWORD(context,state,idx1+1);
 if state=PARAM_INVALID then Exit;

DoIt:
 vp:=Variable_GetAddress(context,var_idx);
 if vp=nil
  then Result:=CMD_INVALID_VARIABLE_INDEX
  else
   begin
     if IsArray[vp^.VarType]
      then begin
            //        
            p1:=_GetArrayItemPtr(vp,idx1);
            p2:=_GetArrayItemPtr(vp,idx2);
            if (p1=nil) or (p2=nil) //      
              then Result:=CMD_INVALID_ARRAY_ITEM_INDEX
              else //     -   
                begin
                  sub_swap(vp^.VarType,p1,p2);
                  Result:=CMD_OK;
                end;
           end
      else Result:=CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE
   end;
end;

function C_F_TO_xSTR(var context:TScriptContext; UnicodeFunction:Boolean):Integer;
label DoIt;
var read_from,write_to,width,decimals:Cardinal;
    state:TParamState;
    us:PUA_UnicodeString;
    s:AnsiString;
    e:Extended;
begin
 Result:=CMD_PARAM_ERROR;
 read_from:=LoadParameter_DWORD(context,state,0);
 width:=_MINUS_ONE;decimals:=_MINUS_ONE;
 if state<>PARAM_OK then Exit;
 write_to:=LoadParameter_DWORD(context,state,read_from);
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  Exit;
 end;//case

 width:=LoadParameter_DWORD(context,state,_MINUS_ONE);
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  Exit;
 end;//case

 decimals:=LoadParameter_DWORD(context,state,_MINUS_ONE);
 if state=PARAM_INVALID then  Exit;

DoIt:
 Result:=Variable_qLoadFLOAT(context,read_from,e);
 if Result=CMD_OK then
  begin
   case IfThen(width=_MINUS_ONE,0,1)+IfThen(decimals=_MINUS_ONE,0,2) of
    1:  Str(e:width,s);
    2:  Str(e:0:decimals,s);
    3:  Str(e:width:decimals,s);
    else Str(e,s);
   end;//case
   if UnicodeFunction then
     begin
       us:=ExtToUSTR(e,width,decimals);
       Result:=Variable_AssignArray(context,write_to,PArrayHeader(us),vtUnicodeString);
       if Result<>CMD_OK
        then UA_Destroy(PArrayHeader(us));
     end
   else Result:=Variable_qWriteBinary(context,write_to,PAnsiChar(s),Length(s));
  end;
end;

function C_F_TO_STR(var context:TScriptContext):integer;
begin
  Result:=C_F_TO_xSTR(context,False);
end;

function C_xSTR_TO_F(var context:TScriptContext;IsUnicode:Boolean):Integer;
var read_from,write_to,errcode,len:Cardinal;
    state:TParamState;
    s:AnsiString;
    u:UnicodeString;
    e:Extended;
    v_a:PNeoS0MVariable;
begin
  Result:=CMD_PARAM_ERROR;
  //   -  ,   
  read_from:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;
  //   -  ,   
  write_to:=LoadParameter_DWORD(context,state,read_from);
  if state=PARAM_INVALID
    then Exit;

  v_a:=Variable_GetAddress(context,read_from);
  if v_a=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else
    begin
      Result:=CMD_OK;
      //     BinaryBlock,    Unicode- ,
      //  ,     BinaryBlock'
      if v_a^.VarType=vtBinBlock
        then IsUnicode:=False;

      if IsUnicode then
        begin
          //   
          if v_a^.VarType=vtUnicodeString then
            begin
              len:=UStr_Length(PUA_UnicodeString(v_a^.UA));
              //       nil    
              if len=0
                then Result:=CMD_NOT_FLOAT_NUMBER
                else
                  begin
                    //      Unicode-
                    SetLength(u,len);
                    Move(PUA_UnicodeString(v_a^.UA)^.Arr[0],u[1],len+len);
                  end;//else
            end//if v_a^...
          else Result:=CMD_TYPECAST_IMPOSSIBLE;
        end
      else
        begin
          //   
          if v_a^.VarType=vtBinBlock then
            begin
              len:=BB_Length(PUA_BinaryBlock(v_a^.UA));
              //       nil    
              if len=0
                then Result:=CMD_NOT_FLOAT_NUMBER
                else
                  begin
                    //      
                    SetLength(s,len);
                    Move(PUA_BinaryBlock(v_a^.UA)^.Arr[0],s[1],len);
                    u:=s;
                  end;//else
            end//if v_a^...
          else Result:=CMD_TYPECAST_IMPOSSIBLE;
        end;
      //           u
      if Result=CMD_OK then
        begin
          Val(u,e,errcode);
          if errcode=0
            then Result:=Variable_qStoreFLOAT(context,write_to,e)
            else Result:=CMD_NOT_FLOAT_NUMBER;
        end;
    end;//else
end;

function C_STR_TO_F(var context:TScriptContext):Integer;
begin
  Result:=C_xSTR_TO_F(context,False);
end;

procedure InitConvTable;
var i,c:Byte;
begin
  for i:=Low(str_to_i_conv_table) to High (str_to_i_conv_table) do
  begin
    case AnsiChar(i) of
     '0'..'9': c:=i-ord('0');
     'a'..'z': c:=i-ord('a')+10;
     'A'..'Z': c:=i-ord('A')+10;
     else c:=$FF;
    end;//case
    str_to_i_conv_table[i]:=c;
  end;//for
  str_to_i_conv_table[Ord('-')]:=$FE;
end;

procedure InitCharConvTable;
var i:AnsiChar;
begin
  for i:=Low(ToUpperTable) to High (ToUpperTable) do
    begin
      ToUpperTable[i]:=i;
      ToLowerTable[i]:=i;
    end;
  CharUpperBuffA(@ToUpperTable,SizeOf(ToUpperTable));
  CharLowerBuffA(@ToLowerTable,SizeOf(ToLowerTable));

  FillChar(CharCase,SizeOf(CharCase),3);
  for i:=Low(CharCase) to High (CharCase) do
    begin
      //        
      if i=ToUpperTable[i] then Dec(CharCase[i],1);
      //        
      if i=ToLowerTable[i] then Dec(CharCase[i],2);
    end;//for
end;



{$WARNINGS OFF}
function C_VAR_COPY(var context:TScriptContext):integer;
var copy_from,copy_to:Cardinal;
    sv,dv:PNeoS0MVariable;
    state:TParamState;
    NewArr:PArrayHeader;
begin
 Result:=CMD_PARAM_ERROR;
 copy_from:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;
 copy_to:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;

 if copy_from<>copy_to then
  begin
   sv:=Variable_GetAddress(context,copy_from);
   dv:=Variable_GetAddress(context,copy_to);
   if (sv=nil) or (dv=nil) // ,    
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else
     begin
      //     -
      Variable_Deinitialize(dv);
      //   ...
      if IsArray[sv^.VarType] then
        begin
          // ...   -         -
          if sv^.UA^.IsDynamic
            //    ,  
            then NewArr:=_CopyArrayPart(sv^.UA,sv^.VarType,0,$FFFFFFFF);
        end;
      //        
      Move(sv^,dv^,SizeOf(TNeoS0MVariable));
      //   ...
      if IsArray[sv^.VarType]
             // ...  
        then if sv^.UA^.IsDynamic
              //       ,    
              // (   ,       )
              then dv^.UA:=NewArr;
      Result:=CMD_OK;
     end;//else
  end
 else Result:=CMD_OK;
end;
{$WARNINGS ON}

function C_RANDOM(var context:TScriptContext):integer;
var var_idx:Cardinal;
    MaxVal:Int64;
    r_n:Extended;
    state:TParamState;
begin
 Result:=CMD_PARAM_ERROR;
 var_idx:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;
 MaxVal:=LoadParameter_Integer(context,state,0);
 if state=PARAM_INVALID then Exit;

 r_n:=Random;
 if MaxVal=0
  then Result:=Variable_qStoreFLOAT(context,var_idx,r_n)
  else Result:=Variable_qStoreINTEGER(context,var_idx,Round(r_n*MaxVal));
end;

function C_STR_TRIM(var context:TScriptContext):integer;
label DoIt;
type TArrayOfByte=packed array[0..$FFFFFFF] of Byte;
     PArrayOfByte=^TArrayOfByte;
var trim_var,trim_method,arr_len,TrimBytesCount:Cardinal;
    FirstGood,LastGood,j:Integer;
    state:TParamState;
    TrimChars,tmp:PUA_BinaryBlock;
    TrimmedChar:Boolean;
    PData:PArrayOfByte;
begin
 trim_method:=0;
 Result:=CMD_PARAM_ERROR;
 //   ,     
 trim_var:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then Exit;
 //   ,   
 TrimChars:=LoadParameter_BinBlock(context,state);
 case state of
  PARAM_INVALID:  Exit;
  PARAM_DEFAULT:  TrimChars:=@SpaceBinaryBlock;
  PARAM_END:      begin
                    TrimChars:=@SpaceBinaryBlock;
                    goto DoIt;
                  end;
 end;//case
 //   
 trim_method:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_INVALID then Exit;

DoIt:
  //   ,    
  if not Variable_DuplicateIfStatic(context,trim_var) then
  begin
    Result:=CMD_OUT_OF_MEMORY;
    Exit;
  end;
 Result:=Variable_qLoadBinary(context,trim_var,tmp);
 if Result=CMD_OK then
  begin
    Variable_GetArrayItemPtr(context,trim_var,0,arr_len);
    PData:=PArrayOfByte(@(tmp^.Arr[0]));
    if PData<>nil then
      begin
        TrimBytesCount:=BB_Length(TrimChars);
        //  ,    ,  
        //  FirstGood  LastGood      
        FirstGood:=0;
        LastGood:=arr_len-1;
        //       -       
        //       
        if (trim_method=0) or (trim_method=1) then
         begin
          for FirstGood:=FirstGood to LastGood do
            begin
              TrimmedChar:=False;
              for j:=0 to TrimBytesCount-1
               do TrimmedChar:=TrimmedChar or (PData^[FirstGood]=TrimChars^.Arr[j]);
              if not TrimmedChar then Break;
            end;//for i
         end//if (trim_method=0) or (trim_method=1)
        else FirstGood:=0;
        //       
        if (trim_method=0) or (trim_method=2) then
          begin
          for LastGood:=LastGood downto FirstGood do
            begin
              TrimmedChar:=False;
              for j:=0 to TrimBytesCount-1
               do TrimmedChar:=TrimmedChar or (PData^[LastGood]=TrimChars^.Arr[j]);
              if not TrimmedChar then Break;
            end;//for i
          end//if (trim_method=0) or (trim_method=2)
        else LastGood:=arr_len-1;
        //    ,   
        for j:=FirstGood to LastGood do PData^[j-FirstGood]:=PData^[j];
        //      
        if LastGood<FirstGood
         then LastGood:=0
         else LastGood:=LastGood-FirstGood+1;
        BB_Resize(PUA_BinaryBlock(Variable_GetAddress(context,trim_var)^.UA),LastGood);
        Result:=CMD_OK;
      end
    else Result:=CMD_INVALID_ARRAY_ITEM_INDEX;
  end;
end;

function C_COPY(var context:TScriptContext):integer;
label DoIt;
var copy_from,copy_to,start_pos,len:Cardinal;
    sv:PNeoS0MVariable;
    state:TParamState;
    NewArr:PArrayHeader;
begin
 Result:=CMD_PARAM_ERROR;
 len:=$7FFFFFFF;
 //  
 copy_from:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK
  then Exit
  else copy_to:=copy_from;
 //  
 start_pos:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  Exit;
 end;//case
 //  
 len:=LoadParameter_DWORD(context,state,$7FFFFFFF);
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  Exit;
 end;//case
 //  
 copy_to:=LoadParameter_DWORD(context,state,copy_from);
 if state=PARAM_INVALID then Exit;

DoIt:
 sv:=Variable_GetAddress(context,copy_from);
 if (sv=nil) or (Variable_GetAddress(context,copy_to)=nil) // ,    
  then Result:=CMD_INVALID_VARIABLE_INDEX
  else
   begin
    if IsArray[sv^.VarType] then
     begin //    
      NewArr:=_CopyArrayPart(sv^.UA,sv^.VarType,start_pos,len); //    ,  
      if NewArr=nil
       then Result:=CMD_INVALID_ARRAY_ITEM_INDEX
       else begin
              Result:=Variable_AssignArray(context,copy_to,NewArr,sv^.VarType);
              if Result<>CMD_OK then UA_Destroy(NewArr);
            end;
     end
    else Result:=CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE;
   end;
end;

type TScreenMeteringOp=(smoGetScreenSize,smoGetDesktopSize,smoGetDesktopPos);
function x_GET_x(var context:TScriptContext; op:TScreenMeteringOp):integer;
label DoIt;
var v_x,v_y:Cardinal;
    r:TRect;
    use_x,use_y:Boolean;
    state:TParamState;
begin
  use_x:=False;
  use_y:=False;
  Result:=CMD_PARAM_ERROR;
  v_x:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_OK:  use_x:=True;
   PARAM_END: goto DoIt;
   PARAM_INVALID: Exit;
  end;//case
{$WARNINGS OFF}
  v_y:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_OK: use_y:=True;
   PARAM_INVALID: Exit;
  end;//case
DoIt:
  case op of
    smoGetScreenSize: begin
                       r.Left:=GetSystemMetrics(SM_CXSCREEN);
                       r.Top:=GetSystemMetrics(SM_CYSCREEN);
                      end;
    smoGetDesktopSize,smoGetDesktopPos:
                      begin
                       SystemParametersInfoA(SPI_GETWORKAREA,0,@r,0);
                       if op=smoGetDesktopSize then begin r.Left:=r.Right; r.Top:=r.Bottom end;
                      end;
  end;//case

  if use_x
   then Result:=Variable_qStoreDWORD(context,v_x,r.Left)
   else Result:=CMD_OK;
  if use_y and (Result=CMD_OK)
   then Result:=Variable_qStoreDWORD(context,v_y,r.Top);
end;
{$WARNINGS ON}

function C_SCREEN_GET_SIZE(var context:TScriptContext):integer;
begin
  Result:=x_GET_x(context,smoGetScreenSize)
end;

function C_DESKTOP_GET_SIZE(var context:TScriptContext):integer;
begin
  Result:=x_GET_x(context,smoGetDesktopSize)
end;

function C_DESKTOP_GET_POS(var context:TScriptContext):integer;
begin
  Result:=x_GET_x(context,smoGetDesktopPos)
end;

function C_DISK_GET_LIST(var context:TScriptContext):Integer;
var i,write_to,bit_drives:Cardinal;
    state:TParamState;
    buf:array[1..3] of WideChar;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      Result:=Variable_InitUStrL(context,write_to);
      if Result=CMD_OK then
        begin
          buf[2]:=':';
          buf[3]:='\';
          bit_drives:=GetLogicalDrives;
          for i:=0 to 31 do
            begin
              if Odd(bit_drives) then
                begin
                  buf[1]:=WideChar(i+Ord('A'));
                  Result:=Variable_AddItemUStrL(context,write_to,@Buf[1],High(Buf));
                end;
              bit_drives:=bit_drives shr 1;
            end;//for
        end//if
      else 
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_WINDOWS_VERSION(var context:TScriptContext):integer;
label DoIt;
var platform_id,maj_v,min_v,build_v,add_info_v:Cardinal;
    use_platform_id,use_maj_v,use_min_v,use_build_v,use_add_info_v:Boolean;
    state:TParamState;
    vi:OSVERSIONINFOEXW;
begin
  use_platform_id:=False;use_maj_v:=False;use_min_v:=False;
  use_build_v:=False;use_add_info_v:=False;
  Result:=CMD_PARAM_ERROR;
  platform_id:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_OK:  use_platform_id:=True;
   PARAM_END: goto DoIt;
   PARAM_INVALID: Exit;
  end;//case
  maj_v:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_OK:  use_maj_v:=True;
   PARAM_END: goto DoIt;
   PARAM_INVALID: Exit;
  end;//case
  min_v:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_OK:  use_min_v:=True;
   PARAM_END: goto DoIt;
   PARAM_INVALID: Exit;
  end;//case
  build_v:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_OK:  use_build_v:=True;
   PARAM_END: goto DoIt;
   PARAM_INVALID: Exit;
  end;//case
  add_info_v:=LoadParameter_DWORD(context,state,0);
  case state of
   PARAM_OK:  use_add_info_v:=True;
   PARAM_INVALID: Exit;
  end;//case

DoIt:
  vi.dwOSVersionInfoSize:=SizeOf(vi);
  GetVersionExW(vi);
{$WARNINGS OFF}
  if use_platform_id
   then Result:=Variable_qStoreDWORD(context,platform_id,vi.wProductType)
   else Result:=CMD_OK;
  if use_maj_v and (Result=CMD_OK)
   then Result:=Variable_qStoreDWORD(context,maj_v,vi.dwMajorVersion);
  if use_min_v and (Result=CMD_OK)
   then Result:=Variable_qStoreDWORD(context,min_v,vi.dwMinorVersion);
  if use_build_v and (Result=CMD_OK)
   then Result:=Variable_qStoreDWORD(context,build_v,vi.dwBuildNumber);
  if use_add_info_v and (Result=CMD_OK)
   then Result:=Variable_qWriteUnicodeString(context,add_info_v,@vi.szCSDVersion,lstrlenW(@vi.szCSDVersion));
end;
{$WARNINGS ON}

function C_IS_SCREENSAVER_x(var context:TScriptContext; IsRunning:Boolean):integer;
var write_to:Cardinal;
    res:BOOL;
    state:TParamState;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      SystemParametersInfoA(IfThen(IsRunning,SPI_GETSCREENSAVERRUNNING,SPI_GETSCREENSAVEACTIVE),0,@res,0);
      Result:=Variable_qStoreDWORD(context,write_to,IfThen(res,1,0));
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_IS_SCREENSAVER_ON(var context:TScriptContext):integer;
begin
 Result:=C_IS_SCREENSAVER_X(context,False);
end;

function C_IS_SCREENSAVER_RUNNING(var context:TScriptContext):integer;
begin
 Result:=C_IS_SCREENSAVER_X(context,True);
end;

function C_DISK_GET_TYPE(var context:TScriptContext):integer;
label _Exit;
var write_to:Cardinal;
    dir_name:PUA_UnicodeString;
    state:TParamState;
begin
  Result:=CMD_PARAM_ERROR;
  dir_name:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then Exit;

  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then goto _Exit;

  Result:=Variable_qStoreDWORD(context,write_to,GetDriveTypeW(@dir_name^.Arr));
_Exit:
  UA_Destroy(PArrayHeader(dir_name));
end;


function GetVariableAsDWORD(var context:TScriptContext; const var_idx:Cardinal; var res:Cardinal):Boolean;
var v_p:PNeoS0MVariable;
begin
  Result:=True;
  //   
  v_p:=Variable_GetAddress(context,var_idx);
  if v_p<>nil then
    begin
       case v_p^.VarType of
        vtDWORD:    res:=v_p^.AsDWORD; // DWORD  " "
        vtInteger:  res:=Cardinal(@v_p^.AsInteger); // INTEGER  FLOAT   
        vtExtended: res:=Cardinal(@v_p^.AsExtended);
        vtIntArray,vtExtArray,vtDWORDArray,vtBinBlock,vtUnicodeString:
          begin //        
            res:=Cardinal(_GetArrayItemPtr(v_p,0));
            //      Unicode-    - 
            //     NIL      
            if (res=Cardinal(@EmptyBinaryBlock)) or (res=Cardinal(@EmptyUnicodeString))
              then res:=0;
          end
       else Result:=False;
      end; //case
    end//if
end;

function GetParamAsDWORD(var context:TScriptContext; var ptype:TParamType; var res:Cardinal):Boolean;
type PSignedByte=^ShortInt;
     PSignedWord=^SmallInt;
// " ":
//   -    
// DWORD   
// INTEGER -   
// BINARY_BLOCK -    (   )
// "  " -  0
// Float- -   
//  -     DWORD -   ,
//    -    ,   
//   -  ,  FALSE
var data:Pointer;
begin
  Result:=True;
  ptype:=TParamType(PByte(context.IP)^);
  data:=Pointer(Cardinal(context.IP)+1);
  case ptype of
    ptByte:       res:=(PSignedByte(data))^;
    ptWord:       res:=(PSignedWord(data))^;
    ptDWord:      res:=(PCardinal(data))^;
    ptInteger,ptExtended:
                  res:=Cardinal(data);
    ptDefault:    res:=Cardinal(@context);
    ptEndOfParam: res:=0;
    ptBinBlock,ptUnicodeString:
                  begin
                    res:=Cardinal(@(PUA_BinaryBlock(Cardinal(context.LongDataSection)+(PCardinal(data))^)^.Arr));
                  end;
    ptVariable:   Result:=GetVariableAsDWORD(context,PCardinal(data)^,res);
    else Result:=False; Exit;
  end;//case ptype
  //  context.IP      
  Inc(NativeUInt(context.IP),ParamTypeSize[ptype]+1);
end;

function C_EXTERNAL_CALL(var context:TScriptContext):integer;
label _Exit,_DoIt;
type T32Array=array [0..$FFFF] of Cardinal;
     P32Array=^T32Array;
const MAX_CALL_PARAM=24;
var DataAsCardinal:Cardinal;
    idx,AddrVarIdx,VarForResult,CallingConv:Cardinal;
    CallAddr:Cardinal;
    _eax,_edx:Cardinal;
    p_count:Cardinal; //  
    FncAsUStr:PUA_UnicodeString;
    state:TParamState;
    NextCommand:Pointer;
    ParamBuffer:array [0..MAX_CALL_PARAM-1] of Cardinal; //     
    PParamBuffer:P32Array;
    UseVarIdx,UseVarForResult,DoCall:Boolean;
    ptype:TParamType;
    AsteriskPos:Integer;

    i:int64;

begin
  DoCall:=False;
  PParamBuffer:=@ParamBuffer;
  Result:=CMD_PARAM_ERROR;
  FncAsUStr:=nil;
//  tmp_ip:=context.IP;
  //    . :
  //   -  ,    , 
  //     
  UseVarIdx:=True;
  case PByte(context.IP)^ of
    Byte(ptInteger),Byte(ptDWORD),Byte(ptByte),Byte(ptWord):
      begin
        AddrVarIdx:=LoadParameter_DWORD(context,state,0);
      end;
    Byte(ptBinBlock),Byte(ptUnicodeString):
      begin
        FncAsUStr:=LoadParameter_UnicodeString(context,state);
        UseVarIdx:=False;
      end;
    Byte(ptVariable):
      begin
        //   
        AddrVarIdx:=PCardinal(Cardinal(context.IP)+1)^;
        //    -    
        //   /
        case Variable_GetType(context,AddrVarIdx) of
          vtDWORD,vtInteger:
            AddrVarIdx:=LoadParameter_DWORD(context,state,0);
          vtBinBlock,vtUnicodeString:
            begin
              FncAsUStr:=LoadParameter_UnicodeString(context,state);
              UseVarIdx:=False;
            end
          else begin Result:=CMD_PARAM_TYPE_MISMATCH; goto _Exit; end;
        end;//case
      end//Byte(ptVariable)
    else begin
          Result:=CMD_PARAM_TYPE_MISMATCH;
          goto _Exit;
         end;
  end; //case
  //   -     
  if state<>PARAM_OK then goto _Exit;

 //    -  ,    
 UseVarForResult:=False;
 CallingConv:=0;
 idx:=0;
 Result:=CMD_PARAM_ERROR;
 VarForResult:=LoadParameter_DWORD(context,state,0);
 case state of
   PARAM_OK:  UseVarForResult:=True;
   PARAM_END: begin NextCommand:=context.IP; goto _DoIt; end;
   PARAM_INVALID: goto _Exit;
 end;

 //    -    
 CallingConv:=LoadParameter_DWORD(context,state,0);
 case state of
   PARAM_INVALID: goto _Exit;
   PARAM_END: begin  NextCommand:=context.IP; goto _DoIt; end;
 end;

 //          
 p_count:=GetParamCount(context.IP,NextCommand);
 if p_count>MAX_CALL_PARAM
  then GetMem(PParamBuffer,p_count*SizeOf(Cardinal));

 repeat
   if not GetParamAsDWORD(context,ptype,DataAsCardinal)
    then begin Result:=CMD_PARAM_TYPE_MISMATCH; goto _Exit; end
    else begin
            if ptype<>ptEndOfParam then
              begin
                PParamBuffer^[idx]:=DataAsCardinal;
                Inc(idx);
              end;
         end;
 until ptype=ptEndOfParam;

 //       
_DoIt:
  //       -  ,
  //    
{$WARNINGS OFF}
  if UseVarIdx
   then
    begin
      Result:=Variable_qLoadDWORD(context,AddrVarIdx,CallAddr);
      DoCall:=True;
    end
  else //       - _DLL*_
    begin
      Result:=CMD_OK;
      AsteriskPos:=_UStr_PosEx('*',1,@FncAsUStr^.Arr,UStr_Length(FncAsUStr),0);
      if AsteriskPos<0 //     /  
        then
          begin
            //        
            _eax:=NeoLoadLibrary(@FncAsUStr^.Arr,UStr_Length(FncAsUStr));
            if _eax=0
              then Result:=CMD_LIBRARY_NOT_FOUND
              else _edx:=0;
          end
        else //    / 
          begin
              if AsteriskPos=0
                //     EXE
                then CallAddr:=GetModuleHandleW(nil)
                //       
                else CallAddr:=NeoLoadLibrary(@FncAsUStr^.Arr,AsteriskPos);
              if CallAddr=0
                then Result:=CMD_LIBRARY_NOT_FOUND
                else //   
                  begin
                    //   
                    CallAddr:=Cardinal(GetProcAddress(CallAddr,PWideChar(@FncAsUStr^.Arr[AsteriskPos+1])));
                    if CallAddr=0
                      then Result:=CMD_EXTERNAL_FUNCTION_NOT_FOUND
                      else DoCall:=True; //    -   
                  end;
          end;
    end;
if Result=CMD_OK then
begin
 if DoCall then
 begin
  {$IFDEF Win32}
  case CallingConv of
    0:  // STDCALL
        begin
          asm
            mov ecx,PParamBuffer
            mov eax,[p_count]
            @1:

            or eax,eax
            je @2
            dec eax
            push [ecx+eax*4]
            jmp @1
            @2:
            call [CallAddr]
            mov _eax,eax
            mov _edx,edx
          end;
        end;
    1:  // PASCAL
        begin
          asm
            mov ecx,PParamBuffer
            xor eax,eax
            @1:
            cmp eax,[p_count]
            je @2
            push [ecx+eax*4]
            inc eax
            jmp @1
            @2:
            call [CallAddr]
            mov _eax,eax
            mov _edx,edx
          end;
        end;
    2:  // CDECL
        begin
          { DONE :     CDECL  FASTCALL }
          asm
            mov ecx,PParamBuffer
            mov eax,[p_count]
            @1:

            or eax,eax
            je @2
            dec eax
            push [ecx+eax*4]
            jmp @1
            @2:
            call [CallAddr]
            mov _eax,eax
            mov _edx,edx
            mov eax,[p_count]
            shl eax,2
            add esp,eax
          end;
        end;
    3:  // FASTCALL
        begin
          asm
            mov ecx,PParamBuffer
            mov eax,3
            @1:
            cmp eax,[p_count]
            jle @2
            push [ecx+eax*4]
            inc eax
            jmp @1
            @2:
            //     ,  3 DWORD',
            //     ""   
            mov eax,PParamBuffer
            mov ecx,[eax+8]
            mov edx,[eax+4]
            mov eax,[eax]
            call [CallAddr]
            mov _eax,eax
            mov _edx,edx
          end;
        end;
    4:  // MSFASTCALL
        begin
          asm
            mov ecx,PParamBuffer
            mov eax,[p_count]
            @1:
            cmp eax,2
            jle @2
            dec eax
            push [ecx+eax*4]
            jmp @1
            @2:
            //     ,  2 DWORD',
            //     ""   
            mov eax,PParamBuffer
            mov edx,[eax+4]
            mov ecx,[eax]
            call [CallAddr]
            mov _eax,eax
            mov _edx,edx
          end;
        end
    else Result:=CMD_INVALID_CALLING_CONVENTION;
  end; //case
  {$ENDIF}

  {$IFDEF Win64}
    { TODO :       64-  }
    Result:=CMD_OK;
  {$ENDIF}

 end;//if DoCall
  if Result=CMD_OK then
    begin
      //  ,   
      if UseVarForResult then
        begin
            if DoCall then //     -  
              begin
                i:=_edx;
                Result:=Variable_qStoreINTEGER(context,VarForResult,(i shl 32)+_eax)
              end
            //     -     
            else Result:=Variable_qStoreDWORD(context,VarForResult,_eax)
        end;
    end;
end; // if Result=CMD_OK

_Exit:
  //  ,    
  if PParamBuffer<>@ParamBuffer
    then FreeMem(PParamBuffer);
  UA_Destroy(PArrayHeader(FncAsUStr));
  context.IP:=NextCommand;
end;

function WND_FIND_x2(var context:TScriptContext; const GetWhat:TGetWhat):integer;
var i,var_from,var_to:Cardinal;
    a_hwnd,ToPtr:PCardinal;// ,   / 
    state:TParamState;
    var_addr:PNeoS0MVariable;
    vt:TVarType;
    NewArr:PArrayHeader;
    wnd_count:Cardinal;
begin
  //    -   
 var_from:=LoadParameter_DWORD(context,state,0);
 if state<>PARAM_OK then result:=CMD_PARAM_ERROR else Result:=CMD_OK;

 //  ,     
 if result=CMD_OK then
  begin
    var_to:=LoadParameter_DWORD(context,state,var_from);
    if state=PARAM_INVALID then result:=CMD_PARAM_ERROR;
  end;

  if Result=CMD_OK then
    begin
      var_addr:=Variable_GetAddress(context,var_from);
      vt:=var_addr^.VarType;
      if (vt=vtDWORD) or (vt=vtDWORDArray) then
        begin
          if vt=vtDWORD then //     
            begin
              a_hwnd:=@(var_addr^.AsDWORD);
              wnd_count:=1;
            end
          else //     
            begin
              if var_addr^.UA=nil
               then wnd_count:=0
               else
                begin
                 with PUA_DWORD(var_addr^.UA)^ do
                   begin
                     a_hwnd:=@Arr;
                     wnd_count:=Header.ElemCount;
                   end;//with
                end;//else
            end;
        end//if
      else begin Result:=CMD_NOT_WND_LIST; exit; end;
      //      ,     
      NewArr:=UA_Create(wnd_count,SizeOf(HWND));
      ToPtr:=@(PUA_DWORD(NewArr)^.Arr);
      //        
      for i:=1 to wnd_count do
        begin
          if GetWhat=gwParent
            then ToPtr^:=GetParent(a_hwnd^)
            else ToPtr^:=GetWindow(a_hwnd^,sysGetWhat[GetWhat]);
          inc(a_hwnd);
          inc(ToPtr);
        end;//for
      Result:=Variable_AssignArray(context,var_to,NewArr,vtDWORDArray);
      if Result<>CMD_OK //       -   
        then UA_Destroy(NewArr);
    end;//if Result=CMD_OK
end;
{$WARNINGS ON}

function C_WND_FIND_PARENT(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_x2(context,gwParent);
end;

function C_WND_FIND_FIRST_CHILD(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_x2(context,gwFirstChild);
end;

function C_WND_FIND_OWNER(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_x2(context,gwOwner);
end;

function C_WND_FIND_PREV(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_x2(context,gwPrev);
end;

function C_WND_FIND_NEXT(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_x2(context,gwNext);
end;


function WND_FIND_ALL_x(var context:TScriptContext; const GetWhat:TGetWhat):integer;
label wnd_search_loop;
var var_to:Cardinal;
    hwnd:Cardinal;//  
    NewArr:PArrayHeader;
begin
  //   
  Result:=_hashReadvar_hashDE(context,hwnd,False,var_to);

  if Result=CMD_OK then
    begin
      //   
      NewArr:=UA_CreateR(0,SizeOf(HWND));
      //       
      wnd_search_loop:
        if hwnd<>0 then
          begin
            if GetWhat=gwParent
             then hwnd:=GetParent(hwnd)
             else hwnd:=GetWindow(hwnd,sysGetWhat[GetWhat]);
          end;
      if hwnd<>0 then
        begin
          _AddDWORDToArray(PUA_DWORD(NewArr),hwnd,1);
          goto wnd_search_loop;
      end;
      Result:=Variable_AssignArray(context,var_to,NewArr,vtDWORDArray);
      if Result<>CMD_OK //       -   
        then UA_Destroy(NewArr);
    end;// if Result=CMD_OK
end;

function C_WND_FIND_ALL_PARENTS(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_ALL_x(context,gwParent);
end;

function C_WND_FIND_ALL_OWNERS(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_ALL_x(context,gwOwner);
end;

function C_WND_FIND_ALL_PREV(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_ALL_x(context,gwPrev);
end;

function C_WND_FIND_ALL_NEXT(var context:TScriptContext):integer;
begin
  Result:=WND_FIND_ALL_x(context,gwNext);
end;

function C_B_x(var context:TScriptContext;IsCRC32:Boolean):integer;
var BinBlock:PUA_BinaryBlock;
    write_to:Cardinal;
    state:TParamState;
    crc32:Cardinal;
    md5:MD5_CTX;
begin
  BinBlock:=LoadParameter_BinBlock(context,state);
  if state<>PARAM_OK then begin result:=CMD_PARAM_ERROR; Exit; end;

  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin result:=CMD_PARAM_ERROR; Exit; end;

  if IsCRC32 then //  CRC32
    begin
      CRC32_Init(crc32);
      CRC32_Calc(@BinBlock^.arr,BB_Length(BinBlock),crc32);
      Result:=Variable_qStoreDWORD(context,write_to,not crc32);
    end
  else
    begin
      MD5_Init(md5);
      MD5_Update(md5,@BinBlock^.arr,BB_Length(BinBlock));
      MD5_Final(md5);
      with md5
        do Result:=Variable_qWriteBinary(context,write_to,@Digest,SizeOf(Digest));
    end;
end;

function C_B_CRC32(var context:TScriptContext):integer;
begin
  Result:=C_B_x(context,True);
end;

function C_B_MD5(var context:TScriptContext):integer;
begin
  Result:=C_B_x(context,False);
end;

function C_B_TO_HEX(var context:TScriptContext):integer;
var state:TParamState;
    BinBlock,Res:PUA_BinaryBlock;
    write_to,sz,i:Cardinal;
    p1,p2:PByte;
begin
  BinBlock:=LoadParameter_BinBlock(context,state);
  if state<>PARAM_OK then begin result:=CMD_PARAM_ERROR; Exit; end;

  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin result:=CMD_PARAM_ERROR; Exit; end;

  with BinBlock^ do
    begin
      sz:=Header.ElemCount-2;
      p1:=@Arr;
    end;

  if sz=0
    then Result:=Variable_AssignArray(context,write_to,@EmptyBinaryBlock,vtBinBlock)
  else
    begin
      Res:=BB_Allocate(sz+sz);
      if Res=nil then Result:=CMD_OUT_OF_MEMORY
        else
          begin
            p2:=@Res^.Arr;
            for i:=1 to sz do
              begin
                PAnsiChar(p2)^:=HexDigits[p1^ shr 4];
                Inc(p2);
                PAnsiChar(p2)^:=HexDigits[p1^ and $0F];
                Inc(p2);
                Inc(p1);
              end;
            Result:=Variable_qStoreBinary(context,write_to,Res);
            if Result<>CMD_OK then UA_Destroy(PArrayHeader(Res));
          end;
    end;//else
end;

function C_FILE_CHECKSUM(var context:TScriptContext;IsCrc32:Boolean):integer;
label Finish;
type TFileLen=packed record
        case Integer of
          0: (Lo,Hi:Cardinal);
          1: (Full:UInt64);
      end;
const READ_BLOCK_SIZE=$100000; //    
var state:TParamState;
    fname:PUA_UnicodeString;
    buf:Pointer;
    hfile,write_to:Cardinal;
    flen:TFileLen;
    crc32,size,readed:Cardinal;
    MD5:MD5_CTX;
begin
  //   -  
  fname:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK then begin result:=CMD_PARAM_ERROR; Exit; end;

  //   -  
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin result:=CMD_PARAM_ERROR; goto Finish; end;

  hfile:=CreateFileW(@fname^.Arr,GENERIC_READ,FILE_SHARE_READ,context.SecurityAttributes,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  if hfile=INVALID_HANDLE_VALUE then
    begin
      Result:=CMD_CANT_OPEN_FILE;
      context.LastWindowsError:=GetLastError;
    end
  else
    begin
      //  
      GetMem(buf,READ_BLOCK_SIZE);
      //   
      flen.Lo:=GetFileSize(hfile,@flen.Hi);
      //    
      if IsCRC32
        then CRC32_Init(crc32)
        else MD5_Init(md5);
      //          
      while flen.Full>0 do
        begin
          if flen.Full>=READ_BLOCK_SIZE
            then size:=READ_BLOCK_SIZE
            else size:=flen.Full;
          ReadFile(hfile,buf^,size,readed,nil);
          if readed=size //   ,  
            then Dec(flen.Full,readed)
            else begin //   ,  .      
                  flen.Full:=0;
                  context.LastWindowsError:=GetLastError;
                 end;
          //        
          if IsCRC32
            then CRC32_Calc(buf,readed,crc32)
            else MD5_Update(md5,buf,readed);
        end;//while
      //         
      if IsCRC32 then
        begin
          crc32:=not crc32;
          Result:=Variable_qStoreDWORD(context,write_to,crc32);
        end
      else
        begin
          MD5_Final(md5);
          Result:=Variable_qWriteBinary(context,write_to,@md5.Digest,SizeOf(md5.Digest));
        end;
      //  
      CloseHandle(hfile);
      //  
      FreeMem(buf);
    end;//else
Finish:
  //   Unicode-,    
  UA_Destroy(PArrayHeader(fname));
end;

function C_FILE_CRC32(var context:TScriptContext):integer;
begin
  Result:=C_FILE_CHECKSUM(context,True);
end;

function C_FILE_MD5(var context:TScriptContext):integer;
begin
  Result:=C_FILE_CHECKSUM(context,False);
end;

{$WARNINGS OFF}
function C_x_TO_B(var context:TScriptContext; in_type:TParamType):integer;
var state:TParamState;
    d,write_to,sz:Cardinal;
    i:Int64;
    f:Extended;
    data:Pointer;
begin
  case in_type of
    ptDWORD:     begin d:=LoadParameter_DWORD(context,state,0); data:=@d; sz:=SizeOf(Cardinal); end;
    ptInteger:   begin i:=LoadParameter_INTEGER(context,state,0); data:=@i; sz:=SizeOf(Int64); end;
    ptExtended:  begin f:=LoadParameter_FLOAT(context,state,0); data:=@f; sz:=SizeOf(Extended); end;
  end;
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;

  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK
    then Result:=Variable_qWriteBinary(context,write_to,data,sz)
    else Result:=CMD_PARAM_ERROR;

end;
{$WARNINGS ON}

function C_D_TO_B(var context:TScriptContext):integer;
begin
  Result:=C_x_TO_B(context,ptDWORD);
end;

function C_I_TO_B(var context:TScriptContext):integer;
begin
  Result:=C_x_TO_B(context,ptInteger);
end;

function C_F_TO_B(var context:TScriptContext):integer;
begin
  Result:=C_x_TO_B(context,ptExtended);
end;

{$WARNINGS OFF}
function C_B_TO_x(var context:TScriptContext; in_type:TParamType):integer;
var state:TParamState;
    bb:PUA_BinaryBlock;
    write_to:Cardinal;
begin
  bb:=LoadParameter_BinBlock(context,state);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

  write_to:=LoadParameter_DWORD(context,state,0);
if state=PARAM_OK then
begin
  if BB_Length(bb)<>ParamTypeSize[in_type]
   then Result:=CMD_BIN_BLOCK_LENGTH_NOT_COMPATIBLE
   else
    begin
      with bb^ do
      begin
        case in_type of
          ptDWORD:    Result:=Variable_qStoreDWORD(context,write_to,PCardinal(@Arr)^);
          ptInteger:  Result:=Variable_qStoreINTEGER(context,write_to,PInt64(@Arr)^);
          ptExtended: Result:=Variable_qStoreFLOAT(context,write_to,PExtended(@Arr)^);
        end;//case
      end;//with
    end;
end else Result:=CMD_PARAM_ERROR;
end;
{$WARNINGS ON}

function C_B_TO_D(var context:TScriptContext):integer;
begin
  Result:=C_B_TO_x(context,ptDWORD);
end;

function C_B_TO_I(var context:TScriptContext):integer;
begin
  Result:=C_B_TO_x(context,ptINTEGER);
end;

function C_B_TO_F(var context:TScriptContext):integer;
begin
  Result:=C_B_TO_x(context,ptEXTENDED);
end;

function C_WND_SET_FOREGROUND(var context:TScriptContext):integer;
var state:TParamState;
    wnd_var:Cardinal;
    c_tid:Cardinal;
begin
 wnd_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK  then
  begin
    c_tid:=GetCurrentThreadId;
    Result:=ApplyOperationToWindows(context,wnd_var,@woSetForegroundWindow,@c_tid)
  end
  else Result:=CMD_PARAM_ERROR;
end;

function SysFolderToVariable(var context:TScriptContext;sf_idx,var_idx:Cardinal):Cardinal;
var sysfolder:array[0..MAX_PATH] of WideChar;
    f_res:BOOL;
begin
  if sf_idx>High(SysFolders)
    then Result:=CMD_INVALID_SYSFOLDER_INDEX
    else
      begin
//        f_res:=SHGetFolderPathA(0,SysFolders[sf_idx].csidl,0,0 {SHGFP_TYPE_CURRENT},@sysfolder);
        f_res:=SHGetSpecialFolderPathW(0,@sysfolder[0],SysFolders[sf_idx].csidl,False);
        if f_res
          then Result:=Variable_qWriteUnicodeString(context,var_idx,@sysfolder,lstrlenW(sysfolder))
          else Result:=Variable_AssignArray(context,var_idx,@EmptyUnicodeString,vtUnicodeString);
      end;//else
end;

{$WARNINGS OFF}
function C_SYSFOLDER_GET_BY_NAME(var context:TScriptContext):integer;
var state:TParamState;
    sf_name:PUA_UnicodeString;
    sf_idx,write_to:Cardinal;
    i:Integer;
    psfn:PWideChar;
    sfl:Integer;
begin
  sf_name:=LoadParameter_UnicodeString(context,state);
  if (state=PARAM_OK) or (state=PARAM_DEFAULT) then
    begin
      Result:=CMD_OK;
      if State=PARAM_DEFAULT
        then sf_idx:=0
        else begin //        
                Result:=CMD_INVALID_SYSFOLDER_NAME;
                psfn:=@sf_name^.Arr;
                sfl:=UStr_Length(sf_name);
                for i := Low(SysFolders) to High(SysFolders) do
                  begin
                    with SysFolders[i] do
                      begin
                        if _USTR_CompareI(Name,Length(Name),psfn,sfl)=0 then
                          begin
                            //     
                            sf_idx:=i;
                            Result:=CMD_OK;
                            Break;
                          end;
                      end;//with
                  end;//for
             end;//else
      write_to:=LoadParameter_DWORD(context,state,0);
      if Result=CMD_OK then //     -    
      begin
        if state=PARAM_OK
          then Result:=SysFolderToVariable(context,sf_idx,write_to)
          else Result:=CMD_PARAM_ERROR;
      end;
      UA_Destroy(PArrayHeader(sf_name));
    end
  else Result:=CMD_PARAM_ERROR;
end;
{$WARNINGS ON}

{$WARNINGS OFF}
function C_SYSFOLDER_GET_BY_INDEX(var context:TScriptContext):integer;
var state:TParamState;
    sf_index,write_to:Cardinal;
begin
  sf_index:=LoadParameter_DWORD(context,state,0);
  if (state<>PARAM_INVALID) and (state<>PARAM_END) then
    begin
      write_to:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_OK
        then Result:=SysFolderToVariable(context,sf_index,write_to)
        else Result:=CMD_PARAM_ERROR;
    end
  else Result:=CMD_PARAM_ERROR;
end;
{$WARNINGS ON}

function C_SYSFOLDER_NAME_BY_INDEX(var context:TScriptContext):integer;
var state:TParamState;
    sf_index,write_to:Cardinal;
begin
  sf_index:=LoadParameter_DWORD(context,state,Low(SysFolders));
  case state of
    PARAM_END:      Result:=CMD_PARAM_TYPE_MISMATCH;
    PARAM_INVALID:  Result:=CMD_PARAM_ERROR;
    else Result:=CMD_OK;
  end;//case

  if Result=CMD_OK then
    begin
      write_to:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_OK
        then
          begin
            with SysFolders[sf_index] do
            begin
              if sf_index>High(SysFolders) //       
                then Result:=Variable_AssignArray(context,write_to,@EmptyBinaryBlock,vtBinBlock)
                else Result:=Variable_qWriteUnicodeString(context,write_to,Name,Length(Name));
            end;//with
          end // if Result=CMD_OK
        else Result:=CMD_PARAM_ERROR
    end;//if Result=CMD_OK
end;

{$WARNINGS OFF}
function C_USTR_TO_FILENAME_PARTS(var context:TScriptContext):integer;
var state:TParamState;
    fn_var,fn_to,path_to,file_to,ext_to:Cardinal;
    use_fn_to,use_path_to,use_file_to,use_ext_to:Boolean;
    varptr:PNeoS0MVariable;
    i,DotPos,HashPos,fn_len,w_from,w_len:Cardinal;
const has_default=[PARAM_DEFAULT,PARAM_END];
begin
  //   -  ,     
  fn_var:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin result:=CMD_PARAM_ERROR; Exit; end;
  use_path_to:=False;
  use_file_to:=False;
  use_ext_to:=False;

  //   -      
  fn_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_INVALID
   then begin result:=CMD_PARAM_ERROR; Exit; end
   else use_fn_to:=not (state in has_default);

  if state<>PARAM_END then //1
  begin
    //   -    
    path_to:=LoadParameter_DWORD(context,state,0);
    if state=PARAM_INVALID
      then begin result:=CMD_PARAM_ERROR; Exit; end
    else use_path_to:=not (state in has_default);

    if state<>PARAM_END then //2
    begin
      //   -    
      file_to:=LoadParameter_DWORD(context,state,0); //
      if state=PARAM_INVALID then
        begin
          result:=CMD_PARAM_ERROR;
          Exit;
        end
        else use_file_to:=not (state in has_default);

      if state<>PARAM_END then //3
      begin
        //   -    
        ext_to:=LoadParameter_DWORD(context,state,0);
        if state=PARAM_INVALID
          then begin result:=CMD_PARAM_ERROR; Exit; end
          else use_ext_to:=not (state in has_default);
      end;// if state<>PARAM_END 3
    end;// if state<>PARAM_END 2
  end;// if state<>PARAM_END 1

  //       
  varptr:=Variable_GetAddress(context,fn_var);
  if varptr=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else
    begin
      DotPos:=_MINUS_ONE;
      HashPos:=_MINUS_ONE;
      if varptr^.VarType=vtUnicodeString then
        begin
          //   
          fn_len:=UStr_Length(PUA_UnicodeString(VarPtr^.UA));
          with PUA_UnicodeString(VarPtr^.UA)^ do
            begin
              //       
              for i:=fn_len downto 0 do
                begin
                  case Arr[i] of
                    '.':      if DotPos=_MINUS_ONE
                                then DotPos:=i;
                    '/','\':  begin HashPos:=i; break; end;
                  end;//case
                end;//for
              //     , .. ,
              //      
              Result:=CMD_OK;
              if HashPos=_MINUS_ONE
                then w_from:=0
                else w_from:=HashPos+1;
              if use_fn_to then //     
              begin
                Result:=Variable_qWriteUnicodeString(context,fn_to,@Arr[w_from],fn_len-w_from);
                if Result<>CMD_OK then Exit;
              end;
              if use_path_to then //    
              begin
              //    , .. ,
              //      ,   
                if HashPos=_MINUS_ONE
                  then Result:=Variable_AssignArray(context,path_to,@EmptyUnicodeString,vtUnicodeString)
                  else Result:=Variable_qWriteUnicodeString(context,path_to,@Arr,HashPos+1);
                if Result<>CMD_OK then Exit;
              end;
              //    , .. ,
              //       
              if HashPos=_MINUS_ONE //      -       
               then w_from:=0 //   -    
               else w_from:=HashPos+1; //      
              //       
              if (DotPos=_MINUS_ONE) or (DotPos=w_from)
              //             "._"
               then w_len:=fn_len-w_from //   -    
               else w_len:=DotPos-w_from;
              if use_file_to then //     
              begin
                if w_len=0
                  then Result:=Variable_AssignArray(context,file_to,@EmptyUnicodeString,vtUnicodeString)
                  else Result:=Variable_qWriteUnicodeString(context,file_to,@Arr[w_from],w_len);
                if Result<>CMD_OK then Exit;
              end;

              if use_ext_to then //    
              begin
                //   , .. ,   
                if (DotPos=_MINUS_ONE) or (DotPos=w_from) //             "._"
                  then Result:=Variable_AssignArray(context,ext_to,@EmptyUnicodeString,vtUnicodeString)
                  else Result:=Variable_qWriteUnicodeString(context,ext_to,@Arr[DotPos+1],fn_len-DotPos-1);
                end;//with
            end;
        end
      else Result:=CMD_TYPECAST_IMPOSSIBLE;
    end;//else
end;
{$WARNINGS ON}

type TBuildFileTreeIntData=record
        StoreFullPath:Boolean;
        FullTree:Boolean;
        UseFileNameArray:Boolean;
        FileNameArray:PUA_UnicodeStringList;
        FileSizeArray:PUA_Integer;
        AttrArray:PUA_DWORD;
        CreaDateArray,LastAccArray,LastWriteArray:PUA_Integer;
        DepthArray:PUA_DWORD;
        MaxDepth:Cardinal;
        buffer_for_data:WIN32_FIND_DATAW;
        IgnoreSymlinks:Boolean;
     end;

function AddDataToArrays(const Path:UnicodeString; cur_depth:Cardinal;
          var int_data:TBuildFileTreeIntData):Boolean;
var fn:UnicodeString;
    i64:Int64;
begin
with int_data,int_data.buffer_for_data do
begin
  //    '.'  '..'  
  fn:=cFileName;
  Result:=(fn='.') or (fn='..');
  if Result
    then Exit;
  //    ,    "  "
  if not FullTree
   then if (dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY)=0
          then Exit;
  //   
  if UseFileNameArray then
    begin
      if StoreFullPath
        then fn:=Path+'\'+fn;
      UStrL_Add(FileNameArray,PWideChar(fn));
    end;// if FileNameArray<>nil
  //   
  { TODO : ,       >4Gb }
  if FileSizeArray<>nil
   then begin
          i64:=nFileSizeHigh;
          i64:=(i64 shl 32)+nFileSizeLow;
          _AddIntegerToArray(FileSizeArray,i64,1);
        end;
  //   
  if AttrArray<>nil
    then _AddDWORDToArray(AttrArray,dwFileAttributes,1);
  //   
  if CreaDateArray<>nil
    then _AddIntegerToArray(CreaDateArray,Int64(ftCreationTime),1);
  //    
  if LastAccArray<>nil
    then _AddIntegerToArray(LastAccArray,Int64(ftLastAccessTime),1);
  //    
  if LastWriteArray<>nil
    then _AddIntegerToArray(LastWriteArray,Int64(ftLastWriteTime),1);
  //   
  if DepthArray<>nil
    then _AddDWORDToArray(DepthArray,cur_depth,1);
end;//with
end;

//     
//  -      NIL,     
function FileBuildTree(cur_path:UnicodeString;
          scan_depth:Cardinal;
          var int_data:TBuildFileTreeIntData):Cardinal;
label search_loop;
var fenum:HANDLE;
    skip_it:Boolean;
begin
  Result:=CMD_OK;
  fenum:=FindFirstFileW(PWideChar(cur_path+'\*'),int_data.buffer_for_data);
  if fenum<>INVALID_HANDLE_VALUE then
    begin
      try
        skip_it:=AddDataToArrays(cur_path,scan_depth,int_data);
        if (int_data.buffer_for_data.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY)<>0  then
        //  , ,     
        begin
            //    "   ", ,    
            if int_data.IgnoreSymlinks
              then skip_it:=skip_it or ((int_data.buffer_for_data.dwFileAttributes and FILE_ATTRIBUTE_REPARSE_POINT)<>0);
            if (scan_depth<int_data.MaxDepth) and (not skip_it)
              then FileBuildTree(cur_path+'\'+int_data.buffer_for_data.cFileName,scan_depth+1,int_data);
        end;//if (for_data...
        //        
        search_loop:
        if FindNextFileW(fenum,int_data.buffer_for_data) then
          begin
            skip_it:=AddDataToArrays(cur_path,scan_depth,int_data);
            if (int_data.buffer_for_data.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY)<>0  then
            //  , ,     
              begin
                //    "   ", ,    
                if int_data.IgnoreSymlinks
                  then skip_it:=skip_it or ((int_data.buffer_for_data.dwFileAttributes and FILE_ATTRIBUTE_REPARSE_POINT)<>0);
                if (scan_depth<int_data.MaxDepth) and (not skip_it)
                  then FileBuildTree(cur_path+'\'+int_data.buffer_for_data.cFileName,scan_depth+1,int_data);
              end;//if (for_data...
            goto search_loop;
          end;// if FindNextFileW(fenum,for_data)
      finally
        FindClose(fenum);
      end;
    end// if fenum<>INVALID_HANDLE_VALUE
    else
      begin
        if scan_depth=1
          then Result:=CMD_INVALID_FILETREE_ROOT;
      end;
end;

{$WARNINGS OFF}
function C_FILE_BUILD_x_TREE(var context:TScriptContext;BuildFullTree:Boolean):Integer;
label DoIt,Finish;
var state:TParamState;
    start_dir:PUA_UnicodeString;
    l,TreeVar,SizeVar,AttrVar,LevelVar:Cardinal;
    UseSizeVar,UseAttrVar,UseLevelVar:Boolean;
    CreaVar,LastAccVar,LastModVar:Cardinal;
    UseCreaVar,UseLastAccVar,UseLastModVar:Boolean;
    BuildTreeData:TBuildFileTreeIntData;
    StartPath:UnicodeString;
begin
  with BuildTreeData do
    begin
      StoreFullPath:=True;
      FullTree:=BuildFullTree;
      MaxDepth:=MAX_FILESYSTEM_SCAN_DEPTH;
      IgnoreSymlinks:=(context.IgnoreSymlinks<>0);
      UseFileNameArray:=False;
      FileNameArray:=nil; //   -   ,    
    end;//with
//   - ,    
  start_dir:=LoadParameter_UnicodeString(context,state);
  Result:=CMD_OK;
  UseSizeVar:=False;
  UseAttrVar:=False;
  UseLevelVar:=False;
  UseCreaVar:=False;
  UseLastAccVar:=False;
  UseLastModVar:=False;
  case state of
    PARAM_DEFAULT:    start_dir:=@EmptyUnicodeString;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        begin
                        start_dir:=@EmptyUnicodeString;
                        goto DoIt;
                      end;
  end;//case
//   -    
  TreeVar:=LoadParameter_DWORD(context,state,0);
  Result:=CMD_OK;
  case state of
    PARAM_OK:         BuildTreeData.UseFileNameArray:=True;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        goto DoIt;
  end;//case
//   -       ?
  BuildTreeData.StoreFullPath:=LoadParameter_DWORD(context,state,1)>0;
  Result:=CMD_OK;
  case state of
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        goto DoIt;
  end;//case

//   -    
  SizeVar:=LoadParameter_DWORD(context,state,0);
  Result:=CMD_OK;UseSizeVar:=False;
  case state of
    PARAM_OK:         UseSizeVar:=True;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        goto DoIt;
  end;//case
//   -    
  AttrVar:=LoadParameter_DWORD(context,state,0);
  Result:=CMD_OK;UseAttrVar:=False;
  case state of
    PARAM_OK:         UseAttrVar:=True;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        goto DoIt;
  end;//case
//   -     
  CreaVar:=LoadParameter_DWORD(context,state,0);
  Result:=CMD_OK;UseCreaVar:=False;
  case state of
    PARAM_OK:         UseCreaVar:=True;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        goto DoIt;
  end;//case
//   -       
  LastAccVar:=LoadParameter_DWORD(context,state,0);
  Result:=CMD_OK;UseLastAccVar:=False;
  case state of
    PARAM_OK:         UseLastAccVar:=True;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        goto DoIt;
  end;//case
//   -      
  LastModVar:=LoadParameter_DWORD(context,state,0);
  Result:=CMD_OK;UseLastModVar:=False;
  case state of
    PARAM_OK:         UseLastModVar:=True;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        goto DoIt;
  end;//case
//   -    
  LevelVar:=LoadParameter_DWORD(context,state,0);
  Result:=CMD_OK;UseLevelVar:=False;
  case state of
    PARAM_OK:         UseLevelVar:=True;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoIt;
                      end;
    PARAM_END:        goto DoIt;
  end;//case
//   - .  
  BuildTreeData.MaxDepth:=LoadParameter_DWORD(context,state,MAX_FILESYSTEM_SCAN_DEPTH);
  if state=PARAM_INVALID then Result:=CMD_PARAM_ERROR;

DoIt:
  if Result=CMD_OK then
    begin
      //      -  nil,
      //    ,   
      with BuildTreeData do
      begin
        // ,   ,  
        //    ( )
        if UseFileNameArray then
          begin
            if Variable_GetAddress(context,TreeVar)=nil then
              begin
                Result:=CMD_INVALID_VARIABLE_INDEX;
                goto Finish;
              end
            else FileNameArray:=UStrL_Create;
          end;
        if UseSizeVar then
          begin
            // ,   ,     
            if Variable_GetAddress(context,SizeVar)=nil then
              begin
                Result:=CMD_INVALID_VARIABLE_INDEX;
                goto Finish;
              end
            else FileSizeArray:=PUA_Integer(UA_CreateR(0,SizeOf(Int64)))
          end
          else FileSizeArray:=nil;
        if UseAttrVar then
          begin
            if Variable_GetAddress(context,AttrVar)=nil then
              begin
                Result:=CMD_INVALID_VARIABLE_INDEX;
                goto Finish;
              end
            else AttrArray:=PUA_DWORD(UA_CreateR(0,SizeOf(Cardinal)))
          end
          else AttrArray:=nil;
        if UseLevelVar then
          begin
            if Variable_GetAddress(context,LevelVar)=nil then
              begin
                Result:=CMD_INVALID_VARIABLE_INDEX;
                goto Finish;
              end
            else DepthArray:=PUA_DWORD(UA_CreateR(0,SizeOf(Cardinal)))
          end
          else DepthArray:=nil;
        if UseCreaVar then
          begin
            if Variable_GetAddress(context,CreaVar)=nil then
              begin
                Result:=CMD_INVALID_VARIABLE_INDEX;
                goto Finish;
              end
            else CreaDateArray:=PUA_Integer(UA_CreateR(0,SizeOf(Int64)))
          end
          else CreaDateArray:=nil;
        if UseLastAccVar then
          begin
            if Variable_GetAddress(context,LastAccVar)=nil then
              begin
                Result:=CMD_INVALID_VARIABLE_INDEX;
                goto Finish
              end
            else LastAccArray:=PUA_Integer(UA_CreateR(0,SizeOf(Int64)))
          end
          else LastAccArray:=nil;
        if UseLastModVar then
          begin
            if Variable_GetAddress(context,LastModVar)=nil then
              begin
                Result:=CMD_INVALID_VARIABLE_INDEX;
                goto Finish;
              end
              else LastWriteArray:=PUA_Integer(UA_CreateR(0,SizeOf(Int64)))
          end
          else LastWriteArray:=nil;
      end;//with

      StartPath:=PWideChar(@(start_dir^.Arr));
      l:=Length(StartPath);
      //    ,   ,  , ..   
      if l>0 then
        begin
          if (StartPath[l]='\') or (StartPath[l]='/')
            then SetLength(StartPath,l-1);
        end;
      Result:=FileBuildTree(StartPath,1,BuildTreeData);

      //        
      //    ,     
      with BuildTreeData do
      begin
        if UseFileNameArray then
          begin
            if Result=CMD_OK
              then Variable_AssignArray(context,TreeVar,PArrayHeader(FileNameArray),vtUnicodeStringList)
              else UStrL_Destroy(FileNameArray);
          end;
        if UseSizeVar then
          begin
            if Result=CMD_OK
              then Variable_AssignArray(context,SizeVar,PArrayHeader(FileSizeArray),vtIntArray)
              else UA_Destroy(PArrayHeader(FileSizeArray));
          end;
        if UseAttrVar then
          begin
            if Result=CMD_OK
              then Variable_AssignArray(context,AttrVar,PArrayHeader(AttrArray),vtDWORDArray)
              else UA_Destroy(PArrayHeader(AttrArray));
          end;
        if UseLevelVar then
          begin
            if Result=CMD_OK
              then Variable_AssignArray(context,LevelVar,PArrayHeader(DepthArray),vtDWORDArray)
              else UA_Destroy(PArrayHeader(DepthArray));
          end;
        if UseCreaVar then
          begin
            if Result=CMD_OK
              then Variable_AssignArray(context,CreaVar,PArrayHeader(CreaDateArray),vtIntArray)
              else UA_Destroy(PArrayHeader(CreaDateArray));
          end;
        if UseLastAccVar then
          begin
            if Result=CMD_OK
              then Variable_AssignArray(context,LastAccVar,PArrayHeader(LastAccArray),vtIntArray)
              else UA_Destroy(PArrayHeader(LastAccArray));
          end;
        if UseLastModVar then
          begin
            if Result=CMD_OK
              then Variable_AssignArray(context,LastModVar,PArrayHeader(LastWriteArray),vtIntArray)
              else UA_Destroy(PArrayHeader(LastWriteArray));
          end;
      end;//with
    end;//if Result=CMD_OK
Finish:
  UA_Destroy(PArrayHeader(start_dir));
end;
{$WARNINGS OFF}

function C_FILE_BUILD_DIR_TREE(var context:TScriptContext):integer;
begin
  Result:=C_FILE_BUILD_x_TREE(context,False);
end;

type TCompactProcInfo=packed record
       pids:PUA_DWORD;
       names:PUA_UnicodeStringList;
       parents:PUA_DWORD
     end;

procedure AddProcInfo(var cpi:TCompactProcInfo; pid:Cardinal; fname:PWideChar; parent:Cardinal);
begin
with cpi do
begin
  if pids<>nil
    then _AddDWORDToArray(pids,pid,1);
  if fname<>nil
    then UStrL_Add(names,fname);
  if parents<>nil
    then _AddDWORDToArray(parents,parent,1);
end;//with
end;

function PIDListViaNA(var cpi:TCompactProcInfo):Integer;
label loop;
const STATUS_SUCCESS=0;
      _EmptyMyUnicodeString:WideChar=#0;

type TMyUnicodeString=packed record
      Length:WORD;
      MaximumLength:WORD;
      Buffer:PWideChar;
     end;

  SYSTEM_PROCESSES = packed record
     NextEntryDelta, //        
     ThreadCount: dword;
     Reserved1 : array [0..5] of DWORD;
     CreateTime,
     UserTime,
     KernelTime: LARGE_INTEGER;
     ProcessName:TMyUnicodeString; //    Unicode
     BasePriority: Cardinal;
     ProcessId,              // PID
     InheritedFromProcessId, // PID 
     HandleCount: dword;
     Reserved2: array [0..1] of DWORD;
     VmCounters: Pointer;
     IoCounters: Pointer; // ,   NT4   -    
//   Threads: array [0..0] of SYSTEM_THREADS;      
  end;//SYSTEM_PROCESSES

var bufsize:Cardinal;
    res:NTStatus;
    buffer:Pointer;
    onerec:^SYSTEM_PROCESSES;
begin
  bufsize:=0;
  buffer:=nil;
  repeat
    if buffer<>nil
      then FreeMem(buffer);
    //       64.
    //    -  ,   
    Inc(bufsize,$10000);
    GetMem(buffer,bufsize);
    //   ,   ,
    //    
    res:=ZwQuerySystemInformation(5,buffer,bufsize,bufsize);
  until res=STATUS_SUCCESS;
  //       
  onerec:=buffer;

  loop:
  with onerec^ do
  begin
    if ProcessName.Buffer=nil
      then ProcessName.Buffer:=@_EmptyMyUnicodeString;
    AddProcInfo(cpi,ProcessId,ProcessName.Buffer,InheritedFromProcessId);
  end;//with

  if onerec^.NextEntryDelta<>0 then
    begin
      Inc(PByte(onerec),onerec^.NextEntryDelta);
      goto loop;
    end;

  //  ,   
  FreeMem(buffer);
  Result:=CMD_OK;
end;

function C_FILE_BUILD_FULL_TREE(var context:TScriptContext):integer;
begin
  Result:=C_FILE_BUILD_x_TREE(context,True);
end;

{$WARNINGS OFF}
function C_PROCESS_GET_LIST(var context:TScriptContext):integer;
label DoIt;
var var_pid,var_name,var_parent:Cardinal;
    use_var_pid,use_var_name,use_var_parent:Boolean;
    state:TParamState;
    cpi:TCompactProcInfo;
begin
  use_var_parent:=False;
  use_var_name:=False;
  Result:=CMD_PARAM_ERROR;
//   -    PID
  var_pid:=LoadParameter_DWORD(context,state,0);
  use_var_pid:=(state=PARAM_OK);
  case state of
    PARAM_INVALID:  Exit;
    PARAM_END:      goto DoIt;
  end;
//   -    
  var_name:=LoadParameter_DWORD(context,state,0);
  use_var_name:=(state=PARAM_OK);
  case state of
    PARAM_INVALID:  Exit;
    PARAM_END:      goto DoIt;
  end;
//   -     PID
  var_parent:=LoadParameter_DWORD(context,state,0);
  use_var_parent:=(state=PARAM_OK);
  if state=PARAM_INVALID
    then Exit;

DoIt:
  //   
  if (Variable_GetAddress(context,var_pid)=nil) or
     (Variable_GetAddress(context,var_name)=nil) or
     (Variable_GetAddress(context,var_parent)=nil)
  then
    begin
      Result:=CMD_INVALID_VARIABLE_INDEX;
      Exit;
    end;

  with cpi do
  begin
    //    
    if use_var_pid
      then pids:=PUA_DWORD(UA_CreateR(0,SizeOf(Cardinal)))
      else pids:=nil;
    if use_var_name
      then names:=UStrL_Create
      else names:=nil;
    if use_var_parent
      then parents:=PUA_DWORD(UA_CreateR(0,SizeOf(Cardinal)))
      else parents:=nil;
    //     NativeAPI

    Result:=PIDListViaNA(cpi);

    //      ,
    //    
    if Result=CMD_OK then
      begin
        if use_var_pid
          then Variable_AssignArray(context,var_pid,PArrayHeader(pids),vtDWORDArray);
        if use_var_name
          then Variable_AssignArray(context,var_name,PArrayHeader(names),vtUnicodeStringList);
        if use_var_parent
          then Variable_AssignArray(context,var_parent,PArrayHeader(parents),vtDWORDArray);
      end//if Result=CMD_OK
   else
      begin
        context.LastWindowsError:=GetLastError;
        if use_var_pid
          then UA_Destroy(PArrayHeader(pids));
        if use_var_name
          then UStrL_Destroy(names);
        if use_var_parent
          then UA_Destroy(PArrayHeader(parents));
      end;//else
  end;//with
end;
{$WARNINGS ON}

function C_SYSTEM_x(var context:TScriptContext;do_what:Cardinal):integer;
begin
  Result:=CMD_POWEROFF_FAILED;
  ForcePowerPrivilege; //   -       
  if ShutdownPrivilege then
  //    
  //        ShellAPI
    begin
      if ExitWindowsEx(do_what,$40001)  //SHTDN_REASON_MAJOR_APPLICATION or SHTDN_REASON_MINOR_MAINTENANCE
        then Result:=CMD_OK;
      context.LastWindowsError:=GetLastError;  
    end;
  context.LastWindowsError:=GetLastError;
end;

function C_SYSTEM_SHUTDOWN(var context:TScriptContext):integer;
begin
  Result:=C_SYSTEM_x(context,EWX_POWEROFF or EWX_FORCEIFHUNG);
end;

function System_SLEEP_x(var context:TScriptContext; IsHibernate:Boolean):integer;
begin
  LoadPwrProf;
  if Assigned(SetSuspendState) then
    begin
      if SetSuspendState(IsHibernate,False,False)
        then Result:=CMD_OK
        else Result:=CMD_SLEEP_FAILED;
      context.LastWindowsError:=GetLastError;  
    end
  else Result:=CMD_NOT_SUPPORTED_BY_OS;
end;

function C_SYSTEM_HIBERNATE(var context:TScriptContext):Integer;
begin
  Result:=System_SLEEP_x(context,True);
end;

function C_SYSTEM_SLEEP(var context:TScriptContext):Integer;
begin
  Result:=System_SLEEP_x(context,False);
end;

function C_SYSTEM_LOGOFF(var context:TScriptContext):Integer;
begin
  Result:=C_SYSTEM_x(context,EWX_LOGOFF or EWX_FORCEIFHUNG);
end;

function C_SYSTEM_REBOOT(var context:TScriptContext):Integer;
begin
  Result:=C_SYSTEM_x(context,EWX_REBOOT or EWX_FORCEIFHUNG);
end;

function C_x_SECTION_x(var context:TScriptContext; UseFilename:Boolean):Integer;
label DoIt,Finish;
var state:TParamState;
    fname:PUA_UnicodeString;
    sname:PUA_BinaryBlock;
    handle_var:Cardinal;
    section_idx:Integer;
    hfile,written,start,len:Cardinal;
begin
  len:=0;
  sname:=LoadParameter_BinBlock(context,state);
  if state=PARAM_OK then
    begin
      if UseFilename
        then fname:=LoadParameter_UnicodeString(context,state)
        else handle_var:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_OK then
        begin
          start:=LoadParameter_DWORD(context,state,0);
          case state of
            PARAM_INVALID:  begin
                              Result:=CMD_PARAM_ERROR;
                              goto Finish;
                            end;
            PARAM_END:      goto DoIt;
          end;//case

          len:=LoadParameter_DWORD(context,state,0);
          if state=PARAM_INVALID then
            begin
              Result:=CMD_PARAM_ERROR;
              goto Finish;
            end;

        DoIt:
          section_idx:=FindSection(context,sname);
          if section_idx=-1
            then Result:=CMD_SECTION_NOT_FOUND
            else
             //         
              begin
               if start>context.SectionIndex[section_idx].SectionLength
                //       
                then  Result:=CMD_INVALID_OFFSET_IN_SECTION
                else
                  begin
                    if UseFileName then
                    //     -   
                    begin
                      hfile:=CreateFileW(@fname^.Arr,GENERIC_WRITE,FILE_SHARE_READ,context.SecurityAttributes,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
                      if hfile=INVALID_HANDLE_VALUE
                        then Result:=CMD_CANT_OPEN_FILE
                        else Result:=CMD_OK;
                    end
                    //    -     
                    else Result:=Variable_qLoadDWORD(context,handle_var,hfile);
                  end;//else
               if Result=CMD_OK then
                 begin
                   SetFilePointer(hfile,0,nil,FILE_BEGIN);
                   with context.SectionIndex[section_idx] do
                     begin
                       //   ,    
                       if len=0
                         then len:=SectionLength-start
                         else
                           //        - 
                           if len>SectionLength-start then len:=SectionLength-start;
                       if not WriteFile(hfile,Pointer(Cardinal(SectionPtr)+start)^,len,written,nil)
                        then Result:=CMD_WRITE_FILE_FAILED;
                     end;//with
                  //    ,     
                   if UseFilename then
                     begin
                      //   ,       
                      SetEndOfFile(hfile);
                      //  
                      CloseHandle(hfile);
                     end;
                 end;//if Result=CMD_OK
              end;//else
        end//if state=PARAM_OK
      else Result:=CMD_PARAM_ERROR;
    Finish:
      UA_Destroy(PArrayHeader(fname));
    end//if state=PARAM_OK
  else Result:=CMD_PARAM_ERROR;
end;

function C_SECTION_TO_FILE(var context:TScriptContext):Integer;
begin
  Result:=C_x_SECTION_x(context,True);
end;


function C_SECTION_ds(var context:TScriptContext; GetSize:Boolean):Integer;
var state:TParamState;
    sname:PUA_BinaryBlock;
    write_to,value:Cardinal;
    section_idx:Integer;
begin
  sname:=LoadParameter_BinBlock(context,state);
  if state=PARAM_OK then
    begin
      write_to:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_OK then
        begin
          section_idx:=FindSection(context,sname);
          if section_idx=-1
            then Result:=CMD_SECTION_NOT_FOUND
            else
              begin
                with context.SectionIndex[section_idx] do
                  begin
                    if GetSize
                      then value:=SectionLength
                      else value:=Cardinal(SectionPtr);
                  end;//with
                Result:=Variable_qStoreDWORD(context,write_to,value);
              end;//else
        end
      else Result:=CMD_PARAM_ERROR;
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_SECTION_DATA(var context:TScriptContext):integer;
begin
  Result:=C_SECTION_ds(context,False);
end;

function C_SECTION_SIZE(var context:TScriptContext):integer;
begin
  Result:=C_SECTION_ds(context,True);
end;

function C_EXTERNAL_UNLOAD_ALL(var context:TScriptContext):integer;
begin
  UnloadAllLibraries;
  Result:=CMD_OK;
end;

procedure C_MONITOR_x(code:Integer);
begin
  PostMessageA(HWND_BROADCAST,WM_SYSCOMMAND,SC_MONITORPOWER,code);
end;

function C_MONITOR_OFF(var context:TScriptContext):integer;
begin
  C_MONITOR_x(2);
  Result:=CMD_OK;
end;

function C_MONITOR_ON(var context:TScriptContext):integer;
begin
  C_MONITOR_x(-1);
  Result:=CMD_OK;
end;

function C_MONITOR_SLEEP(var context:TScriptContext):integer;
begin
  C_MONITOR_x(1);
  Result:=CMD_OK;
end;

function C_FILE_WRITE_SECTION(var context:TScriptContext):integer;
begin
  Result:=C_x_SECTION_x(context,False);
end;

function C_SYSTEM_LOCK(var context:TScriptContext):integer;
begin
  if not Assigned(SystemLock)
    then SystemLock:=GetProcAddress(User32Handle,'LockWorkStation');
  if Assigned(SystemLock)
    then
      begin
        if SystemLock
          then Result:=CMD_OK
          else Result:=CMD_CANT_LOCK_WORKSTATION;
        context.LastWindowsError:=GetLastError;
      end
    else Result:=CMD_NOT_SUPPORTED_BY_OS;
end;

function C_STR_EXPAND(var context:TScriptContext):integer;
label DoIt;
var state:TParamState;
    str_to_expand,expander,res:PUA_BinaryBlock;
    write_to,expand_to,method:Cardinal;

    idx,fillpos,filllen:Cardinal;
    len,i,_start,_end:Integer;
    RightAlign:Boolean;
begin
  method:=0;
  //   -   
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;
  //   -  
  str_to_expand:=LoadParameter_BinBlock(context,state);
  case state of
    PARAM_DEFAULT: str_to_expand:=@EmptyBinaryBlock;
    PARAM_INVALID,PARAM_END: begin Result:=CMD_PARAM_ERROR; Exit; end;
  end;
  //   - ,     
  expand_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;
  //   - -
  expander:=LoadParameter_BinBlock(context,state);
  case state of
    PARAM_DEFAULT: expander:=@SpaceBinaryBlock;
    PARAM_END: begin expander:=@SpaceBinaryBlock; goto DoIt; end;
    PARAM_INVALID: begin Result:=CMD_PARAM_ERROR; Exit; end;
  end;
  //   -  
  method:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_INVALID then begin Result:=CMD_PARAM_ERROR; Exit; end;

DoIt:  
  //       
  filllen:=BB_Length(expander);
  if (expand_to=0) or (filllen=0) then
    begin
      Result:=CMD_STRING_TOO_SHORT;
      Exit;
    end;

  len:=BB_Length(str_to_expand);
  _end:=Max(len,expand_to);
  res:=BB_Allocate(_end);
  //      ,     0
  RightAlign:=(method and 1)<>0;
  //    
  if len>0 then
    begin
      if RightAlign then
        //    
          begin
            idx:=Integer(_end)-len;
            _start:=0;
            _end:=_end-len-1;
          end
        //    
        else
          begin
            idx:=0;
            _start:=len;
            Dec(_end);
          end;
      Move(str_to_expand^.Arr[0],res^.Arr[idx],len)
    end
   else begin _start:=0; Dec(_end); end;
  fillpos:=0;
  //    
  for i:=_start to _end do
    begin
      //   
      res^.Arr[i]:=expander^.Arr[fillpos];
      //    
      if fillpos=filllen-1
        then fillpos:=0
        else Inc(fillpos);
    end;//for
  //         
  Result:=Variable_AssignArray(context,write_to,PArrayHeader(res),vtBinBlock);
  if Result<>CMD_OK then UA_Destroy(PArrayHeader(res))
end;

function C_DIR_CREATE(var context:TScriptContext):integer;
var state:TParamState;
    dir_name:PUA_UnicodeString;
begin
  dir_name:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_OK then
    begin
      if CreateDirectoryW(@dir_name^.Arr,context.SecurityAttributes)
        then Result:=CMD_OK
        else
          begin
            Result:=CMD_CREATE_DIRECTORY_FAILED;
            context.LastWindowsError:=GetLastError;
          end;
      //    ,    
      UA_Destroy(PArrayHeader(dir_name));
    end
  else Result:=CMD_PARAM_ERROR;
end;

procedure DelIt(fname:PWideChar; Forced:Boolean; attribs:Cardinal);
begin
  //    -   
  if (attribs and FILE_ATTRIBUTE_DIRECTORY)=0 then
    begin
      if Forced
        then SetFileAttributesW(fname,FILE_ATTRIBUTE_ARCHIVE);
      DeleteFileW(fname);
    end;
end;

function EnterHere(Recursive, IgnoreSymlinks:Boolean; attribs:Cardinal):Boolean;
begin
  Result:=Recursive and ((attribs and FILE_ATTRIBUTE_DIRECTORY)=FILE_ATTRIBUTE_DIRECTORY);
  //   
  if IgnoreSymlinks
    then Result:=Result and ((attribs and FILE_ATTRIBUTE_REPARSE_POINT)=0);
end;

function AddBackslashToDir(const d:String):String;
var ch:WideChar;
begin
  Result:=d;
  if d<>'' then
    begin
      ch:=d[Length(d)];
      if (ch<>'\') and (ch<>'/')
        then Result:=Result+'\'
    end;//if d<>''
end;

function rmdir(start:UnicodeString;Recursive,DelNonEmpty,Forced,IgnoreSymlinks:Boolean):Integer;
label loop;
var f_h:Cardinal;
    ffd:WIN32_FIND_DATAW;
    fname:UnicodeString;
begin
  start:=AddBackslashToDir(start);
  //    
  if DelNonEmpty then
    begin
      f_h:=FindFirstFileW(PWideChar(start+'*'),ffd);
      try
        if f_h=INVALID_HANDLE_VALUE then
          begin
            Result:=GetLastError;
            Exit
          end;
        fname:=ffd.cFileName;
        if (fname<>'.') and (fname<>'..') then
          begin
            fname:=start+fname;
            if EnterHere(Recursive,IgnoreSymlinks,ffd.dwFileAttributes)
              then rmdir(fname,Recursive,DelNonEmpty,Forced,IgnoreSymlinks);
            DelIt(PWideChar(fname),Forced,ffd.dwFileAttributes);
          end;
        //        
        loop:
        if FindNextFileW(f_h,ffd) then
          begin
            fname:=ffd.cFileName;
            if (fname<>'.') and (fname<>'..') then
              begin
                fname:=start+fname;
                if EnterHere(Recursive,IgnoreSymlinks,ffd.dwFileAttributes)
                  then rmdir(fname,Recursive,DelNonEmpty,Forced,IgnoreSymlinks);
                DelIt(PWideChar(fname),Forced,ffd.dwFileAttributes);
              end;
            goto loop;
          end// if FindNextFileW(fenum,for_data)
      finally
        FindClose(f_h);
      end;//try/finally
    end;//if DelNonEmpty
  if RemoveDirectoryW(PWideChar(start))
    then Result:=0
    else begin
            //     
            if Forced then
              begin
                //      ReadOnly,   
                SetFileAttributesW(PWideChar(start),GetFileAttributesW(PWideChar(start)) and (not FILE_ATTRIBUTE_READONLY));
                //    
                if RemoveDirectoryW(PWideChar(start))
                  then Result:=0
                  else Result:=GetLastError;
              end//if Forced
            else Result:=GetLastError;
          end;
end;

function C_DIR_DELETE(var context:TScriptContext):integer;
var state:TParamState;
    dir_name:PUA_UnicodeString;
    attribs:Cardinal;
    s:UnicodeString;
begin
  dir_name:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;
  attribs:=LoadParameter_DWORD(context,state,7);
  if state=PARAM_INVALID
    then Result:=CMD_PARAM_ERROR
    else
      begin
        if dir_name=nil
          then s:=''
          else s:=PWideChar(@dir_name^.Arr);
        context.LastWindowsError:=rmdir(s,(attribs and 1)=1,(attribs and 2)=2,(attribs and 4)=4,context.IgnoreSymlinks<>0);
        if context.LastWindowsError=0
          then Result:=CMD_OK
          else Result:=CMD_REMOVE_DIRECTORY_FAILED;
      end;
  UA_Destroy(PArrayHeader(dir_name));
end;

procedure CopyMoveFile(const s_a:PSecurityAttributes; i_from,i_to:UnicodeString;find_data:WIN32_FIND_DATAW; MoveMode:Boolean; var err_count:Integer);
begin
  with find_data do
    begin
      i_from:=i_from+cFileName;
      i_to:=i_to+cFileName;
    end;//with
  if not CopyFileW(PWideChar(i_from),PWideChar(i_to),False) then Inc(err_count);
  if MoveMode then //   
    begin
      SetFileAttributesW(PWideChar(i_from),FILE_ATTRIBUTE_ARCHIVE);
      if not DeleteFileW(PWideChar(i_from))
        then Inc(err_count);
    end;
end;

procedure CopyMoveDir(const s_a:PSecurityAttributes; const dir_from, dir_to:UnicodeString; MoveMode,IgnoreSymlinks:Boolean; var err_count:Integer);
label loop,fail;
var f_h:HANDLE;
    ffd:WIN32_FIND_DATAW;
    fname:UnicodeString;
begin
  //    ,  
  if not CreateDirectoryW(PWideChar(dir_to),s_a) then
    begin
      //        ,  
      if GetLastError<>ERROR_ALREADY_EXISTS then
        begin
          Inc(err_count);
          Exit;
        end;//if GetLastError...
    end;
  //  , , /   
  f_h:=FindFirstFileW(PWideChar(dir_from+'*'),ffd);
  try
    if f_h=INVALID_HANDLE_VALUE then
      begin
        Inc(err_count);
        Exit;
      end;//if f_h=INVALID_HANDLE_VALUE
    fname:=ffd.cFileName;
    if (fname<>'.') and (fname<>'..') then
      begin
        if EnterHere(True,IgnoreSymlinks,ffd.dwFileAttributes)
          then CopyMoveDir(s_a,dir_from+fname+'\',dir_to+fname+'\',MoveMode,IgnoreSymlinks,err_count)
          else CopyMoveFile(s_a,dir_from,dir_to,ffd,MoveMode,err_count);
        if err_count<>0
          then goto fail;
      end;

    //        
    loop:
    if FindNextFileW(f_h,ffd) then
      begin
        fname:=ffd.cFileName;
        if (fname<>'.') and (fname<>'..') then
          begin
            if EnterHere(True,IgnoreSymlinks,ffd.dwFileAttributes)
              then CopyMoveDir(s_a,dir_from+fname+'\',dir_to+fname+'\',MoveMode,IgnoreSymlinks,err_count)
              else CopyMoveFile(s_a,dir_from,dir_to,ffd,MoveMode,err_count);
            if err_count<>0 then goto fail;
          end;
        goto loop;
      end;// if FindNextFileW(fenum,for_data)
    fail:
  finally
    FindClose(f_h);
  end;//try/finally
  //          -   
  if MoveMode and (err_count=0) then
    begin
      if not RemoveDirectoryW(PWideChar(dir_from)) then
        //      -   
        begin
          SetFileAttributesW(PWideChar(dir_from),FILE_ATTRIBUTE_ARCHIVE);
          if not RemoveDirectoryW(PWideChar(dir_from))
            then Inc(err_count);
        end;
    end;
end;

function DIR_x(var context:TScriptContext; MoveDir:Boolean):Integer;
label loop,Finish;
var _from,_to:PUA_UnicodeString;
    dir_from,dir_to:UnicodeString;
    state:TParamState;
    e_c:Integer;
begin
  _to:=nil;
  _from:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;
  _to:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;

  dir_from:=AddBackslashToDir(UStr_To_String(_from));
  dir_to:=AddBackslashToDir(UStr_To_String(_to));

  e_c:=0;
  CopyMoveDir(context.SecurityAttributes,dir_from,dir_to,MoveDir,context.IgnoreSymlinks<>0,e_c);
  if e_c=0
    then Result:=CMD_OK
    else Result:=CMD_CANT_COPY_MOVE_DIR;
Finish:
  UA_Destroy(PArrayHeader(_from));
  UA_Destroy(PArrayHeader(_to));
end;

function C_DIR_RENAME(var context:TScriptContext):integer;
begin
  Result:=Dir_X(context,True);
end;

function C_USTR_FROM_FILENAME_PARTS(var context:TScriptContext):integer;
label Finish;
var state:TParamState;
    write_to:Cardinal;
    f_path,f_name,f_ext,res,dot:PUA_UnicodeString;
begin
  //   -   
  write_to:=LoadParameter_DWORD(context,state,0);
  f_name:=nil;
  f_ext:=nil;
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;

  //   -   
  f_path:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

  //   -  
  f_name:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_INVALID  then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;

  //   - 
  f_ext:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;

  if f_path=nil
    then f_path:=@EmptyUnicodeString;
  if f_name=nil
    then f_name:=@EmptyUnicodeString;
  if f_ext=nil
    then f_ext:=@EmptyUnicodeString;

  if UStr_Length(f_name)=0 //   
    then Result:=CMD_INVALID_FILE_NAME
    else
      begin
        //   -    
        res:=UStr_Duplicate(f_path);
        //    ,        (  )
        if UStr_Length(res)<>0
          then UStr_Add_BackSlash(res);
        //   -   
        if UStr_Length(f_ext)<>0
          then dot:=@DotUnicodeString //    
          else dot:=nil;              //     -   
        //       ( ,   )
        UStr_Concat(res,f_name,dot);
        //    -      
        if dot<>nil
          then UStr_Concat(res,f_ext,nil);
        //  
        Result:=Variable_AssignArray(context,write_to,PArrayHeader(res),vtUnicodeString);
        //     -   
        if Result<>CMD_OK
          then UA_Destroy(PArrayHeader(res));
      end;

Finish:
  UA_Destroy(PArrayHeader(f_path));
  UA_Destroy(PArrayHeader(f_name));
  UA_Destroy(PArrayHeader(f_ext));
end;

function C_DIR_COPY(var context:TScriptContext):integer;
begin
  Result:=Dir_X(context,False);
end;

{$WARNINGS OFF}
function MEM_GET_X(var context:TScriptContext; read_what:Cardinal):Integer;
var write_to,rva,len:Cardinal;
    state:TParamState;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;

  rva:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;
  //       -    
  if read_what=4 then
  begin
    len:=LoadParameter_DWORD(context,state,0);
    if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;
  end;

  try
    case read_what of
      0:  Result:=Variable_qStoreDWORD(context,write_to,PByte(rva)^);
      1:  Result:=Variable_qStoreDWORD(context,write_to,PCardinal(rva)^);
      2:  Result:=Variable_qStoreINTEGER(context,write_to,PInt64(rva)^);
      3:  Result:=Variable_qStoreFLOAT(context,write_to,PExtended(rva)^);
      4:  Result:=Variable_qWriteBinary(context,write_to,Pointer(rva),len);
      5:  begin
            len:=lstrlenA(PAnsiChar(rva));
            Result:=Variable_qWriteBinary(context,write_to,Pointer(rva),len)
          end;
      6:  Result:=Variable_qStoreDWORD(context,write_to,PWord(rva)^);
      7:  begin
            len:=lstrlenW(PWideChar(rva));
            Result:=Variable_qWriteUnicodeString(context,write_to,PWideChar(rva),len)
          end;
    end;//case
  except
    Result:=CMD_CANT_READ_PROCCESS_MEM;
  end;
end;
{$WARNINGS ON}

function C_MEM_GET_B(var context:TScriptContext):integer;
begin
  Result:=MEM_GET_X(context,0);
end;

function C_MEM_GET_D(var context:TScriptContext):integer;
begin
  Result:=MEM_GET_X(context,1);
end;

function C_MEM_GET_I(var context:TScriptContext):integer;
begin
  Result:=MEM_GET_X(context,2);
end;

function C_MEM_GET_F(var context:TScriptContext):integer;
begin
  Result:=MEM_GET_X(context,3);
end;

function C_MEM_GET_BB(var context:TScriptContext):integer;
begin
  Result:=MEM_GET_X(context,4);
end;

function C_MEM_GET_STR(var context:TScriptContext):integer;
begin
  Result:=MEM_GET_X(context,5);
end;

function C_STR_REPLACE(var context:TScriptContext):integer;
var my_str,substr_to_replace,new_substr,res_str:PUA_BinaryBlock;
    write_to,case_sens:Cardinal;
    state:TParamState;

    found:array of Integer;
    add_to,found_pos,new_pos,my_str_len,repl_len,new_len,i,j,min_r_char:Integer;
    c:AnsiChar;
begin
  case_sens:=0;
  //   -   
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;

  //   - ,     
  my_str:=LoadParameter_BinBlock(context,state);
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;

  //   - ,   
  substr_to_replace:=LoadParameter_BinBlock(context,state);
  if state<>PARAM_OK then begin Result:=CMD_PARAM_ERROR; Exit; end;

  //   - ,    
  new_substr:=LoadParameter_BinBlock(context,state);
  case state of
    PARAM_OK: ;
    PARAM_DEFAULT, PARAM_END: new_substr:=@EmptyBinaryBlock;
    else begin Result:=CMD_PARAM_ERROR; Exit; end;
  end;

  //   -   
  if state<>PARAM_END then
    begin
      case_sens:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_INVALID then begin Result:=CMD_PARAM_ERROR; Exit; end;
    end;

  //   
  my_str_len:=BB_Length(my_str);
  repl_len:=BB_Length(substr_to_replace);
  new_len:=BB_Length(new_substr);

  add_to:=0;
  found_pos:=0;
  repeat
    //    
    found_pos:=_StrPosEx(@substr_to_replace^.Arr,repl_len,@my_str^.Arr,my_str_len,found_pos,case_sens<>0);
    //   -      
    if found_pos<>-1 then
      begin
        if Length(found)=add_to then SetLength(found,add_to+16);
        found[add_to]:=found_pos;
        Inc(found_pos,repl_len); //       
        Inc(add_to);
      end
  until found_pos=-1;
  //         
  res_str:=BB_Allocate(my_str_len+(new_len-repl_len)*add_to);

  found_pos:=0;
  new_pos:=0;
  //       
  if repl_len>new_len then min_r_char:=new_len-1 else min_r_char:=repl_len-1;
with my_str^ do
begin
  for i:=0 to add_to-1 do
    begin
      //        ,
      //    ,     ,
      //  ,    ,  
      if found_pos<>found[i] then
        begin
          Move(Arr[found_pos],res_str^.Arr[new_pos],found[i]-found_pos);
          Inc(new_pos,found[i]-found_pos);
        end;
      //       
      if new_len>0 then
        begin
          Move(new_substr^.Arr[0],res_str^.Arr[new_pos],new_len);
          if case_sens>=2 then //     
            begin
              found_pos:=found[i]; //     found_pos  
              for j:=0 to min_r_char do
                begin
                  //    
                  c:=AnsiChar(res_str^.Arr[new_pos+j]);
                  //         
                  case CharCase[AnsiChar(Arr[found_pos])] of
                    #1:  res_str^.Arr[new_pos+j]:=Byte(ToLowerTable[c]); //      
                    #2:  res_str^.Arr[new_pos+j]:=Byte(ToUpperTable[c]); //      
                    //      (#0),      
                  end;//case
                  //   new_pos         
                  Inc(found_pos);
                end;//for
            end;
          //  ,    
          Inc(new_pos,new_len);
        end;//if new_len>0
      //   -       
      //     
      found_pos:=found[i]+repl_len;
    end;//for

  //   
  if (my_str_len-found_pos+1)>0
   then Move(Arr[found_pos],res_str^.Arr[new_pos],my_str_len-found_pos+1);
end;//with
  //      
  Result:=Variable_AssignArray(context,write_to,PArrayHeader(res_str),vtBinBlock);
  //     .
  //     
  if Result<>CMD_OK
    then UA_Destroy(PArrayHeader(res_str));
end;

function DIALOG_x_FILE(var context:TScriptContext; IsOpenFileDialog:Boolean):Integer;
label DoIt, Finish;
const OFN_ALLOWMULTISELECT=$00000200;

type DialogFn=function(var ofn:TagOFNW):Bool;stdcall;

var state:TParamState;
    write_to:Integer;
    fname_dir,fname_filter,wnd_hdr,CurrentDir:PUA_UnicodeString;
    AllowMulti,flg,DelimPos:Cardinal;

    filter_ptr:PWideChar;
    FileListBuffer:PWideChar;
    fname, filter:UnicodeString;
    ofn:tagOFNW;
    MyFn:DialogFn;

    wnd_owner:Cardinal;
    // 32 ( )    
begin
  AllowMulti:=IfThen(IsOpenFileDialog,1,0);

  fname_filter:=nil;
  wnd_hdr:=nil;
  wnd_owner:=0;
  flg:=OFN_EXPLORER; //     - 
  //   -   
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

  //   -     
  fname_dir:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      Exit;
                    end;
  end;

  //   - 
  fname_filter:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;

  //   -  
  wnd_hdr:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;

  //   -   ?
  AllowMulti:=LoadParameter_DWORD(context,state,AllowMulti);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;

  //   -  
  flg:=LoadParameter_DWORD(context,state,flg);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;

  //   - ,     - 
  wnd_owner:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end
  else
    begin
      //     -     
      if state=PARAM_OK then
        begin
          Result:=VariableOrArray_qLoadDWORD(context,wnd_owner,wnd_owner);
          if Result<>CMD_OK
            then goto Finish;
        end;//if state=PARAM_OK
    end;

DoIt:

  with ofn do
  begin
    ZeroMemory(@ofn,SizeOf(ofn));
    ofn.lStructSize:=SizeOf(ofn);
    //    
    lpstrFile:=nil;
    //  -
    hWndOwner:=wnd_owner;
    //        
    if fname_dir=nil
      then lpstrInitialDir:=nil
      else //    /  
      begin
        //  
        fname:=fname_dir^.Arr;
        //  
        lpstrInitialDir:=PWideChar(fname);
        //  -    
        DelimPos:=Pos('|',fname);
        // - ?
        if DelimPos<>0 then
          begin
            //  -    ,     
            fname[DelimPos]:=#0;
            //       
            lpstrFile:=@fname[DelimPos+1];
            //       -    nil
            if lstrlenW(lpstrInitialDir)=0
              then lpstrInitialDir:=nil;
            //      -    nil
            if lstrlenW(lpstrFile)=0
              then lpstrFile:=nil;
          end//if delim_pos<>0
      end;//if not default_fname_dir

    //  
    //    AllowMulti      
    if AllowMulti<>0
      then Flags:=flg or OFN_ALLOWMULTISELECT
      else Flags:=flg and (not OFN_ALLOWMULTISELECT);

    //  
    if fname_filter=nil     //   - " ",
      then lpstrFilter:=nil //   .   nil
      else
        begin
          //     1   -    #0,
          // ..     
          SetLength(filter,fname_filter^.Header.ElemCount);
          //   1  ,   -
          // (..   #0)
          //   #0     UnicodeString    Delphi
          Move(fname_filter^.Arr[0],filter[1],fname_filter^.Header.ElemCount shl 1);
          //      '|'  #0
          for DelimPos:=1 to Length(filter)
            do if filter[DelimPos]='|'
                then filter[DelimPos]:=#0;
          lpstrFilter:=PWideChar(filter);
        end;
    //  
    if wnd_hdr=nil //    
      then lpstrTitle:=PWideChar(KernelName)
      else lpstrTitle:=@wnd_hdr^.Arr;
  end;//with

  if IsOpenFileDialog
    then MyFn:=GetOpenFileNameW
    else MyFn:=GetSaveFileNameW;
  //    Unicode-
  Result:=Variable_InitUStrL(context,write_to);
  if Result=CMD_OK then
  begin
    // Get/SetOpenFileName    -  
    CurrentDir:=UStr_GetCurrentDirectory;
    //    
    GetMem(FileListBuffer,context.FileDialogBufferSize shl 1);
    //   " "  "  " 
    ofn.nMaxFile:=context.FileDialogBufferSize;
    //       -    
    if ofn.lpstrFile<>nil then
      begin
        DelimPos:=Min(lstrlenW(ofn.lpstrFile),context.FileDialogBufferSize-1);
        Move(ofn.lpstrFile^,FileListBuffer^,DelimPos shl 1);
      end
    else DelimPos:=0;
    //      
    (FileListBuffer+DelimPos)^:=#0;
    //         
    ofn.lpstrFile:=FileListBuffer;

    // , , 
    if MyFn(ofn) then
      begin
        //   
        filter_ptr:=FileListBuffer;
        //     -  
        if (ofn.Flags and OFN_EXPLORER)=0 then
          //   ,  "".
          //    #0,      
          begin
            while filter_ptr^<>#0 do
              begin
                if filter_ptr^=' '
                  then filter_ptr^:=#0;
                Inc(filter_ptr);
              end;
            //      
            //   c "" 
            (filter_ptr+1)^:=#0;
            //  filter_ptr   
            filter_ptr:=FileListBuffer;
          end;
          //        Unicode-
          filter:=filter_ptr;

          //      
          Inc(filter_ptr,Length(filter)+1);
          //    #0, ,     -     Unicode-
          if filter_ptr^=#0
            then Result:=Variable_AddItemUStrL(context,write_to,PWideChar(filter),Length(filter))
            else filter:=AddBackslashToDir(filter); //        -  
          while filter_ptr^<>#0 do
            begin
              //   
              fname:=filter_ptr;
              //    
              Inc(filter_ptr,Length(fname)+1);
              //      
              fname:=filter+fname;
              //           Unicode-
              Result:=Variable_AddItemUStrL(context,write_to,@fname[1],Length(fname));
              if Result<>CMD_OK
                then Break;
            end;//while
      end//if MyFn(ofn)
    else
      begin
        context.LastWindowsError:=CommDlgExtendedError;
        //  CommDlgExtendedError=0,   ,
        //     ""  
        if context.LastWindowsError<>0
          then Result:=CMD_DIALOG_ERROR;
      end;
    //  
    FreeMem(FileListBuffer);
    // Get/SetOpenFileName     -  
    SetCurrentDirectoryW(CurrentDir^.Arr);
    //  ,     
    UA_Destroy(PArrayHeader(CurrentDir));
  end;//if Result=CMD_OK

Finish:
  UA_Destroy(PArrayHeader(fname_dir));
  UA_Destroy(PArrayHeader(fname_filter));
  UA_Destroy(PArrayHeader(wnd_hdr));
end;

function C_DIALOG_OPEN_FILE(var context:TScriptContext):integer;
begin
  Result:=DIALOG_x_FILE(context,True);
end;

function C_DIALOG_SAVE_FILE(var context:TScriptContext):integer;
begin
  Result:=DIALOG_x_FILE(context,False);
end;

function C_IS_DIR_EXISTS(var context:TScriptContext):integer;
begin
  Result:=IS_FILE_DIR_EXISTS(context,False);
end;

{$IFDEF Win32}
type FSingeMathOp=function (const X : Extended):Extended;

function ArcSin(const X : Extended) : Extended;
asm
  fld1
  fld    X
  fst    st(2)
  fmul   st(0), st(0)
  fsubp
  fsqrt
  fpatan
end;

function ArcCos(const X : Extended) : Extended;
asm
  FLD   X
  FLD1
  FADD  ST(0), ST(1)
  FLD1
  FSUB  ST(0), ST(2)
  FMULP ST(1), ST(0)
  FSQRT
  FXCH
  FPATAN
end;

function Power(const Base, Exponent: Extended): Extended;
const
  Max  : Double = MaxInt;
var
  IntExp : Integer;
asm
  fld     Exponent
  fld     st             {copy to st(1)}
  fabs                   {abs(exp)}
  fld     Max
  fcompp                 {leave exp in st(0)}
  fstsw   ax
  sahf
  jb      @@RealPower    {exp > MaxInt}
  fld     st             {exp in st(0) and st(1)}
  frndint                {round(exp)}
  fcomp                  {compare exp and round(exp)}
  fstsw   ax
  sahf
  jne     @@RealPower
  fistp   IntExp
  mov     eax, IntExp    {eax=Trunc(Exponent)}
  mov     ecx, eax
  cdq
  fld1                   {Result=1}
  xor     eax, edx
  sub     eax, edx       {abs(exp)}
  jz      @@Exit
  fld     Base
  jmp     @@Entry
@@Loop:
  fmul    st, st         {Base * Base}
@@Entry:
  shr     eax, 1
  jnc     @@Loop
  fmul    st(1), st      {Result * X}
  jnz     @@Loop
  fstp    st
  cmp     ecx, 0
  jge     @@Exit
  fld1
  fdivrp                 {1/Result}
  jmp     @@Exit
@@RealPower:
  fld     Base
  ftst
  fstsw   ax
  sahf
  jz      @@Done
  fldln2
  fxch
  fyl2x
  fxch
  fmulp   st(1), st
  fldl2e
  fmulp   st(1), st
  fld     st(0)
  frndint
  fsub    st(1), st
  fxch    st(1)
  f2xm1
  fld1
  faddp   st(1), st
  fscale
@@Done:
  fstp    st(1)
@@Exit:
end;

function Tan(const X: Extended): Extended;
asm
        FLD    X
        FPTAN
        FSTP   ST(0)      { FPTAN pushes 1.0 after result }
        FWAIT
end;

function Log10(const X: Extended): Extended;
asm
        FLDLG2     { Log base ten of 2 }
        FLD     X
        FYL2X
        FWAIT
end;

function Log2(const X: Extended): Extended;
asm
        FLD1
        FLD     X
        FYL2X
        FWAIT
end;

function Pow2(const X: Extended): Extended;
begin
  Result:=x*x;
end;

function Pow3(const X: Extended): Extended;
begin
  Result:=x*x*x;
end;

function Root3(const X: Extended): Extended;
begin
  Result:=Power(x,1/3);
end;

function Ceil(const X: Extended): Extended;
begin
  if Frac(x)>0
    then Result:=Trunc(x)+1
    else Result:=Trunc(x);
end;

function Floor(const X: Extended): Extended;
begin
  if Frac(x)<0
    then Result:=Trunc(x)-1
    else Result:=Trunc(x);
end;

function Round1(const X: Extended): Extended;
begin
  Result:=Round(x);
end;

function Trunc1(const X: Extended): Extended;
begin
  Result:=Trunc(x);
end;

function DegToRad(const X: Extended): Extended;
begin
  Result:=x*PI/180;
end;

function RadToDeg(const X: Extended): Extended;
begin
  Result:=x*180/PI;
end;
{$ENDIF}

{$IFDEF Win64}
type FSingeMathOp=function (const X:Double):Double;

{ TODO :   64-  }

function ArcSin(const X:Double):Double;
begin
//  Result:=ArcTan2(X,Extended(Sqrt((1+X)*(1-X))))
end;

function ArcCos(const X:Double):Double;
asm
{  FLD   X
  FLD1
  FADD  ST(0), ST(1)
  FLD1
  FSUB  ST(0), ST(2)
  FMULP ST(1), ST(0)
  FSQRT
  FXCH
  FPATAN }
end;

function Power(const Base, Exponent:Double):Double;
const
  Max  : Double = MaxInt;
var
  IntExp : Integer;
asm
(*  fld     Exponent
  fld     st             {copy to st(1)}
  fabs                   {abs(exp)}
  fld     Max
  fcompp                 {leave exp in st(0)}
  fstsw   ax
  sahf
  jb      @@RealPower    {exp > MaxInt}
  fld     st             {exp in st(0) and st(1)}
  frndint                {round(exp)}
  fcomp                  {compare exp and round(exp)}
  fstsw   ax
  sahf
  jne     @@RealPower
  fistp   IntExp
  mov     eax, IntExp    {eax=Trunc(Exponent)}
  mov     ecx, eax
  cdq
  fld1                   {Result=1}
  xor     eax, edx
  sub     eax, edx       {abs(exp)}
  jz      @@Exit
  fld     Base
  jmp     @@Entry
@@Loop:
  fmul    st, st         {Base * Base}
@@Entry:
  shr     eax, 1
  jnc     @@Loop
  fmul    st(1), st      {Result * X}
  jnz     @@Loop
  fstp    st
  cmp     ecx, 0
  jge     @@Exit
  fld1
  fdivrp                 {1/Result}
  jmp     @@Exit
@@RealPower:
  fld     Base
  ftst
  fstsw   ax
  sahf
  jz      @@Done
  fldln2
  fxch
  fyl2x
  fxch
  fmulp   st(1), st
  fldl2e
  fmulp   st(1), st
  fld     st(0)
  frndint
  fsub    st(1), st
  fxch    st(1)
  f2xm1
  fld1
  faddp   st(1), st
  fscale
@@Done:
  fstp    st(1)
@@Exit:
*)
end;

function Tan(const X:Double):Double;
asm
(*        FLD    X
        FPTAN
        FSTP   ST(0)      { FPTAN pushes 1.0 after result }
        FWAIT
*)
end;

function Log10(const X:Double):Double;
asm
(*        FLDLG2     { Log base ten of 2 }
        FLD     X
        FYL2X
        FWAIT
*)
end;

function Log2(const X:Double):Double;
asm
{        FLD1
        FLD     X
        FYL2X
        FWAIT
}
end;

function Pow2(const X:Double):Double;
begin
  Result:=x*x;
end;

function Pow3(const X:Double):Double;
begin
  Result:=x*x*x;
end;

function Root3(const X:Double):Double;
begin
  Result:=Power(x,1/3);
end;

function Ceil(const X:Double):Double;
begin
  if Frac(x)>0
    then Result:=Trunc(x)+1
    else Result:=Trunc(x);
end;

function Floor(const X:Double):Double;
begin
  if Frac(x)<0
    then Result:=Trunc(x)-1
    else Result:=Trunc(x);
end;

function Round1(const X:Double):Double;
begin
  Result:=Round(x);
end;

function Trunc1(const X:Double):Double;
begin
  Result:=Trunc(x);
end;

function DegToRad(const X:Double):Double;
begin
  Result:=x*PI/180;
end;

function RadToDeg(const X:Double):Double;
begin
  Result:=x*180/PI;
end;
{$ENDIF}


function C_SINGLE_OP_MATH(var context:TScriptContext; SingleMathOp:FSingeMathOp):Integer;
var write_to:Cardinal;
    state:TParamState;
    Argument:Extended;
begin
  //  ,     
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;
  //  
  Argument:=LoadParameter_FLOAT(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;
  try
    Argument:=SingleMathOp(Argument);
    Result:=Variable_qStoreFLOAT(context,write_to,Argument);
  except
    Result:=CMD_FLOATPOINT_OVERFLOW;
  end;
end;

function C_SIN(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Sin);
end;

function C_COS(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Cos);
end;

function C_TAN(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Tan);
end;

function C_ARCTAN(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,ArcTan);
end;

function C_POW2(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Pow2);
end;

function C_POW3(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Pow3);
end;

function C_ROOT2(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Sqrt);
end;

function C_ROOT3(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Root3);
end;

function C_LN(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Ln);
end;

function C_LG(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Log10);
end;

function C_LOG2(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Log2);
end;

function C_EXP(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Exp);
end;

function C_ROUND(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Round1);
end;

function C_CEIL(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Ceil);
end;

function C_FLOOR(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Floor);
end;

function C_ARCSIN(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,ArcSin);
end;

function C_ARCCOS(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,ArcCos);
end;

function C_TRUNC(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Trunc1);
end;

function C_FRAC(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,Frac);
end;

function C_DEG_TO_RAD(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,DegToRad);
end;

function C_RAD_TO_DEG(var context:TScriptContext):Integer;
begin
  Result:=C_SINGLE_OP_MATH(context,RadToDeg);
end;

function C_PI(var context:TScriptContext):Integer;
var write_to:Cardinal;
    state:TParamState;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK
    then Result:=Variable_qStoreFLOAT(context,write_to,PI)
    else Result:=CMD_PARAM_ERROR;
end;

function EncodingConversion(var context:TScriptContext; ToOEM:Boolean):Integer;
var read_from,write_to:Cardinal;
    state:TParamState;
    v1,v2:PNeoS0MVariable;
    bb:PUA_BinaryBlock;
    len:Integer;
    start:Pointer;
begin
  read_from:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      write_to:=LoadParameter_DWORD(context,state,read_from);
      if state<>PARAM_INVALID then
        begin
          v1:=Variable_GetAddress(context,read_from);
          v2:=Variable_GetAddress(context,write_to);
          //   -  ?
          if (v1=nil) or (v2=nil) then
            begin
              Result:=CMD_INVALID_VARIABLE_INDEX;
              Exit;
            end;
          // -   ?
          if v1^.VarType<>vtBinBlock then
            begin
              Result:=CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE;
              Exit;
            end;
          //   -,        
          if v1=v2
            then if not Variable_DuplicateIfStatic(context,read_from) then
                  begin
                    Result:=CMD_OUT_OF_MEMORY;
                    Exit;
                  end;
          //      
          start:=_GetArrayItemPtr(v1,0);
          len:=_GetArrayLength(v1);
          //     ,       
          if v1=v2
            then bb:=PUA_BinaryBlock(v1^.UA)
            //    -    
            else bb:=BB_Allocate(len);
          if ToOEM
            then CharToOemBuffA(start,@bb.Arr,len)
            else OemToCharBuffA(start,@bb.Arr,len);
          //      ,       
          if v1<>v2
            then Variable_AssignArray(context,write_to,PArrayHeader(bb),vtBinBlock);
          Result:=CMD_OK;
        end
      else Result:=CMD_PARAM_ERROR;
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_STR_OEM_TO_ANSI(var context:TScriptContext):Integer;
begin
  Result:=EncodingConversion(context,False);
end;

function C_STR_ANSI_TO_OEM(var context:TScriptContext):Integer;
begin
  Result:=EncodingConversion(context,True);
end;

function C_ANSI_TO_USTR(var context:TScriptContext):Integer;
var write_to:Cardinal;
    bb:PUA_BinaryBlock;
    res:PUA_UnicodeString;
    state:TParamState;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      bb:=LoadParameter_BinBlock(context,state);
      case State of
        PARAM_DEFAULT,PARAM_END:
                  bb:=@EmptyBinaryBlock;
        PARAM_INVALID:
                  begin
                    Result:=CMD_PARAM_ERROR;
                    Exit;
                  end;
      end;//case
      //     Unicode-
      res:=BB_To_UStr(bb);
      //  Unicode- 
      Result:=Variable_AssignArray(context,write_to,PArrayHeader(res),vtUnicodeString);
      //    ,   Unicode  
      if Result<>CMD_OK
        then UA_Destroy(PArrayHeader(res));
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_USTR_TO_ANSI(var context:TScriptContext):Integer;
var state:TParamState;
    us:PUA_UnicodeString;
    res:PUA_BinaryBlock;
    write_to:Cardinal;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      us:=LoadParameter_UnicodeString(context,state);
      case State of
        PARAM_DEFAULT,PARAM_END:
                  us:=@EmptyUnicodeString;
        PARAM_INVALID:
                  begin
                    Result:=CMD_PARAM_ERROR;
                    Exit;
                  end;
      end;//case
      //  Unicode-   
      res:=UStr_To_BB(us);
      //      -  
      UA_Destroy(PArrayHeader(us));
      //  Unicode- 
      Result:=Variable_AssignArray(context,write_to,PArrayHeader(res),vtBinBlock);
      //    ,     
      if Result<>CMD_OK
        then UA_Destroy(PArrayHeader(res));
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_STO_USTR(var context:TScriptContext):Integer;
var state:TParamState;
    us:PUA_UnicodeString;
    write_to:Cardinal;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      us:=LoadParameter_UnicodeString(context,state);
      case State of
        PARAM_DEFAULT,PARAM_END:
                  us:=@EmptyUnicodeString;
        PARAM_INVALID:
                  begin
                    Result:=CMD_PARAM_ERROR;
                    Exit;
                  end;
      end;//case
      Result:=Variable_AssignArray(context,write_to,PArrayHeader(us),vtUnicodeString);
      //    ,  
      if Result<>CMD_OK
        then UA_Destroy(PArrayHeader(us));
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_I_TO_USTR(var context:TScriptContext):Integer;
begin
  Result:=C_I_TO_xSTR(context,True);
end;

function C_F_TO_USTR(var context:TScriptContext):Integer;
begin
  Result:=C_F_TO_xSTR(context,True);
end;

function TwoUnicodeStringOp(var context:TScriptContext; Operation:TTwoStringOperation):integer;
label DoIt,Finish;
var write_to,start_pos,tmp:Cardinal;
    str1,str2:PUA_UnicodeString;
    IgnoreCase:LongBool;
    state:TParamState;
    l1,l2:Integer;
begin
  Result:=CMD_PARAM_ERROR;
  tmp:=0;
  str2:=@EmptyUnicodeString;
  start_pos:=0;

  //   -   
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;

  //   -  
  str1:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK
    then Exit;

  str2:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  goto Finish;
  end;
//  if state<>PARAM_OK then Exit;

  if Operation=tsoFindSubstr then  //       -   
  begin
    start_pos:=LoadParameter_DWORD(context,state,0);
    case state of
      PARAM_END:     goto DoIt;
      PARAM_INVALID: goto Finish;
    end;//case
  end;

 //  ? 0 -  " ",  -  
 tmp:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_INVALID
  then goto Finish;

DoIt:
  //   
  IgnoreCase:=tmp=1;
  l1:=UStr_Length(str1);
  l2:=UStr_Length(str2);
  case Operation of
    tsoCompare:     tmp:=UStrComparator[IgnoreCase](@(str2^.Arr),l2,@(str1^.Arr),l1);
    tsoFindSubstr:  tmp:=UStrFinder[IgnoreCase](@(str2^.Arr),l2,@(str1^.Arr),l1,start_pos);
  end;//case
  Result:=Variable_qStoreDWORD(context,write_to,tmp);

Finish:
  UA_Destroy(PArrayHeader(str1));
  UA_Destroy(PArrayHeader(str2));
end;

function C_CMP_USTR(var context:TScriptContext):integer;
begin
  Result:=TwoUnicodeStringOp(context,tsoCompare);
end;

function C_USUBSTR_POS(var context:TScriptContext):integer;
begin
  Result:=TwoUnicodeStringOp(context,tsoFindSubstr);
end;

function C_USTR_UPPERCASE(var context:TScriptContext):integer;
begin
 Result:=C_xCASE(context,cWUpper);
end;

function C_USTR_LOWERCASE(var context:TScriptContext):integer;
begin
 Result:=C_xCASE(context,cWLower);
end;

function C_MEM_WRITE_USTR(var context:TScriptContext):integer;
begin
 Result:=MEM_WRITE_x(context,ptUnicodeString);
end;

function C_CALL_BRANCH(var context:TScriptContext):integer;
begin
  Result:=C_xBRANCH(context,True);
end;


function C_INIT_USTRL(var context:TScriptContext):Integer;
label _Failure;
var var_idx,read_from,i,j,p_count,repeat_count:Cardinal;
    state:TParamState;
    NextCommand:Pointer;
    us:PUA_UnicodeString;
    var_addr:PNeoS0MVariable;
begin
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      p_count:=GetParamCount(context.IP,NextCommand);
      repeat_count:=1;
      Result:=Variable_InitUStrL(context,var_idx);
      if result<>CMD_OK
        then goto _Failure;
      for i:=1 to p_count do
        begin
          case TParamType(PByte(context.IP)^) of
            ptByte,ptWord,ptDWORD,ptInteger,ptDefault:
                repeat_count:=LoadParameter_DWORD(context,state,1);
            ptBinBlock,ptUnicodeString:
              begin
                //   
                us:=LoadParameter_UnicodeString(context,state);
                //     - Unicode-
                for j:=1 to repeat_count do
                  begin
                    Result:=Variable_AddItemUStrL(context,var_idx,@(us^.Arr),UStr_Length(us));
                    if Result<>CMD_OK then
                      begin
                        //       
                        UA_Destroy(PArrayHeader(us));
                        goto _Failure;
                      end;
                  end;//for
                //       
                repeat_count:=1;
                //      ,     
                UA_Destroy(PArrayHeader(us));
              end;
            ptVariable:
              begin
                //  4 ,   
                read_from:=PCardinal(Cardinal(context.IP)+1)^;
                //   IP  5 
                Inc(NativeUInt(context.IP),ParamTypeSize[ptVariable]+1);
                //   
                var_addr:=Variable_GetAddress(context,read_from);
                //      - 
                if var_addr=nil then
                  begin
                    Result:=CMD_INVALID_VARIABLE_INDEX;
                    goto _Failure;
                  end;
                case var_addr^.VarType of
                  vtDWORD,vtInteger:  Variable_qLoadDWORD(context,read_from,repeat_count);
                  vtBinBlock,vtUnicodeString:
                                      begin
                                        //    BinaryBlock  UncodeString
                                        if var_addr^.VarType=vtBinBlock
                                          //   
                                          then us:=BB_To_UStr(PUA_BinaryBlock(var_addr^.UA))
                                          //    
                                          else us:=PUA_UnicodeString(var_addr^.UA);
                                        //       -  
                                        for j:=1 to repeat_count do
                                          begin
                                            Result:=Variable_AddItemUStrL(context,var_idx,@us^.Arr,UStr_Length(us));
                                            if Result<>CMD_OK
                                              then goto _Failure;
                                          end;//for
                                          repeat_count:=1;
                                        //     ,  
                                        if var_addr^.VarType=vtBinBlock
                                          then UA_Destroy(PArrayHeader(us));
                                      end;
                  else //     -  
                    begin
                      Result:=CMD_TYPECAST_IMPOSSIBLE;
                      goto _Failure;
                    end;
                end;//case
              end;
            else
              begin
                Result:=CMD_TYPECAST_IMPOSSIBLE;
                goto _Failure;
              end;
          end;//case
        end;//for
      Result:=CMD_OK;
    end
  else Result:=CMD_PARAM_ERROR;
_Failure:
  context.IP:=NextCommand;
end;

function C_STO_USTRL(var context:TScriptContext):Integer;
begin
  Result:=C_STO_xA(context,True);
end;

function C_READ_USTRL(var context:TScriptContext):Integer;
begin
  Result:=READ_xA(context,vtUnicodeStringList);
end;

function C_JOIN_USTR(var context:TScriptContext):Integer;
begin
  Result:=JOIN_x(context,ptUnicodeString);
end;

function C_STO_USTR_CHAR(var context:TScriptContext):Integer;
begin
  Result:=STO_xA(context,vtUnicodeString);
end;

function C_READ_USTR_CHAR(var context:TScriptContext):Integer;
begin
  Result:=READ_xA(context,vtUnicodeString);
end;

function C_DATE_x_To_x(var context:TScriptContext;LocalToSystem:Boolean):Integer;
var dt,res:Int64;
    var_from,var_to:Cardinal;
    state:TParamState;
begin
  Result:=CMD_PARAM_ERROR;
  //   -  ,  /
  var_from:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      //   -  ,    
      var_to:=LoadParameter_DWORD(context,state,var_from);
      if state<>PARAM_INVALID then
        begin
          //    64-    
          if Variable_GetType(context,var_from)=vtInteger then
            begin
              //  /
              Variable_qLoadINTEGER(context,var_from,dt);
              //       UTC
              if LocalToSystem
                then CorrectLocalFileTimeToFileTime(_FILETIME(dt),_FILETIME(res))
                else CorrectFileTimeToLocalFileTime(_FILETIME(dt),_FILETIME(res));
              //  
              Result:=Variable_qStoreINTEGER(context,var_to,res);
            end
          else Result:=CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE;
          //  
        end;//if state<>...
    end//if state=...
end;

function C_DATE_LOCAL_TO_SYSTEM(var context:TScriptContext):Integer;
begin
  Result:=C_DATE_x_To_x(context,True);
end;

function C_DATE_SYSTEM_TO_LOCAL(var context:TScriptContext):Integer;
begin
  Result:=C_DATE_x_To_x(context,False);
end;

function C_REG_STORE_USTR(var context:TScriptContext):Integer;
begin
  Result:=REG_VALUE_x(context,rvoStoreUStr)
end;

function C_REG_READ_USTR(var context:TScriptContext):Integer;
begin
  Result:=REG_READ_x(context,rvoReadUStr);
end;

function C_REG_VALUE_GET_TYPE(var context:TScriptContext):Integer;
begin
  Result:=REG_READ_x(context,rvoReadType);
end;

function C_FILE_WRITE_USTR(var context:TScriptContext):integer;
var handle_var,len,written:Cardinal;
    ustr:PUA_UnicodeString;
    state:TParamState;
begin
 handle_var:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_OK then
  begin
   ustr:=LoadParameter_UnicodeString(context,state);
   if state=PARAM_INVALID
    then Result:=CMD_PARAM_ERROR
    else
     begin
      Result:=Variable_qLoadDWORD(context,handle_var,handle_var);
      if (Result=CMD_OK) and (ustr<>nil) then
      begin
        len:=UStr_Length(ustr);
        if WriteFile(handle_var,ustr^.Arr,len shl 1,written,nil)
          then Result:=CMD_OK
          else Result:=CMD_WRITE_FILE_FAILED;
        context.LastWindowsError:=GetLastError;
        UA_Destroy(PArrayHeader(ustr));
      end;//if (Result=CMD_OK) and (BinBlock<>nil)
     end;//else
  end
 else Result:=CMD_PARAM_ERROR;
end;

function C_USTR_EXTRACT(var context:TScriptContext):integer;
label DoIt, Finish;
var ustr_var,write_to:Cardinal;
    delim,quote:PUA_UnicodeString;
    state:TParamState;
    dont_use_delim,dont_use_quote:Boolean;
    AddEmptyLines:Cardinal;
    VarPtr:PNeoS0MVariable;

    res_ustrl:PUA_UnicodeStringList;
begin
  Result:=CMD_PARAM_ERROR;
  dont_use_delim:=True;
  dont_use_quote:=True;
  delim:=nil;
  quote:=nil;
  AddEmptyLines:=0;
  // ,     .   
  ustr_var:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;
  // ,     
  write_to:=LoadParameter_DWORD(context,state,ustr_var);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  Exit;
  end;//case
  // -
  delim:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_OK:       dont_use_delim:=False;
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  Exit;
  end;
  // -"" (/ )
  quote:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_OK:       dont_use_quote:=False;
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  goto Finish;
  end;
  //   ?
  AddEmptyLines:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_INVALID
    then goto Finish;

DoIt:
  VarPtr:=Variable_GetAddress(context,ustr_var);
  if VarPtr=nil then //  -   -  
  begin
    Result:=CMD_INVALID_VARIABLE_INDEX;
    goto Finish;
  end;
  if VarPtr^.VarType=vtUnicodeString then //  -   
  begin
    res_ustrl:=nil;
    case IfThen(dont_use_delim,2,0)+IfThen(dont_use_quote,1,0) of
      0: //   
        begin
          Result:=ParseDandQUStr(res_ustrl,PUA_UnicodeString(VarPtr^.UA),delim,quote,AddEmptyLines<>0);
        end;
      1: //   
        begin
          Result:=ParseDelimitedUStr(res_ustrl,PUA_UnicodeString(VarPtr^.UA),delim,AddEmptyLines<>0);
        end;
      2: //   
        begin
          Result:=ParseQuotedUStr(res_ustrl,PUA_UnicodeString(VarPtr^.UA),quote,AddEmptyLines<>0);
        end;
      3: //   
        Result:=CMD_OK;
    end;//case
    if (Result=CMD_OK) and (res_ustrl<>nil) then //     
    begin
      //   -  
      Result:=Variable_AssignArray(context,write_to,PArrayHeader(res_ustrl),vtUnicodeStringList);
      if Result<>CMD_OK //       -   ,     
        then UStrL_Destroy(res_ustrl);
    end//if
  end
 else Result:=CMD_TYPECAST_IMPOSSIBLE;

Finish:
  UA_Destroy(PArrayHeader(delim));
  UA_Destroy(PArrayHeader(quote));
end;

function C_USTR_TRIM(var context:TScriptContext):Integer;
label DoIt,Finish;
type TArrayOfWideChar=packed array[0..$FFFFFFF] of WideChar;
     PArrayOfWideChar=^TArrayOfWideChar;
var trim_var,trim_method,arr_len,TrimBytesCount:Cardinal;
    FirstGood,LastGood,j:Integer;
    state:TParamState;
    TrimChars,tmp:PUA_UnicodeString;
    TrimmedChar:Boolean;
    PData:PArrayOfWideChar;
begin
  trim_method:=0;
  Result:=CMD_PARAM_ERROR;
  //   ,     
  trim_var:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;
  //   ,   
  TrimChars:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_INVALID:  Exit;
    PARAM_DEFAULT:  TrimChars:=@SpaceUnicodeString;
    PARAM_END:      begin
                      TrimChars:=@SpaceUnicodeString;
                      goto DoIt;
                    end;
  end;//case
 //   
  trim_method:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_INVALID
    then goto Finish;

DoIt:
  //   ,    
  if not Variable_DuplicateIfStatic(context,trim_var) then
  begin
    Result:=CMD_OUT_OF_MEMORY;
    goto Finish;
  end;
 Result:=Variable_qLoadxArray(context,trim_var,vtUnicodeString,Pointer(tmp));
 if Result=CMD_OK then
  begin
    Variable_GetArrayItemPtr(context,trim_var,0,arr_len);
    PData:=PArrayOfWideChar(@(tmp^.Arr[0]));
    if PData<>nil then
      begin
        TrimBytesCount:=UStr_Length(TrimChars);
        //  ,    ,  
        //  FirstGood  LastGood      
        FirstGood:=0;
        LastGood:=arr_len-1;
        //       -       
        //       
        if (trim_method=0) or (trim_method=1) then
          begin
          for FirstGood:=FirstGood to LastGood do
            begin
              TrimmedChar:=False;
              for j:=0 to TrimBytesCount-1
                do TrimmedChar:=TrimmedChar or (PData^[FirstGood]=TrimChars^.Arr[j]);
              if not TrimmedChar
                then Break;
            end;//for FirstGood
         end//if (trim_method=0) or (trim_method=1)
        else FirstGood:=0;
        //       
        if (trim_method=0) or (trim_method=2) then
          begin
          for LastGood:=LastGood downto FirstGood do
            begin
              TrimmedChar:=False;
              for j:=0 to TrimBytesCount-1
                do TrimmedChar:=TrimmedChar or (PData^[LastGood]=TrimChars^.Arr[j]);
              if not TrimmedChar
                then Break;
            end;//for i
          end//if (trim_method=0) or (trim_method=2)
        else LastGood:=arr_len-1;
        //    ,   
        for j:=FirstGood to LastGood
          do PData^[j-FirstGood]:=PData^[j];
        //      
        if LastGood<FirstGood
          then LastGood:=0
          else LastGood:=LastGood-FirstGood+1;
        UStr_Resize(PUA_UnicodeString(Variable_GetAddress(context,trim_var)^.UA),LastGood);
        Result:=CMD_OK;
      Finish:
        //    
        UA_Destroy(PArrayHeader(TrimChars));
      end// if PData<>nil
    else Result:=CMD_INVALID_ARRAY_ITEM_INDEX;
  end;
end;

function C_USTR_EXPAND(var context:TScriptContext):integer;
label DoIt,Finish;
var state:TParamState;
    str_to_expand,expander,res:PUA_UnicodeString;
    write_to,expand_to,method:Cardinal;

    idx,fillpos,filllen:Cardinal;
    len,i,_start,_end:Integer;
    RightAlign:Boolean;
begin
    method:=0;
    expander:=nil;
    //   -   
    write_to:=LoadParameter_DWORD(context,state,0);
    if state<>PARAM_OK then
      begin
        Result:=CMD_PARAM_ERROR;
        Exit;
      end;

  //   -  
  str_to_expand:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_DEFAULT:            str_to_expand:=@EmptyUnicodeString;
    PARAM_INVALID,PARAM_END:  begin
                                Result:=CMD_PARAM_ERROR;
                                Exit;
                              end;
  end;//case

  //   - ,     
  expand_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;

  //   - -
  expander:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_DEFAULT:  expander:=@SpaceUnicodeString;
    PARAM_END:      begin
                      expander:=@SpaceUnicodeString;
                      goto DoIt;
                    end;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;
  //   -  
  method:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;

DoIt:
  //       
  filllen:=UStr_Length(expander);
  if (expand_to=0) or (filllen=0) then
    begin
      Result:=CMD_STRING_TOO_SHORT;
      goto Finish;
    end;

  len:=UStr_Length(str_to_expand);
  _end:=Max(len,expand_to);
  res:=UStr_Allocate(_end);
  //      ,     0
  RightAlign:=(method and 1)<>0;
  //    
  if len>0 then
    begin
      if RightAlign then
        //    
          begin
            idx:=Integer(_end)-len;
            _start:=0;
            _end:=_end-len-1;
          end
        //    
        else
          begin
            idx:=0;
            _start:=len;
            Dec(_end);
          end;
      //     
      Move(str_to_expand^.Arr[0],res^.Arr[idx],len shl 1)
    end
   else
    begin
      _start:=0;
      Dec(_end);
    end;
  fillpos:=0;
  //    
  for i:=_start to _end do
    begin
      //   
      res^.Arr[i]:=expander^.Arr[fillpos];
      //    
      if fillpos=filllen-1
        then fillpos:=0
        else Inc(fillpos);
    end;//for
  //         
  Result:=Variable_AssignArray(context,write_to,PArrayHeader(res),vtUnicodeString);
  if Result<>CMD_OK
    then UA_Destroy(PArrayHeader(res));
Finish:
  UA_Destroy(PArrayHeader(str_to_expand));
  UA_Destroy(PArrayHeader(expander));
end;

function C_USTR_REPLACE(var context:TScriptContext):Integer;
label Finish;
var my_str,substr_to_replace,new_substr,res_str:PUA_UnicodeString;
    write_to,case_sens:Cardinal;
    state:TParamState;

    found:array of Integer;
    add_to,found_pos,new_pos,my_str_len,repl_len,new_len,i,j,min_r_char:Integer;
    c,old_c:WideChar;
    Finder:TUStrFinder;
begin
  case_sens:=0;
  substr_to_replace:=nil;
  new_substr:=nil;
  res_str:=nil;
  //   -   
  write_to:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

  //   - ,     
  my_str:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

  //   - ,   
  substr_to_replace:=LoadParameter_UnicodeString(context,state);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;

  //   - ,    
  new_substr:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_OK: ;
    PARAM_DEFAULT, PARAM_END: new_substr:=@EmptyUnicodeString;
    else begin
          Result:=CMD_PARAM_ERROR;
          goto Finish;
         end;
  end;

  //   -   
  if state<>PARAM_END then
    begin
      case_sens:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_INVALID then
        begin
          Result:=CMD_PARAM_ERROR;
          goto Finish;
        end;
    end;

  //   
  my_str_len:=UStr_Length(my_str);
  repl_len:=UStr_Length(substr_to_replace);
  new_len:=UStr_Length(new_substr);

  add_to:=0;
  found_pos:=0;
  Finder:=UStrFinder[case_sens<>0];
  repeat
    //    
    found_pos:=Finder(@substr_to_replace^.Arr,repl_len,@my_str^.Arr,my_str_len,found_pos);
    //   -      
    if found_pos<>-1 then
      begin
        //      -  
        if Length(found)=add_to
          then SetLength(found,add_to+16);
        //      
        found[add_to]:=found_pos;
        //       
        Inc(found_pos,repl_len);
        Inc(add_to);
      end
  until found_pos=-1;
  //         
  res_str:=UStr_Allocate(my_str_len+(new_len-repl_len)*add_to);

  found_pos:=0;
  new_pos:=0;
  //      
  if repl_len>new_len
    then min_r_char:=new_len-1
    else min_r_char:=repl_len-1;
with my_str^ do
begin
  for i:=0 to add_to-1 do
    begin
      //        ,
      //    ,     ,
      //  ,    ,  
      if found_pos<>found[i] then
        begin
          Move(Arr[found_pos],res_str^.Arr[new_pos],(found[i]-found_pos) shl 1);
          Inc(new_pos,found[i]-found_pos);
        end;
      //       
      if new_len>0 then
        begin
          Move(new_substr^.Arr[0],res_str^.Arr[new_pos],new_len shl 1);
          if case_sens>=2 then //     
            begin
              found_pos:=found[i]; //     found_pos  
              for j:=0 to min_r_char do
                begin
                  //    
                  c:=res_str^.Arr[new_pos+j];
                  //    
                  old_c:=Arr[found_pos];
                  //          - ,    
                  if old_c<>WideToLowerTable[old_c]
                    then c:=WideToUpperTable[c]
                    //          - ,    
                    else if old_c<>WideToUpperTable[old_c]
                          then c:=WideToLowerTable[c];
                          //     ,      
                  res_str^.Arr[new_pos+j]:=c;
                  //   new_pos         
                  Inc(found_pos);
                end;//for
            end;
          //  ,    
          Inc(new_pos,new_len);
        end;//if new_len>0
      //   -       
      //     
      found_pos:=found[i]+repl_len;
    end;//for

  //   
  if (my_str_len-found_pos)>0
    then Move(Arr[found_pos],res_str^.Arr[new_pos],(my_str_len-found_pos) shl 1);
end;//with
  //      
  Result:=Variable_AssignArray(context,write_to,PArrayHeader(res_str),vtUnicodeString);
  //      ,
  //    
  if Result<>CMD_OK
    then UA_Destroy(PArrayHeader(res_str));
Finish:
  UA_Destroy(PArrayHeader(my_str));
  UA_Destroy(PArrayHeader(substr_to_replace));
  UA_Destroy(PArrayHeader(new_substr));
end;

function C_MEM_GET_WORD(var context:TScriptContext):integer;
begin
  Result:=MEM_GET_X(context,6);
end;

function C_MEM_GET_USTR(var context:TScriptContext):integer;
begin
  Result:=MEM_GET_X(context,7);
end;

function C_MEM_WRITE_WORD(var context:TScriptContext):integer;
begin
 Result:=MEM_WRITE_x(context,ptWord);
end;

function SetUnicodeClipbrdText(Text:PUA_UnicodeString):Boolean;
var len,sz:Cardinal;
    hBuf:HANDLE;
    buffer:PWideChar;
begin
  Result:=False;
  //    Clipboard
  if OpenClipboard(0) then
  begin
    len:=UStr_Length(Text);
    //    
    if len<>0 then
    begin
      sz:=len+len+2;
      hbuf:=GlobalAlloc(GMEM_MOVEABLE+GMEM_DDESHARE,sz);
      if hbuf=0 then
        begin
          //    
          CloseClipboard;
          Exit;
        end;
      try
        buffer:=GlobalLock(hbuf);
        if buffer=nil then
          begin
            //     
            CloseClipboard;
            GlobalUnlock(hBuf);
            GlobalFree(hBuf);
            Exit;
          end;
        Move(Text^.Arr[0],buffer^,sz);
        if SetClipboardData(CF_UNICODETEXT,hbuf)=0 then
          begin
            //    Clipboard  
            CloseClipboard;
            GlobalUnlock(hBuf);
            GlobalFree(hBuf);
            Exit;
          end;
        //    -  Clipboard
        CloseClipboard;
        Result:=True;
      finally
        //    
        GlobalUnlock(hBuf);
      end;
    end
    //    -   Clipboard
    else
      begin
        EmptyClipboard;
        CloseClipboard;
        Result:=True;
      end;
  end;
end;

function C_CLIPBOARD_SET_TEXT(var context:TScriptContext):integer;
var _text:PUA_UnicodeString;
    state:TParamState;
begin
  _text:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_OK then
    begin
      if SetUnicodeClipbrdText(_text)
        then Result:=CMD_OK
        else Result:=CMD_CANT_SET_CLIPBOARD_TEXT;
    end
  else Result:=CMD_PARAM_ERROR;
  UA_Destroy(PArrayHeader(_text));
end;

function C_CLIPBOARD_CLEAR(var context:TScriptContext):integer;
begin
  if OpenClipboard(0) then
    begin
      EmptyClipboard;
      CloseClipboard;
    end;
  Result:=CMD_OK;
end;

function C_USTR_TO_F(var context:TScriptContext):Integer;
begin
  Result:=C_xSTR_TO_F(context,True);
end;

function C_USTR_TO_I(var context:TScriptContext):Integer;
begin
  Result:=C_xSTR_TO_I(context,True);
end;

function C_SCRIPT_EXECUTABLE_FILENAME(var context:TScriptContext):Integer;
const BUF_SIZE_GRANULARITY=MAX_PATH;
var write_to,char_c,res,buf_size:Cardinal;
    state:TParamState;
    pBuffer:PWideChar;
begin
  write_to:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      Result:=CMD_CANT_GET_SCRIPT_FILENAME;
      buf_size:=BUF_SIZE_GRANULARITY;
      repeat
        GetMem(pBuffer,buf_size*SizeOf(WideChar));
        char_c:=GetModuleFileNameW(0,pBuffer,buf_size);
        res:=GetLastError;
        case res of
          ERROR_SUCCESS:
            //     
            Result:=Variable_qWriteUnicodeString(context,write_to,pBuffer,char_c);
          ERROR_INSUFFICIENT_BUFFER:
            //         -  
            Inc(buf_size,BUF_SIZE_GRANULARITY)
          else
            begin
              //    -        CMD_CANT_GET_SCRIPT_FILENAME
              FreeMem(pBuffer);
              Break;
            end;
        end;
        FreeMem(pBuffer);
      until res=ERROR_SUCCESS;
      context.LastWindowsError:=res;
    end
  else Result:=CMD_PARAM_ERROR;
end;

function FIND_x_xA(var context:TScriptContext; _type:TVarType; FindAll:Boolean):Integer;
label DoIt,Finish,EndOfSearch;
var state:TParamState;
    search_var, write_to:Cardinal;
    find_dword:Cardinal;
    find_integer:Int64;
    find_float:Extended;
    find_bb:PUA_BinaryBlock;
    find_ustr:PUA_UnicodeString;
    SearchFrom,SearchTo:Cardinal;
    ComparsionMethod:TStringComparsionMethod;
    v_a:PNeoS0MVariable;
    FoundList:PUA_DWORD;
begin
  find_dword:=0;
  find_integer:=0;
  find_float:=0;
  find_bb:=@EmptyBinaryBlock;
  find_ustr:=@EmptyUnicodeString;
  SearchFrom:=0;
  ComparsionMethod:=scmTrueEquality;
  FoundList:=nil;
  //   -  ,  ,    
  search_var:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;
  //   -  ,     
  write_to:=LoadParameter_DWORD(context,state,search_var);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      Exit;
                    end;
  end;//case
  //   -  
  case _type of
    vtDWORDArray:   find_dword:=LoadParameter_DWORD(context,state,0);
    vtIntArray:     find_integer:=LoadParameter_INTEGER(context,state,0);
    vtExtArray:     find_float:=LoadParameter_FLOAT(context,state,0);
    vtBinBlockList: begin
                      find_bb:=LoadParameter_BinBlock(context,state);
                      if (state=PARAM_DEFAULT) or (state=PARAM_END)
                        then find_bb:=@EmptyBinaryBlock;
                    end;
    vtUnicodeStringList:
                    begin
                      find_ustr:=LoadParameter_UnicodeString(context,state);
                      if (state=PARAM_DEFAULT) or (state=PARAM_END)
                        then find_ustr:=@EmptyUnicodeString;
                    end;
  end;//case _type
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      Exit;
                    end;
  end;//case state
  //   - /    
  SearchFrom:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      goto Finish;
                    end;
  end;//case
  //        -  
  if (_type=vtBinBlockList) or (_type=vtUnicodeStringList) then
    begin
      ComparsionMethod:=TStringComparsionMethod(LoadParameter_DWORD(context,state,Cardinal(scmTrueEquality)));
      if state=PARAM_INVALID then
        begin
          Result:=CMD_PARAM_ERROR;
          goto Finish;
        end;//if
      //       
      if not (ComparsionMethod in [scmTrueEquality,scmEqualityWOCase,scmTrueIsSubstring,scmIsSubstringWOCase]) then
        begin
          Result:=CMD_INVALID_COMPARSION_METHOD;
          goto Finish;
        end;
    end;//if (_type=...

DoIt:
  //  ,      ,    
  v_a:=Variable_GetAddress(context,search_var);
  //  ?
  if v_a=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else
      begin
        if v_a^.VarType<>_type
          then Result:=CMD_TYPECAST_IMPOSSIBLE
          else
            begin
              //  search_var      
              // $FFFFFFFF -   
              search_var:=$FFFFFFFF;
              //  ,     
              if FindAll
                then FoundList:=PUA_DWORD(UA_Create(0,SizeOf(Cardinal)));
              if Integer(SearchFrom)<0 then
              //   ,    0,  - 
                begin
                  SearchTo:=-Integer(SearchFrom);
                  SearchFrom:=0;
                end
              //   ,   ,  - "  "
              else SearchTo:=$FFFFFFFF;

              //   
              repeat
                //   
              { DONE :      }
                case _type of
                  vtDWORDArray: search_var:=_FindDWORDInArray(PUA_DWORD(v_a^.UA),find_dword,SearchFrom,SearchTo);
                  vtIntArray:   search_var:=_FindIntegerInArray(PUA_INTEGER(v_a^.UA),find_integer,SearchFrom,SearchTo);
                  vtExtArray:   search_var:=_FindFloatInArray(PUA_EXTENDED(v_a^.UA),find_float,SearchFrom,SearchTo);
                  vtBinBlockList: search_var:=BBL_Find(PUA_BinBlockList(v_a^.UA),find_bb,SearchFrom,SearchTo,ComparsionMethod);
                  vtUnicodeStringList: search_var:=UStrL_Find(PUA_UnicodeStringList(v_a^.UA),find_ustr,SearchFrom,SearchTo,ComparsionMethod);
                end;//case

                if FindAll then
                  //    
                  begin
                    //   
                    if search_var<>$FFFFFFFF then
                      begin
                        //     
                        _AddDWORDToArray(FoundList,search_var,1);
                        //     
                        SearchFrom:=search_var+1
                      end;//if search_var<>$FFFFFFFF
                  end
                //      ,    
                else Break;
              //  ,   - 
              until search_var=$FFFFFFFF;

              EndOfSearch:
                if FindAll then
                  begin
                    //     
                    Result:=Variable_AssignArray(context,write_to,PArrayHeader(FoundList),vtDWORDArray);
                    //    ,     
                    if Result<>CMD_OK
                      then UA_Destroy(PArrayHeader(FoundList));
                  end
                //  -     
                else Result:=Variable_qStoreDWORD(context,write_to,search_var);
            end;
      end;

Finish:
  if _type=vtUnicodeStringList
    then UA_Destroy(PArrayHeader(find_ustr));
end;

function C_FIND_DA(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtDWORDArray,False);
end;

function C_FIND_ALL_DA(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtDWORDArray,True);
end;

function C_FIND_IA(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtIntArray,False);
end;

function C_FIND_ALL_IA(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtIntArray,True);
end;

function C_FIND_FA(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtExtArray,False);
end;

function C_FIND_ALL_FA(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtExtArray,True);
end;

function C_FIND_BA(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtBinBlockList,False);
end;

function C_FIND_ALL_BA(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtBinBlockList,True);
end;

function C_FIND_USTRL(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtUnicodeStringList,False);
end;

function C_FIND_ALL_USTRL(var context:TScriptContext):Integer;
begin
  Result:=FIND_x_xA(context,vtUnicodeStringList,True);
end;

{$WARNINGS OFF}
function C_APPEND_xA(var context:TScriptContext; _type: TVarType):Integer;
label DoIt,Finish;
var state:TParamState;
    var_idx:Cardinal;
    val_count:Cardinal;
    append_dword:Cardinal;
    append_integer:Int64;
    append_float:Extended;
    append_bb:PUA_BinaryBlock;
    append_ustr:PUA_UnicodeString;
    v_a:PNeoS0MVariable;
begin
  val_count:=1;
  //   -  ,  ,    
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;
  //   -  
  case _type of
    vtDWORDArray:   append_dword:=LoadParameter_DWORD(context,state,0);
    vtIntArray:     append_integer:=LoadParameter_INTEGER(context,state,0);
    vtExtArray:     append_float:=LoadParameter_FLOAT(context,state,0);
    vtBinBlockList: begin
                      append_bb:=LoadParameter_BinBlock(context,state);
                      if (state=PARAM_DEFAULT) or (state=PARAM_END)
                        then append_bb:=@EmptyBinaryBlock;
                    end;
    vtUnicodeStringList:
                    begin
                      append_ustr:=LoadParameter_UnicodeString(context,state);
                      if (state=PARAM_DEFAULT) or (state=PARAM_END)
                        then append_ustr:=@EmptyUnicodeString;
                    end;
  end;//case _type
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      Exit;
                    end;
  end;//case state
  //   -   
  val_count:=LoadParameter_DWORD(context,state,1);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      goto Finish;
    end;
DoIt:
  //  ,      ,    
  v_a:=Variable_GetAddress(context,var_idx);
  //  ?
  if v_a=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else
      begin
        if v_a^.VarType<>_type
          then Result:=CMD_TYPECAST_IMPOSSIBLE
          else
            begin
              Result:=CMD_OK;
              //    0  -   ,  
              if val_count=0
                then goto Finish;
              case _type of
                vtDWORDArray:   Result:=_AddDWORDToArray(PUA_DWORD(v_a^.UA),append_dword,val_count);
                vtIntArray:     Result:=_AddIntegerToArray(PUA_INTEGER(v_a^.UA),append_integer,val_count);
                vtExtArray:     Result:=_AddFloatToArray(PUA_EXTENDED(v_a^.UA),append_float,val_count);
                vtBinBlockList:       Result:=BBL_Append(PUA_BinBlockList(v_a^.UA),append_bb,val_count);
                vtUnicodeStringList:  Result:=UStrL_Append(PUA_UnicodeStringList(v_a^.UA),append_ustr,val_count);
                { DONE :      }
              end;
            end;//else
      end;//else v_a=nil

 Finish:
  if _type=vtUnicodeString
    then UA_Destroy(PArrayHeader(append_ustr));
end;
{$WARNINGS ON}

function C_APPEND_DA(var context:TScriptContext):Integer;
begin
  Result:=C_APPEND_xA(context,vtDWORDArray);
end;

function C_APPEND_IA(var context:TScriptContext):Integer;
begin
  Result:=C_APPEND_xA(context,vtIntArray);
end;

function C_APPEND_FA(var context:TScriptContext):Integer;
begin
  Result:=C_APPEND_xA(context,vtExtArray);
end;

function C_APPEND_BA(var context:TScriptContext):Integer;
begin
  Result:=C_APPEND_xA(context,vtBinBlockList);
end;

function C_APPEND_USTRL(var context:TScriptContext):Integer;
begin
  Result:=C_APPEND_xA(context,vtUnicodeStringList);
end;

function Var_Resize(v_a:PNeoS0MVariable; new_len:Int64; method:Cardinal):Integer;
var vt:TVarType;
    i,old_len:Cardinal;
    p:PPointer;
    i_p:Pointer;
begin
  vt:=v_a.VarType;
  //    ?
  if  IsArray[vt] then
        begin
          //     
          old_len:=_ArrayLength(v_a.UA,vt);
          //     ,     
          if method<>0
            then new_len:=new_len+old_len;
          if new_len<0
            then new_len:=0;
          if vt=vtBinBlock
           then
            begin
              BB_Resize(PUA_BinaryBlock(v_a.UA),new_len);
              Result:=CMD_OK;
            end
           else if vt=vtUnicodeString
                  then
                    begin
                      USTR_Resize(PUA_UnicodeString(v_a.UA),new_len);
                      Result:=CMD_OK;
                    end
                  else
                    //    
                    begin
                      //   
                      UA_Resize(v_a.UA,new_len);
                      //    
                      if v_a.UA=nil then
                         begin
                           Result:=CMD_OUT_OF_MEMORY;
                           Exit;
                         end;
                      //    
                      p:=_GetArrayItemPtr(v_a,old_len);
                      if (vt=vtBinBlockList) or (vt=vtUnicodeStringList) then
                        begin
                          if vt=vtBinBlockList
                            then i_p:=@EmptyBinaryBlock
                            else i_p:=@EmptyUnicodeString;
                          //  ""    Unicode-/  
                          if new_len>old_len then
                            begin
                              for i:=old_len to new_len do
                                begin
                                  p^:=i_p;
                                  Inc(p);
                                end;
                            end;//if
                        end
                        //  INTARRAY, FLOATARRAY  DWORDARRAY   "" 
                        else if new_len>old_len
                              then ZeroMemory(p,(new_len-old_len)*VarArrayItemSize[vt]);
                        Result:=CMD_OK;
                    end;
        end
      else Result:=CMD_TYPECAST_IMPOSSIBLE;
end;

function C_RESIZE(var context:TScriptContext):Integer;
label DoIt;
var state:TParamState;
    var_idx,method:Cardinal;
    v_a:PNeoS0MVariable;
    new_len:Int64;
begin
  Result:=CMD_PARAM_ERROR;
  //   -    
  method:=0;
  //   -  
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;
 //   -     
 new_len:=LoadParameter_INTEGER(context,state,1);
 case state of
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  Exit;
 end;//case
 //   -   
 method:=LoadParameter_DWORD(context,state,0);
 if state=PARAM_INVALID
  then Exit;

DoIt:
  v_a:=Variable_GetAddress(context,var_idx);
  //  ?
  if v_a<>nil
    then Result:=Var_Resize(v_a,new_len,method)
    else Result:=CMD_INVALID_VARIABLE_INDEX;
end;

function C_REMOVE(var context:TScriptContext):Integer;
label DoIt;
var state:TParamState;
    var_idx,count,start_from:Cardinal;
    i,len:Cardinal;
    v_a:PNeoS0MVariable;
    copy_from,copy_to:PPointer;
    vt:TVarType;
    DefaultItemIndex:Boolean;
begin
  count:=1;
  Result:=CMD_PARAM_ERROR;
  DefaultItemIndex:=True;
  //   -  
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;
 //   -    
 start_from:=LoadParameter_DWORD(context,state,0);
 case state of
  PARAM_OK:       DefaultItemIndex:=False;
  PARAM_END:      goto DoIt;
  PARAM_INVALID:  Exit;
 end;//case
 //   -   
 count:=LoadParameter_DWORD(context,state,1);
 if state=PARAM_INVALID
  then Exit;

DoIt:
  v_a:=Variable_GetAddress(context,var_idx);
  //  ?
  if v_a<>nil then
    begin
      vt:=v_a.VarType;
      //    ?
      if  IsArray[vt] then
        begin
          //   
          if count=0 then
          begin
            Result:=CMD_OK;
            Exit;
          end;
          //  
          len:=_GetArrayLength(v_a);
          //       -     
          if DefaultItemIndex
            then start_from:=len-1;
          //  
          copy_to:=_GetArrayItemPtr(v_a,start_from);
          //     ,   
          if copy_to=nil then
            begin
              Result:= CMD_INVALID_ARRAY_ITEM_INDEX;
              Exit;
            end;
          //  
          copy_from:=_GetArrayItemPtr(v_a,start_from+count);
          //         ,
          //    
          if (vt=vtBinBlockList) or (vt=vtUnicodeStringList) then
            begin
              //          
              for i:=start_from to Min(len,start_from+count)-1
                do UA_Destroy(PArrayHeader(PUA_BinBlockList(v_a.UA)^.Arr[i]));
            end;
          //  ,    
          if copy_from<>nil then
            begin
              i:=len-start_from-count;
              if i>0
                then Move(copy_from^,copy_to^,i*VarArrayItemSize[vt]);
            end;
          //      
          if count>len
            then count:=len;
          //  
          Result:=Var_Resize(v_a,Max(len-count,start_from),0);
        end
      else Result:=CMD_TYPECAST_IMPOSSIBLE;
    end
  else Result:=CMD_INVALID_VARIABLE_INDEX;
end;

function single_op(var context:TScriptContext; op:Cardinal):Integer;
var var_idx:Cardinal;
    state:TParamState;
    v_a:PNeoS0MVariable;
    d:Integer;
begin
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      v_a:=Variable_GetAddress(context,var_idx);
      if v_a<>nil then
        begin
        with v_a^ do
        begin
          Result:=CMD_OK;
          case VarType of
            vtDWORD:
              begin
                d:=Integer(AsDWORD);
                case op of
                  0: AsDWORD:=Cardinal(-d);
                  1: if d=0
                      then AsDWORD:=1
                      else AsDWORD:=0;
                  2: begin
                       if d>0
                         then AsInteger:=1
                         else if d<0
                               then AsInteger:=-1
                               else AsInteger:=0;
                       VarType:=vtInteger;
                     end;
                  3: if d<0
                      then AsDWORD:=Cardinal(-d);
                end;
              end;
            vtInteger:
              begin
                case op of
                  0: AsInteger:=-AsInteger;
                  1: if AsInteger<>0
                      then AsInteger:=1;
                  2: if AsInteger>0
                      then AsInteger:=1
                      else if AsInteger<0
                            then AsInteger:=-1;
                  3: if AsInteger<0
                      then AsInteger:=-AsInteger;
                end;
              end;
            vtExtended:
              begin
                case op of
                  0: AsExtended:=-AsExtended;
                  1: if AsExtended<>0
                      then AsExtended:=1;
                  2: begin
                        if AsExtended>0
                          then AsInteger:=1
                          else if AsExtended<0
                                then AsInteger:=-1
                                else AsInteger:=0;
                       VarType:=vtInteger;
                     end;
                  3: if AsExtended<0
                      then AsExtended:=-AsExtended;
                end;
              end
            else Result:=CMD_TYPECAST_IMPOSSIBLE;
          end;//case
        end;
        end
      else Result:=CMD_INVALID_VARIABLE_INDEX;
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_NEG(var context:TScriptContext):Integer;
begin
  Result:=single_op(context,0);
end;

function C_INV(var context:TScriptContext):Integer;
begin
  Result:=single_op(context,1);
end;

function C_SIGN(var context:TScriptContext):Integer;
begin
  Result:=single_op(context,2);
end;

function C_ABS(var context:TScriptContext):Integer;
begin
  Result:=single_op(context,3);
end;

function FILE_x_ATTR(var context:TScriptContext; SetAttr:Boolean; IsDirectory:Boolean):Integer;
label _exit;
var fname:PUA_UnicodeString;
    w_p,attr:Cardinal;
    state:TParamState;
begin
  Result:=CMD_PARAM_ERROR;
  fname:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_OK then
    begin
      w_p:=LoadParameter_DWORD(context,state,FILE_ATTRIBUTE_NORMAL);
      if (state=PARAM_OK) or (SetAttr and (state in [PARAM_DEFAULT,PARAM_END])) then
        begin
          //  
          attr:=GetFileAttributesW(fname^.Arr);
          if attr=INVALID_FILE_ATTRIBUTES then
            begin
              Result:=CMD_CANT_ACCESS_FILE_ATTRIB;
              goto _exit;
            end;
          //       ""
          if ((attr and FILE_ATTRIBUTE_DIRECTORY)=FILE_ATTRIBUTE_DIRECTORY)<>IsDirectory then
            begin
              Result:=CMD_NOT_A_FILE_DIR;
              goto _exit;
            end;

          if SetAttr then
            begin
              if SetFileAttributesW(fname^.Arr,w_p)
               then Result:=CMD_OK
               else Result:=CMD_CANT_ACCESS_FILE_ATTRIB;
              context.LastWindowsError:=GetLastError;
            end
          else
            begin
              context.LastWindowsError:=GetLastError;
              Result:=Variable_qStoreDWORD(context,w_p,attr);
            end;
        end
      else
_exit:
      UA_Destroy(PArrayHeader(fname));
    end
end;

function C_FILE_SET_ATTR(var context:TScriptContext):Integer;
begin
  Result:=FILE_x_ATTR(context,True,False);
end;

function C_FILE_GET_ATTR(var context:TScriptContext):Integer;
begin
  Result:=FILE_x_ATTR(context,False,False);
end;

function C_DIR_SET_ATTR(var context:TScriptContext):Integer;
begin
  Result:=FILE_x_ATTR(context,True,True);
end;

function C_DIR_GET_ATTR(var context:TScriptContext):Integer;
begin
  Result:=FILE_x_ATTR(context,False,True);
end;

function C_VAR_GET_DATA_ADDR(var context:TScriptContext):Integer;
var v1,v2:Cardinal;
    v_a:PNeoS0MVariable;
    p:Pointer;
    state:TParamState;
begin
  v1:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      v2:=LoadParameter_DWORD(context,state,0);
      if state=PARAM_OK then
        begin
          v_a:=Variable_GetAddress(context,v1);
          if v_a=nil
            then Result:=CMD_INVALID_VARIABLE_INDEX
            else
              begin
                case v_a^.VarType of
                  vtDWORD:    p:=@v_a^.AsDWORD;
                  vtInteger:  p:=@v_a^.AsInteger;
                  vtExtended: p:=@v_a^.AsExtended;
                  vtIntArray,vtExtArray,vtBinBlock,vtDWORDArray,vtUnicodeString:
                    p:=@PUA_BinaryBlock(v_a^.UA)^.Arr;
                  else
                    begin
                      Result:=CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE;
                      Exit;
                    end;
                end;
                Result:=Variable_qStoreDWORD(context,v2,Cardinal(p));
              end;
        end
      else Result:=CMD_PARAM_ERROR;
    end
  else Result:=CMD_PARAM_ERROR;
end;

function C_SCRIPT_GET_PROC_THx(var context:TScriptContext; ReadHandles:Boolean):Integer;
var ProcVar,ThVar:Cardinal;
    UseProcVar,UseThVar:Boolean;
begin
  Result:=_hashD_hashDE(context,ProcVar,UseProcVar,0,ThVar,UseThVar,0);
  if (Result=CMD_OK) and UseProcVar
    then Result:=Variable_qStoreDWORD(context,ProcVar,IfThen(ReadHandles,GetCurrentProcess,GetCurrentProcessId));
  if (Result=CMD_OK) and UseThVar
    then Result:=Variable_qStoreDWORD(context,ThVar,IfThen(ReadHandles,GetCurrentThread,GetCurrentThreadId));
end;

function C_SCRIPT_PROC_TH(var context:TScriptContext):Integer;
begin
  Result:=C_SCRIPT_GET_PROC_THx(context,False);
end;

function C_SCRIPT_PROC_TH_HANDLE(var context:TScriptContext):Integer;
begin
  Result:=C_SCRIPT_GET_PROC_THx(context,True);
end;

function WND_CLIENT_x_SCREEN(var context:TScriptContext; CToS:Boolean):Integer;
label DoIt;
var handle_var,x_var,y_var,i:Cardinal;
    UseX,UseY,res:Boolean;
    state:TParamState;
    p:TPoint;
begin
  UseX:=False;
  UseY:=False;
  Result:=CMD_PARAM_ERROR;
  //   ,       
  handle_var:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK
    then Exit;
  //   ,     
  x_var:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:       UseX:=True;
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  Exit;
  end;//case
  //   ,     
  y_var:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:       UseY:=True;
    PARAM_INVALID:  Exit;
  end;//case

DoIt:
  //  ,   
  Result:=CMD_OK;
  if UseX
    then Result:=Variable_qLoadDWORD(context,x_var,i)
    else i:=0;
  if Result=CMD_OK
    then p.X:=i
    else Exit;
  if UseY
    then Result:=Variable_qLoadDWORD(context,y_var,i)
    else i:=0;
  if Result=CMD_OK
    then p.Y:=i
    else Exit;
  //  
  Result:=VariableOrArray_qLoadDWORD(context,handle_var,handle_var);
  if Result=CMD_OK then
    begin
      if CToS
        then res:=ClientToScreen(handle_var,p)
        else res:=ScreenToClient(handle_var,p);
      context.LastWindowsError:=GetLastError;
      if res then
        begin
          //      
          if UseX
            then Result:=Variable_qStoreDWORD(context,x_var,Cardinal(p.X));
          if UseY and (Result=CMD_OK)
            then Result:=Variable_qStoreDWORD(context,y_var,Cardinal(p.Y));
        end
      else Result:=CMD_CANT_CONVERT_COORDINATES;
    end;
end;

function C_WND_CLIENT_TO_SCREEN(var context:TScriptContext):Integer;
begin
  Result:=WND_CLIENT_x_SCREEN(context,True);
end;

function C_WND_SCREEN_TO_CLIENT(var context:TScriptContext):Integer;
begin
  Result:=WND_CLIENT_x_SCREEN(context,False);
end;

function xFREE(var context:TScriptContext; IsGlobal:Boolean):Integer;
var var_count:Cardinal;
    state:TParamState;
begin
  //   
  var_count:=LoadParameter_DWORD(context,state,1);
  if state=PARAM_INVALID
    then Result:=CMD_PARAM_ERROR
    //    
    else Result:=Variables_Free(context,var_count,IsGlobal);
end;

function C_GFREE(var context:TScriptContext):Integer;
begin
  Result:=xFREE(context,True);
end;

function C_LFREE(var context:TScriptContext):Integer;
begin
  Result:=xFREE(context,False);
end;

function xCOUNT(var context:TScriptContext; IsGlobal:Boolean):Integer;
var var_idx,l:Cardinal;
    state:TParamState;
begin
  var_idx:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      with context do
        begin
          // ,         
          l:=Length(StackFrames);
          if l>0 then
            begin
              //      (),    ()
              //   
              if IsGlobal
                then l:=0
                else Dec(l);
              Result:=Variable_qStoreDWORD(context,var_idx,Length(StackFrames[l]));
            end
          else Result:=CMD_NO_STACK;
        end;//with
    end//if state=PARAM_OK
  else Result:=CMD_PARAM_ERROR;
end;

function C_GCOUNT(var context:TScriptContext):Integer;
begin
  Result:=xCOUNT(context,True);
end;

function C_LCOUNT(var context:TScriptContext):Integer;
begin
  Result:=xCOUNT(context,False);
end;

type TBuildRegTreeIntData=record
        RegBranch:HKEY;           //  
        RegBranchName:String;     //   
        NameBufferPtr:PChar;      //      /
        NameBufferSize:Cardinal;  //     /,  
        DataBufferPtr:Pointer;    //     
        DataBufferSize:Cardinal;  //    

        PKeyNameList:PUA_UnicodeStringList;   //    
        PWriteDateList:PUA_Integer;           //     
        PKeyLevelList:PUA_DWORD;              //    
        PValueNameList:PUA_UnicodeStringList; //     
        PValueTypeList:PUA_DWORD;             //    
        PValueDataList:PUA_BinBlockList;      //    

        ReadValues:Boolean;     //   ?
        StoreFullPath:Boolean;  //     ?
        MaxDepth:Cardinal;      // .  
     end;

function RegWalker(const full_key_path, key_name:UnicodeString; var IntData:TBuildRegTreeIntData; Level:Cardinal):Longint;
var reg_key:HKEY;
    err_code,err_code2:Longint;
    key_idx,val_idx,v_type:Cardinal;
    KeyNameLen:Cardinal;
    DataLen:DWORD;
    KeyName:String;
    BufSize,MaxKeyLen,MaxValueLen,MaxValueDataLen:Cardinal;
    LastAccess:Int64;

    procedure StoreKeyInfo;
    var k_name:String;
    begin
      with IntData do
      begin
        //     ,  ,   ,   
        if Assigned(PKeyNameList) then
          begin
            if StoreFullPath
              then k_name:=RegBranchName+full_key_path
              else k_name:=key_name;
            UStrL_Add(PKeyNameList,PChar(k_name),Length(k_name));
          end;
        //     
        if Assigned(PWriteDateList)
          then _AddIntegerToArray(PWriteDateList,LastAccess,1);
        //   
        if Assigned(PKeyLevelList)
          then _AddDWORDToArray(PKeyLevelList,Level,1);
      end;//with
    end;//procedure

begin
  //      
  with IntData do
  begin
  //   
  Result:=RegOpenKeyEx(RegBranch,PChar(full_key_path),0,KEY_READ,reg_key);
//  Result:=RegOpenKey(RegBranch,PChar(full_key_path),reg_key);
  if Result=ERROR_SUCCESS then
  begin
    //         
    RegQueryInfoKey(reg_key,nil,nil,nil,nil,@MaxKeyLen,nil,nil,@MaxValueLen,@MaxValueDataLen,nil,@LastAccess);
    //         ,   
    if not ReadValues
      then StoreKeyInfo;

    //          
    //        
    BufSize:=RoundUp((Max(MaxKeyLen,MaxValueLen)+1),32);
    //  ,  
    if BufSize>NameBufferSize then
      begin
        if Assigned(NameBufferPtr)
          then FreeMem(NameBufferPtr);
        GetMem(NameBufferPtr,BufSize*SizeOf(Char));
        NameBufferSize:=BufSize;
      end;
    //     ,  
    if ReadValues and Assigned(PValueDataList) then
      begin
        BufSize:=RoundUp(Max(DataBufferSize,MaxValueDataLen),64);
        //  ,  
        if BufSize>DataBufferSize then
          begin
            if Assigned(DataBufferPtr)
              then FreeMem(DataBufferPtr);
            GetMem(DataBufferPtr,BufSize);
            DataBufferSize:=BufSize;
          end;
      end;

    //      
    if ReadValues then
    begin
      val_idx:=0;
      repeat
        KeyNameLen:=NameBufferSize;
        DataLen:=DataBufferSize;
        err_code2:=RegEnumValue(reg_key,val_idx,NameBufferPtr,KeyNameLen,nil,@v_type,DataBufferPtr,@DataLen);
        //       ,  
        if err_code2=ERROR_SUCCESS then
        begin
          StoreKeyInfo;
            if Assigned(PValueNameList)
              then UStrL_Add(PValueNameList,PChar(NameBufferPtr),KeyNameLen);
            if Assigned(PValueTypeList)
              then _AddDWORDToArray(PValueTypeList,v_type,1);
            if Assigned(PValueDataList)
              then BBL_Add(PValueDataList,DataBufferPtr,DataLen);
            Inc(val_idx); //   
        end;//if err_code=ERROR_SUCCESS
      until err_code2<>ERROR_SUCCESS;
    end;

  //       RegWalker
  key_idx:=0;
  repeat
    KeyNameLen:=NameBufferSize;
    err_code:=RegEnumKeyEx(reg_key,key_idx,NameBufferPtr,KeyNameLen,nil,nil,nil,@LastAccess);
    if err_code=ERROR_SUCCESS then
      begin
        KeyName:=NameBufferPtr;
        //       
        if Level<MaxDepth
          then Result:=RegWalker(AddBackslashToDir(full_key_path)+KeyName,KeyName,IntData,Level+1);
        Inc(key_idx);
      end;
  until err_code<>ERROR_SUCCESS;

{    repeat
      //     
      //   ,      
      KeyNameLen:=NameBufferSize;
      err_code:=RegEnumKeyEx(reg_key,key_idx,NameBufferPtr,KeyNameLen,nil,nil,nil,@LastAccess);
      if err_code=ERROR_SUCCESS then
        begin
          KeyName:=NameBufferPtr;
          if ReadValues then //    ,      
            begin
              val_idx:=0;
              //      
              repeat
                KeyNameLen:=NameBufferSize;
                DataLen:=0;
                err_code2:=RegEnumValue(reg_key,val_idx,NameBufferPtr,KeyNameLen,nil,@v_type,DataBufferPtr,@DataLen);
                //       ,  
                if err_code2=ERROR_SUCCESS then
                  begin
                    StoreKeyInfo;
                    if Assigned(PValueNameList)
                      then UStrL_Add(PValueNameList,PChar(NameBufferPtr),KeyNameLen);
                    if Assigned(PValueTypeList)
                      then _AddDWORDToArray(PValueTypeList,v_type,1);
                    if Assigned(PValueDataList)
                      then BBL_Add(PValueDataList,DataBufferPtr,DataLen);
                    Inc(val_idx); //   
                  end;//if err_code=ERROR_SUCCESS
              until err_code2<>ERROR_SUCCESS;
            end;
          //       
          if Level<MaxDepth
            then Result:=RegWalker(AddBackslashToDir(full_key_path)+KeyName,KeyName,IntData,Level+1);

          //      
          Inc(key_idx);
        end;//if err_code=ERROR_SUCCESS

    until err_code<>ERROR_SUCCESS;}

    //   
    RegCloseKey(reg_key);
  end;// if RegOpenKey...
  end;//with
end;

function REG_BUILD_x_TREE(var context:TScriptContext; const IsValueTree:Boolean):Integer;
label DoIt,DoNothing;
var start_reg_key:PUA_UnicodeString;
    tmp_var_idx:Cardinal;
    I:Integer;

    KeyListAddr,               //  . 
    LastAccessAddr,
    LevelAddr,
    ValueNameAddr,
    ValueTypeAddr,
    ValueDataAddr:PNeoS0MVariable;

    IntData:TBuildRegTreeIntData;
    state:TParamState;

    FullRegKey:String;
begin
  KeyListAddr:=nil;
  LastAccessAddr:=nil;
  LevelAddr:=nil;
  ValueNameAddr:=nil;
  ValueTypeAddr:=nil;
  ValueDataAddr:=nil;
  IntData.MaxDepth:=MAX_REGISTRY_SCAN_DEPTH;
  IntData.ReadValues:=False;

  //   -   ,    
  start_reg_key:=LoadParameter_UnicodeString(context,state);
  case state of
    PARAM_DEFAULT:    start_reg_key:=@EmptyUnicodeString;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoNothing;
                      end;
    PARAM_END:        begin
                        start_reg_key:=@EmptyUnicodeString;
                        goto DoIt;
                      end;
  end;//case

  //   -  ,      
  tmp_var_idx:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:         begin
                        KeyListAddr:=Variable_GetAddress(context,tmp_var_idx);
                        if not Assigned(KeyListAddr) then
                          begin
                            Result:=CMD_INVALID_VARIABLE_INDEX;
                            goto DoNothing;
                          end;
                      end;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoNothing;
                      end;
    PARAM_END:        goto DoIt;
  end;//case

  //   - ,    ( )     (0)
  IntData.StoreFullPath:=LoadParameter_DWORD(context,state,0)<>0;
  case state of
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoNothing;
                      end;
    PARAM_END:        goto DoIt;
  end;//case

  //   -  ,        
  tmp_var_idx:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:         begin
                        LastAccessAddr:=Variable_GetAddress(context,tmp_var_idx);
                        if not Assigned(LastAccessAddr) then
                          begin
                            Result:=CMD_INVALID_VARIABLE_INDEX;
                            goto DoNothing;
                          end;
                      end;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoNothing;
                      end;
    PARAM_END:        goto DoIt;
  end;//case

  //   -  ,        
  tmp_var_idx:=LoadParameter_DWORD(context,state,0);
  case state of
    PARAM_OK:         begin
                        LevelAddr:=Variable_GetAddress(context,tmp_var_idx);
                        if not Assigned(LevelAddr) then
                          begin
                            Result:=CMD_INVALID_VARIABLE_INDEX;
                            goto DoNothing;
                          end;
                      end;
    PARAM_INVALID:    begin
                        Result:=CMD_PARAM_ERROR;
                        goto DoNothing;
                      end;
    PARAM_END:        goto DoIt;
  end;//case

  //      ,    
  if IsValueTree then
    begin
      //   -  ,      
      tmp_var_idx:=LoadParameter_DWORD(context,state,0);
      case state of
        PARAM_OK:     begin
                        ValueNameAddr:=Variable_GetAddress(context,tmp_var_idx);
                        IntData.ReadValues:=True;
                        if not Assigned(ValueNameAddr) then
                          begin
                            Result:=CMD_INVALID_VARIABLE_INDEX;
                            goto DoNothing;
                          end;
                      end;
        PARAM_INVALID:    begin
                            Result:=CMD_PARAM_ERROR;
                            goto DoNothing;
                          end;
        PARAM_END:        goto DoIt;
      end;//case

      //   -  ,      
      tmp_var_idx:=LoadParameter_DWORD(context,state,0);
      case state of
        PARAM_OK:     begin
                        ValueTypeAddr:=Variable_GetAddress(context,tmp_var_idx);
                        IntData.ReadValues:=True;
                        if not Assigned(ValueTypeAddr) then
                          begin
                            Result:=CMD_INVALID_VARIABLE_INDEX;
                            goto DoNothing;
                          end;
                      end;
        PARAM_INVALID:    begin
                            Result:=CMD_PARAM_ERROR;
                            goto DoNothing;
                          end;
        PARAM_END:        goto DoIt;
      end;//case

      //   -  ,      
      tmp_var_idx:=LoadParameter_DWORD(context,state,0);
      case state of
        PARAM_OK:     begin
                        ValueDataAddr:=Variable_GetAddress(context,tmp_var_idx);
                        IntData.ReadValues:=True;
                        if not Assigned(ValueDataAddr) then
                          begin
                            Result:=CMD_INVALID_VARIABLE_INDEX;
                            goto DoNothing;
                          end;
                      end;
        PARAM_INVALID:    begin
                            Result:=CMD_PARAM_ERROR;
                            goto DoNothing;
                          end;
        PARAM_END:        goto DoIt;
      end;//case
    end;//if IsValueTree

  // /  -    
  IntData.MaxDepth:=LoadParameter_DWORD(context,state,MAX_REGISTRY_SCAN_DEPTH);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      goto DoNothing;
    end;

DoIt:
  Result:=CMD_OK;
  with IntData do
  begin
    //         
    NameBufferSize:=0;
    DataBufferSize:=0;
    NameBufferPtr:=nil;
    DataBufferPtr:=nil;
    //  ,      
    //   
    if Assigned(KeyListAddr) then
      begin
        PKeyNameList:=UStrL_Create;
        if not Assigned(PKeyNameList)
          then Result:=CMD_OUT_OF_MEMORY;
      end
    else PKeyNameList:=nil;
    //    
    if (Assigned(LastAccessAddr) and (Result=CMD_OK)) then
      begin
        PWriteDateList:=PUA_Integer(UA_CreateR(0,VarArrayItemSize[vtIntArray]));
          if not Assigned(PWriteDateList)
            then Result:=CMD_OUT_OF_MEMORY;
      end
    else PWriteDateList:=nil;
    //   
    if (Assigned(LevelAddr) and (Result=CMD_OK)) then
      begin
        PKeyLevelList:=PUA_DWORD(UA_CreateR(0,VarArrayItemSize[vtDWORDArray]));
        if not Assigned(PKeyLevelList)
          then Result:=CMD_OUT_OF_MEMORY;
      end
    else PKeyLevelList:=nil;

    //   
    if (Assigned(ValueNameAddr) and (Result=CMD_OK)) then
      begin
        PValueNameList:=UStrL_Create;
        if not Assigned(PValueNameList)
          then Result:=CMD_OUT_OF_MEMORY;
      end
    else PValueNameList:=nil;

    //   
    if (Assigned(ValueTypeAddr) and (Result=CMD_OK)) then
      begin
        PValueTypeList:=PUA_DWORD(UA_CreateR(0,VarArrayItemSize[vtDWORDArray]));
        if not Assigned(PValueTypeList)
          then Result:=CMD_OUT_OF_MEMORY;
      end
    else PValueTypeList:=nil;

        //   
    if (Assigned(ValueDataAddr) and (Result=CMD_OK)) then
      begin
        PValueDataList:=BBL_Create;
        if not Assigned(PValueDataList)
          then Result:=CMD_OUT_OF_MEMORY;
      end
    else PValueDataList:=nil;

    if Result=CMD_OK then
      begin
        if ExtractKeyNameAndBranch(start_reg_key,RegBranch,FullRegKey) then
          begin
            //       
            for i:=Low(RegRoots) to High(RegRoots)
              do if RegRoots[i].val=RegBranch then
                  begin
                    RegBranchName:=RegRoots[i].Name;
                    Break;
                  end;
            //     
            RegWalker(FullRegKey,'',IntData,0);
          end
          else Result:=CMD_INVALID_REG_KEY_NAME;
      end;

    //     ,
    // ,   ,  
    if Result=CMD_OK then
      begin
        //    ,   ,
        //     
        Variable_AssignArray(KeyListAddr,PArrayHeader(PKeyNameList),vtUnicodeStringList);
        Variable_AssignArray(LastAccessAddr,PArrayHeader(PWriteDateList),vtIntArray);
        Variable_AssignArray(LevelAddr,PArrayHeader(PKeyLevelList),vtDWORDArray);
        Variable_AssignArray(ValueNameAddr,PArrayHeader(PValueNameList),vtUnicodeStringList);
        Variable_AssignArray(ValueTypeAddr,PArrayHeader(PValueTypeList),vtDWORDArray);
        Variable_AssignArray(ValueDataAddr,PArrayHeader(PValueDataList),vtBinBlockList);
      end
    else
      begin
        //       NIL  
        //   UA_Destroy  
        UStrL_Destroy(PKeyNameList);
        UA_Destroy(PArrayHeader(PWriteDateList));
        UA_Destroy(PArrayHeader(PKeyLevelList));
        UStrL_Destroy(PValueNameList);
        UA_Destroy(PArrayHeader(PValueTypeList));
        BBL_Destroy(PValueDataList);
      end;

    //  
    if Assigned(NameBufferPtr)
      then FreeMem(NameBufferPtr);
    if Assigned(DataBufferPtr)
      then FreeMem(DataBufferPtr);
  end;//with

DoNothing:
  UA_Destroy(PArrayHeader(start_reg_key));

end;

function C_REG_BUILD_KEY_TREE(var context:TScriptContext):Integer;
begin
  Result:=REG_BUILD_x_TREE(context,False);
end;

function C_REG_BUILD_VALUE_TREE(var context:TScriptContext):Integer;
begin
  Result:=REG_BUILD_x_TREE(context,True);
end;

function C_MAX(var context:TScriptContext):Integer;
begin
 Result:=SingleDWORDOperation(context,opMaxDWORD,opMaxInt,OpMaxExt);
end;

function C_MIN(var context:TScriptContext):Integer;
begin
 Result:=SingleDWORDOperation(context,opMinDWORD,opMinInt,OpMinExt);
end;

type FIsWow64Process=function(hProcess: THandle; var Wow64Process: BOOL): BOOL; stdcall;
var FirstWow64Checked:Boolean=False;
    Wow64Checked:Boolean=False;
    IsWow64Process:FIsWow64Process;
//        IsWow64Process; ,    .
function CheckWow64:Boolean;
begin
  //         -  
  if not FirstWow64Checked then
    begin
      IsWow64Process:=GetProcAddress(Kernel32Handle,'IsWow64Process');
      FirstWow64Checked:=True;
      Wow64Checked:=Assigned(IsWow64Process);
    end;
  Result:=Wow64Checked;
end;

function C_IS_X64(var context:TScriptContext):Integer;
var res_var:Cardinal;
    state:TParamState;
begin
  res_var:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK
    then Result:=Variable_qStoreDWORD(context,res_var,Ord((SystemInfo.wProcessorArchitecture and PROCESSOR_ARCHITECTURE_AMD64)=PROCESSOR_ARCHITECTURE_AMD64))
    else Result:=CMD_PARAM_ERROR;
end;

function C_IS_PROCESS_64(var context:TScriptContext):Integer;
var hProc:HANDLE;
    handle_var,res_var:Cardinal;
    res:BOOL;
    state:TParamState;
    res_64:DWORD;
begin
  Result:=CMD_PARAM_ERROR;
  handle_var:=LoadParameter_DWORD(context,state,0);
  if state=PARAM_OK then
    begin
      res_var:=LoadParameter_DWORD(context,state,handle_var);
      if state<>PARAM_INVALID
        then Result:=CMD_OK;
    end;
  if Result=CMD_OK then
    begin
      {$IFDEF Win32}
        Result:=Variable_qLoadDWORD(context,handle_var,hProc);
      {$ENDIF}
      {$IFDEF Win64}
        Result:=Variable_qLoadInteger(context,handle_var,hProc);
      {$ENDIF}
    end;
  if Result=CMD_OK then
    begin
      //     32-
      res_64:=0;
      //     64-
      if (SystemInfo.wProcessorArchitecture and PROCESSOR_ARCHITECTURE_AMD64)=PROCESSOR_ARCHITECTURE_AMD64 then
      begin
        if CheckWOW64 then
          begin
            if IsWow64Process(hProc,res)
              then res_64:=Ord(not res)
              else
                begin
                  context.LastWindowsError:=GetLastError;
                  Result:=CMD_CANT_GET_WOW64;
                  Exit;
                end
          end;//if CheckWOW64
      end;//if (SystemInfo...)
      Result:=Variable_qStoreDWORD(context,res_var,res_64);
    end;
end;

function C_B_TO_USTR(var context:TScriptContext):Integer;
var state:TParamState;
    bb:PUA_BinaryBlock;
    write_to,len:Cardinal;
begin
  bb:=LoadParameter_BinBlock(context,state);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;
  write_to:=LoadParameter_DWORD(context,state,0);

  if state=PARAM_OK then
  begin
    len:=BB_Length(bb);
    if Odd(len)
      then Result:=CMD_BIN_BLOCK_LENGTH_NOT_COMPATIBLE
      else Result:=Variable_qWriteUnicodeString(context,write_to,@bb^.Arr,len shr 1);
  end
  else Result:=CMD_PARAM_ERROR;
end;

function C_B_TO_UHEX(var context:TScriptContext):Integer;
label DoIt;
var state:TParamState;
    r_v:PNeoS0MVariable;
    read_from,write_to,sz,i:Cardinal;
    delimiter,res:PUA_UnicodeString;
    p1:PByte;
    p2,delim:PChar;
    u_l:Cardinal;
begin
  delimiter:=nil;
  read_from:=LoadParameter_DWORD(context,state,0);
  if state<>PARAM_OK then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

  write_to:=LoadParameter_DWORD(context,state,read_from);
  case state of
    PARAM_END:      goto DoIt;
    PARAM_INVALID:  begin
                      Result:=CMD_PARAM_ERROR;
                      Exit;
                    end;
  end;//case

  delimiter:=LoadParameter_UnicodeString(context,state);
  if state=PARAM_INVALID then
    begin
      Result:=CMD_PARAM_ERROR;
      Exit;
    end;

DoIt:
  if not Assigned(Delimiter)
    then Delimiter:=@EmptyUnicodeString;
  r_v:=Variable_GetAddress(context,read_from);
  if Assigned(r_v) then
    begin
      if r_v.VarType=vtBinBlock then
        begin
          with PUA_BinaryBlock(r_v^.UA)^ do
          begin
            sz:=Header.ElemCount-2;
            p1:=@Arr;
          end;//with
          //  
          if sz=0
            then Result:=Variable_AssignArray(context,write_to,@EmptyUnicodeString,vtUnicodeString)
            else
              begin
                delim:=@delimiter.Arr;
                //   
                u_l:=UStr_Length(delimiter);
                //          -
                Res:=UStr_Allocate((sz shl 1)+(sz-1)*u_l);
                if Assigned(Res) then
                  begin
                    p2:=@Res^.Arr;
                    for i:=1 to sz do
                      begin
                        PChar(p2)^:=Char(HexDigits[p1^ shr 4]);
                        Inc(p2);
                        PChar(p2)^:=Char(HexDigits[p1^ and $0F]);
                        Inc(p2);
                        if (i<>sz) and (u_l<>0) then
                          begin
                            Move(delim^,p2^,u_l*SizeOf(Char));
                            Inc(p2,u_l);
                          end;//if i<>sz
                        Inc(p1);
                      end;//for
                      Result:=Variable_AssignArray(context,write_to,PArrayHeader(Res),vtUnicodeString);
                      if Result<>CMD_OK
                        then UA_Destroy(PArrayHeader(Res));
                  end
                else Result:=CMD_OUT_OF_MEMORY;
              end;
        end
      else Result:=CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE;
    end
  else Result:=CMD_INVALID_VARIABLE_INDEX;
  UA_Destroy(PArrayHeader(delimiter));
end;

function C_RANDOMIZE(var context:TScriptContext):Integer;
var state:TParamState;
    rand_value:Integer;
    {$IFDEF Win64}
    Counter:Int64;
    {$ENDIF}
begin
{$IFDEF Win32}
  asm
    rdtsc
    mov rand_value,eax
  end;
{$ENDIF}
{$IFDEF Win64}
  if QueryPerformanceCounter(Counter)
    then rand_value:=Integer(Counter)
    else rand_value:=GetTickCount;
{$ENDIF}

  RandSeed:=LoadParameter_DWORD(context,state,rand_value);
  if state<>PARAM_INVALID
    then Result:=CMD_OK
    else Result:=CMD_PARAM_ERROR;
end;

function GetProcessEXEPath(h:HANDLE; var res:UnicodeString; var win_err:Cardinal):Integer;
var sz:DWORD;
    r:BOOL;
begin
  //    ,    
  if @QueryFullProcessImageName=nil then
  begin
    QueryFullProcessImageName:=TQueryFullProcessImageName(GetProcAddress(Kernel32Handle,'QueryFullProcessImageNameW'));
    //      -   "  "
    if @QueryFullProcessImageName=nil then
      begin
        Result:=CMD_NOT_SUPPORTED_BY_OS;
        Exit;
      end;
  end;
  //  
  sz:=MAX_PATH;
  SetLength(res,sz+1);
  //     
  r:=QueryFullProcessImageName(h,0,PChar(res),sz);
  if r then
    begin
      SetLength(res,sz);
      Result:=CMD_OK;
    end
    else
      begin
        Result:=CMD_CANT_GET_EXE_PATH;
        win_err:=GetLastError;
      end;
end;

function C_PROCESS_GET_EXE_NAME(var context:TScriptContext):Integer;
var handle_var,res_var:DWORD;
    win_err:Cardinal;
    h:HANDLE;
    res:UnicodeString;
begin
  Result:=_ReadTwoVarsIndexes(context,handle_var,res_var);
  if Result=CMD_OK then
    begin
      Result:=Variable_qLoadDWORD(context,handle_var,h);
      if Result=CMD_OK then
        begin
          Result:=GetProcessEXEPath(h,res,win_err);
          if Result=CMD_OK
            then Result:=Variable_qWriteUnicodeString(context,res_var,PChar(res),Length(res))
            else context.LastWindowsError:=win_err;
        end;//if Result=CMD_OK
    end;//if Result=CMD_OK
end;

function C_ENV_STRINGS_EXPAND(var context:TScriptContext):Integer;
label Again;
var in_var,res_var:Cardinal;
    res_len:Integer;
    in_str,buf_str:UnicodeString;
begin
  Result:=_ReadTwoVarsIndexes(context,in_var,res_var);
  if Result<>CMD_OK
    then Exit;
  Result:=Variable_qLoadUnicodeString(context,in_var,in_str);
  if Result<>CMD_OK
    then Exit;

  //   ,    +MAX_PATH.
  //      
  res_len:=Length(in_str)+MAX_PATH;
Again:
  SetLength(buf_str,res_len);
  res_len:=ExpandEnvironmentStringsW(PWideChar(in_str),PWideChar(buf_str),res_len);
  // ExpandEnvironmentStrings  
  if res_len=0 then
  begin
    context.LastWindowsError:=GetLastError;
    Result:=CMD_CANT_EXPAND_ENV_STRING;
  end
  else
  begin
    //   -  ,    
    //     
    if res_len>Length(buf_str) then
    begin
      res_len:=res_len;
      goto Again;
    end
    //     
    else Result:=Variable_qWriteUnicodeString(context,res_var,PWideChar(buf_str),res_len-1);
  end;


end;

initialization
begin
  InitConvTable;
  InitCharConvTable;
end;

end.
