unit CRC64;

interface

procedure CRC64_Block(Data:PByte;const Count:Cardinal; var CRC64:Int64);
function CRC64_Calculate(Data:PByte; const Count:Cardinal): Int64;

implementation
var CRC64Table: array[Byte] of Int64;

procedure CRC64_Block(Data:PByte;const Count:Cardinal; var CRC64:Int64);
var
 MyCRC64: Int64;
 i: Cardinal;
begin
 MyCRC64:=CRC64;
 for i:=1 to Count do
 begin
  MyCRC64:=MyCRC64 shr 8 xor CRC64Table[Cardinal(MyCRC64) and $FF xor Data^];
  Inc(Data);
 end;//for
 CRC64 := MyCRC64;
end;

function CRC64_Calculate(Data:PByte; const Count:Cardinal): Int64;
begin
 Result:=not 0;
 CRC64_Block(Data,Count,Result);
end;

var i,j:Byte;tmp:Int64;

initialization

for i:=0 to 255 do
begin
 tmp:=i;
 for j:=1 to 8 do
  if Odd(tmp)
    then tmp:=tmp shr 1 xor $C96C5795D7870F42
    else tmp:=tmp shr 1;
  CRC64Table[i]:=tmp;
end;//for

end.
