unit NeoS0M_CompilerTypes;

interface

uses Classes;

const SECTION_ANY='';
      MODULE_ANY=-2; // -2,  -1    SCRPIT_MAIN_MODULE

type TOneLabelInfo=record
      OffsetInSection:Cardinal; //    
      ModuleIndex:Integer;      //      
      SectionGlobal:Boolean;    //      
     end;
     TLabelsInfo=array of TOneLabelInfo;

     TCompSection=record
      Ptr:Pointer;             //      
      SectionName: AnsiString; //  
      Size,BufSize,Flags:Cardinal;
      OffsetInFile:Cardinal; //   -     JTS
      Labels:TStringList;    //        
      LabelsInfo:TLabelsInfo;
//      LabelRefs:TStringList; //            
     end;

     TOneScriptLine=packed record
       ModuleIndex:Integer;  //   ()   .   -  
       LineNumber:Cardinal;  //    
     end;
     TScriptLines=array of TOneScriptLine;

     TOneLabelReference=record
       Name:String;         //  ,    
       Section:AnsiString;  //  ,    
       SectionWhere:Integer;//  ,    
       Module:Integer;      //  
       LabelOffsetInFile:Cardinal; //   
       LineNumber:Integer;         //  ,       (    ,      )
     end;
     TLabelReferences=array of TOneLabelReference;

type TRawScript=record
      ScriptPath:String;     //   ,    
      ReparseFileNames:Boolean; //          
      ScriptText:TStringList;
      ScriptModules:TStringList;
      ScriptLines:TScriptLines;
      CRC64_Needed:Boolean; //    CRC64  
      LabelReferences:TLabelReferences; //    
      TrueLabelRefCount:Integer;        //      

      CompilingResult,ErrLine:Cardinal;
      NowCompiling:Integer;       //    (     )
      StopErrorHandling: Boolean; // ,          USES  INCLUDE
      ErrModule:Integer;
      NewIcon:String;       //   

      //    
      Sections:array of TCompSection;
      CurrentSection:Cardinal;
     end;
     PRawScript=^TRawScript;

     TLineCompilingMode=(lcmCommand,lcmParameters,lcmLabels,lcmSectionName,lcmDirective);
     TDirectiveMode=(dmNone,dmFile,dmFileSize,dmDB,dmDW,dmDD,dmDI,dmDF,dmInclude,dmUses,dmIcon);

const LC_OK=0; //   
      //    
      LC_CANT_READ_SCRIPT_FILE=2;
      LC_CANT_WRITE_COMPILED_FILE=3;
      LC_OUT_OF_MEMORY=4;

      LC_INVALID_COMMAND_NAME=100; //    
      LC_TOO_MANY_PARAMETERS=101;  //     
      LC_OUT_OF_PARAMETERS=102;    //  
      LC_INVALID_SECTION_DESCRIPTION=103; //   
      LS_MODIFICATION_OF_SYS_SECTION=104; //      
      LS_SECTION_PARAMETERS_DIFFERS=105;  //      
      LC_UNKNOWN_DIRECTIVE=106;    //  
      LC_FILE_NOT_EXISTS=107;      //    
      LC_FILE_CANT_BE_LOADED=108;  //     
      LC_DATA_COMPILING_NOT_ALLOWED=109;
                                   //      
      LC_DEFAULT_NOT_ALLOWED=110;  //        
      LC_END_OF_PARAM_NOT_ALLOWED=111;  //          

      LC_INVALID_PARAM_INT=1000;    //   
      LC_INVALID_PARAM_VARIDX=1001; //   -  
      LC_INVALID_PARAM_FLOAT=1002;  //   -  
      LC_INVALID_PARAM_STRING=1003; //   - Ansi-
      LC_INVALID_HEX_DIGITS_COUNT=1004; //   16-     
      LC_INVALID_DATE_TIME=1005;    //   /
      LC_INCOMPATIBLE_PARAM_TYPE=1006; //   
      LC_INVALID_CHAR_CODE=1007;    //   
      LC_INVALID_LABEL_NAME=1008;   //   
      LC_SECTION_NOT_EXISTS=1009;   //   
      //...
      LC_UNKNOWN_PARAM_TYPE=1020;
      LC_LABEL_NOT_FOUND=1021;
      LC_DIRECTIVE_PARAMETER_IS_NOT_NUMBER=1022;
      LC_DIRECTIVE_PARAMETER_VIOLATES_BOUNDS=1023;
      LC_DIRECTIVE_PARAMETER_IS_INVALID=1024; //   
      LC_SYNTAX_ERROR=1025;
      LC_CANT_REPLACE_ICON=1026;    //   

      COMPILING_BUFFER_GRANULARITY=4096;

      COMPILED_END_OF_PARAM=1;

      _FileNotFound='File ''%s'' not found';
      FORCE_UNICODE_STRINGS=1;

implementation

end.
 