unit NeoS0M_ReplaceIcon;

interface

uses Windows;

type TIconDirEntry=packed record
      bWidth:Byte;               //  
	    bHeight:Byte;              //  
	    bColorCount:Byte;          //     (0,  >=256)
	    bReserved:Byte;            // 
	    wPlanes:Word;              //     
	    wBitCount:Word;            //  ,   
	    dwBytesInRes:Cardinal;     //    
	    dwImageOffset:Cardinal;    //    
     end;
     PIconDirEntry=^TIconDirEntry;

     TIconDir=packed record
      idReserved: Word;   // 
      idType:     Word;   //   (  - 1)
      idCount:    Word;   //    
      idEntries:  array [0..0] of TIconDirEntry; //  
     end;
     PIconDir=^TIconDir;

     TMemIconDirEntry=packed record
      bWidth:Byte;               //  
	    bHeight:Byte;              //  
	    bColorCount:Byte;          //     (0,  >=256)
	    bReserved:Byte;            // 
	    wPlanes:Word;              //     
	    wBitCount:Word;            //  ,   
	    dwBytesInRes:Cardinal;     //    
	    nID:Word;                  // 
     end;

     TMemIconDir=packed record
      idReserved: Word;   // 
      idType:     Word;   //   (  - 1)
      idCount:    Word;   //    
      idEntries:  array [0..0] of TMemIconDirEntry; //  
     end;
     PMemIconDir=^TMemIconDir;

function ReplaceIcon(const ExeName,IconName:String):Boolean;


implementation

var ICON_COUNT:Integer=4;

type TOneIconInfo=record
       DataPtr:Pointer;
       DataSize:Cardinal;
     end;
     TIconList=array of TOneIconInfo;

function ParseIcon(IconData:Pointer; var Icons:TIconList):Boolean;
var IconDir:PIconDir;
    i:Integer;
begin
  IconDir:=IconData;
  Result:=(IconDir^.idReserved=0) and (IconDir^.idType=1) and (IconDir^.idCount<256);
  if Result then
    begin
      SetLength(Icons,IconDir^.idCount);
      //     
      for i:=0 to IconDir^.idCount-1 do
        begin
          Icons[i].DataPtr:=IconData;
          Inc(PByte(Icons[i].DataPtr),IconDir^.idEntries[i].dwImageOffset);
          Icons[i].DataSize:=IconDir^.idEntries[i].dwBytesInRes;
        end;//for
    end;
end;

function ReplaceIconByData(const ExeName:String; IconData:Pointer; IconSize:Cardinal):Boolean;
const MY_LANG_ID=0;
var hUpdateResource:THandle;
    Icons:TIconList;
    MemIconDir:PMemIconDir;
    MemIconDirSize:Integer;
    i:Cardinal;
begin
  Result:=False;
  hUpdateResource:=BeginUpdateResourceW(PWideChar(ExeName),False);
  if hUpdateResource<>0 then
    begin
      Result:=ParseIcon(IconData,Icons);
      //     ,   
      if Result then
        begin
          // ,        
          MemIconDirSize:=6+SizeOf(TMemIconDirEntry)*Length(Icons);
          GetMem(MemIconDir,MemIconDirSize);
          MemIconDir^.idReserved:=0;
          MemIconDir^.idType:=1;
          MemIconDir^.idCount:=(PIconDir(IconData))^.idCount;
          Result:=True;
          for i:=Low(Icons) to High(Icons) do
            begin
              //     
              //   12   , ..     
              Move(PIconDir(IconData)^.idEntries[i],MemIconDir^.idEntries[i],12);
              MemIconDir^.idEntries[i].nID:=i+1;
              Result:=Result and UpdateResourceW(hUpdateResource,RT_ICON,MakeIntResource(i+1),MY_LANG_ID,Icons[i].DataPtr,Icons[i].DataSize);
            end;//for
          //      ,   ,     
          if Length(Icons)<ICON_COUNT then
            begin
              for i:=Length(Icons)+1 to ICON_COUNT
                do UpdateResourceW(hUpdateResource,RT_ICON,MakeIntResource(i),MY_LANG_ID,nil,0);
            end;
          //   " "
          Result:=Result and UpdateResourceW(hUpdateResource,RT_GROUP_ICON,'MAINICON',MY_LANG_ID,MemIconDir,MemIconDirSize);
          //   ,     -  
          EndUpdateResourceW(hUpdateResource,not Result);
        end;
    end;
end;

function ReplaceIcon(const ExeName,IconName:String):Boolean;
var Icon:Pointer;
    hIconFile:THandle;
    fsize,readed:Cardinal;
begin
  Result:=False;
  hIconFile:=CreateFileW(PChar(IconName),GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  //   ?
  if hIconFile<>INVALID_HANDLE_VALUE then
    begin
      fsize:=GetFileSize(hIconFile,nil);
      GetMem(Icon,fsize);
      //      ,   ?
      if Assigned(Icon) then
        begin
          ReadFile(hIconFile,Icon^,fsize,readed,nil);
          //    ,    ?
          if fsize=readed
            //        
            then Result:=ReplaceIconByData(ExeName,Icon,fsize);
          FreeMem(Icon);
        end;//if Assigned(Icon);
      CloseHandle(hIconFile);
    end
end;

end.
