library Miniface;

uses
  Windows,
  Messages;

// {$R *.res}
const WND_IB_CLASS_NAME='MinifaceIBWnd';
      WND_MB_CLASS_NAME='MinifaceMBWnd';
      WND_DDF_CLASS_NAME='MinifaceDDFWnd';
      WND_NEOKIT_NAME='MinIFaceNeoKitWnd';

      _Default:UnicodeString='DEFAULT';

      X_SIZE=454;
      Y_SIZE=106;
      DDF_Y_SIZE=300;

      ID_BUTTONOK=11;
      ID_BUTTONCANCEL=22;

      BASE_BTN_ID=123;
const I64_BASE=$100000000;
      UNKNOWN_SLOT=I64_BASE;
      UNKNOWN_SIZE=I64_BASE;
      SCREEN_LEFT=I64_BASE;
      SCREEN_TOP=I64_BASE;
      SCREEN_CENTER=I64_BASE+1;
      SCREEN_RIGHT=I64_BASE+2;
      SCREEN_BOTTOM=I64_BASE+2;
      HW_AUTO=I64_BASE;
      DEFAULT_FORM_FONT=I64_BASE;
      FORM_CENTER=I64_BASE+1;

      NO_ID=I64_BASE;

      FONT_ITALIC=16;
      FONT_UNDERLINE=32;
      FONT_STRIKEOUT=64;
      FONT_BOLD_MASK=15;

      DEFAULT_FORM_STYLE=WS_CAPTION or WS_CLIPSIBLINGS or WS_SYSMENU or DS_3DLOOK or DS_CONTEXTHELP;
      DEFAULT_FORM_EXSTYLE=0;
      DEFAULT_BUTTON_STYLE=WS_CHILD or BS_TEXT or WS_TABSTOP;
      DEFAULT_EDIT_STYLE=WS_CHILD or ES_AUTOHSCROLL;
      DEFAULT_EDIT_EXSTYLE=WS_EX_CLIENTEDGE;
      DEFAULT_LABEL_EXSTYLE=0;
      DEFAULT_LABEL_STYLE=WS_CHILD or SS_NOTIFY;
      DEFAULT_MEMO_STYLE=WS_CHILD or ES_MULTILINE or ES_WANTRETURN or ES_AUTOVSCROLL or ES_AUTOHSCROLL;
      DEFAULT_MEMO_EXSTYLE=WS_EX_CLIENTEDGE;
      DEFAULT_CHECKBOX_STYLE=WS_CHILD or BS_AUTOCHECKBOX;
      TRI_STATE_CHECKBOX_STYLE=WS_CHILD or BS_AUTO3STATE;
      DEFAULT_RADIOBUTTON_STYLE=WS_CHILD or BS_AUTORADIOBUTTON;
      DEFAULT_LISTBOX_STYLE=WS_CHILD or LBS_NOTIFY;
      DEFAULT_LISTBOX_EXSTYLE=WS_EX_CLIENTEDGE;

      INVALID_PARAMETER='Invalid parameter';

      SIGNAL_FORM_CLOSED=1;
      SIGNAL_FORM_MOVED_OR_RESTORED=2;
      SIGNAL_FORM_RESIZED=3;
      SIGNAL_FORM_MAXIMIZED=4;
      SIGNAL_FORM_MINIMIZED=5;

      SIGNAL_CONTROL_CLICKED=10;

      SIGNAL_LISTBOX_SELCHANGE=50;
      SIGNAL_LISTBOX_DBLCLICKED=51;


type fVar_StoreUnicodeString=function(const context:Cardinal; index:Cardinal; val_start:PWideChar; char_count:Cardinal):Cardinal; stdcall;
     fVar_InitUStrL=function (const context:Cardinal; index:Cardinal):Cardinal;stdcall;
     fVar_AddItemUStrL=function (const context:Cardinal; index:Cardinal; str_start:Pointer; str_len:Cardinal):Cardinal; stdcall;
     fVar_StoreDWORD=function (context:Cardinal; index,value:Cardinal):Cardinal; stdcall;
     TIBWindowData=record
      Context:Cardinal;
      VarIdx:Cardinal;
      MainWndHandle:HWND; //  
      LabelCaption,EditValue,ButtonOK,ButtonCancel:HWND;

      Result:Cardinal;
     end;
     PIBWindowData=^TIBWindowData;

     TMBWindowData=record
      Context:Cardinal;
      MainWndHandle:HWND; //  

      Result:Cardinal;
     end;
     PMBWindowData=^TMBWindowData;

     TDDFWindowData=record
      Context:Cardinal;
      VarIdx:Cardinal;
      MainWndHandle:HWND; //  
      LabelCaption,EditValue,ButtonCancel:HWND;

      Result:Cardinal;
     end;
     PDDFWindowData=^TDDFWindowData;

type TNeoKitItemType=(nkitNone,nkitMain,nkitButton,nkitEdit,nkitCheckbox,nkitFont,nkitLabel,nkitGroupBox,
                      nkitRadioButton,nkitMemo,nkitListBox);
const NeoKitContainers=[nkitMain];

type TNeoKitItem=record
      TypeID:TNeoKitItemType;  //   
      I:Int64;                 //   ;     0
//      Handle:Cardinal;         //  
      P:Int64;                 //   (  . ,   )
      R:Boolean;               //  Read-only   
      V:Boolean;               // 
      E:Boolean;               // ?
      C:Int64;                 // Checked? 


      X,Y,W,H:Int64;           //   
      F:Int64;                 //   (   )
      S,Z:Int64;               //     
      T:UnicodeString;         //   ( ;  )
      SLOT:Int64;              // -
      HandleSLOT:Int64;        // - 
     end;
     type TNKItemList=array of TNeoKitItem;

type FItemCreator=function(var ItemList:TNKItemList):UnicodeString;

     TOneCreatedItem=packed record
      t: TNeoKitItemType;
      Handle:Cardinal;
      UseSlot:Boolean;
      Slot: Integer;
     end;
     POneCreatedItem=^TOneCreatedItem;

     //      
     TCreatedItems=record
                    Context:Cardinal;
                    DeviceCaps:Integer;
                    Items:packed array [1..2] of TOneCreatedItem;
                   end;
     PCreatedItems=^TCreatedItems;
     FControlCreator=function(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;

type TForNeoKitItems=record
      t:TNeoKitItemType;
      cmd:UnicodeString;
      ItemCreator:FItemCreator;
      ControlCreator:FControlCreator;
      allowed:set of AnsiChar;
     end;

     TItemToDestroy=record
      items:PCreatedItems;
      thread:Cardinal;
     end;
     TItemsToDestroy=array of TItemToDestroy;
                           

// var UpperCaseTable:array [WideChar] of WideChar;

// X - x-
// Y - -
// H - 
// W - 
// T - 
// P - -
// V - 
// E - 
// I -   
// F - I  
// R - "  " ( Edit)
// C- checked ( Checkbox  Radiobutton)
// S -  
// Z -   
// # - -
// @ - - 

function NeoKitWindowProc(hwnd, msg, wparam, lparam: longint): longint; stdcall; forward; // 

function MainFormInit(var ItemList:TNKItemList):UnicodeString;forward;
function MainFormCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;
function ButtonInit(var ItemList:TNKItemList):UnicodeString;forward;
function ButtonCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;
function CheckBoxInit(var ItemList:TNKItemList):UnicodeString;forward;
function CheckBoxCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;
function EditInit(var ItemList:TNKItemList):UnicodeString;forward;
function EditCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;
function FontInit(var ItemList:TNKItemList):UnicodeString;forward;
function FontCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;
function LabelInit(var ItemList:TNKItemList):UnicodeString;forward;
function LabelCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;
function MemoInit(var ItemList:TNKItemList):UnicodeString;forward;
//function MemoCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;
function RadioButtonInit(var ItemList:TNKItemList):UnicodeString;forward;
function RadioButtonCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;
function ListBoxInit(var ItemList:TNKItemList):UnicodeString;forward;
function ListBoxCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString; forward;

const NeoKitItems:array [nkitMain..High(TNeoKitItemType)] of TForNeoKitItems=(
      (cmd:'FORM';       ItemCreator:MainFormInit;  ControlCreator: MainFormCreate;
       allowed:['X','Y','H','W','T','V','E','S','Z','#','@']),
      (cmd:'BUTTON';     ItemCreator:ButtonInit;  ControlCreator: ButtonCreate;
       allowed:['X','Y','H','W','T','V','E','F','P','S','#','@']),
      (cmd:'EDIT';       ItemCreator:EditInit;  ControlCreator: EditCreate;
       allowed:['X','Y','H','W','T','V','E','F','P','R','S','Z','#','@']),
      (cmd:'CHECKBOX';   ItemCreator:CheckBoxInit;  ControlCreator: CheckBoxCreate;
       allowed:['X','Y','H','W','T','V','E','I','F','P','S','C','#','@']),
      (cmd:'FONT';       ItemCreator:FontInit;  ControlCreator: FontCreate;
       allowed:['H','T','S','I','@']),
      (cmd:'LABEL';      ItemCreator:LabelInit;  ControlCreator: LabelCreate;
       allowed:['X','Y','H','W','T','V','E','F','P','S','Z','#','@']),
      (cmd:'GROUPBOX';
       allowed:['X','Y','H','W','T','V','E','F','P','S','@']),
      (cmd:'RADIOBUTTON';ItemCreator:RadioButtonInit;  ControlCreator: RadioButtonCreate;
       allowed:['X','Y','H','W','T','V','E','F','P','S','C','#','@']),
      (cmd:'MEMO';       ItemCreator:MemoInit;  ControlCreator: EditCreate;
       allowed:['X','Y','H','W','T','V','E','F','P','R','S','#','@']),
      (cmd:'LISTBOX';    ItemCreator:ListBoxInit;  ControlCreator: ListBoxCreate;
       allowed:['X','Y','H','W','T','V','E','F','P','S','Z','#','@'])
    );

var MyModule:HModule;
    hFont:HWND=0;
    Result:UnicodeString='';
    IB_class_atom:Cardinal=0;
    MB_class_atom:Cardinal=0;
    DDF_class_atom:Cardinal=0;
    NEOKIT_class_atom:Cardinal=0;

    Var_StoreUnicodeString:fVar_StoreUnicodeString=nil;
    Var_InitUStrL:fVar_InitUStrL=nil;
    Var_AddItemUStrL:fVar_AddItemUStrL=nil;
    Var_StoreDWORD:fVar_StoreDWORD=nil;

procedure DragAcceptFiles(Wnd: HWND; Accept: BOOL); stdcall; external 'shell32' name 'DragAcceptFiles';
function DragQueryFileW(Drop: Cardinal; FileIndex: UINT; FileName: PWideChar; cb: UINT): UINT; stdcall; external 'shell32' name 'DragQueryFileW';
procedure DragFinish(Drop: Cardinal); stdcall; external 'shell32' name 'DragFinish';

procedure MakeFont;
begin
if hFont=0 then
  begin
    //  
    hFont := CreateFont(
    -11, 0, 0, 0, 0, 0, 0, 0,
    DEFAULT_CHARSET,
    OUT_DEFAULT_PRECIS,
    CLIP_DEFAULT_PRECIS,
    DEFAULT_QUALITY,
    DEFAULT_PITCH or FF_DONTCARE, 'MS Sans Serif');
  end;
end;

function IBWindowProc(hwnd, msg, wparam, lparam: longint): longint; stdcall; // 
var pwd:PIBWindowData;
    textlen:Integer;
    _text:UnicodeString;
begin
    Result:=DefWindowProc(hwnd, msg, wparam, lparam);
    case Msg of
      WM_COMMAND: begin
                    pwd:=PIBWindowData(GetWindowLong(hwnd,GWL_USERDATA));
                    if (LOWORD(wParam)=ID_BUTTONOK) and (HIWORD(wParam)=BN_CLICKED) then
                      begin
                        textlen:=SendMessageW(pwd.EditValue,WM_GETTEXTLENGTH,0,0);
                        if textlen>0
                          then
                            begin
                              SetLength(_text,textlen+1);
                              SendMessageW(pwd.EditValue,WM_GETTEXT,textlen+1,Cardinal(PWideChar(_text)));
                            end
                          else _text:='';
                        textlen:=Var_StoreUnicodeString(pwd.context,pwd.VarIdx,PWideChar(_text),lstrlenW(PWideChar(_text)));
                        if textlen=0
                          then pwd.Result:=1
                          else pwd.Result:=$FFFFFFFD;
                        DestroyWindow(pwd.MainWndHandle);
                      end;
                    if (LOWORD(wParam)=ID_BUTTONCANCEL) and (HIWORD(wParam)=BN_CLICKED) then
                      begin
                        pwd.Result:=0;
                        DestroyWindow(pwd.MainWndHandle);
                      end;
                  end;
      WM_CLOSE:   begin
                    pwd:=PIBWindowData(GetWindowLong(hwnd,GWL_USERDATA));
                    DestroyWindow(pwd.MainWndHandle);
                  end;
      WM_DESTROY: PostQuitMessage(0);
    end;//case
  end;//function

function InputBox(context:Cardinal; Caption,Text,Default:PWideChar;VarIdx:Cardinal):Cardinal;stdcall;
//  :
// 0 -   ""
// 1 -   "OK"
// -1 -    
// -2 -     ,    
var
  WinData:TIBWindowData;
  WinClassEx:TWndClassExW;
  hInst:Cardinal;
  Msg:TMSG; //
  le:Cardinal;
  LastErr:UnicodeString;
  ClientArea:TRect;

begin
  WinData.Context:=context;
  WinData.VarIdx:=VarIdx;
  hInst := GetModuleHandle(nil);

  if not Assigned(Var_StoreUnicodeString) then
  begin
    Var_StoreUnicodeString:=GetProcAddress(PCardinal(context)^,'Var_StoreUnicodeString');
    if not Assigned(Var_StoreUnicodeString) then
    begin
      MessageBoxW(0,'     Var_StoreUnicodeString   Neo Sign 0f Misery','',MB_ICONERROR);
      Result:=$FFFFFFFE;
      Exit;
    end;
  end;//if not Assigned(...)

  WinData.Result:=$FFFFFFFF;
  FillChar(WinClassEx,SizeOf(WndClassEx),0);
  with WinClassEx do
  begin
  cbSize:=SizeOf(WndClassEx);
  //    
  //     
  style := CS_HREDRAW or CS_VREDRAW;
  //  
  lpfnWndProc := @IBWindowProc;
  //     
  cbClsExtra := 0;
  //     
  cbWndExtra := 0;
  //  
  hInstance := HInstance;
  //  
  hIcon := LoadIcon(0, IDI_QUESTION);
  //   
  hCursor := LoadCursor(0, IDC_ARROW);
  //  
  hbrBackground := COLOR_WINDOW;
  //   
  lpszMenuName := nil;
  //  
  lpszClassName := WND_IB_CLASS_NAME;
  //  
  end;

//InitCommonControls;
if IB_class_atom=0
  then IB_class_atom:=RegisterClassExW(WinClassEx); //   

//    InputBox
WinData.MainWndHandle:=CreateWindowExW(0, WND_IB_CLASS_NAME, Caption,
            DEFAULT_FORM_STYLE,
            (GetSystemMetrics(SM_CXSCREEN)-X_SIZE) div 2,
            (GetSystemMetrics(SM_CYSCREEN)-Y_SIZE) div 2,
            X_SIZE,Y_SIZE,
            0, 0,hInst, nil);
if WinData.MainWndHandle=0 then
  begin
    le:=GetLastError;
    Str(le,LastErr);
    MessageBoxW(0,PWideChar('  Windows:'+LastErr{+#13#10+SysErrorMessage(le)}),': CreateWindowEx',MB_ICONERROR)
  end;

SetWindowLongW(WinData.MainWndHandle,GWL_USERDATA,Integer(@WinData));
GetClientRect(WinData.MainWndHandle,ClientArea);
MakeFont;

WinData.LabelCaption := CreateWindow(
'Static',Text,
WS_CHILD or SS_LEFT or WS_VISIBLE,
4, 2, ClientArea.Right-8, 13, WinData.MainWndHandle, 0, hInst, nil);
SendMessage(WinData.LabelCaption, WM_SETFONT, hFont, 0);

WinData.EditValue := CreateWindowEx(
WS_EX_CLIENTEDGE,
'Edit',Default,
WS_CHILD or ES_AUTOHSCROLL or WS_VISIBLE or WS_TABSTOP,
4, 20, ClientArea.Right-8, 21, WinData.MainWndHandle, 0, hInst, nil);
SendMessage(WinData.EditValue, WM_SETFONT, hFont, 0);

//   ""
WinData.ButtonOK := CreateWindow(
'Button',
'',
WS_CHILD or BS_TEXT or WS_VISIBLE or WS_TABSTOP,
4, 48, (ClientArea.Right-10) div 2, 25, WinData.MainWndHandle, 0, hInst, nil);
SendMessage(WinData.ButtonOK, WM_SETFONT, hFont, 0);
SetWindowLongW(WinData.ButtonOK,GWL_ID,ID_BUTTONOK);

//   ""
WinData.ButtonCancel := CreateWindow(
'Button',
'',
WS_CHILD or BS_TEXT or WS_VISIBLE or WS_TABSTOP,
(ClientArea.Right div 2)+1, 48, (ClientArea.Right-10) div 2, 25, WinData.MainWndHandle, 0, hInst, nil);
SendMessage(WinData.ButtonCancel, WM_SETFONT, hFont, 0);
SetWindowLongW(WinData.ButtonCancel,GWL_ID,ID_BUTTONCANCEL);


ShowWindow(WinData.MainWndHandle,SW_SHOW);
UpdateWindow(WinData.MainWndHandle);

  //   
  while(GetMessage(Msg, 0, 0, 0)) do
  begin
    if not IsDialogMessage(WinData.MainWndHandle,Msg) then
      begin
        TranslateMessage(Msg); // 
        DispatchMessage(Msg); //   
      end;
  end;
Result:=WinData.Result;
end;

procedure DLLHandler(Reason: Integer);
begin
  case reason of
    DLL_PROCESS_ATTACH:
      begin
        //    
        MyModule:=GetModuleHandleA(nil);
      end;
    DLL_PROCESS_DETACH:
      begin
        if hFont<>0 then DeleteObject(hFont); // 
        if IB_class_atom<>0
          then UnregisterClassW(WND_IB_CLASS_NAME,0{hInst});
        if MB_class_atom<>0
          then UnregisterClassW(WND_MB_CLASS_NAME,0{hInst});
        if DDF_class_atom<>0
          then UnregisterClassW(WND_DDF_CLASS_NAME,0{hInst});
      end;
  end;//case
end;

function MBWindowProc(hwnd, msg, wparam, lparam: longint): longint; stdcall; // 
var pwd:PMBWindowData;
begin
    Result:=DefWindowProc(hwnd, msg, wparam, lparam);
    case Msg of
      WM_COMMAND: begin
                    if HIWORD(wParam)=BN_CLICKED then
                      begin
                        pwd:=PMBWindowData(GetWindowLong(hwnd,GWL_USERDATA));
                        pwd.Result:=LOWORD(wParam)-BASE_BTN_ID+1;
                        DestroyWindow(pwd.MainWndHandle);
                      end;
                  end;
      WM_CLOSE:   begin
                    pwd:=PMBWindowData(GetWindowLong(hwnd,GWL_USERDATA));
                    pwd.Result:=0;
                    DestroyWindow(pwd.MainWndHandle);
                  end;
      WM_DESTROY: PostQuitMessage(0);
    end;//case
end;

function MultiButton(context:Cardinal; Caption,Buttons:PWideChar;DefaultButton:Cardinal;BtnWidth:Integer):Cardinal;stdcall;
const BTN_HEIGHT=30;
var
  WinData:TMBWindowData;
  WinClassEx:TWndClassExW;
  hInst:Cardinal;
  Msg:TMSG;
  BtnX,BtnY,BtnID,le,DeltaX,DeltaY:Cardinal;
  LastErr:UnicodeString;
  ClientArea,WindowArea:TRect;
  BtnText:UnicodeString;
  CurChar:PWideChar;

begin
  WinData.Context:=context;
  hInst := GetModuleHandle(nil);

  WinData.Result:=0;
  FillChar(WinClassEx,SizeOf(WndClassEx),0);
  with WinClassEx do
  begin
  cbSize:=SizeOf(WndClassEx);
  //    
  //     
  style := CS_HREDRAW or CS_VREDRAW;
  //  
  lpfnWndProc := @MBWindowProc;
  //     
  cbClsExtra := 0;
  //     
  cbWndExtra := 0;
  //  
  hInstance := HInstance;
  //  
  hIcon := LoadIcon(0, IDI_QUESTION);
  //   
  hCursor := LoadCursor(0, IDC_ARROW);
  //  
  hbrBackground := COLOR_WINDOW;
  //   
  lpszMenuName := nil;
  //  
  lpszClassName := WND_MB_CLASS_NAME;
  //  
  end;//with

  if MB_class_atom=0
    then MB_class_atom:=RegisterClassExW(WinClassEx); //   

  //    MultiButton
  WinData.MainWndHandle:=CreateWindowEx(0, WND_MB_CLASS_NAME, Caption,
            DEFAULT_FORM_STYLE,
            (GetSystemMetrics(SM_CXSCREEN)-X_SIZE) div 2,
            (GetSystemMetrics(SM_CYSCREEN)-Y_SIZE) div 2,
            X_SIZE,Y_SIZE,
            0, 0,hInst, nil);
  if WinData.MainWndHandle=0 then
  begin
    le:=GetLastError;
    Str(le,LastErr);
    MessageBoxW(0,PWideChar('  Windows:'+LastErr{+#13#10+SysErrorMessage(le)}),': CreateWindowEx',MB_ICONERROR)
  end;

  //  GWL_USR      
  SetWindowLongW(WinData.MainWndHandle,GWL_USERDATA,Integer(@WinData));
  //  
  MakeFont;

  BtnText:='';
  BtnX:=2;BtnY:=2;BtnID:=BASE_BTN_ID;
  CurChar:=Buttons;
  //          
  while true do
  begin
    if (CurChar^=#9) or (CurChar^=#0) then
      begin
        //    (  )
        DeltaX:=BtnID-BASE_BTN_ID+1;
        //   
        le:=CreateWindow('Button',PWideChar(BtnText),WS_CHILD or BS_TEXT or WS_VISIBLE or WS_TABSTOP or BS_PUSHBUTTON,
          BtnX,BtnY,Abs(BtnWidth),BTN_HEIGHT, WinData.MainWndHandle, 0, hInst, nil);
        SetWindowLongW(le,GWL_ID,BtnID);
        SendMessage(le, WM_SETFONT, hFont, 0);
        //     -    
        if DeltaX=DefaultButton
          then SetFocus(le);

        if BtnWidth<0 //   
          then  Inc(BtnX,(-BtnWidth)+2)
          else  Inc(BtnY,BTN_HEIGHT+2); //   
        if CurChar^=#0
          then Break;
        Inc(BtnID);
        BtnText:='';
      end
    else BtnText:=BtnText+CurChar^;
    Inc(CurChar);
  end;

  GetWindowRect(WinData.MainWndHandle,WindowArea);
  GetClientRect(WinData.MainWndHandle,ClientArea);
  DeltaX:=WindowArea.Right-WindowArea.Left-ClientArea.Right;
  DeltaY:=WindowArea.Bottom-WindowArea.Top-ClientArea.Bottom;
  if BtnWidth<0 then //     
    begin
      //   
      ClientArea.Right:=BtnX+2+DeltaX;
      ClientArea.Bottom:=BTN_HEIGHT+4+DeltaY;
    end
  else //     
    begin
      //   
      ClientArea.Right:=Cardinal(Abs(BtnWidth))+4+DeltaX;
      ClientArea.Bottom:=BtnY+2+DeltaY;
    end;
  //     -  
  WindowArea.Left:=(GetSystemMetrics(SM_CXSCREEN)-ClientArea.Right) div 2;
  WindowArea.Top:=(GetSystemMetrics(SM_CYSCREEN)-ClientArea.Bottom) div 2;
  //      
  SetWindowPos(WinData.MainWndHandle,HWND_TOP,WindowArea.Left,WindowArea.Top,ClientArea.Right,ClientArea.Bottom,SWP_SHOWWINDOW);
  UpdateWindow(WinData.MainWndHandle);

  //   
  while(GetMessage(Msg, 0, 0, 0)) do
  begin
    if not IsDialogMessage(WinData.MainWndHandle,Msg) then
      begin
        TranslateMessage(Msg); // 
        DispatchMessage(Msg); //   
      end;  
  end;
  Result:=WinData.Result;
end;

function DDFWindowProc(hwnd, msg, wparam, lparam: longint): longint; stdcall; // 
var pwd:PDDFWindowData;
    FileCount:Cardinal;

    buf:Pointer;
    bufsize,NewBufSize:Cardinal;
    i:Cardinal;
begin
    Result:=DefWindowProc(hwnd, msg, wparam, lparam);
    case Msg of
      WM_COMMAND: begin
                    pwd:=PDDFWindowData(GetWindowLong(hwnd,GWL_USERDATA));
                    if (LOWORD(wParam)=ID_BUTTONCANCEL) and (HIWORD(wParam)=BN_CLICKED) then
                      begin
                        pwd.Result:=0;
                        DestroyWindow(pwd.MainWndHandle);
                      end;
                  end;
      WM_DROPFILES:
                  begin
                    pwd:=PDDFWindowData(GetWindowLong(hwnd,GWL_USERDATA));
                    //       Unicode-
                    if Var_InitUStrL(pwd.Context,pwd.VarIdx)=0 then //   
                    begin
                    //   
                    FileCount:=DragQueryFileW(wparam,$FFFFFFFF,nil,0);
                    if  FileCount<>0 then
                      begin
                        bufsize:=4096;
                        //     4
                        GetMem(buf,bufsize);
                        for i:=0 to FileCount-1 do
                          begin
                            //  ,     
                            NewBufSize:=DragQueryFileW(wparam,i,nil,0);
                            //     -  
                            if NewBufSize+NewBufSize>=bufsize then
                              begin
                                FreeMem(buf);
                                //     2   ( +1)
                                bufsize:=NewBufSize+NewBufSize+2;
                                GetMem(buf,bufsize);
                              end;
                            //    
                            NewBufSize:=DragQueryFileW(wparam,i,buf,bufsize div 2);
                            //      -    
                            if NewBufSize<>0
                              then Var_AddItemUStrL(pwd.Context,pwd.VarIdx,buf,NewBufSize);
                          end;
                        //  
                        FreeMem(buf);
                        pwd.Result:=1;
                      end;
                    end//if Var_InitUStrL(...)
                    else pwd.Result:=$FFFFFFFD;
                    //   drag-n-drop
                    DragFinish(wparam);
                    DestroyWindow(pwd.MainWndHandle);
                  end;
      WM_CLOSE:   begin
                    pwd:=PDDFWindowData(GetWindowLong(hwnd,GWL_USERDATA));
                    pwd.Result:=$FFFFFFFF;
                    DestroyWindow(pwd.MainWndHandle);
                  end;
      WM_DESTROY: PostQuitMessage(0);
    end;//case
  end;//function

function DragAndDropFile(context:Cardinal; Caption,Text:PWideChar;VarIdx:Cardinal):Cardinal;stdcall;
// Caption -  
// Text -   
// VarIdx -  ,      

//  :
// 0 -   ""
// 1 -   ()  
// -1 -   
// -2 -     ,    
var
  WinData:TDDFWindowData;
  WinClassEx:TWndClassExW;
  hInst:Cardinal;
  Msg:TMSG; //
  le:Cardinal;
  LastErr:UnicodeString;
  ClientArea:TRect;

begin
  WinData.Context:=context;
  WinData.VarIdx:=VarIdx;
  hInst := GetModuleHandle(nil);

  if not Assigned (Var_InitUStrL) then
  begin
  Var_InitUStrL:=GetProcAddress(PCardinal(context)^,'Var_InitUStrL');
  if not Assigned(Var_InitUStrL) then
  begin
    MessageBoxW(0,'     Var_InitUStrL   Neo Sign 0f Misery','',MB_ICONERROR);
    Result:=$FFFFFFFE;
    Exit;
  end;
  end;//if not Assigned(...)

  if not Assigned (Var_AddItemUStrL) then
  begin
  Var_AddItemUStrL:=GetProcAddress(PCardinal(context)^,'Var_AddItemUStrL');
  if not Assigned(Var_AddItemUStrL) then
  begin
    MessageBoxW(0,'     Var_AddItemUStrL   Neo Sign 0f Misery','',MB_ICONERROR);
    Result:=$FFFFFFFE;
    Exit;
  end;
  end;//if not Assigned(...)

  WinData.Result:=$FFFFFFFF;
  FillChar(WinClassEx,SizeOf(WndClassEx),0);
  with WinClassEx do
  begin
  cbSize:=SizeOf(WndClassEx);
  //    
  //     
  style := CS_HREDRAW or CS_VREDRAW;
  //  
  lpfnWndProc := @DDFWindowProc;
  //     
  cbClsExtra := 0;
  //     
  cbWndExtra := 0;
  //  
  hInstance := HInstance;
  //  
  hIcon := LoadIcon(0, IDI_QUESTION);
  //   
  hCursor := LoadCursor(0, IDC_ARROW);
  //  
  hbrBackground := COLOR_WINDOW;
  //   
  lpszMenuName := nil;
  //  
  lpszClassName := WND_DDF_CLASS_NAME;
  //  
  end;

//InitCommonControls;
if DDF_class_atom=0
  then DDF_class_atom:=RegisterClassExW(WinClassEx); //   

//    InputBox
WinData.MainWndHandle:=CreateWindowExW(0, WND_DDF_CLASS_NAME, Caption,
            DEFAULT_FORM_STYLE,
            (GetSystemMetrics(SM_CXSCREEN)-X_SIZE) div 2,
            (GetSystemMetrics(SM_CYSCREEN)-Y_SIZE) div 2,
            X_SIZE,DDF_Y_SIZE,
            0, 0,hInst, nil);
if WinData.MainWndHandle=0 then
  begin
    le:=GetLastError;
    Str(le,LastErr);
    MessageBoxW(0,PWideChar('  Windows:'+LastErr{+#13#10+SysErrorMessage(le)}),': CreateWindowEx',MB_ICONERROR)
  end;

SetWindowLongW(WinData.MainWndHandle,GWL_USERDATA,Integer(@WinData));
GetClientRect(WinData.MainWndHandle,ClientArea);
MakeFont;

//   
WinData.LabelCaption := CreateWindow(
'Static',Text,
WS_CHILD or SS_NOTIFY or SS_CENTER or SS_SUNKEN or WS_VISIBLE,
4, 2, ClientArea.Right-8, ClientArea.Bottom-4-27, WinData.MainWndHandle, 0, hInst, nil);
SendMessage(WinData.LabelCaption, WM_SETFONT, hFont,0);

//   ""
WinData.ButtonCancel := CreateWindow(
'Button',
'',
WS_CHILD or BS_TEXT or WS_VISIBLE or WS_TABSTOP,
2, ClientArea.Bottom-27,ClientArea.Right-2, 25, WinData.MainWndHandle, 0, hInst, nil);
SendMessage(WinData.ButtonCancel, WM_SETFONT, hFont, 0);
SetWindowLongW(WinData.ButtonCancel,GWL_ID,ID_BUTTONCANCEL);

//    
DragAcceptFiles(WinData.MainWndHandle,True);


ShowWindow(WinData.MainWndHandle,SW_SHOW);
UpdateWindow(WinData.MainWndHandle);

  //   
  while(GetMessage(Msg, 0, 0, 0)) do
  begin
    if not IsDialogMessage(WinData.MainWndHandle,Msg) then
      begin
        TranslateMessage(Msg); // 
        DispatchMessage(Msg); //   
      end;
  end;
Result:=WinData.Result;
end;

function FindWord(start:PWideChar; var len:Integer):PWideChar;
//     . ,  nil,    
var QuoteMode,IsDoubleQuote:Boolean;
begin
  QuoteMode:=False;
  Result:=nil;
  len:=0;
while True do
begin
  case start^ of
    //  
    #0:     Break;
    //  
    #1..#32:begin
              if not QuoteMode then //     -   
                begin
                  Inc(start);
                  while (start^>=#1) and (start^<=#32)
                    do Inc(start);
                  Result:=start;
                  Break;
                end
              else begin Inc(start); Inc(len); end;
            end;
    '"':    begin
              Inc(start); Inc(len);
              if QuoteMode then
                begin
                  IsDoubleQuote:=start^='"';
                  if IsDoubleQuote //      ?
                    then begin Inc(start); Inc(len); end
                    //       ?
                    else if (start^>=#0) and (start^<=#32)
                          then QuoteMode:=False;
                end
              else QuoteMode:=True;
            end;
    else begin
          Inc(start);
          Inc(Len);
         end;
  end;//case
end;//while
end;


function MyUpperCase(const s:UnicodeString):UnicodeString;
var l:Integer;
begin
  l:=Length(s);
  Result:=Copy(s,1,l);
  CharUpperBuffW(@Result[1],l);
end;

function NewNKItem(var ItemList:TNKItemList):Integer;
begin
  Result:=Length(ItemList);
  SetLength(ItemList,Result+1);
end;

procedure AreaByClientArea(ItemList:TNKItemList; ItemIndex:Integer);
var rc:TRect;
begin
  with rc,ItemList[ItemIndex] do
    begin
      Left:=0;
      Top:=0;
      Right:=W;
      Bottom:=H;
      AdjustWindowRectEx(rc,S,False,Z);
      W:=Right-Left;
      H:=Bottom-Top;
    end;
end;

function Max(a,b:Int64):Int64;
begin
  if a>b then Max:=a else Max:=b;
end;

procedure CalculateItemSize(var ItemList:TNKItemList; ItemIdx:Integer);
var new_h,new_w:Int64;
  i,tmp:Integer;
  CalcH,CalcW:Boolean;
  HasChildren:Boolean;
begin
  CalcH:=ItemList[ItemIdx].H=UNKNOWN_SIZE;
  CalcW:=ItemList[ItemIdx].W=UNKNOWN_SIZE;

  if CalcW or CalcH then //       
    begin
      //     ,    ,  
      if CalcH then new_h:=0 else new_h:=ItemList[ItemIdx].H;
      if CalcW then new_w:=0 else new_w:=ItemList[ItemIdx].W;
      //      
      HasChildren:=False;

      //     
      for i:=ItemIdx+1 to High(ItemList) do
        begin
          // -        .    .
          tmp:=i;
          with ItemList[i] do
            begin
              //       ,   ,
              //        
              if ItemList[i].P=ItemIdx then
                begin
                  HasChildren:=True;
                  //      - 
                  //     
                  if (H=UNKNOWN_SIZE) or (W=UNKNOWN_SIZE)
                    then CalculateItemSize(ItemList,tmp);
                  //       
                  if CalcW then new_w:=Max(new_w,X+W);
                  if CalcH then new_h:=Max(new_h,Y+H);
                end;//if
            end;//with
        end;//for
      with ItemList[ItemIdx] do
      begin
      //    ""     -   25
      if CalcH and (not HasChildren) then new_h:=25;
      //    "",     -   100
      if CalcW and (not HasChildren) then new_w:=100;

      H:=new_h; W:=new_w;
      end;//with
    end;//if CalcW or CalcH
end;

procedure CalculateItemPos(var ItemList:TNKItemList; ItemIndex:Integer);
begin
  with ItemList[ItemIndex] do
  begin
    //       
    if TypeID=nkitMain then
      begin
        if X=SCREEN_LEFT
          then X:=0
          else if X=SCREEN_RIGHT
                then X:=GetSystemMetrics(SM_CXSCREEN)-W
                else if X=SCREEN_CENTER then X:=(GetSystemMetrics(SM_CXSCREEN)-W) div 2;
        if Y=SCREEN_TOP
          then Y:=0
          else if Y=SCREEN_BOTTOM
                then Y:=GetSystemMetrics(SM_CYSCREEN)-H
                else if Y=SCREEN_CENTER then Y:=(GetSystemMetrics(SM_CYSCREEN)-H) div 2;
      end
    else
    //        
      begin
        if X=SCREEN_LEFT
          then X:=0
          else if X=SCREEN_RIGHT
                then X:=ItemList[P].W-W
                else if X=SCREEN_CENTER then X:=(ItemList[P].W-W) div 2;
        if Y=SCREEN_TOP
          then Y:=0
          else if Y=SCREEN_BOTTOM
                then Y:=ItemList[P].H-H
                else if Y=SCREEN_CENTER then Y:=(ItemList[P].H-H) div 2;
      end;
  end;//with
end;

function ParamAsInteger(const v:UnicodeString; var res:Int64):Boolean;
var errcode:Integer;
    r:Int64;
begin
  Val(v,r,errcode);
  if errcode=0
    then res:=r;
  Result:=errcode=0;
end;

function FindInArray(const v:UnicodeString; var res:Int64; const arr:array of const):Boolean;
var i:Integer;
begin
  i:=0;
  Result:=False;
  while i<Length(arr) do
    begin
      if UnicodeString(arr[i].VUnicodeString)=v then
        begin
          res:=arr[i+1].VInt64^;
          Result:=True;
          Break;
        end;
      Inc(i,2);
    end;//while
end;

function ParamAsConstant(const v:UnicodeString; var res:Int64; const arr:array of const):Boolean;
begin
  Result:=FindInArray(v,res,arr);
end;

function NextConst(const s:UnicodeString; start:Integer; var end_of_line:Boolean):UnicodeString;
var i:Integer;
begin
  for I:=start to Length(s) do
    begin
      if s[i]=',' then
        begin
          end_of_line:=False;
          Result:=Copy(s,start,i-start);
          Exit;
        end;
    end;
  end_of_line:=True;
  Result:=Copy(s,start,Length(s)-start+1);
end;


function ParamAsSumOfConstants(const v:UnicodeString; var res:Int64; const arr:array of const):Boolean;
var start:Integer;
    tmp_s:UnicodeString;
    r:Int64;
    finish_it:Boolean;
begin
  res:=0;
  start:=1;
  Result:=False;
  while True do
  begin
    tmp_s:=NextConst(v,start,finish_it);
    //    
    Result:=FindInArray(tmp_s,r,arr);
    if Result
      then Res:=Res or r
      else Exit;
    //   . 
    if finish_it
      then Break
      else Inc(start,Length(tmp_s)+1);
  end;

end;

function ParamAsBoolean(const v:UnicodeString; var res:Boolean):Boolean;
begin
  if (v='Y') or (v='YES') or (v='TRUE') then begin res:=True; Result:=True; Exit; end;
  if (v='N') or (v='NO') or (v='FALSE') then begin res:=False; Result:=True; Exit; end;
  Result:=False;
end;

function ParamAsText(const v:UnicodeString; var res:UnicodeString):Boolean;
var i,l,c_start:Integer;
begin
  c_start:=2; l:=Length(v);
  res:='';
  i:=2;
  while i<=l-1 do
    begin
      if v[i]='"' then
        begin
          //    -  ,   
          if (v[i+1]='"') and (i+1<l) then
            begin
              res:=res+Copy(v,c_start,i-c_start+1);
              Inc(i);
              c_start:=i+1;
            end
          else //    -    
            begin
              Result:=False;
              Exit;
            end;
        end;//if
      Inc(i);
    end;//while
    if c_start<>l then res:=res+Copy(v,c_start,l-c_start);
    Result:=True;
end;

function InterpretParam(ItemList:TNKItemList; param:WideChar; value:UnicodeString):UnicodeString;
var _i,_l:Integer;
    found,ValidParam:Boolean;
    default_style:Int64;
begin
  _l:=Length(ItemList);
  if _l=0 then begin Result:='  .  .'; Exit; end;
  with ItemList[_l-1] do
  begin
    if not (param in NeoKitItems[TypeID].allowed)
      then begin Result:='     '+NeoKitItems[TypeID].cmd; Exit; end;
    case param of
// I -  
      'I':  begin
              if ParamAsInteger(value,I) then
                begin
                  //    
                  found:=False;
                  for _i:=Low(ItemList) to High(ItemList)-1
                    do if ItemList[_i].I=I then begin found:=True; Break; end;
                  //    ,  
                  if found then Result:=INVALID_PARAMETER+' I:    '+value;
                end;
            end;
// X - x-
      'X':  begin
              if ParamAsInteger(value,X)
                then Result:=''
                else if not ParamAsConstant(MyUpperCase(value),X,['LEFT',SCREEN_LEFT,'RIGHT',SCREEN_RIGHT,'CENTER',SCREEN_CENTER])
                      then Result:=INVALID_PARAMETER+' X: '+value+''
            end;
// Y - y-
      'Y':  begin
              if ParamAsInteger(value,Y)
                then Result:=''
                else if not ParamAsConstant(MyUpperCase(value),Y,['TOP',SCREEN_TOP,'BOTTOM',SCREEN_BOTTOM,'CENTER',SCREEN_CENTER])
                      then Result:=INVALID_PARAMETER+' Y: '+value+''
            end;
// H -       
      'H':  begin
              if ParamAsInteger(value,H)
                then Result:=''
                else if not ParamAsConstant(MyUpperCase(value),H,['AUTO',HW_AUTO])
                      then Result:=INVALID_PARAMETER+' H: '+value+''
            end;
// W - 
      'W':  begin
              if ParamAsInteger(value,W)
                then Result:=''
                else if not ParamAsConstant(MyUpperCase(value),W,['AUTO',HW_AUTO])
                      then Result:=INVALID_PARAMETER+' W: '+value+''
            end;
// P - -
      'P':  begin
              if ParamAsInteger(value,P) then
                begin
                  found:=False;
                  //       ID     ( )
                  for _i:= 0 to _l-1
                    do if (ItemList[_i].I=P) and (ItemList[_i].TypeID in NeoKitContainers)
                        then begin found:=True; P:=_i; Break; end;
                  //    ,  
                  if not found then Result:='   ID='+value+'  ';
                end
              else Result:=INVALID_PARAMETER+' P: '+value+''
            end;
// V - 
      'V':  begin
              if ParamAsBoolean(value,V)
                then Result:=''
                else Result:=INVALID_PARAMETER+' V: '+value+''
            end;
// E - 
      'E':  begin
              if ParamAsBoolean(value,E)
                then Result:=''
                else Result:=INVALID_PARAMETER+' E: '+value+''
            end;
// R - "  " ( Edit)
      'R':  begin
              if ParamAsBoolean(value,R)
                then Result:=''
                else Result:=INVALID_PARAMETER+' R: '+value+''
            end;
// C- checked ( Checkbox  Radiobutton)
      'C':  begin
              if ParamAsConstant(MyUpperCase(value),C,['CHECKED',Int64(BST_CHECKED),'UNCHECKED',Int64(BST_UNCHECKED),'INDETERMINATE',Int64(BST_INDETERMINATE)])
                then Result:=''
                else Result:=INVALID_PARAMETER+' C: '+value+''
            end;
// T - 
      'T':  begin
              if ParamAsText(value,T)
                then Result:=''
                else Result:=INVALID_PARAMETER+' T: '+value+''
            end;
// F - 
      'F':  begin
              if ParamAsInteger(value,F) then
                begin
                  found:=False;
                  //      ID     ( )
                  for _i:= 0 to _l-1
                    do if (ItemList[_i].I=F) and (ItemList[_i].TypeID=nkitFont) then begin found:=True; F:=_i; Break; end;
                  //    ,  
                  if not found then Result:='  ID='+value+'  ';
                end
              else Result:=INVALID_PARAMETER+' F: '+value+''
            end;
// S -  /
      'S':  begin
              if ParamAsInteger(value,S)
                then Result:=''
                else
                  begin
                    case TypeId of
                      nkitMain: ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),S,
                                 [_Default,Int64(DEFAULT_FORM_STYLE),
                                  'MINIMIZEBOX',Int64(WS_MINIMIZEBOX),
                                  'MAXIMIZEBOX',Int64(WS_MAXIMIZEBOX),
                                  'SIZEBOX',Int64(WS_SIZEBOX)]);
                      nkitLabel:ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),S,
                                 [_Default,Int64(DEFAULT_BUTTON_STYLE),
                                  'BORDER',Int64(WS_BORDER),
                                  'LEFT',Int64(BS_LEFT),
                                  'RIGHT',Int64(BS_RIGHT),
                                  'CENTER',Int64(BS_CENTER),
                                  'TOP',Int64(BS_TOP),
                                  'BOTTOM',Int64(BS_BOTTOM),
                                  'VCENTER',Int64(BS_VCENTER)]);
                      nkitButton:ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),S,
                                 [_Default,Int64(DEFAULT_BUTTON_STYLE),
                                  'BORDER',Int64(WS_BORDER),
                                  'LEFT',Int64(BS_LEFT),
                                  'RIGHT',Int64(BS_RIGHT),
                                  'CENTER',Int64(BS_CENTER),
                                  'TOP',Int64(BS_TOP),
                                  'BOTTOM',Int64(BS_BOTTOM),
                                  'VCENTER',Int64(BS_VCENTER),
                                  'FLAT',Int64(BS_FLAT),
                                  'DEFPUSHBUTTON',Int64(BS_DEFPUSHBUTTON)]);
                      nkitEdit,nkitMemo:
                                  begin
                                  if TypeId=nkitEdit
                                    then default_style:=DEFAULT_EDIT_STYLE
                                    else default_style:=DEFAULT_MEMO_STYLE;
                                  ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),S,
                                 [_Default,Int64(default_style),
                                  'LEFT',Int64(ES_LEFT),
                                  'RIGHT',Int64(ES_RIGHT),
                                  'CENTER',Int64(ES_CENTER),
                                  'PASSWORD',Int64(ES_PASSWORD),
                                  'NUMBER',Int64(ES_NUMBER),
                                  'UPPERCASE',Int64(ES_UPPERCASE),
                                  'LOWERCASE',Int64(ES_LOWERCASE),
                                  'HSCROLL',Int64(WS_HSCROLL),
                                  'VSCROLL',Int64(WS_VSCROLL)
                                  ]);
                                  end;
                      nkitCheckbox:ValidParam:=ParamAsConstant(MyUpperCase(value),S,
                                  [_Default,Int64(DEFAULT_CHECKBOX_STYLE),
                                  '3STATE',Int64(TRI_STATE_CHECKBOX_STYLE)]);
                      nkitRadioButton:
                                  begin
                                    ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),S,
                                    [_Default,Int64(DEFAULT_RADIOBUTTON_STYLE),
                                      'PUSHLIKE',Int64(BS_PUSHLIKE),
                                      'RIGHTBUTTON',Int64(BS_RIGHTBUTTON)]);
                                  end;
                      nkitFont: ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),S,
                                 ['BOLD',Int64(9),
                                  'ITALIC',Int64(FONT_ITALIC),
                                  'UNDERLINE',Int64(FONT_UNDERLINE),
                                  'STRIKEOUT',Int64(FONT_STRIKEOUT),
                                  _Default,Int64(0)]);
                      nkitListBox: ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),S,
                                 [_Default,Int64(DEFAULT_LISTBOX_STYLE),
                                  'DISABLENOSCROLL',Int64(LBS_DISABLENOSCROLL),
                                  'EXTENDEDSEL',Int64(LBS_EXTENDEDSEL),
                                  'MULTIPLESEL',Int64(LBS_MULTIPLESEL),
                                  'NOSEL',Int64(LBS_NOSEL),
                                  'SORT',Int64(LBS_SORT),
                                  'STANDARD',Int64(LBS_STANDARD),
                                  'HSCROLL',Int64(WS_HSCROLL),
                                  'VSCROLL',Int64(WS_VSCROLL)
                                  ]
                                  )
                      else ValidParam:=False;
                    end;//case
                    if ValidParam then Result:='' else Result:=INVALID_PARAMETER+' S: '+value+''
                  end;
            end;
// Z -   
      'Z':  begin
              if ParamAsInteger(value,Z)
                then Result:=''
                else
                  begin
                    case TypeId of
                      nkitMain: ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),Z,
                                 [_Default,Int64(DEFAULT_FORM_EXSTYLE),
                                  'TOPMOST',Int64(WS_EX_TOPMOST),
                                  'TOOLWINDOW',Int64(WS_EX_TOOLWINDOW),
                                  'APPWINDOW',Int64(WS_EX_APPWINDOW),
                                  'ACCEPTFILES',Int64(WS_SIZEBOX)]);
                      nkitEdit,nkitMemo,nkitListBox:
                                 ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),Z,
                                 [_Default,Int64(DEFAULT_EDIT_EXSTYLE),
                                  'DLGMODALFRAME',Int64(WS_EX_DLGMODALFRAME),
                                  'CLIENTEDGE',Int64(WS_EX_CLIENTEDGE),
                                  'STATICEDGE',Int64(WS_EX_STATICEDGE),
                                  'WINDOWEDGE',Int64(WS_EX_WINDOWEDGE)]);
                      nkitLabel:
                                 ValidParam:=ParamAsSumOfConstants(MyUpperCase(value),Z,
                                 [_Default,Int64(DEFAULT_LABEL_EXSTYLE),
                                  'DLGMODALFRAME',Int64(WS_EX_DLGMODALFRAME),
                                  'CLIENTEDGE',Int64(WS_EX_CLIENTEDGE),
                                  'STATICEDGE',Int64(WS_EX_STATICEDGE),
                                  'WINDOWEDGE',Int64(WS_EX_WINDOWEDGE)]);
                      else ValidParam:=False;
                    end;//case
                    if ValidParam then Result:='' else Result:=INVALID_PARAMETER+' Z: '+value+''
                  end;
            end;

// # - -
      '#':  begin
              if ParamAsInteger(value,SLOT)
                then Result:=''
                else if not ParamAsConstant(MyUpperCase(value),SLOT,['NO',UNKNOWN_SLOT,'NONE',UNKNOWN_SLOT])
                      then Result:=INVALID_PARAMETER+' #(): '+value+''
            end;
// @ - - 
      '@':  begin
              if ParamAsInteger(value,HandleSLOT)
                then Result:=''
                else if not ParamAsConstant(MyUpperCase(value),HandleSLOT,['NO',UNKNOWN_SLOT,'NONE',UNKNOWN_SLOT])
                      then Result:=INVALID_PARAMETER+' @(  ): '+value+''
            end;
    end;//case
  end;//with
end;

function InterpretWord(start:PWideChar; var error:UnicodeString; var ItemList:TNKItemList):PWideChar;
var l:Integer;
    cur_word,uc_word:UnicodeString;
    i,create_item_cmd:TNeoKitItemType;
begin
  Result:=FindWord(start,l);
  if l=0
    then Exit
    else begin
           SetLength(cur_word,l);
           Move(start^,cur_word[1],l*SizeOf(WideChar));
         end;
  //        
  //  ,         
  uc_word:=MyUpperCase(cur_word);
  create_item_cmd:=nkitNone;
  for i:=Low(NeoKitItems) to High(NeoKitItems) do
    begin
      if uc_word=NeoKitItems[i].cmd then
        begin
          create_item_cmd:=i;
          Break;
        end;
    end;
  //   -      -  
  if create_item_cmd<>nkitNone
    then error:=NeoKitItems[create_item_cmd].ItemCreator(ItemList)
  else //  -        
    begin
      error:=' : '+cur_word;
      if Length(cur_word)>2 then
        begin
          if cur_word[2]='=' //    : <>=< >
            then error:=InterpretParam(ItemList,uc_word[1],Copy(cur_word,3,Length(cur_word)-2));
        end//if Length(...
    end;//else
end;

function MakeWindowStyle(BaseStyle:Cardinal; Visible,Enabled:Boolean):Cardinal;
begin
  Result:=BaseStyle;
    // ?
  if Visible
    then Result:=Result or WS_VISIBLE
    else Result:=Result and (not WS_VISIBLE);
  // ?
  if Enabled
    then Result:=Result and (not WS_DISABLED)
    else Result:=Result or WS_DISABLED;
end;

procedure BeforeControlCreate(var ItemList:TNKItemList; ItemIdx:Integer);
begin
  with ItemList[ItemIdx]
    do S:=MakeWindowStyle(S,V,E);
  //   
  CalculateItemSize(ItemList,ItemIdx);
  //   
  CalculateItemPos(ItemList,ItemIdx);
end;

function AfterControlCreate(control_handle:HWND; const ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
begin
  if control_handle=0 then
    begin
      Str(GetLastError,Result);
      Result:='    .   Windows:'+Result;
      MessageBoxW(0,PWideChar(Result),': CreateWindowEx',MB_ICONERROR);
    end//if Handle=0
  else
    begin
      //  
      items^.Items[idx].Handle:=control_handle;
      //  ,   
      if ItemList[ItemIdx].F<>DEFAULT_FORM_FONT
        then SendMessage(control_handle,WM_SETFONT,items^.items[ItemList[ItemIdx].F+1].Handle,0);
      //  GWL_ID ,    
      SetWindowLongW(control_handle,GWL_ID,idx);
      //   GWL_USERDATA      
      SetWindowLongW(control_handle,GWL_USERDATA,Integer(items));
      //    
      Result:='';
    end;
end;

function ButtonInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  idx:=NewNKItem(ItemList);
  with ItemList[idx] do
    begin
      //  : ,,,  , , - 
      TypeID:=nkitButton;
      I:=NO_ID;
      F:=DEFAULT_FORM_FONT;
      X:=0;
      Y:=0;
      W:=UNKNOWN_SIZE;
      H:=UNKNOWN_SIZE;
      T:='Button';
      V:=True;
      E:=True;
      S:=DEFAULT_BUTTON_STYLE;
      Z:=0;
      SLOT:=UNKNOWN_SLOT;
      HandleSLOT:=UNKNOWN_SLOT;
    end;//with
    Result:='';
end;

function ButtonCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
var tmp_h:HWND;
begin
  BeforeControlCreate(ItemList,ItemIdx);
  with ItemList[ItemIdx]
    do tmp_h:=CreateWindowExW(Z,'Button',PWideChar(T),S,X,Y,W,H,items^.Items[P+1].Handle,0,GetModuleHandle(nil),nil);
  Result:=AfterControlCreate(tmp_h,ItemList,ItemIdx,items,idx);
end;

function CheckBoxInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  idx:=NewNKItem(ItemList);
  with ItemList[idx] do
    begin
      //  : ,,,  , , - 
      TypeID:=nkitCheckbox;
      I:=NO_ID;
      F:=DEFAULT_FORM_FONT;
      X:=0;
      Y:=0;
      W:=UNKNOWN_SIZE;
      H:=UNKNOWN_SIZE;
      T:='CheckBox';
      V:=True;
      E:=True;
      C:=BST_UNCHECKED;
      S:=DEFAULT_CHECKBOX_STYLE;
      Z:=0;
      SLOT:=UNKNOWN_SLOT;
      HandleSLOT:=UNKNOWN_SLOT;
    end;//with
    Result:='';
end;

function CheckBoxCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
var tmp_h:HWND;
begin
  BeforeControlCreate(ItemList,ItemIdx);
  with ItemList[ItemIdx]
    do tmp_h:=CreateWindowExW(Z,'Button',PWideChar(T),S,X,Y,W,H,items^.Items[P+1].Handle,0,GetModuleHandle(nil),nil);
  Result:=AfterControlCreate(tmp_h,ItemList,ItemIdx,items,idx);
  //   CheckBox'
  if tmp_h<>0 then SendMessage(tmp_h, BM_SETCHECK,ItemList[ItemIdx].C,0);
end;

function EditInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  idx:=NewNKItem(ItemList);
  with ItemList[idx] do
    begin
      //   : ,,,  , , - 
      TypeID:=nkitEdit;
      I:=NO_ID;
      F:=DEFAULT_FORM_FONT;
      X:=0;
      Y:=0;
      W:=UNKNOWN_SIZE;
      H:=UNKNOWN_SIZE;
      T:='Edit';
      V:=True;
      R:=False;
      E:=True;
      S:=DEFAULT_EDIT_STYLE;
      Z:=DEFAULT_EDIT_EXSTYLE;
      SLOT:=UNKNOWN_SLOT;
      HandleSLOT:=UNKNOWN_SLOT;
    end;//with
    Result:='';
end;

function EditCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
var tmp_h:HWND;
begin
  BeforeControlCreate(ItemList,ItemIdx);
  with ItemList[ItemIdx] do
    begin
      //    Read-Only
      if R then S:=S or ES_READONLY else S:=S and (not ES_READONLY);
      tmp_h:=CreateWindowExW(Z,'Edit',PWideChar(T),S,X,Y,W,H,items^.Items[P+1].Handle,0,GetModuleHandle(nil),nil);
    end;//with
  Result:=AfterControlCreate(tmp_h,ItemList,ItemIdx,items,idx);
end;

function MemoInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  // Memo -   Edit,   ,    
  EditInit(ItemList);
  idx:=High(ItemList);
  ItemList[idx].TypeID:=nkitMemo;
  ItemList[idx].S:=ItemList[idx].S or ES_MULTILINE or ES_AUTOVSCROLL or ES_AUTOHSCROLL;
end;

function RadioButtonInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  idx:=NewNKItem(ItemList);
  with ItemList[idx] do
    begin
      //  : ,,,  , , - 
      TypeID:=nkitRadioButton;
      I:=NO_ID;
      F:=DEFAULT_FORM_FONT;
      X:=0;
      Y:=0;
      W:=UNKNOWN_SIZE;
      H:=UNKNOWN_SIZE;
      T:='RadioButton';
      V:=True;
      E:=True;
      C:=BST_UNCHECKED;
      S:=DEFAULT_RADIOBUTTON_STYLE;
      Z:=0;
      SLOT:=UNKNOWN_SLOT;
      HandleSLOT:=UNKNOWN_SLOT;
    end;//with
    Result:='';
end;

function RadioButtonCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
var tmp_h:HWND;
begin
  BeforeControlCreate(ItemList,ItemIdx);
  with ItemList[ItemIdx]
    do tmp_h:=CreateWindowExW(Z,'Button',PWideChar(T),S,X,Y,W,H,items^.Items[P+1].Handle,0,GetModuleHandle(nil),nil);
  Result:=AfterControlCreate(tmp_h,ItemList,ItemIdx,items,idx);
  //   CheckBox'
  if tmp_h<>0 then SendMessage(tmp_h, BM_SETCHECK,ItemList[ItemIdx].C,0);
end;

type FLineProcessor=procedure (anydata:Pointer; line:PWideChar);


procedure ProcessTabbedLine(const s:UnicodeString; anydata:Pointer; proc:FLineProcessor);
var s2:UnicodeString;
    p,p2,word_start:PWideChar;
begin
  if s=''
    then Exit;
  SetLength(s2,Length(s));
  p:=PWideChar(s);
  p2:=PWideChar(s2);
  //  
  word_start:=p2;
  while True do
  begin
    if p^>#13
      //      - -  
      then p2^:=p^
      else
        begin
          //   -
          case p^ of
            #0:   begin
                    p2^:=p^;
                    proc(anydata,word_start);
                    Break;
                  end;
            #9:   begin
                    p2^:=#0;
                    proc(anydata,word_start);
                    word_start:=p2+1;
                  end;
            #13:  begin
                    p2^:=#0;
                    //    -  LF  ?
                    if (p+1)^=#10
                      //   -  
                      then Inc(p);
                    proc(anydata,word_start);
                    word_start:=p2+1;
                  end;
            //     " "
            else p2^:=p^
          end;//case
        end;//if
      Inc(p);
      Inc(p2);
  end;//while
end;

procedure AddToLB(anydata:Pointer; line:PWideChar);
// anydata -    
type PHWND=^HWND;
begin
  SendMessageW((PHWND(anydata))^,LB_ADDSTRING,0,LPARAM(line));
end;

function ListBoxInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  idx:=NewNKItem(ItemList);
  with ItemList[idx] do
    begin
      //   : ,,,  , , - 
      TypeID:=nkitListBox;
      I:=NO_ID;
      F:=DEFAULT_FORM_FONT;
      X:=0;
      Y:=0;
      W:=UNKNOWN_SIZE;
      H:=UNKNOWN_SIZE;
      T:='';
      V:=True;
      E:=True;
      S:=DEFAULT_LISTBOX_STYLE;
      Z:=DEFAULT_LISTBOX_EXSTYLE;
      SLOT:=UNKNOWN_SLOT;
      HandleSLOT:=UNKNOWN_SLOT;
    end;//with
    Result:='';
end;

function ListBoxCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
var tmp_h:HWND;
begin
  BeforeControlCreate(ItemList,ItemIdx);
  with ItemList[ItemIdx] do
    begin
      tmp_h:=CreateWindowExW(Z,'ListBox','',S,X,Y,W,H,items^.Items[P+1].Handle,0,GetModuleHandle(nil),nil);
      Result:=AfterControlCreate(tmp_h,ItemList,ItemIdx,items,idx);
      //    ListBox 
      if T<>'' then
        begin
          ProcessTabbedLine(T,@tmp_h,AddToLB);
        end;
    end;//with
end;

function MainFormInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  // ,     
  if Length(ItemList)<>0
    then Result:=' FORM     '
    else
      begin
        idx:=NewNKItem(ItemList);
        with ItemList[idx] do
          begin
            //  : ,,,  , , - 
            TypeID:=nkitMain;
            I:=0;
            X:=SCREEN_CENTER;
            Y:=SCREEN_CENTER;
            W:=UNKNOWN_SIZE;
            H:=UNKNOWN_SIZE;
            T:='Main form';
            V:=True;
            E:=True;
            S:=DEFAULT_FORM_STYLE;
            Z:=DEFAULT_FORM_EXSTYLE;
            SLOT:=UNKNOWN_SLOT;
            HandleSLOT:=UNKNOWN_SLOT;
          end;//with
        Result:='';
      end;
end;

function MainFormCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
var Style,ExStyle:Cardinal;
    LastErr:UnicodeString;
    WinClassEx:TWndClassExW;
    ClientH,ClientW:Int64;
begin
  Result:='';

  with items^.items[idx] do
    begin
      with ItemList[ItemIdx]
        do Style:=MakeWindowStyle(S,V,E);
      ExStyle:=ItemList[ItemIdx].Z;
      //     
      CalculateItemSize(ItemList,ItemIdx);
      //      ,   
      //      
      ClientH:=ItemList[ItemIdx].H;
      ClientW:=ItemList[ItemIdx].W;
      //         ,
      // ..      
      AreaByClientArea(ItemList,ItemIdx);
      //   
      CalculateItemPos(ItemList,ItemIdx);
      //   
      FillChar(WinClassEx,SizeOf(WndClassEx),0);
      with WinClassEx do
      begin
        cbSize:=SizeOf(WndClassEx);
        //    
        //     
        style := CS_HREDRAW or CS_VREDRAW;
        //  
        lpfnWndProc := @NeoKitWindowProc;
        //     
        cbClsExtra := 0;
        //     
        cbWndExtra := 0;
        //  
        hInstance := HInstance;
        //  
        hIcon := LoadIcon(0, IDI_APPLICATION);
        //   
        hCursor := LoadCursor(0, IDC_ARROW);
        //  
        hbrBackground := COLOR_BTNFACE+1;
        //   
        lpszMenuName := nil;
        //  
        lpszClassName := WND_NEOKIT_NAME;
        //  
      end;//with
      if NEOKIT_class_atom=0
        then NEOKIT_class_atom:=RegisterClassExW(WinClassEx); //   
      //   
      with ItemList[ItemIdx]
       do Handle:=CreateWindowExW(ExStyle,WND_NEOKIT_NAME,PWideChar(T),Style,X,Y,W,H,0,0,GetModuleHandle(nil),nil);
      if Handle=0 then
        begin
          Str(GetLastError,LastErr);
          Result:='   .   Windows:'+LastErr;
          MessageBoxW(0,PWideChar(Result),': CreateWindowEx',MB_ICONERROR);
        end//if Handle=0
      else
        begin
          with ItemList[ItemIdx] do
            begin
              //       
              ItemList[ItemIdx].H:=ClientH;
              ItemList[ItemIdx].W:=ClientW;
              //   GWL_USERDATA      
              SetWindowLongW(Handle,GWL_USERDATA,Integer(items));
            end; //with

{          //           
          ReplaceWHByClientWH(Handle,ItemList,ItemIdx);}
        end;
  end;//with
end;

function FontInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  idx:=NewNKItem(ItemList);
  with ItemList[idx] do
    begin
      //  : , , , ,  
      TypeID:=nkitFont;
      I:=NO_ID;
      H:=UNKNOWN_SIZE;
      T:='MS Sans Serif';
      S:=0;
      HandleSLOT:=UNKNOWN_SLOT;
    end;//with
    Result:='';
end;

function FontCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
var LastErr:UnicodeString;
    Italic,Underline,Strikeout:Cardinal;
    size:Integer;
begin
  with ItemList[ItemIdx] do
    begin
      if I=NO_ID
        then begin Result:='      '; Exit; end
        else Result:='';
      //  
      if H=UNKNOWN_SIZE
        //     - 10
        then size:=-Round(10*items^.DeviceCaps/72)
        else
          begin
            if H>0
              //    -    
              then size:=-Round(H*items^.DeviceCaps/72)
              //   ,      " "
              else size:=H;
          end;
      //  
      if (S and FONT_ITALIC)<>0 then Italic:=1 else Italic:=0;
      if (S and FONT_UNDERLINE)<>0 then Underline:=1 else Underline:=0;
      if (S and FONT_STRIKEOUT)<>0 then Strikeout:=1 else Strikeout:=0;
    end;//with

with items^.items[idx] do
begin
  with ItemList[ItemIdx] do
    begin
      Handle:=CreateFontW(size,0, 0, 0,
        (ItemList[ItemIdx].S and FONT_BOLD_MASK)*100, //  
        Italic, Underline, Strikeout, //  
        DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
        DEFAULT_PITCH or FF_DONTCARE,
        PWideChar(T));
    end;//with
  if Handle=0 then
    begin
      Str(GetLastError,LastErr);
      Result:='   .   Windows:'+LastErr;
      MessageBoxW(0,PWideChar(Result),': CreateFontW',MB_ICONERROR);
    end//if Handle=0
end;//with
end;

function LabelInit(var ItemList:TNKItemList):UnicodeString;
var idx:Integer;
begin
  idx:=NewNKItem(ItemList);
  with ItemList[idx] do
    begin
      //  : ,,,  , , - 
      TypeID:=nkitLabel;
      I:=NO_ID;
      F:=DEFAULT_FORM_FONT;
      X:=0;
      Y:=0;
      W:=UNKNOWN_SIZE;
      H:=UNKNOWN_SIZE;
      T:='Label';
      V:=True;
      E:=True;
      S:=DEFAULT_LABEL_STYLE;
      Z:=DEFAULT_LABEL_EXSTYLE;
      SLOT:=UNKNOWN_SLOT;
      HandleSLOT:=UNKNOWN_SLOT;
    end;//with
    Result:='';
end;

function LabelCreate(var ItemList:TNKItemList; ItemIdx:Integer; items:PCreatedItems; idx:Integer):UnicodeString;
var tmp_h:HWND;
begin
  BeforeControlCreate(ItemList,ItemIdx);
  with ItemList[ItemIdx]
    do tmp_h:=CreateWindowExW(Z,'Static',PWideChar(T),S,X,Y,W,H,items^.Items[P+1].Handle,0,GetModuleHandle(nil),nil);
  Result:=AfterControlCreate(tmp_h,ItemList,ItemIdx,items,idx);
end;

function CreateAllItems(context:Cardinal; var ItemList:TNKItemList; var err:UnicodeString):PCreatedItems;
var i,l:Integer;
    res:Integer;
    v_idx:UnicodeString;
begin
  err:='';
  l:=Length(ItemList);
  //    
  GetMem(Result,(l+1)*SizeOf(TOneCreatedItem));
  //   
  Result^.Context:=context;
  //         
  Result^.DeviceCaps:=GetDeviceCaps(GetDC(0),LogPixelsY);
  //  - ("" ,  )
  with Result^.Items[l+1] do
    begin
      t:=nkitNone;
      Handle:=0;
    end;
  //   
  for i:=0 to l-1 do
    begin
      //    
      Result^.Items[i+1].t:=ItemList[i].TypeID;
      //  ,   
      err:=NeoKitItems[ItemList[i].TypeID].ControlCreator(ItemList,i,Result,i+1);
      if err<>'' then Break;
      //   -
      if ItemList[i].SLOT<>UNKNOWN_SLOT then
        begin
          Result^.Items[i+1].UseSlot:=True;
          Result^.Items[i+1].Slot:=ItemList[i].SLOT;
        end
      else Result^.Items[i+1].UseSlot:=False;
      //   - ,     
      if ItemList[i].HandleSLOT<>UNKNOWN_SLOT then
        begin
          res:=Var_StoreDWORD(context,ItemList[i].HandleSLOT,Result^.Items[i+1].Handle);
          //     
          if res<>0 then
            begin
              err:='   (';
              if ItemList[i].HandleSLOT>=$80000000 then err:=err+' ';
              Str(ItemList[i].HandleSLOT and $80000000,v_idx);
              err:=err+' '+v_idx+')  ';
              Break;
            end;//if res<>0
        end;//if ItemList[i].HandleSLOT<>UNKNOWN_SLOT
    end;//for
end;

type TInternalNeoKitData=record
       context:Cardinal;
       event:Cardinal;
       ItemList:TNKItemList;
       ThreadHandle:Cardinal;
       Res:Cardinal;
     end;
     PInternalNeoKitData=^TInternalNeoKitData;

procedure CleanAllCreated(items:PCreatedItems);
var i,c:Integer;
begin
  //    
  c:=1;
  while items^.Items[c].t<>nkitNone do Inc(c);
  //        
  for i:=c-1 downto 1 do
    begin
      case items^.Items[i].t of
       nkitMain:    DestroyWindow(items^.Items[i].Handle); //   
       nkitFont:    DeleteObject(items^.Items[i].Handle);  //  
      end;//case
    end;
  FreeMem(items);
end;

function NeoKitWindowProc(hwnd, msg, wparam, lparam: longint): longint; stdcall; // 
var me:PCreatedItems;
    control_id:Cardinal;
    items:PCreatedItems;
begin
    Result:=DefWindowProc(hwnd, msg, wparam, lparam);
    case Msg of
      WM_COMMAND: begin
                    items:=PCreatedItems(GetWindowLong(hwnd,GWL_USERDATA));
                    control_id:=LOWORD(wParam);
                    if control_id>0 then
                       begin
                        with items^.Items[control_id] do
                        begin
                          //     -  ID      ;
                          //     GWL_USERDATA
                          if (HIWORD(wParam)=BN_CLICKED) and (t in [nkitButton,nkitCheckbox,nkitRadioButton,nkitLabel]) then
                          begin
                            //   ,        
                            if UseSlot
                              then Var_StoreDWORD(items^.Context,Slot,SIGNAL_CONTROL_CLICKED);
                          end;//if HIWORD(...)
                          if (t=nkitListBox) and UseSlot then
                            begin
                              case HIWORD(wParam) of
                                LBN_SELCHANGE:  Var_StoreDWORD(items^.Context,Slot,SIGNAL_LISTBOX_SELCHANGE);
                                LBN_DBLCLK:     Var_StoreDWORD(items^.Context,Slot,SIGNAL_LISTBOX_DBLCLICKED);
                              end;
                            end;

                       end;//if control_id>0
                    end;//with
                  end;
      WM_SIZE:    begin
                    case wParam of
                      SIZE_MAXIMIZED: control_id:=SIGNAL_FORM_MAXIMIZED;
                      SIZE_MINIMIZED: control_id:=SIGNAL_FORM_MINIMIZED;
                      else control_id:=SIGNAL_FORM_MOVED_OR_RESTORED;
                    end;
                    items:=PCreatedItems(GetWindowLong(hwnd,GWL_USERDATA));
                    //     WM_SIZE  ,  GWL_USERDATA   
                    if items<>nil then
                    begin
                      with items^.Items[1] do
                        //   ,       
                        if UseSlot then Var_StoreDWORD(items^.Context,Slot,control_id);
                    end;
                  end;
      WM_MOVE:    begin
                    items:=PCreatedItems(GetWindowLong(hwnd,GWL_USERDATA));
                    //     WM_MOVE  ,  GWL_USERDATA   
                    if items<>nil then
                    begin
                      with items^.Items[1] do
                        //   ,       
                        if UseSlot then Var_StoreDWORD(items^.Context,Slot,101);
                    end;
                  end;

      WM_CLOSE:   begin
                    me:=PCreatedItems(GetWindowLong(hwnd,GWL_USERDATA));
                    //        
                    with me^.Items[1] do
                      begin
                        if UseSlot then Var_StoreDWORD(me^.Context,Slot,SIGNAL_FORM_CLOSED);
                        DestroyWindow(Handle);
                      end;
                  end;
      WM_DESTROY: PostQuitMessage(0);
    end;//case
end;//function

function NeoKitThreadProc(param:PInternalNeoKitData):Cardinal;stdcall;
label _Exit;
var items:PCreatedItems;
    Failure:UnicodeString;
    Msg:TMSG;
    context:Cardinal;
begin
  context:=param^.context;
  items:=CreateAllItems(context,param^.ItemList,Failure);
  if Failure='' then //      
    begin
      //  
      param^.Res:=0;
      //  !
      SetEvent(param^.event);
    end
  else //    
    begin
      CleanAllCreated(items);
      MessageBoxW(0,PWideChar(Failure),'    NeoKit',MB_ICONERROR);
      param^.Res:=$FFFFFFFC;
      //  !
      SetEvent(param^.event);
      goto _Exit;
    end;

  //   ,     
  while(GetMessage(Msg, 0, 0, 0)) do
  begin
    if not IsDialogMessage(items^.Items[1].Handle,Msg) then
      begin
        TranslateMessage(Msg); // 
        DispatchMessage(Msg); //   
      end;
  end;//while

  //      
  CleanAllCreated(items);

  _Exit:
  //   ,     
  Result:=0;
end;

function NeoKit(context:Cardinal; Scenario:PWideChar):Cardinal;stdcall;
//  - ASCIIZ  ,     1..32
// : $FFFFFFFF -    
//         $FFFFFFFE -     -   
//         $FFFFFFFC -    
var start:PWideChar;
    Failure:UnicodeString;
    IData:TInternalNeoKitData;
    TID:Cardinal;
begin
  if not Assigned(Var_StoreDWORD) then
  begin
    Var_StoreDWORD:=GetProcAddress(PCardinal(context)^,'Var_StoreDWORD');
    if not Assigned(Var_StoreDWORD) then
    begin
      MessageBoxW(0,'     Var_StoreDWORD   Neo Sign 0f Misery','',MB_ICONERROR);
      Result:=$FFFFFFFE;
      Exit;
    end;// if not Assigned(StoreDWORD)
  end; // if not Assigned(StoreDWORD)
  start:=Scenario;
  //  ,    
  while start<>nil do
    begin
      start:=InterpretWord(start,Failure,IData.ItemList);
      //    ?
      if Failure<>'' then Break;
    end;//while
  //     
  if Failure='' then
    begin
      //  
      IData.context:=context;
      //     . ,        
      IData.event:=CreateEvent(nil,True,False,nil);
      //   ,    "" 
      IData.ThreadHandle:=CreateThread(nil,0,@NeoKitThreadProc,@IData,0,TID);
      if IData.ThreadHandle<>0 then
        begin
          // ,       
          WaitForSingleObject(IData.event,INFINITE);
          //   
          CloseHandle(IData.event);
          //       
          Result:=IData.Res;
        end
        else
          begin
            //   
            CloseHandle(IData.event);
            Result:=$FFFFFFFB;
            MessageBoxW(0,PWideChar(Failure),'      NeoKit',MB_ICONERROR);
          end;
    end// if Failure=''
  else
    begin
      MessageBoxW(0,PWideChar(failure),'   NeoKit',MB_ICONERROR);
      Result:=$FFFFFFFF; //   
    end;
end;

exports InputBox;
exports MultiButton;
exports DragAndDropFile;
exports NeoKit;

begin
  DLLProc:=@DLLHandler;
end.
