unit ANY_ErrList;

interface

uses Classes;

const _IN_LINE:String='   ';
      _OF_MODULE:String='  ';

type TOneError=record
      ErrorCode:Integer;
      ErrorText:UnicodeString;
     end;
     
type TErrorList=array of TOneError;

procedure CreateErrorList(var ErrList:TErrorList; const ErrFile:UnicodeString);
function GetErrorAsText(const ErrList:TErrorList;err_code:Integer;LineNo:Cardinal; Module:PChar):String;

implementation

uses SysUtils;

procedure CreateErrorList(var ErrList:TErrorList; const ErrFile:String);
var sl:TStringList;
    i,p:Integer;
    s:String;
begin
  if FileExists(ErrFile) then
    begin
      sl:=TStringList.Create;
      sl.LoadFromFile(ErrFile);
      SetLength(ErrList,sl.Count);
      for i:=0 to sl.Count-1 do
        begin
          s:=sl.Strings[i];
          p:=Pos(',',s);
          if p>1 then
          begin
            with ErrList[i] do
              begin
                ErrorCode:=StrToInt(Copy(s,1,p-1));
                ErrorText:=Copy(s,p+1,Length(s)-p);
              end;//with
          end;//if p>1
        end;//for
    end//if FileExists
  else SetLength(ErrList,0);
end;

function GetErrorAsText(const ErrList:TErrorList;err_code:Integer;LineNo:Cardinal; Module:PChar):String;
var i:Integer;
begin
  Result:='';
  for i:=0 to High(ErrList) do
  begin
    if ErrList[i].ErrorCode=err_code then
    begin
      Result:=ErrList[i].ErrorText;
      Break;
    end;
  end;//for
  if Result=''
    then Result:='Error #'+IntToStr(err_code);
  if LineNo<>$FFFFFFFF
    then Result:=Result+_IN_LINE+IntToStr(LineNo);
  if Module<>nil then
    begin
      if Module^<>#0
        then Result:=Result+_OF_MODULE+''+Module+'';
    end;
end;

end.
