unit NC_Chars;

interface

uses Windows;

const CHAR_IS_END_OF_LINE=1;
      CHAR_IS_LETTER=2;
      CHAR_IS_IDENT=4;
      CHAR_IS_SPACE=8;
      CHAR_IS_TRUE_SPACE=16;
      CHAR_IS_WORD_BREAKING=32;
      CHAR_IS_DIGIT=64;
      CHAR_IS_HEX_DIGIT=128;
      CHAR_IS_ANSI=256;

      HexDigits:array[0..15] of WideChar='0123456789ABCDEF';

var CharInfoTable:packed array [WideChar] of Word;
    UpperCaseTable,LowerCaseTable:array[WideChar] of WideChar;

implementation


var cc:WideChar;
    c:AnsiChar;
    i:Integer;
    AnsiStr:AnsiString;
    UnicodeStr:UnicodeString;
const _IdentChars='#@$^!+-*_%$.''";';
      _WordBreakingChars='\|/:`~[](){}<>';
      _AddHexDigits='abcdefABCDEF';
initialization
  //  
  for cc:=Low(UpperCaseTable) to High(UpperCaseTable) do
    begin
      UpperCaseTable[cc]:=cc;
      if IsCharAlpha(cc)
        //      ,  
        then CharInfoTable[cc]:=CHAR_IS_LETTER or CHAR_IS_IDENT
        else CharInfoTable[cc]:=0;
    end;
  Move(UpperCaseTable,LowerCaseTable,SizeOf(LowerCaseTable));
  CharUpperBuffW(UpperCaseTable,65536);
  CharLowerBuffW(LowerCaseTable,65536);

  // ,  
  for cc:='0' to '9'
    do CharInfoTable[cc]:=CharInfoTable[cc] or CHAR_IS_DIGIT or CHAR_IS_HEX_DIGIT or CHAR_IS_IDENT;
  for i:=1 to Length(_IdentChars)
    do CharInfoTable[_IdentChars[i]]:=CharInfoTable[_IdentChars[i]] or CHAR_IS_IDENT;

  // ,  ++ 
  for cc:=#0 to #32 do
    begin
      case cc of
        #0..#9,#11,#12,#14..#32:
          CharInfoTable[cc]:=CHAR_IS_SPACE or CHAR_IS_TRUE_SPACE or CHAR_IS_WORD_BREAKING;
        else CharInfoTable[cc]:=CHAR_IS_SPACE or CHAR_IS_WORD_BREAKING;
      end;

    end;
  for i:=1 to Length(_WordBreakingChars)
    do Inc(CharInfoTable[_WordBreakingChars[i]],CHAR_IS_WORD_BREAKING);

  //  
  for i:=1 to Length(_AddHexDigits)
    do Inc(CharInfoTable[_AddHexDigits[i]],CHAR_IS_HEX_DIGIT);

  //   
  CharInfoTable[#0]:=CharInfoTable[#0] or CHAR_IS_END_OF_LINE;
  CharInfoTable[#10]:=CharInfoTable[#10] or CHAR_IS_END_OF_LINE;
  CharInfoTable[#13]:=CharInfoTable[#13] or CHAR_IS_END_OF_LINE;

  // Unicode-,     ANSI
  SetLength(AnsiStr,255);
  for c:=#1 to #255
    do AnsiStr[Ord(c)]:=c;
  UnicodeStr:=UnicodeString(AnsiStr);
  for i:=1 to 255
    do CharInfoTable[UnicodeStr[i]]:=CharInfoTable[UnicodeStr[i]] or CHAR_IS_ANSI;
end.
