unit NC_ColorSettings;

interface

uses Windows, Highlighting, Graphics, SynEdit, SynEditHighlighter;

type TColorSchema=record
        Name:String;
        LNColor,LNBackground,LNBorderColor,LNGradientStart,LNGradientEnd:TColor;
        LNGradientPresent:Boolean;
        Colors: array [TtkTokenKind] of TSyntaxHighlightAttributes;
      end;
     PColorSchema=^TColorSchema;

const StandardColorSchema:TColorSchema=
  (
    Name: ' Neo Sign 0f Misery';
//    EditorBackground: clWindow;
    LNColor:clWindowText;
    LNBackground:clGray;
    LNBorderColor:clWindow;
    LNGradientStart:clBtnFace;
    LNGradientEnd:clWindow;
    LNGradientPresent:True;
    Colors: (( {Token: tkNull;}     Background: clWindow; Foreground: clWindowText; Style:[] ),
             ( {Token: tkNone;}     Background: clWindow; Foreground: clWindowText; Style:[] ),
             ( {Token: tkSpace;}    Background: clWindow; Foreground: clWindowText; Style:[] ),
             ( {Token: tkKeyword;}  Background: clWindow; Foreground: clWindowText; Style:[fsBold,fsUnderline] ),
             ( {Token: tkCommandName;}   Background: clWindow; Foreground: clWindowText; Style:[fsBold] ),
             ( {Token: tkLabel;}    Background: clWindow; Foreground: clRed;        Style:[fsBold,fsUnderline] ),
             ( {Token: tkLabelRef;}   Background: clWindow; Foreground: clRed;        Style:[fsBold] ),
             ( {Token: tkComment;}  Background: clWindow; Foreground: clGray;       Style:[fsItalic] ),
             ( {Token: tkHexDump;}    Background: clWindow; Foreground: clRed;        Style:[fsItalic] ),
             ( {Token: tkAnsiString;} Background: clWindow; Foreground: clBlue;       Style:[fsItalic] ),
             ( {Token: tkUnicodeString;} Background: clWindow; Foreground: clNavy;   Style:[fsItalic] ),
             ( {Token: tkGlobalVariable;}Background: clYellow; Foreground: clGray;   Style:[fsBold] ),
             ( {Token: tkLocalVariable;} Background: clYellow; Foreground: clGray;   Style:[fsBold,fsItalic] ),
             ( {Token: tkIntNumber;}Background: clWindow; Foreground: clGreen;      Style:[] ),
             ( {Token: tkHexNumber;}Background: clWindow; Foreground: clGreen;      Style:[fsUnderline] ),
             ( {Token: tkFloatNumber;}  Background: clWindow; Foreground: clPurple;    Style:[] ),
             ( {Token: tkDate;}     Background: clWindow;  Foreground: clMaroon;    Style:[] ),
             ( {Token: tkDefault;}  Background: clWindow;  Foreground: clMaroon;    Style:[fsBold] ),
             ( {Token: tkParamEnd;} Background: clWindow;  Foreground: clPurple;    Style:[fsBold] ),
             ( {Token: tkDirective;}Background: clWindow; Foreground: clPurple;     Style:[fsBold] ),
             ( {Token: tkAnsiChar;} Background: clWindow; Foreground: clBlue;       Style:[fsUnderline] ),
             ( {Token: tkUnicodeChar;}  Background: clWindow; Foreground: clNavy;      Style:[fsUnderline] ),
             ( {Token: tkError;}    Background: clRed;     Foreground: clWindowText; Style:[] )
            );
    );

const BlueClasicColorSchema:TColorSchema=
  (
    Name: ' ';
//    EditorBackground: clNavy;
    LNColor:clWhite;
    LNBackground:clNavy;
    LNBorderColor:clSilver;
    LNGradientStart:clNavy;
    LNGradientEnd:clNavy;
    LNGradientPresent:False;
    Colors: (( {Token: tkNull;}       Background: clNavy;     Foreground: clYellow;     Style:[] ),
             ( {Token: tkNone;}       Background: clNavy;     Foreground: clYellow;     Style:[] ),
             ( {Token: tkSpace;}      Background: clNavy;     Foreground: clYellow;     Style:[] ),
             ( {Token: tkKeyword;}    Background: clNavy;     Foreground: clWhite;      Style:[fsBold] ),
             ( {Token: tkCommandName;}    Background: clNavy; Foreground: clYellow;     Style:[fsBold] ),
             ( {Token: tkLabel;}      Background: clNavy;     Foreground: clRed;        Style:[fsBold,fsUnderline] ),
             ( {Token: tkLabelRef;}   Background: clNavy;     Foreground: clRed;        Style:[] ),
             ( {Token: tkComment;}    Background: clNavy;     Foreground: clSilver;     Style:[fsItalic] ),
             ( {Token: tkHexDump;}    Background: clNavy;     Foreground: clAqua;       Style:[fsItalic,fsUnderline] ),
             ( {Token: tkAnsiString;} Background: clNavy;     Foreground: clAqua;       Style:[fsItalic] ),
             ( {Token: tkUnicodeString;}  Background: clNavy; Foreground: clSkyBlue;    Style:[fsItalic] ),
             ( {Token: tkGlobalVariable;} Background: clBlack; Foreground: clWhite;     Style:[] ),
             ( {Token: tkLocalVariable;}  Background: clBlack; Foreground: clWhite;     Style:[fsItalic] ),
             ( {Token: tkIntNumber;}  Background: clNavy;     Foreground: clLime;      Style:[] ),
             ( {Token: tkHexNumber;}  Background: clNavy;     Foreground: clLime;      Style:[fsUnderline] ),
             ( {Token: tkFloatNumber;} Background: clNavy;    Foreground: clFuchsia;     Style:[] ),
             ( {Token: tkDate;}       Background: clBlack;     Foreground: clRed;     Style:[] ),
             ( {Token: tkDefault;}    Background: clNavy;     Foreground: clWhite;     Style:[fsBold] ),
             ( {Token: tkParamEnd;}   Background: clNavy;     Foreground: clYellow;     Style:[fsBold] ),
             ( {Token: tkDirective;}  Background: clNavy;     Foreground: clFuchsia;    Style:[fsBold] ),
             ( {Token: tkAnsiChar;}   Background: clNavy;     Foreground: clAqua;       Style:[fsUnderline] ),
             ( {Token: tkUnicodeChar;} Background: clNavy;    Foreground: clSkyBlue;    Style:[fsUnderline] ),
             ( {Token: tkError;}      Background: clRed;      Foreground: clWhite;      Style:[fsBold] )
            )
  );

const BWClassicColorSchema:TColorSchema=
  (
    Name: ' -';
//    EditorBackground: clBlack;
    LNColor:clWhite;
    LNBackground:clBlack;
    LNBorderColor:clSilver;
    LNGradientStart:clBlack;
    LNGradientEnd:clBlack;
    LNGradientPresent:False;
    Colors: (( {Token: tkNull;}       Background: clBlack;     Foreground: clWhite;  Style:[] ),
             ( {Token: tkNone;}       Background: clBlack;     Foreground: clWhite;  Style:[] ),
             ( {Token: tkSpace;}      Background: clBlack;     Foreground: clWhite;  Style:[] ),
             ( {Token: tkKeyword;}    Background: clBlack;     Foreground: clSilver;    Style:[fsBold] ),
             ( {Token: tkCommandName;}    Background: clBlack; Foreground: clWhite;   Style:[fsBold] ),
             ( {Token: tkLabel;}      Background: clRed;       Foreground: clWhite;   Style:[fsBold] ),
             ( {Token: tkLabelRef;}   Background: clBlack;     Foreground: clRed;     Style:[] ),
             ( {Token: tkComment;}    Background: clBlack;     Foreground: clSilver;  Style:[fsItalic] ),
             ( {Token: tkHexDump;}    Background: clBlack;     Foreground: clAqua;    Style:[fsUnderline] ),
             ( {Token: tkAnsiString;} Background: clBlack;     Foreground: clAqua;    Style:[] ),
             ( {Token: tkUnicodeString;}  Background: clBlack; Foreground: clSkyBlue; Style:[] ),
             ( {Token: tkGlobalVariable;} Background: clWhite; Foreground: clBlack;   Style:[fsBold] ),
             ( {Token: tkLocalVariable;}  Background: clGray;  Foreground: clBlack;   Style:[] ),
             ( {Token: tkIntNumber;}  Background: clBlack;     Foreground: clLime;    Style:[] ),
             ( {Token: tkHexNumber;}  Background: clBlack;     Foreground: clLime;    Style:[fsUnderline] ),
             ( {Token: tkFloatNumber;} Background: clBlack;    Foreground: clFuchsia; Style:[] ),
             ( {Token: tkDate;}       Background: clNavy;      Foreground: clWhite;   Style:[] ),
             ( {Token: tkDefault;}    Background: clBlack;     Foreground: clWhite;   Style:[fsBold] ),
             ( {Token: tkParamEnd;}   Background: clBlack;     Foreground: clYellow;  Style:[fsBold] ),
             ( {Token: tkDirective;}  Background: clBlack;     Foreground: clRed;     Style:[fsBold] ),
             ( {Token: tkAnsiChar;}   Background: clBlack;     Foreground: clAqua;    Style:[fsUnderline] ),
             ( {Token: tkUnicodeChar;} Background: clBlack;    Foreground: clSkyBlue; Style:[fsUnderline] ),
             ( {Token: tkError;}      Background: clRed;       Foreground: clBlack;   Style:[fsBold] )
            )
  );

const CRT_BRIGHT=$A0FFA0;
      CRT_LIGHT=$55FF55;
      CRT_NORMAL=$4B840;
      CRT_DARK=$278027;
      CRT_VERY_DARK=$124012;
const TerminalColorSchema:TColorSchema=
  (
    Name: ' ';
//    EditorBackground: clBlack;
    LNColor: CRT_NORMAL;
    LNBackground:clBlack;
    LNBorderColor:CRT_NORMAL;
    LNGradientStart:clBlack;
    LNGradientEnd:clBlack;
    LNGradientPresent:False;
    Colors: (( {Token: tkNull;}       Background: clBlack;      Foreground: CRT_LIGHT;    Style:[] ),
             ( {Token: tkNone;}       Background: clBlack;      Foreground: CRT_LIGHT;    Style:[] ),
             ( {Token: tkSpace;}      Background: clBlack;      Foreground: CRT_NORMAL;   Style:[] ),
             ( {Token: tkKeyword;}    Background: CRT_NORMAL;   Foreground: clBlack;      Style:[fsBold] ),
             ( {Token: tkCommandName;}    Background: clBlack;  Foreground: CRT_LIGHT;    Style:[fsBold] ),
             ( {Token: tkLabel;}      Background: CRT_VERY_DARK;Foreground: CRT_BRIGHT;   Style:[fsBold,fsUnderline] ),
             ( {Token: tkLabelRef;}   Background: clBlack;      Foreground: CRT_BRIGHT;   Style:[fsBold,fsUnderline] ),
             ( {Token: tkComment;}    Background: clBlack;      Foreground: CRT_NORMAL;   Style:[] ),
             ( {Token: tkHexDump;}    Background: CRT_VERY_DARK; Foreground: CRT_LIGHT;   Style:[fsBold] ),
             ( {Token: tkAnsiString;} Background: CRT_VERY_DARK; Foreground: CRT_LIGHT;   Style:[fsBold] ),
             ( {Token: tkUnicodeString;}  Background: clBlack; Foreground: CRT_BRIGHT;    Style:[fsBold] ),
             ( {Token: tkGlobalVariable;} Background: CRT_LIGHT; Foreground: clBlack;     Style:[fsBold] ),
             ( {Token: tkLocalVariable;}  Background: CRT_NORMAL;Foreground: clBlack;     Style:[fsBold] ),
             ( {Token: tkIntNumber;}  Background: clBlack;     Foreground: CRT_NORMAL;    Style:[fsBold] ),
             ( {Token: tkHexNumber;}  Background: clBlack;     Foreground: CRT_NORMAL;    Style:[fsBold] ),
             ( {Token: tkFloatNumber;} Background: clBlack;    Foreground: CRT_NORMAL;    Style:[fsBold] ),
             ( {Token: tkDate;}       Background: clBlack;     Foreground: CRT_NORMAL;    Style:[fsBold] ),
             ( {Token: tkDefault;}    Background: clBlack;     Foreground: CRT_LIGHT;     Style:[fsBold] ),
             ( {Token: tkParamEnd;}   Background: clBlack;     Foreground: CRT_LIGHT;     Style:[fsBold] ),
             ( {Token: tkDirective;}  Background: CRT_DARK;     Foreground: CRT_BRIGHT;   Style:[fsBold] ),
             ( {Token: tkAnsiChar;}   Background: CRT_VERY_DARK; Foreground: CRT_LIGHT;   Style:[fsUnderline] ),
             ( {Token: tkUnicodeChar;} Background: clBlack;    Foreground: CRT_BRIGHT;    Style:[fsUnderline] ),
             ( {Token: tkError;}      Background: clRed;       Foreground: clBlack;       Style:[fsBold] )
            )
  );


const AsmEditBg=$EAFFFE;
const AsmEditColorSchema:TColorSchema=
  (
    Name: 'AsmEdit - ';
//    EditorBackground: AsmEditBg;
    LNColor: clBlack;
    LNBackground:     clWhite;
    LNBorderColor:    $A0A0A0;
    LNGradientStart:  $EAFFED;
    LNGradientEnd:    $EAFFED;
    LNGradientPresent:True;
    Colors: (( {Token: tkNull;}       Background: AsmEditBg;      Foreground: clBlack;   Style:[] ),
             ( {Token: tkNone;}       Background: AsmEditBg;      Foreground: clBlack;   Style:[] ),
             ( {Token: tkSpace;}      Background: AsmEditBg;      Foreground: clBlack;   Style:[] ),
             ( {Token: tkKeyword;}    Background: AsmEditBg;      Foreground: $8000FF;   Style:[fsBold] ),
             ( {Token: tkCommandName;}    Background: AsmEditBg;  Foreground: clBlack;   Style:[fsBold] ),
             ( {Token: tkLabel;}      Background: $80FFFF;        Foreground: $8000FF;   Style:[fsBold] ),
             ( {Token: tkLabelRef;}   Background: $80FFFF;        Foreground: $8000FF;   Style:[] ),
             ( {Token: tkComment;}    Background: $EFEFEF;        Foreground: clBlack;   Style:[] ),
             ( {Token: tkHexDump;}    Background: AsmEditBg;      Foreground: $FF0080;   Style:[] ),
             ( {Token: tkAnsiString;} Background: AsmEditBg;      Foreground: $FF0080;   Style:[] ),
             ( {Token: tkUnicodeString;}  Background: AsmEditBg;  Foreground: $FF0040;   Style:[] ),
             ( {Token: tkGlobalVariable;} Background: AsmEditBg;  Foreground: $8000FF;   Style:[fsBold] ),
             ( {Token: tkLocalVariable;}  Background: AsmEditBg;  Foreground: $8000FF;   Style:[] ),
             ( {Token: tkIntNumber;}  Background: AsmEditBg;      Foreground: $006000;   Style:[] ),
             ( {Token: tkHexNumber;}  Background: AsmEditBg;      Foreground: $006000;   Style:[] ),
             ( {Token: tkFloatNumber;} Background:$EFEFEF;        Foreground: $006000;   Style:[] ),
             ( {Token: tkDate;}       Background: $EFEFEF;        Foreground: $006000;   Style:[fsBold] ),
             ( {Token: tkDefault;}    Background: AsmEditBg;      Foreground: $404040;   Style:[] ),
             ( {Token: tkParamEnd;}   Background: AsmEditBg;      Foreground: clBlack;   Style:[fsBold] ),
             ( {Token: tkDirective;}  Background: AsmEditBg;      Foreground: $400080;   Style:[fsBold] ),
             ( {Token: tkAnsiChar;}   Background: $EFEFEF;        Foreground: $FF0080;   Style:[] ),
             ( {Token: tkUnicodeChar;} Background: $EFEFEF;       Foreground: $FF0040;   Style:[] ),
             ( {Token: tkError;}      Background: clRed;          Foreground: clBlack;   Style:[fsBold] )
            )
  );


const ColorSchemas:array [0..4] of PColorSchema=
  (@StandardColorSchema, @AsmEditColorSchema, @BlueClasicColorSchema, @BWClassicColorSchema, @TerminalColorSchema);

type TColorSettings=class(TObject)
  private
    procedure StoreSettings(const fname:String='');
    //        ( fname='')
    procedure ReadSettings(const fname:String='');
    //       ( fname='')
  public
    Schema:TColorSchema;

    procedure ReadFromRegistry;
    //    
    procedure ReadFromFile(const fname:String);
    //    
    procedure WriteToRegistry;
    //    
    procedure WriteToFile(const fname:String);
    //    
    procedure SetColorSchema(const _schema:TColorSchema);
    //   
    procedure DefaultColorSchema;
    //   
    procedure ColorSchemaByIndex(idx:Integer);
    //     

    procedure ApplyToEditor(edt:TSynEdit);
end;

type TOneTokenDescription=record
  Token:TtkTokenKind;
  RegValueName:String;
  Description:String;
  Sample:String;
end;

const TOKEN_DESCRIPTIONS_COUNT=21;
const TokenDescriptions:array [0..21] of TOneTokenDescription=
(
  (Token: tkNone; RegValueName:'AnyText'; Description:'    '; Sample:' ' ),
  (Token: tkSpace; RegValueName:'Space'; Description:''; Sample:' ' ),
  (Token: tkComment; RegValueName:'Comment'; Description:''; Sample:'; ' ),
  (Token: tkDirective; RegValueName:'Directive'; Description:''; Sample:'&DIRECTIVE' ),
  (Token: tkKeyword; RegValueName:'Keyword'; Description:' '; Sample:'KEYWORD' ),
  (Token: tkCommandName; RegValueName:'CommandName'; Description:' '; Sample:'ANY_COMMAND_NAME' ),
  (Token: tkGlobalVariable; RegValueName:'GlobalVariable'; Description:' ';Sample:'@123' ),
  (Token: tkLocalVariable; RegValueName:'LocalVariable'; Description:' ';Sample:'@_123'),
  (Token: tkLabel; RegValueName:'Label'; Description:''; Sample:'^My_Label' ),
  (Token: tkLabelRef; RegValueName:'LabelReference'; Description:'  '; Sample:'^My_Label' ),
  (Token: tkHexDump; RegValueName:'HexDump'; Description:'    '; Sample:'!01 02 04 08!' ),
  (Token: tkAnsiString; RegValueName:'AnsiString'; Description:'ANSI-'; Sample:''' ''' ),
  (Token: tkUnicodeString; RegValueName:'UnicodeString'; Description:'Unicode-'; Sample:'" "' ),
  (Token: tkAnsiChar; RegValueName:'AnsiChar'; Description:' ANSI-'; Sample:'~?' ),
  (Token: tkUnicodeChar; RegValueName:'UnicodeChar'; Description:' Unicode-'; Sample:'~~?' ),
  (Token: tkIntNumber; RegValueName:'IntNumber'; Description:' '; Sample:'12345' ),
  (Token: tkHexNumber; RegValueName:'HexNumber'; Description:'  '; Sample:'$ABCDEF' ),
  (Token: tkFloatNumber; RegValueName:'FloatNumber'; Description:'   '; Sample:'*123.45' ),
  (Token: tkDate; RegValueName:'Date'; Description:'  '; Sample:'#01.02.2012,12:34:56.789' ),
  (Token: tkDefault; RegValueName:'DefaultValue'; Description:'"   "'; Sample:'$' ),
  (Token: tkParamEnd; RegValueName:'ParamEnd'; Description:'  '; Sample:'.' ),
  (Token: tkError; RegValueName:'Error'; Description:' '; Sample:' ' )
);

implementation

uses Classes, SysUtils, StrUtils, NC_SimpleRegAccess, NC_AllVars;

const REGISTRY_EDITOR_COLORS='EditorColors';

{ TColorSettings }

function StyleToText(s:TFontStyles):String;
var r:Cardinal;
begin
  r:=0;
  if fsBold in s then Inc(r,1);
  if fsItalic in s then Inc(r,2);
  if fsUnderline in s then Inc(r,4);
  if fsStrikeOut in s then Inc(r,8);
  Result:=IntToStr(r);
end;

function DecodeEditorColors(const s:String; var LNColor,LNBg,LNBorder,LNGradStart,LNGradEnd:TColor; var HasGrad:Boolean):Boolean;
var commas:array[1..5] of Integer;
    i,p:Integer;
begin
  //   - 
  p:=1;
  for i:=1 to Length(s) do
    begin
      if s[i]=',' then
        begin
          commas[p]:=i;
          if p=High(commas)
            then Break
            else Inc(p);
        end;
    end;
  //     -     
  if p<High(commas)
    then Result:=False
    else
      begin
        LNColor:=StrToIntDef(Copy(s,1,commas[1]-1),clWindow);
        LNBg:=StrToIntDef(Copy(s,commas[1]+1,commas[2]-commas[1]-1),clWindowText);
        LNBorder:=StrToIntDef(Copy(s,commas[2]+1,commas[3]-commas[2]-1),clWhite);
        LNGradStart:=StrToIntDef(Copy(s,commas[3]+1,commas[4]-commas[3]-1),clWindowText);
        LNGradEnd:=StrToIntDef(Copy(s,commas[4]+1,commas[5]-commas[4]-1),clWhite);
        HasGrad:=StrToIntDef(Copy(s,commas[5]+1,Length(s)-commas[5]),0)=1;
        Result:=True;
      end;
  if Result=False then
    begin
      LNColor:=clWindowText;
      LNBg:=clWhite;
      LNBorder:=clWindowText;
      LNGradStart:=clWhite;
      LNGradEnd:=clWhite;
      HasGrad:=False;
    end;
end;

function DecodeFontStyle(const s:String; var Foreground, Background:TColor; var Style:TFontStyles):Boolean;
var p1,p2:Integer;
begin
  //   
  Foreground:=clWindow;
  Background:=clWindowText;
  Style:=[];
  //  
  p1:=Pos(',',s);
  if p1>0
    then p2:=PosEx(',',s,p1+1)
    else p2:=-1;
  Result:=(p1>0) and (p2>0);
  //    -   
  if Result then
    begin
      Foreground:=StrToIntDef(Copy(s,1,p1-1),clWindow);
      Background:=StrToIntDef(Copy(s,p1+1,p2-p1-1),clWindowText);
      //  
      p1:=StrToIntDef(Copy(s,p2+1,Length(s)-p2),0);
      if (p1 and 1)<>0
        then Include(Style,fsBold);
      if (p1 and 2)<>0
        then Include(Style,fsItalic);
      if (p1 and 4)<>0
        then Include(Style,fsUnderline);
      if (p1 and 8)<>0
        then Include(Style,fsStrikeOut);
    end;//if
end;

function IndexByRegValueName(s:String):Integer;
var i:Integer;
begin
  Result:=-1;
  for i:=Low(TokenDescriptions) to High(TokenDescriptions) do
    begin
      if TokenDescriptions[i].RegValueName=s then
        begin
          Result:=i;
          Break;
        end;//if
    end;//for
end;

function IndexByToken(tk:TtkTokenKind):Integer;
var i:Integer;
begin
  Result:=-1;
  for i:=Low(TokenDescriptions) to High(TokenDescriptions)
    do if TokenDescriptions[i].Token=tk then
      begin
        Result:=i;
        Break;
      end;
end;

procedure TColorSettings.ApplyToEditor(edt: TSynEdit);
var i:TtkTokenKind;
begin
  if Assigned(edt.Highlighter) then
    begin
    with edt.Highlighter as TSynNeoS0MSyn do
      begin
        //    
        with edt.Gutter, Schema do
          begin
            Font.Color:=LNColor;
            Color:=LNBackground;
            Gradient:=LNGradientPresent;
            GradientStartColor:=LNGradientStart;
            GradientEndColor:=LNGradientEnd;
            BorderColor:=LNBorderColor;
          end;// with
        for i:=Low(Schema.Colors) to High(Schema.Colors) do
          SetStyleByToken(i,Schema.Colors[i]);
        //   tkNull    ,    tkNone
        Schema.Colors[tkNull]:=Schema.Colors[tkNone];
        edt.Color:=Schema.Colors[tkNone].Background;
      end;//with edt.Highlighter as TSynNeoS0MSyn
      edt.Repaint;
    end;//if
end;

procedure TColorSettings.ColorSchemaByIndex(idx: Integer);
begin
  if (idx>=Low(ColorSchemas)) and (idx<=High(ColorSchemas))
    then SetColorSchema(ColorSchemas[idx]^)
    else DefaultColorSchema;
end;

procedure TColorSettings.SetColorSchema(const _schema: TColorSchema);
var i:TtkTokenKind;
begin
  Schema:=_schema;
  Schema.Name:=_schema.Name;
//  Schema.EditorBackground:=_schema.EditorBackground;
  Schema.LNColor:=_schema.LNColor;
  Schema.LNBackground:=_schema.LNBackground;
  Schema.LNGradientStart:=_schema.LNGradientStart;
  Schema.LNGradientEnd:=_schema.LNGradientEnd;
  Schema.LNGradientPresent:=_schema.LNGradientPresent;
  Schema.LNBorderColor:=_schema.LNBorderColor;
  for i:=Low(TtkTokenKind) to High(TtkTokenKind) do
    begin
      Schema.Colors[i]:=_schema.Colors[i];
    end;
end;

procedure TColorSettings.StoreSettings(const fname: String);
var SaveToRegistry:Boolean;
    value:String;
    otd:TOneTokenDescription;
    sl:TStringList;
begin
  //     -    
  SaveToRegistry:=fname='';
  if not SaveToRegistry
    then sl:=TStringList.Create;
  try
    //       
    value:='$'+IntToHex(Schema.LNColor,0)+
           ',$'+IntToHex(Schema.LNBackground,0)+
           ',$'+IntToHex(Schema.LNBorderColor,0)+
           ',$'+IntToHex(Schema.LNGradientStart,0)+
           ',$'+IntToHex(Schema.LNGradientEnd,0)+
           IfThen(Schema.LNGradientPresent,',1',',0');
    if SaveToRegistry
      then NC_StoreString(NeoS0M_RegKey,REGISTRY_EDITOR_COLORS,value)
      else sl.Add(REGISTRY_EDITOR_COLORS+'='+value);
    //    
    for otd in TokenDescriptions do
      begin
        with Schema.Colors[otd.Token] do
          begin
            value:='$'+IntToHex(Background,0)+',$'+IntToHex(Foreground,0)+','+StyleToText(Style);
            //     StringList
            if SaveToRegistry
              then NC_StoreString(NeoS0M_RegKey,otd.RegValueName,value)
              else sl.Add(otd.RegValueName+'='+value);
          end;//with
      end;//for
    //     -   StringList
    if not SaveToRegistry
      then sl.SaveToFile(fname);
  finally
    if not SaveToRegistry
      then FreeAndNil(sl);
  end;
end;

procedure TColorSettings.DefaultColorSchema;
begin
  SetColorSchema(StandardColorSchema);
end;

procedure TColorSettings.ReadFromFile(const fname: String);
begin
  ReadSettings(fname);
end;

procedure TColorSettings.ReadFromRegistry;
begin
  ReadSettings;
end;

procedure TColorSettings.ReadSettings(const fname: String);
var ReadFromRegistry:Boolean;
    sl:TStringList;
    readed_s:String;
    t:TtkTokenKind;
    otd:TOneTokenDescription;
begin
  ReadFromRegistry:=fname='';
  if not ReadFromRegistry
    then sl:=TStringList.Create;
  //     
  if not ReadFromRegistry then
    begin
      try
        sl.LoadFromFile(fname);
      finally

      end;
    end;

  //     
  if ReadFromRegistry then
    begin
      readed_s:='';
      NC_ReadString(NeoS0M_RegKey,REGISTRY_EDITOR_COLORS,readed_s);
    end
  else readed_s:=sl.Values[REGISTRY_EDITOR_COLORS];
  with Schema
    do DecodeEditorColors(readed_s,LNColor,LNBackground,LNBorderColor,LNGradientStart,LNGradientEnd,LNGradientPresent);

  //      
  for t:=Low(Schema.Colors) to High(Schema.Colors) do
    begin
      with Schema.Colors[t] do
        begin
          Foreground:=clWindowText;
          Background:=clWindow;
          Style:=[];
        end;
    end;

  //     
  for otd in TokenDescriptions do //   -     Low()  High()
    begin
      //   
      if ReadFromRegistry then
        begin
          readed_s:='';
          NC_ReadString(NeoS0M_RegKey,otd.RegValueName,readed_s);
        end
      else readed_s:=sl.Values[otd.RegValueName];
      //   ,    -    
      with Schema.Colors[otd.Token]
        do DecodeFontStyle(readed_s,Background,Foreground,Style)
    end;//for

  //  StringList,    
  if not ReadFromRegistry
    then FreeAndNil(sl);
end;

procedure TColorSettings.WriteToFile(const fname: String);
begin
  StoreSettings(fname);
end;

procedure TColorSettings.WriteToRegistry;
begin
  StoreSettings;
end;

end.
