unit NC_FrameCreator;

interface

uses  Classes,
      PNC_ParamDWORD, PNC_ParamString, PNC_ParamAny, PNC_ParamBeep, PNC_ParamMBox, PNC_ParamVar,
      PNC_ParamFLOAT, PNC_ParamINTEGER, PNC_ParamDWORDAlternatives, PNC_ParamDir,
      PNC_ParamFileName, PNC_ParamTimeDate, PNC_ParamLabel, PNC_ParamSearchPosDir,
      PNC_ParamBinBlock, PNC_ParamFileSharing, PNC_ParamMSec,PNC_ParamFileAttr,
      PNC_ParamFileAccess, PNC_ParamLangID;

type TOneFrameCreator=record
      InputMethod:String;
      FrameClass:TComponentClass;
      DefaultValue:String; //   ,       
     end;

const FrameCreators:array [1..32] of TOneFrameCreator=
      ( (InputMethod:'#';       FrameClass:TfrmParamDWORD;    DefaultValue:'0'),
        (InputMethod:'+';       FrameClass:TfrmParamINTEGER;  DefaultValue:'0'),
        (InputMethod:'*';       FrameClass:TfrmParamFLOAT;    DefaultValue:'0'),
        (InputMethod:'$';       FrameClass:TfrmParamString;   DefaultValue:'""'),
        (InputMethod:'!';       FrameClass:TfrmParamBinBlock;  DefaultValue:''''''),

        (InputMethod:'beep';    FrameClass:TfrmParamBeep;     DefaultValue:'0'),
        (InputMethod:'mbox';    FrameClass:TfrmParamMBox;     DefaultValue:'0'),
        (InputMethod:'var';     FrameClass:TfrmParamVar;      DefaultValue:'0'),
        (InputMethod:'alter';   FrameClass:TfrmParamAlternatives;  DefaultValue:'0'),
        (InputMethod:'dir';     FrameClass:TfrmParamDir;      DefaultValue:'""'),
        (InputMethod:'file';    FrameClass:TfrmParamFileName; DefaultValue:'""'),
        (InputMethod:'timedate';FrameClass:TfrmParamTimeDate; DefaultValue:''),
        (InputMethod:'label';   FrameClass:TfrmParamLabel;    DefaultValue:'^'),
        (InputMethod:'search-pos-direction'; FrameClass:TfrmParamSearchPosDir; DefaultValue:'0'),
        (InputMethod:'file-sharing';         FrameClass:TfrmParamFileSharing;  DefaultValue:'1'),
        (InputMethod:'msec';                 FrameClass:TfrmParamMSec;         DefaultValue:'1000'),
        (InputMethod:'file-attributes';      FrameClass:TfrmParamFileAttr;     DefaultValue:'$80'),
        (InputMethod:'file-access';          FrameClass:TfrmFileAccess;        DefaultValue:'$C0000000'),
        (InputMethod:'lang-id';              FrameClass:TfrmParamLangID;       DefaultValue:'$419'),
        //        
        (InputMethod:'exe-flags';            FrameClass:TfrmParamDWORD;        DefaultValue:'0'),
        (InputMethod:'message-name';         FrameClass:TfrmParamDWORD;        DefaultValue:'0'),
        (InputMethod:'ansi-char';            FrameClass:TfrmParamDWORD;        DefaultValue:'~?'),
        (InputMethod:'proc-acc-attr';        FrameClass:TfrmParamDWORD;        DefaultValue:'$639'),
        (InputMethod:'thread-acc-attr';      FrameClass:TfrmParamDWORD;        DefaultValue:'$63'),
        (InputMethod:'reg-key';              FrameClass:TfrmParamString;       DefaultValue:''),
        (InputMethod:'reg-value';            FrameClass:TfrmParamString;       DefaultValue:''),
        (InputMethod:'function_or_addr';     FrameClass:TfrmParamString;       DefaultValue:'"dll*function"'),
        (InputMethod:'sysfolder';            FrameClass:TfrmParamString;       DefaultValue:'"WINDOWS"'),
        (InputMethod:'sysfolder-idx';        FrameClass:TfrmParamDWORD;        DefaultValue:'0'),
        (InputMethod:'filename-filter';      FrameClass:TfrmParamString;       DefaultValue:'" |*.*|"'),
        (InputMethod:'file-dialog-opts';     FrameClass:TfrmParamDWORD;        DefaultValue:'$80000'),
        (InputMethod:'wide-char';            FrameClass:TfrmParamDWORD;        DefaultValue:'~~?')
      );

function DefaultByInputMethod(const s:String):String;

implementation

function DefaultByInputMethod(const s:String):String;
var i:Integer;
begin
  Result:='';
  for i:=Low(FrameCreators) to High(FrameCreators)
    do if s=FrameCreators[i].InputMethod then
        begin
          Result:=FrameCreators[i].DefaultValue;
          Break;
        end;
end;

end.
