unit NC_SimpleRegAccess;

interface
uses Windows,Registry,SysUtils;

function NC_ReadBoolean(branch:HKEY;Key,ValueName:UnicodeString; var Value:Boolean):boolean;overload;
function NC_ReadBoolean(Key,ValueName:UnicodeString; var Value:boolean):Boolean;overload;

function NC_ReadInteger(branch:HKEY;Key,ValueName:UnicodeString; var Value:Integer):boolean;overload;
function NC_ReadInteger(Key,ValueName:UnicodeString; var Value:integer):boolean;overload;

function NC_ReadString(branch:HKEY;const Key,ValueName:UnicodeString; var Value:UnicodeString):boolean;overload;
function NC_ReadString(const Key,ValueName:UnicodeString; var Value:UnicodeString):boolean;overload;
//     . ,        Value.     , Value  

function NC_StoreBoolean(Branch:HKEY;Key,ValueName:string; Value:boolean):boolean;overload;
function NC_StoreBoolean(Key,ValueName:string; Value:boolean):boolean;overload;

function NC_StoreInteger(Branch:HKEY;Key,ValueName:string; Value:integer):boolean;overload;
function NC_StoreInteger(Key,ValueName:string; Value:integer):boolean;overload;

function NC_StoreString(Branch:HKEY;Key,ValueName:string; Value:string):boolean;overload;
function NC_StoreString(Key,ValueName:string; Value:string):boolean;overload;
//     

implementation

function SimpleOpenRegKey(Branch:HKEY; Key:string; can_create:boolean; var obj_reg:TRegistry):boolean;
begin
  if Assigned(obj_reg)
    then FreeAndNil(obj_reg);
  try
    obj_reg:=TRegistry.Create;
    obj_reg.RootKey:=Branch;
    result:=obj_reg.OpenKey(Key,can_create);
  except
    result:=false;
    if Assigned(obj_reg)
      then FreeAndNil(obj_reg);
  end;
end;

procedure SimpleCloseRegKey(var obj_reg:TRegistry);
begin
  if Assigned(obj_reg)
    then FreeAndNil(obj_reg);
end;

function NC_StoreBoolean(branch:HKEY;Key,ValueName:UnicodeString; Value:Boolean):boolean;
var r:TRegistry;
begin
 r:=nil;
 if SimpleOpenRegKey(branch,key,true,r) then
  begin
   try
    r.WriteBool(ValueName,Value);
    result:=true;
   except
    result:=false;
   end;
   SimpleCloseRegKey(r);
  end
 else result:=false;
end;

function NC_StoreBoolean(Key,ValueName:UnicodeString; Value:Boolean):boolean;
begin
 result:=NC_StoreBoolean(HKEY_CURRENT_USER,Key,ValueName,Value);
end;

function NC_ReadBoolean(branch:HKEY;Key,ValueName:string; var Value:boolean):boolean;
var r:TRegistry;
begin
 r:=nil;
 if SimpleOpenRegKey(branch,key,true,r) then
  begin
   try
    if r.ValueExists(ValueName) then
     begin
      Value:=r.ReadBool(ValueName);
      result:=true;
     end
    else result:=false;
   except
    result:=false;
   end;
   SimpleCloseRegKey(r);
  end
 else result:=false;
end;

function NC_ReadBoolean(Key,ValueName:UnicodeString; var Value:Boolean):boolean;
begin
 result:=NC_ReadBoolean(HKEY_CURRENT_USER,Key,ValueName,Value);
end;

function NC_StoreInteger(Branch:HKEY;Key,ValueName:UnicodeString; Value:Integer):Boolean;overload;
var r:TRegistry;
begin
 r:=nil;
 if SimpleOpenRegKey(branch,key,true,r) then
  begin
   try
    r.WriteInteger(ValueName,Value);
    result:=true;
   except
    result:=false;
   end;
   SimpleCloseRegKey(r);
  end
 else result:=false;
end;

function NC_StoreInteger(Key,ValueName:UnicodeString; Value:integer):Boolean;overload;
begin
 result:=NC_StoreInteger(HKEY_CURRENT_USER,Key,ValueName,Value);
end;

function NC_ReadInteger(branch:HKEY;Key,ValueName:UnicodeString; var Value:integer):boolean;overload;
var r:TRegistry;
begin
 r:=nil;
 if SimpleOpenRegKey(branch,key,true,r) then
  begin
   try
    if r.ValueExists(ValueName) then
     begin
      Value:=r.ReadInteger(ValueName);
      result:=true;
     end
    else result:=false;
   except
    result:=false;
   end;
   SimpleCloseRegKey(r);
  end
 else result:=false;
end;

function NC_ReadInteger(Key,ValueName:UnicodeString; var Value:integer):boolean;overload;
begin
 result:=NC_ReadInteger(HKEY_CURRENT_USER,Key,ValueName,Value);
end;

function NC_StoreString(Branch:HKEY;Key,ValueName:UnicodeString; Value:String):boolean;overload;
var r:TRegistry;
begin
 r:=nil;
 if SimpleOpenRegKey(branch,key,True,r) then
  begin
   try
    r.WriteString(ValueName,Value);
    result:=true;
   except
    result:=false;
   end;
   SimpleCloseRegKey(r);
  end
 else result:=false;
end;

function NC_StoreString(Key,ValueName:UnicodeString; Value:UnicodeString):boolean;overload;
begin
 result:=NC_StoreString(HKEY_CURRENT_USER,Key,ValueName,Value);
end;

function NC_ReadString(branch:HKEY;const Key,ValueName:string; var Value:string):boolean;overload;
var r:TRegistry;
begin
 r:=nil;
 if SimpleOpenRegKey(branch,key,true,r) then
  begin
   try
    if r.ValueExists(ValueName) then
     begin
      Value:=r.ReadString(ValueName);
      result:=true;
     end
    else result:=false;
   except
    result:=false;
   end;
   SimpleCloseRegKey(r);
  end
 else result:=false;
end;

function NC_ReadString(const Key,ValueName:string; var Value:string):boolean;overload;
begin
 Result:=NC_ReadString(HKEY_CURRENT_USER,Key,ValueName,Value);
end;



end.
