unit PNC_Param;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, Buttons, PngBitBtn, PngSpeedButton, ExtCtrls;

type
  TfrmParam = class(TFrame)
    btnValue: TPngSpeedButton;
    btnDefault: TPngSpeedButton;
    btnParamEnd: TPngSpeedButton;
    btnVariable: TPngSpeedButton;
    lblParam: TLabel;
    bvlDelimiter: TBevel;
    lblVariable: TLabel;
    edtVariable: TEdit;
    cbLocalVar: TCheckBox;
    procedure AnyButtonClicked(Sender: TObject);
  private
    { Private declarations }
    // ,        
    procedure ShowVarControls(show:Boolean);
    procedure ShowDataControls(show:Boolean);virtual;
    //  ""     .
    procedure UpdateFrameVisibility;

    // ,      ,     
    function IsGoodVariable(const s:String; var Local:Boolean; var idx:String):Boolean;
    //     
    function GetVariable(var err:String):String;

  protected
    //    ,     
    procedure SetData(const s:String);virtual;
    //   ,      ,  
    function IsDataValid(const s:String):String;virtual;
    //  ,   
    function GetValue:String;virtual;

  public
    { Public declarations }
    //  :    ;    ,  
    //     - ,   
    //       
    procedure Prepare(const Description,DataControls:String);virtual;
    //  :             
    procedure Go(const s, DefaultValue:String; const Abilities:Integer);virtual;
    //  :        
    function GetData(var err:String):String;virtual;
  end;

function IsValidDWORD(const s:String; var res:Cardinal):String;
function IsValidINTEGER(const s:String; var res:Int64):String;
function IsValidFLOAT(const s:String; var res:Extended):String;
function IsValidFileDirName(const s:String):String;
function IsValidDateTime(const s:String; var res:Int64):String;
function IsValidLabel(const s:String):String;
function IsValidBinaryBlock(const s:String; var res:AnsiString; var is_dump:Boolean):String;

// ,    Unicode- ,       ANSI
function CheckANSIString(const s:String; var ansi_str:AnsiString):Boolean;
//  ANSI-    
function AnsiStringToDump(const s:AnsiString):String;
//     ANSI-
function DumpToAnsiString(const s:String):AnsiString;

procedure DrawIcon24(ctrl:TImage; idx:Integer);
//         
function IsValidUnicodeString(const s:String):String;
//        NeoS0M
function UnicodeNaturalToString(const s:String):String;
//   NeoS0M (  )   
function UnicodeStringToNatural(const s:String; var new_s:String):Boolean;
//   '$' ( )    ( '-',   )
procedure InsertBucksSign(var s:String);
//    ""       
function MakeDateTime(const y,m,d:String; hr,mn,sc,ms:String):String;

type TStringArray=array of String;

//        
procedure DataToArray(const s:String; var arr:TStringArray);
//     
procedure DataControlsToRadioGroup(rg:TRadioGroup; const DataControls:String; var res_items:TStringArray);

implementation

uses NC_Main, NC_AllVars, NC_CommandEditor, NC_ParamConversion, NC_Chars, StrUtils;

{$R *.dfm}

function IsValidBinaryBlock(const s:String; var res:AnsiString; var is_dump:Boolean):String;
var i,l,cc:Integer;
    c:WideChar;
begin
  l:=Length(s);
  if l>=2 then
    begin
      //           ?
      if (s[1]=s[l]) and ((s[1]='''') or (s[1]='!')) then
        begin
          //      
          if s[1]='!' then
            begin
              //      
              cc:=0;
              for i:=2 to l-1 do
               case s[i] of
                 '!': begin
                        Result:=_InvalidCharInBinaryBlock;
                        Exit;
                      end;
                 '0'..'9','a'..'f','A'..'F':
                      begin
                        Inc(cc);
                      end;
               end;
              if Odd(cc) then
                begin
                  Result:=_OddHexDigitCount;
                  Exit;
                end;

              // , ,   ANSI-
              res:=AnsiString(Copy(s,2,l-1));
            end
          //      
          else
            begin
              res:='';
              for i:=2 to l-1 do
                begin
                  c:=s[i];
                  //   ,       
                  if c<' '
                    then res:=res+'#'+AnsiString(IntToHex(Ord(c),2))
                    else res:=res+AnsiString(c);
                end;
            end;
        end
      else Result:=_NotABinaryBlock;
    end
  else Result:=_NotABinaryBlock;

end;

function CheckANSIString(const s:String; var ansi_str:AnsiString):Boolean;
var i:Integer;
begin
  Result:=True;
  for i:=1 to Length(s)
    do if (CharInfoTable[s[i]] and CHAR_IS_ANSI)=0 then
        begin
          Result:=False;
          Break;
        end;
  if Result
    then ansi_str:=AnsiString(s);
end;

function AnsiStringToDump(const s:AnsiString):String;
var i,p:Integer;
    b:Byte;
begin
  Result:='';
  p:=Length(s);
  i:=1;
  while i<=p do
    begin
      case s[i] of
        //  #      ,   
        '#':  begin
                if i+2<=p then
                  begin
                    if ((CharInfoTable[s[i+1]] and CHAR_IS_HEX_DIGIT)<>0) and
                       ((CharInfoTable[s[i+2]] and CHAR_IS_HEX_DIGIT)<>0)then
                      begin
                        Result:=Result+String(s[i+1])+String(s[i+2]);
                        Inc(i,2);
                      end
                    else
                      begin
                        b:=Ord(s[i]);
                        Result:=Result+HexDigits[b shr 4]+HexDigits[b and $0F];
                        //   #    
                        if s[i]='#'
                          then Inc(i);
                      end;
                  end
                else
                  begin
                    b:=Ord(s[i]);
                    Result:=Result+HexDigits[b shr 4]+HexDigits[b and $0F];
                    //   #    
                    if s[i]='#'
                      then Inc(i);
                  end;
              end;
        else
              begin
                b:=Ord(s[i]);
                Result:=Result+HexDigits[b shr 4]+HexDigits[b and $0F];
              end;
      end;
      if i<>p
        then Result:=Result+' ';
      Inc(i);
    end;//while
end;

function CharAsHexDigit(c:WideChar):Byte;inline;
begin
  case c of
    '0'..'9': Result:=Ord(c)-Ord('0');
    'a'..'f': Result:=Ord(c)-Ord('a')+10;
    'A'..'F': Result:=Ord(c)-Ord('A')+10;
    else Result:=0;
  end;
end;

function DumpToAnsiString(const s:String):AnsiString;
var i:Integer;
    c:WideChar;
    b:Byte;
    FirstNibble:Boolean;
begin
  Result:='';
  FirstNibble:=True;
  for i:=1 to Length(s) do
    begin
      c:=s[i];
      if (CharInfoTable[c] and CHAR_IS_HEX_DIGIT)<>0 then
        begin
          if FirstNibble
            then b:=CharAsHexDigit(c) shl 4
            else
              begin
                b:=b or CharAsHexDigit(c);
                //           
                case b of
                  0..31,255:
                            Result:=Result+'#'+AnsiString(IntToHex(b,2));
                  Ord('#'): Result:=Result+'##';
                  else Result:=Result+AnsiChar(b);
                end;
              end;
          FirstNibble:=not FirstNibble;
        end;
    end;
end;

function IsValidDateTime(const s:String; var res:Int64):String;
label Failed;
var comma_pos,dp1,dp2,tmp,ec:Integer;
    date,time,y,m,d:String;
    st:_SYSTEMTIME;
    idf:Boolean;
begin
  res:=0;
  idf:=False;
  Result:='';
  ZeroMemory(@st,SizeOf(st));
  if Length(s)>0 then
    begin
      if s[1]='#' then
        begin
          comma_pos:=PosEx(',',s,2);
          //       -   
          if comma_pos=0 then
            begin
              date:=Copy(s,2,Length(s)-1);
              time:='';
            end
          else //       
            begin
              date:=Copy(s,2,comma_pos-2);
              time:=Copy(s,comma_pos+1,Length(s)-comma_pos);
              if time='' then
                begin
                  idf:=True;
                  goto failed;
                end;
            end;
          //   
          dp1:=Pos('.',date);
          dp2:=PosEx('.',date,dp1+1);
          if (dp1=0) or (dp2=0) then
            begin
              idf:=True;
              goto failed;
            end;
          //  
          d:=Copy(date,1,dp1-1);
          // 
          m:=Copy(date,dp1+1,dp2-dp1-1);
          // 
          y:=Copy(date,dp2+1,Length(date)-dp2);
          //             INTEGER
          Val(y,tmp,ec);
          if ec=0
            then st.wYear:=tmp
            else
              begin
                idf:=True;
                goto failed;
              end;
          Val(m,tmp,ec);
          if ec=0
            then st.wMonth:=tmp
            else
              begin
                idf:=True;
                goto failed;
              end;
          Val(d,tmp,ec);
          if ec=0
            then st.wDay:=tmp
            else
              begin
                idf:=True;
                goto failed;
              end;
          //   
          if time<>'' then
          begin
            //  
            dp1:=Pos(':',time);
            if dp1<>0 then
              begin
                date:=Copy(time,1,dp1-1);
                Delete(time,1,dp1);
              end
            else
              begin
                date:=time;
                time:='';
              end;
            Val(date,tmp,ec);
            if ec=0
              then st.wHour:=tmp
              else
                begin
                  idf:=True;
                  goto failed;
                end;
            //  
            dp1:=Pos(':',time);
            if dp1<>0 then
              begin
                date:=Copy(time,1,dp1-1);
                Delete(time,1,dp1);
              end
            else
              begin
                date:=time;
                time:='';
              end;
            if date<>'' then
              begin
                Val(date,tmp,ec);
                if ec=0
                  then st.wMinute:=tmp
                  else
                    begin
                      idf:=True;
                      goto failed;
                    end;
              end;
            //    
            dp1:=Pos('.',time);
            if dp1<>0 then
              begin
                date:=Copy(time,1,dp1-1);
                Delete(time,1,dp1);
              end
            else
              begin
                date:=time;
                time:='';
              end;
            //  
            if date<>'' then
              begin
                Val(date,tmp,ec);
                if ec=0
                  then st.wSecond:=tmp
                  else
                    begin
                      idf:=True;
                      goto failed;
                    end;
                  end;
            //  
            if time<>'' then
              begin
                Val(time,tmp,ec);
                if ec=0
                  then st.wMilliseconds:=tmp
                  else
                    begin
                      idf:=True;
                      goto failed;
                    end;
              end;
          end;//if time<>''
          //  /  INTEGER    
          if not SystemTimeToFileTime(st,_FILETIME(res)) then
            begin
              Result:=_IncorrectDateTime;
              Exit;
            end;
        end
      else Result:=_NoDateTimePrefix;
    end;
Failed:
  if idf
    then Result:=_InvalidDateTimeFormat;
end;

function MakeDateTime(const y,m,d:String; hr,mn,sc,ms:String):String;
  function TrailingZeros(const s:String; digits:Integer):String;
  begin
    Result:=s;
    while Length(Result)<digits
      do Result:='0'+Result;
  end;
var MustPresent,Invalid:Boolean;
    Time:String;
    tmp,ec:Integer;
begin
  Result:='#'+TrailingZeros(d,2)+'.'+TrailingZeros(m,2)+'.'+TrailingZeros(y,4);
  if hr=''
    then hr:='0';
  if mn=''
    then mn:='0';
  if sc=''
    then sc:='0';
  if ms=''
    then ms:='0';

  MustPresent:=False;
  Time:='';
  //    ,   -  " ",
  //  -     
  Val(ms,tmp,ec);
  if ec=0
    then Invalid:=(tmp<0) or (tmp>999)
    else Invalid:=True;
  if Invalid
    then Time:='.'+ms
    else
      begin
        if tmp<>0 then
          begin
            Time:=Format('.%3.3d',[tmp]);
            MustPresent:=True;
          end;
      end;
  //    ,   -  " ",
  //  -     
  Val(sc,tmp,ec);
  if ec=0
    then Invalid:=(tmp<0) or (tmp>59)
    else Invalid:=True;
  if Invalid
    then Time:=':'+sc+Time
    else
      begin
        if (tmp<>0) or MustPresent then
          begin
            Time:=Format(':%2.2d',[tmp])+Time;
            MustPresent:=True;
          end;
      end;
  //    ,   -  " ",
  //  -     
  Val(mn,tmp,ec);
  if ec=0
    then Invalid:=(tmp<0) or (tmp>59)
    else Invalid:=True;
  if Invalid
    then Time:=':'+mn+Time
    else
      begin
        if (tmp<>0) or MustPresent then
          begin
            Time:=Format(':%2.2d',[tmp])+Time;
            MustPresent:=True;
          end;
      end;
  //    ,   -  " ",
  //  -     
  Val(hr,tmp,ec);
  if ec=0
    then Invalid:=(tmp<0) or (tmp>23)
    else Invalid:=True;
  if Invalid
    then Time:=':'+hr+Time
    else
      begin
        if (tmp<>0) or MustPresent then
          begin
            Time:=Format('%2.2d',[tmp])+Time;
            MustPresent:=True;
          end;
      end;
  //     -  
  if MustPresent
    then Result:=Result+','+Time;
end;

procedure DataToArray(const s:String; var arr:TStringArray);
var Delim:WideChar;
    From,i,l:Integer;
begin
  Delim:=s[1];
  From:=2;
  l:=0;
  for i:=2 to Length(s) do
    begin
      if s[i]=Delim then
        begin
          SetLength(arr,l+1);
          arr[l]:=Copy(s,From,i-From);
          Inc(l);
          From:=i+1;
        end;
    end;
  //   
  SetLength(arr,l+1);
  arr[l]:=Copy(s,From,Length(s)-From+1);
end;

procedure DataControlsToRadioGroup(rg:TRadioGroup; const DataControls:String; var res_items:TStringArray);
var i,eq_pos,l,col_count,row_count:Integer;
    s:String;
begin
  //   
  DataToArray(DataControls,res_items);
  l:=Length(res_items)-1;
  //   
  if res_items[0]=''
    then rg.Caption:=''
    else rg.Caption:=' '+res_items[0]+' ';
  //     
  col_count:=StrToIntDef(res_items[1],1);
  rg.Columns:=col_count;
  //  
  row_count:=(l-2) div col_count;
  //          ,
  //   
  if l mod col_count<>0
    then Inc(row_count);
  //   
  row_count:=row_count*20;
  rg.Height:=rg.Height+row_count;
  //   - 
  rg.Parent.Height:=rg.Parent.Height+row_count;
  //    
  rg.Items.BeginUpdate;
  rg.Items.Clear;
  for i:=2 to l do
    begin
      s:=res_items[i];
      eq_pos:=Pos('=',s);
      rg.Items.Add(Copy(s,eq_pos+1,Length(s)-eq_pos));
      //      ,     ,
      //       
      res_items[i-2]:=Copy(s,1,eq_pos-1);
    end;
  rg.Items.EndUpdate;
  SetLength(res_items,l);
end;

procedure InsertBucksSign(var s:String);
var mp:Integer;
begin
  mp:=Pos('-',s);
  if mp<>0
    then Insert('$',s,mp+1)
    else s:='$'+s;
end;

function UnicodeStringToNatural(const s:String; var new_s:String):Boolean;
//    NeoS0M- ( #,    ..)
//   .
// : False,       
//     32;  - True
var i,l:Integer;
    SingleHash,err:Boolean;
    cc:WideChar;
begin
  Result:=True;
  new_s:='';
  i:=1;
  l:=Length(s);
  while i<=l do
    begin
      case s[i] of
        '"': begin
              new_s:=new_s+'"';
              Inc(i);
             end;
        '#': begin
               SingleHash:=True;
               //    ##
               if i<l then
                begin
                  //   ##,        #
                  if s[i+1]='#'
                    then Inc(i);
                end;
               //    (#xxxx)
               if i<l-3 then
                begin
                  //      
                  cc:=WideChar(FromHex(Copy(s,i+1,4),err));
                  if not err then
                    begin
                      SingleHash:=False;
                      new_s:=new_s+cc;
                      Inc(i,4);
                      Result:=Result and (cc>=' ') {and ((CharInfoTable[cc] and (CHAR_IS_LETTER or CHAR_IS_ANSI))<>0)}
                    end;
                end;
               //    '#'
               if SingleHash
                then new_s:=new_s+'#';
             end;
        else new_s:=new_s+s[i];
      end;
      Inc(i);
    end;//while
end;

function UnicodeNaturalToString(const s:String):String;
var i:Integer;
    c:WideChar;
begin
  Result:='';
  for i:=1 to Length(s) do
    begin
      c:=s[i];
      case c of
        '"':  Result:=Result+'""';
        '#':  Result:=Result+'##';
        else
          begin
            if (c>=' ') and ((CharInfoTable[c] and CHAR_IS_ANSI)<>0)
              then Result:=Result+c
              else Result:=Result+'#'+IntToHex(Ord(c),4);
          end;
      end;
    end;//for
end;

function IsValidUnicodeCharCode(const s:String; var cc:WideChar):Boolean;
var l:Integer;
begin
  l:=Length(s);
  Result:=l=4;
  if Result then
    begin
      cc:=WideChar(FromHex(s,Result));
      Result:=not Result;
    end;
end;

function IsValidUnicodeString(const s:String):String;
var l,p:Integer;
    cc:WideChar;
begin
  l:=Length(s);
  if l>=2 then
    begin
      if (s[1]='"') and (s[l]='"') then
        begin
          p:=2;
          while p<l do
            begin
              case s[p] of
                '"':  begin
                        //    
                        if (s[p+1]<>'"') or (p=l-1) then
                          begin
                            Result:=_UnicodeQuotesNotPaired;
                            Break;
                          end
                        else Inc(p);
                      end;
                '#':  begin
                        //   #
                        if s[p+1]='#'
                          then Inc(p)
                          else
                            begin
                              //      -  
                              if IsValidUnicodeCharCode(Copy(s,p+1,4),cc)
                                then Inc(p,4);
                            end;
                      end;
              end;//case
              Inc(p);
            end;//while
        end//if s[1]=...
      else Result:=_UnicodeStringHasntQuotes;
    end//if l>=2
  else Result:=_UnicodeStringHasntQuotes;
end;

function IsValidFileDirName(const s:String):String;
var l,p:Integer;
    cc:WideChar;
begin
  Result:='';
  l:=Length(s);
  if l>=2 then
    begin
      if (s[1]='"') and (s[l]='"') then
        begin
          p:=2;
          while p<l do
            begin
              case s[p] of
                //       /?
                '"','*','>','<','?':
                  begin
                    Result:=_InvalidCharInFileDirName;
                    Break;
                  end;
                '#':  begin
                        //   #
                        if s[p+1]='#'
                          then Inc(p)
                          else
                            begin
                              //      -  
                              if IsValidUnicodeCharCode(Copy(s,p+1,4),cc) then
                                begin
                                  if (cc='"') or (cc='*') or (cc='>') or (cc='<') or (cc='?') then
                                    begin
                                      Result:=_InvalidCharInFileDirName;
                                      Break;
                                    end
                                  else Inc(p,4);
                                end;
                            end;
                      end;
              end;//case
              Inc(p);
            end;//while
        end//if s[1]=...
      else Result:=_UnicodeStringHasntQuotes;
    end//if l>=2
  else Result:=_UnicodeStringHasntQuotes;
end;

procedure DrawIcon24(ctrl:TImage; idx:Integer);
begin
  with ctrl.Canvas do
    begin
      Brush.Color:=clBtnFace;
      Brush.Style:=bsSolid;
      FillRect(Rect(0,0,ctrl.Width,ctrl.Height));
    end;
  Form_Main.pilSmallButtons.PngImages[idx].PngImage.Draw(ctrl.Canvas,Rect(0,0,24,24));
end;

function IsValidDWORD(const s:String; var res:Cardinal):String;
var i:Int64;
    ec:Integer;
begin
  Val(s,i,ec);
  if ec<>0
    then Result:=_NonIntegerValue
    else
      begin
        if (i<-$80000000) or (i>$FFFFFFFF)
          then Result:=_Value32TooLarge
          else
            begin
              Result:='';
              res:=i;
            end;
      end;
end;

function IsValidLabel(const s:String):String;
var i:Integer;
begin
  Result:='';
  for i:=1 to Length(s) do
    begin
      if i=1 then
        begin
          if s[i]<>'^' then
            begin
              Result:=_NoLabelPrefix;
              Break;
            end;
        end
      else
        begin
          if s[i]<=' ' then
            begin
              Result:=_InvalidCharInLabelName;
              Break;
            end;
        end;

    end;//for
end;

function IsValidINTEGER(const s:String; var res:Int64):String;
var i:Int64;
    ec:Integer;
begin
  if Length(s)>1 then
    begin
      if s[1]='%'
        then Result:=Copy(s,2,Length(s)-1)
        else Result:=s;
    end
  else Result:=s;

  Val(Result,i,ec);
  if ec<>0
    then Result:=_NonIntegerValue
    else
      begin
        Result:='';
        res:=i;
      end;
end;

function IsValidFLOAT(const s:String; var res:Extended):String;
var ec:Integer;
begin
  Result:=s;
  //   '*',   
  if Length(s)>=1
    then if s[1]='*'
           then Delete(Result,1,1);
  Val(Result,res,ec);
  if ec=0
    then Result:=''
    else Result:=_NonFloatValue;
end;

{ TfrmParam }

procedure TfrmParam.AnyButtonClicked(Sender: TObject);
begin
  UpdateFrameVisibility;
  (Owner as TCommandEditorForm).UpdateAllFramesVisibility;
end;

function TfrmParam.GetData(var err: String): String;
begin
  //   "  "
  if btnDefault.Down then
    begin
      Result:='$';
      err:='';
    end
  else
    begin
      //   "  "
      if btnParamEnd.Down then
        begin
          Result:='.';
          err:='';
        end
      else
        begin
          //   ""
          if btnVariable.Down
            then Result:=GetVariable(err)
            //   
            else
              begin
                Result:=GetValue;
                err:=IsDataValid(Result);
              end;
        end;//else
    end;//else
end;

function TfrmParam.GetValue: String;
begin
  //       
  Result:='';
end;

function TfrmParam.GetVariable(var err: String): String;
var v,ec:Integer;
    s:String;
begin
  s:=edtVariable.Text;
  Val(s,v,ec);
  if (ec=0) and (v>=0) then
    begin
      if cbLocalVar.Checked
        then Result:='@_'+s
        else Result:='@'+s;
      err:='';
    end
  else
    begin
      Result:='';
      if ec=0
        then err:=_NegativeVarIndex
        else err:=_NonIntVarIndex;
    end;
end;

procedure TfrmParam.Go(const s, DefaultValue: String; const Abilities:Integer);
var local:Boolean;
    var_idx:String;
begin
  // /     
  btnDefault.Visible:=(Abilities and 1)<>0;
  btnParamEnd.Visible:=(Abilities and 2)<>0;

  //    
  if s='$'
    then
      begin
        SetData(DefaultValue);
        btnDefault.Down:=True;
      end
    else
      begin
        //      
        if s='.'
          then
            begin
              SetData(DefaultValue);
              btnParamEnd.Down:=True;
            end
          else
            //     
            begin
              if IsGoodVariable(s,local,var_idx) then
              //   
                begin
                  edtVariable.Text:=var_idx;
                  cbLocalVar.Checked:=local;
                  SetData(DefaultValue);
                  btnVariable.Down:=True;
                end
              //    
              else
                begin
                  SetData(s);
                  btnValue.Down:=True;
                end;
            end;
      end;
  UpdateFrameVisibility;
end;

function TfrmParam.IsDataValid(const s: String): String;
begin
  //        
  Result:='';
end;

function TfrmParam.IsGoodVariable(const s: String; var Local: Boolean;
  var idx: String): Boolean;
var l,p,v,ec:Integer;
begin
  Result:=False;
  l:=Length(s);
  Local:=False;
  if l>1 then
    begin
      if s[1]='@' then
        begin
          Dec(l);
          p:=1;
          if l>1 then
            begin
              //    - '_'
              if s[2]='_' then
                begin
                  Dec(l);
                  Inc(p);
                  Local:=True
                end//if s[2]...
            end;
          idx:=Copy(s,p,l);
          Val(idx,v,ec);
          //         -   
          Result:=(ec<>0) or (v<0);
        end//if s[1]...
    end
end;

procedure TfrmParam.Prepare(const Description, DataControls: String);
begin
  //    
  with Form_Main.pilSmallButtons do
    begin
      btnValue.PngImage:=PngImages[6].PngImage;
      btnDefault.PngImage:=PngImages[7].PngImage;
      btnParamEnd.PngImage:=PngImages[8].PngImage;
      btnVariable.PngImage:=PngImages[9].PngImage;
    end;
  //      
  with lblVariable do
    begin
      Left:=8;
      Top:=44;
    end;
  with edtVariable do
    begin
      Left:=120;
      Top:=41;
    end;
  with cbLocalVar do
    begin
      Left:=176;
      Top:=42;
    end;
  lblParam.Caption:='['+IntToStr(Tag+1)+'] '+Description;
end;

//    , ..      
procedure TfrmParam.SetData(const s: String);
begin

end;

procedure TfrmParam.ShowDataControls(show: Boolean);
var i:Integer;
    c:TControl;
    dont_touch:Boolean;
begin
  //     ,    ""
  //     
  for i:=0 to ControlCount-1 do
    begin
      c:=Controls[i];
      //    ?
      dont_touch:=(c=lblVariable) or (c=edtVariable) or (c=cbLocalVar)
      //    "" ?
        or (c=lblParam) or (c=btnValue) or (c=btnDefault) or (c=btnParamEnd) or (c=btnVariable)
        or (c=bvlDelimiter);
      if not dont_touch
        then c.Visible:=show;
    end;//for
end;

procedure TfrmParam.ShowVarControls(show: Boolean);
begin
  lblVariable.Visible:=show;
  edtVariable.Visible:=show;
  cbLocalVar.Visible:=show;
end;

procedure TfrmParam.UpdateFrameVisibility;
begin
  if (btnDefault.Down) or (btnParamEnd.Down) then
    begin
      ShowVarControls(False);
      ShowDataControls(False);
    end
  else
    begin
      ShowVarControls(btnVariable.Down);
      ShowDataControls(btnValue.Down);
    end;
end;

end.
