unit PNC_ParamBinBlock;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton;

type
  TfrmParamBinBlock = class(TfrmParam)
    edtValue: TEdit;
    lblValue: TLabel;
    cbHexDump: TCheckBox;
    procedure cbHexDumpClick(Sender: TObject);
  private
    { Private declarations }
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;
  public
    { Public declarations }
    procedure StrToDump;
  end;

var
  frmParamBinBlock: TfrmParamBinBlock;

implementation

uses NC_AllVars;

{$R *.dfm}

{ TfrmParamBinBlock }

procedure TfrmParamBinBlock.cbHexDumpClick(Sender: TObject);
begin
  if cbHexDump.Checked then
    //      
    begin
      edtValue.Text:=AnsiStringToDump(AnsiString(edtValue.Text));
    end
  else
    //      
    begin
      edtValue.Text:=String(DumpToAnsiString(edtValue.Text));
    end;

end;

function TfrmParamBinBlock.GetValue: String;
begin
  if cbHexDump.Checked
    then Result:='!'+edtValue.Text+'!'
    else Result:=''''+edtValue.Text+'''';
end;

function TfrmParamBinBlock.IsDataValid(const s: String): String;
var is_dump:Boolean;
    res:AnsiString;
begin
  Result:=IsValidBinaryBlock(s,res,is_dump);
end;

procedure TfrmParamBinBlock.SetData(const s: String);
var res:AnsiString;
    is_dump:Boolean;
begin
  if IsValidBinaryBlock(s,res,is_dump)='' then
    begin
      if is_dump then
        begin
          edtValue.Text:=UnicodeString(res);
          cbHexDump.Checked:=is_dump;
        end
      else
        begin
          edtValue.Text:='';
          cbHexDump.Checked:=False;
        end;
    end;
end;

procedure TfrmParamBinBlock.StrToDump;
var s:AnsiString;
begin
  if CheckANSIString(edtValue.Text,s)
    then edtValue.Text:=AnsiStringToDump(s)
    else Application.MessageBox(PWideChar(_NonAnsiCharsInString),PWideChar(_ERROR),MB_ICONERROR)
end;

end.
