unit PNC_ParamFileAccess;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton;

type
  TfrmFileAccess = class(TfrmParam)
    cbGenericRead: TCheckBox;
    cbGenericWrite: TCheckBox;
    cbGenericExecute: TCheckBox;
    cbAllAccess: TCheckBox;
  private
    { Private declarations }
  public
    { Public declarations }
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;
  end;

var
  frmFileAccess: TfrmFileAccess;

implementation

{$R *.dfm}

{ TfrmFileAccess }

function TfrmFileAccess.GetValue: String;
var c:Cardinal;
begin
  if cbAllAccess.Checked
    then Result:='$10000000'
    else
      begin
        c:=0;
        if cbGenericRead.Checked
          then Inc(c,GENERIC_READ);
        if cbGenericWrite.Checked
          then Inc(c,GENERIC_WRITE);
        if cbGenericExecute.Checked
          then Inc(c,GENERIC_EXECUTE);
        Result:='$'+IntToHex(c,0);
      end;
end;

function TfrmFileAccess.IsDataValid(const s: String): String;
var u:Cardinal;
begin
  Result:=IsValidDWORD(s,u);
end;

procedure TfrmFileAccess.SetData(const s: String);
var v:Cardinal;
begin
  if IsValidDWORD(s,v)='' then
    begin
      cbGenericRead.Checked:=(v and GENERIC_READ)=GENERIC_READ;
      cbGenericWrite.Checked:=(v and GENERIC_WRITE)=GENERIC_WRITE;
      cbGenericExecute.Checked:=(v and GENERIC_EXECUTE)=GENERIC_EXECUTE;
      cbAllAccess.Checked:=(v and GENERIC_ALL)=GENERIC_ALL;
    end
  else
    begin
      cbGenericRead.Checked:=True;
      cbGenericWrite.Checked:=True;
    end;
end;

end.
