unit PNC_ParamFileAttr;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton;

type
  TfrmParamFileAttr = class(TfrmParam)
    cbReadOnly: TCheckBox;
    cbHidden: TCheckBox;
    cbSystem: TCheckBox;
    cbDirectory: TCheckBox;
    cbArchive: TCheckBox;
    cbEncrypted: TCheckBox;
    cbNormal: TCheckBox;
    cbDevice: TCheckBox;
    cbTemporary: TCheckBox;
    cbSparse: TCheckBox;
    cbReparsePoint: TCheckBox;
    cbCompressed: TCheckBox;
    cbOffline: TCheckBox;
    cbNotIndexed: TCheckBox;
    cbVirtual: TCheckBox;
  private
    { Private declarations }
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;
  public
    { Public declarations }
  end;

var
  frmParamFileAttr: TfrmParamFileAttr;

implementation

{$R *.dfm}


{ TfrmParamFileAttr }

function TfrmParamFileAttr.GetValue: String;
var c:Cardinal;
begin
  c:=0;
  if cbReadOnly.Checked
    then Inc(c,FILE_ATTRIBUTE_READONLY);
  if cbHidden.Checked
    then Inc(c,FILE_ATTRIBUTE_HIDDEN);
  if cbSystem.Checked
    then Inc(c,FILE_ATTRIBUTE_SYSTEM);
  if cbDirectory.Checked
    then Inc(c,FILE_ATTRIBUTE_DIRECTORY);
  if cbArchive.Checked
    then Inc(c,FILE_ATTRIBUTE_ARCHIVE);
  if cbDevice.Checked
    then Inc(c,FILE_ATTRIBUTE_DEVICE);
  if cbNormal.Checked
    then Inc(c,FILE_ATTRIBUTE_NORMAL);
  if cbTemporary.Checked
    then Inc(c,FILE_ATTRIBUTE_TEMPORARY);
  if cbSparse.Checked
    then Inc(c,FILE_ATTRIBUTE_SPARSE_FILE);
  if cbReparsePoint.Checked
    then Inc(c,FILE_ATTRIBUTE_REPARSE_POINT);
  if cbCompressed.Checked
    then Inc(c,FILE_ATTRIBUTE_COMPRESSED);
  if cbOffline.Checked
    then Inc(c,FILE_ATTRIBUTE_OFFLINE);
  if cbNotIndexed.Checked
    then Inc(c,FILE_ATTRIBUTE_NOT_CONTENT_INDEXED);
  if cbEncrypted.Checked
    then Inc(c,FILE_ATTRIBUTE_ENCRYPTED);
  if cbVirtual.Checked
    then Inc(c,FILE_ATTRIBUTE_VIRTUAL);

  Result:='$'+IntToHex(c,0);
end;

function TfrmParamFileAttr.IsDataValid(const s: String): String;
var v:Cardinal;
begin
  Result:=IsValidDWORD(s,v);
end;

procedure TfrmParamFileAttr.SetData(const s: String);
var v:Cardinal;
begin
  //   ,    
  if IsValidDWORD(s,v)<>''
    then v:=$80;
  //  
  cbReadOnly.Checked:=(v and FILE_ATTRIBUTE_READONLY)<>0;
  cbHidden.Checked:=(v and FILE_ATTRIBUTE_HIDDEN)<>0;
  cbSystem.Checked:=(v and FILE_ATTRIBUTE_SYSTEM)<>0;
  cbDirectory.Checked:=(v and FILE_ATTRIBUTE_DIRECTORY)<>0;
  cbArchive.Checked:=(v and FILE_ATTRIBUTE_ARCHIVE)<>0;
  cbDevice.Checked:=(v and FILE_ATTRIBUTE_DEVICE)<>0;
  cbNormal.Checked:=(v and FILE_ATTRIBUTE_NORMAL)<>0;
  cbTemporary.Checked:=(v and FILE_ATTRIBUTE_TEMPORARY)<>0;
  cbSparse.Checked:=(v and FILE_ATTRIBUTE_SPARSE_FILE)<>0;
  cbReparsePoint.Checked:=(v and FILE_ATTRIBUTE_REPARSE_POINT)<>0;
  cbCompressed.Checked:=(v and FILE_ATTRIBUTE_COMPRESSED)<>0;
  cbOffline.Checked:=(v and FILE_ATTRIBUTE_OFFLINE)<>0;
  cbNotIndexed.Checked:=(v and FILE_ATTRIBUTE_NOT_CONTENT_INDEXED)<>0;
  cbEncrypted.Checked:=(v and FILE_ATTRIBUTE_ENCRYPTED)<>0;
  cbVirtual.Checked:=(v and FILE_ATTRIBUTE_VIRTUAL)<>0;
end;

end.
