unit PNC_ParamFileName;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton;

type
  TfrmParamFileName = class(TfrmParam)
    lblValue: TLabel;
    cbFileNameOnly: TCheckBox;
    odFileName: TOpenDialog;
    edtValue: TButtonedEdit;
    procedure btnChooseDirClick(Sender: TObject);
    procedure cbFileNameOnlyClick(Sender: TObject);
  private
    { Private declarations }
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;
  public
    { Public declarations }
    procedure Prepare(const Description,DataControls:String);override;
  end;

var
  frmParamFileName: TfrmParamFileName;

implementation

uses NC_Main;

{$R *.dfm}

{ TfrmParam1 }

procedure TfrmParamFileName.btnChooseDirClick(Sender: TObject);
begin
  if odFilename.Execute then
    begin
      if cbFileNameOnly.Checked
        then edtValue.Text:=ExtractFileName(odFileName.FileName)
        else edtValue.Text:=odFileName.FileName;
    end;
end;

procedure TfrmParamFileName.cbFileNameOnlyClick(Sender: TObject);
begin
  if cbFileNameOnly.Checked
    then edtValue.Text:=ExtractFileName(edtValue.Text);
end;

function TfrmParamFileName.GetValue: String;
begin
  Result:='"'+edtValue.Text+'"';
end;

function TfrmParamFileName.IsDataValid(const s: String): String;
begin
  Result:=IsValidFileDirName(s);
end;

procedure TfrmParamFileName.Prepare(const Description, DataControls: String);
begin
  inherited;
  odFileName.Filter:=DataControls;
end;

procedure TfrmParamFileName.SetData(const s: String);
begin
  edtValue.Text:=Copy(s,2,Length(s)-2);
end;

end.
