unit PNC_ParamFileSharing;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton;

type
  TfrmParamFileSharing = class(TfrmParam)
    rbNoSharing: TRadioButton;
    rbShareFile: TRadioButton;
    cbShareRead: TCheckBox;
    cbShareWrite: TCheckBox;
    cbShareDelete: TCheckBox;
    procedure UpdateFrame(Sender: TObject);
  private
    { Private declarations }
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;
  public
    { Public declarations }
  end;

var
  frmParamFileSharing: TfrmParamFileSharing;

implementation

uses NC_AllVars;

{$R *.dfm}

{ TfrmParamFileSharing }

function TfrmParamFileSharing.GetValue: String;
var i:Integer;
begin
  if rbNoSharing.Checked
    then Result:='0'
    else
      begin
        i:=0;
        if cbShareRead.Checked
          then Inc(i);
        if cbShareWrite.Checked
          then Inc(i,2);
        if cbShareDelete.Checked
          then Inc(i,4);
        Result:=IntToStr(i);
      end;
end;

function TfrmParamFileSharing.IsDataValid(const s: String): String;
var v:Cardinal;
begin
  Result:=IsValidDWORD(s,v);
  if v>7
    then Result:=_InvalidFileSharing;
end;

procedure TfrmParamFileSharing.SetData(const s: String);
var v:cardinal;
begin
  if IsValidDWORD(s,v)<>''
    then v:=0;
  if v=0
    then rbNoSharing.Checked:=True
    else
      begin
        rbShareFile.Checked:=True;
        cbShareRead.Checked:=(v and 1)<>0;
        cbShareWrite.Checked:=(v and 2)<>0;
        cbShareDelete.Checked:=(v and 4)<>0;
      end;
end;

procedure TfrmParamFileSharing.UpdateFrame(Sender: TObject);
var b:Boolean;
begin
  b:=rbShareFile.Checked;
  cbShareRead.Enabled:=b;
  cbShareWrite.Enabled:=b;
  cbShareDelete.Enabled:=b;
end;

end.
