unit PNC_ParamMBox;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton, PngBitBtn;

type
  TfrmParamMBox = class(TfrmParam)
    gbButtonSet: TRadioGroup;
    cbHelp: TCheckBox;
    lblDefaultButton: TLabel;
    cbDefaultButton: TComboBox;
    lblModality: TLabel;
    cbModality: TComboBox;
    cbDEFAULT_DESKTOP_ONLY: TCheckBox;
    cbRIGHT: TCheckBox;
    cbRTLREADING: TCheckBox;
    cbSETFOREGROUND: TCheckBox;
    cbTOPMOST: TCheckBox;
    cbSERVICE_NOTIFICATION: TCheckBox;
    rbNoIcon: TRadioButton;
    imgICONERROR: TImage;
    rbICONERROR: TRadioButton;
    imgICONQUESTION: TImage;
    rbICONQUESTION: TRadioButton;
    imgICONWARNING: TImage;
    rbICONWARNING: TRadioButton;
    imgICONINFORMATION: TImage;
    rbICONINFORMATION: TRadioButton;
    btnTestMBox: TPngBitBtn;
    procedure btnTestMBoxClick(Sender: TObject);
  private
    { Private declarations }
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;
  public
    { Public declarations }
    function GetDataAsCardinal:Cardinal;
    procedure SetDataAsCardinal(d:Cardinal);

    procedure Prepare(const Description,DataControls:String);override;
  end;

var
  frmParamMBox: TfrmParamMBox;

implementation

uses NC_AllVars, NC_Main;

{$R *.dfm}

const mbox_buttons:array[0..7] of Cardinal=(0,1,4,3,5,2,6,0); //  0 -    

{ TfrmParamMBox }

procedure TfrmParamMBox.btnTestMBoxClick(Sender: TObject);
var i:Cardinal;
begin
  i:=GetDataAsCardinal;
  MessageBoxW((Owner as TForm).Handle,PWideChar('   .'#13#10'  : $'+IntToHex(i,0)),'',i);
end;

function TfrmParamMBox.GetDataAsCardinal: Cardinal;
begin
  Result:=0;
  //  
  if rbICONERROR.Checked
    then Inc(Result,MB_ICONERROR);
  if rbICONQUESTION.Checked
    then Inc(Result,MB_ICONQUESTION);
  if rbICONWARNING.Checked
    then Inc(Result,MB_ICONWARNING);
  if rbICONINFORMATION.Checked
    then Inc(Result,MB_ICONINFORMATION);
  //  
  if gbButtonSet.ItemIndex>=0
    then Inc(Result,mbox_buttons[gbButtonSet.ItemIndex]);
  //    
  if cbDefaultButton.ItemIndex>=0
    then Inc(Result,cbDefaultButton.ItemIndex shl 8);
  //  
  if cbModality.ItemIndex>=0
    then Inc(Result,cbModality.ItemIndex shl 12);
  //   
  if cbDEFAULT_DESKTOP_ONLY.Checked
    then Inc(Result,MB_DEFAULT_DESKTOP_ONLY);
  if cbRIGHT.Checked
    then Inc(Result,MB_RIGHT);
  if cbRTLREADING.Checked
    then Inc(Result,MB_RTLREADING);
  if cbSETFOREGROUND.Checked
    then Inc(Result,MB_SETFOREGROUND);
  if cbTOPMOST.Checked
    then Inc(Result,MB_TOPMOST);
  if cbSERVICE_NOTIFICATION.Checked
    then Inc(Result,MB_SERVICE_NOTIFICATION);
  if cbHelp.Checked
    then Inc(Result,MB_HELP);
end;

function TfrmParamMBox.GetValue: String;
begin
  Result:='$'+IntToHex(GetDataAsCardinal,0);
end;

function TfrmParamMBox.IsDataValid(const s: String): String;
var u:Cardinal;
begin
  Result:=IsValidDWORD(s,u);
  if (Result='') then
    begin
      if ((u and 7)=7) or ((u and $70)>$40) or ((u and $3000)=$3000)
        then Result:=_InvalidMBoxFlags;
    end;
end;

procedure TfrmParamMBox.Prepare(const Description, DataControls: String);
begin
  inherited;
  btnTestMBox.PngImage:=Form_Main.pilBigButtons.PngImages[10].PngImage;
  //  
  DrawIcon24(imgICONERROR,10);
  DrawIcon24(imgICONQUESTION,11);
  DrawIcon24(imgICONWARNING,12);
  DrawIcon24(imgICONINFORMATION,13);
end;

procedure TfrmParamMBox.SetData(const s: String);
var inp:Cardinal;
    i:Integer;
begin
  Val(s,inp,i);
  //    -  ,    
  if i<>0
    then inp:=0;
  SetDataAsCardinal(inp)
end;

procedure TfrmParamMBox.SetDataAsCardinal(d: Cardinal);
var c:Cardinal;
    i:Integer;
begin
  //  
  c:=d and 7;
  for i:=Low(mbox_buttons) to High(mbox_buttons)
    do if c=mbox_buttons[i] then
        begin
          c:=i;
          Break;
        end;//if
  gbButtonSet.ItemIndex:=c;
  //  
  case (d and $70) of
    $10:  rbICONERROR.Checked:=True;
    $20:  rbICONQUESTION.Checked:=True;
    $30:  rbICONWARNING.Checked:=True;
    $40:  rbICONINFORMATION.Checked:=True;
    else  rbNoIcon.Checked:=True;
  end;
  //    
  cbDefaultButton.ItemIndex:=(d and $300) shr 8;
  //  
  c:=(d and $3000) shr 12;
  if c=3
    then c:=0;
  cbModality.ItemIndex:=c;
  //   
  cbDEFAULT_DESKTOP_ONLY.Checked:=(d and MB_DEFAULT_DESKTOP_ONLY)<>0;
  cbRIGHT.Checked:=(d and MB_RIGHT)<>0;
  cbRTLREADING.Checked:=(d and MB_RTLREADING)<>0;
  cbSETFOREGROUND.Checked:=(d and MB_SETFOREGROUND)<>0;
  cbTOPMOST.Checked:=(d and MB_TOPMOST)<>0;
  cbSERVICE_NOTIFICATION.Checked:=(d and MB_SERVICE_NOTIFICATION)<>0;
  cbHelp.Checked:=(d and MB_HELP)<>0;
end;

end.
