unit PNC_ParamMSec;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton;

type
  TfrmParamMSec = class(TfrmParam)
    Label1: TLabel;
    edtHr: TEdit;
    edtMn: TEdit;
    Label2: TLabel;
    edtSc: TEdit;
    Label3: TLabel;
    edtMs: TEdit;
    Label4: TLabel;
  private
    { Private declarations }
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;
  public
    { Public declarations }
  end;

var
  frmParamMSec: TfrmParamMSec;

implementation

{$R *.dfm}

const _INVALID_='-!-';

{ TfrmParamMSec }

function TfrmParamMSec.GetValue: String;
var res,v:Cardinal;
    ec:Integer;
begin
  res:=0;
  // 
  if edtMs.Text<>'' then
    begin
      Val(edtMs.Text,v,ec);
      if ec<>0 then
        begin
          Result:=_INVALID_;
          Exit;
        end
      else Inc(res,v);
    end;
  // 
  if edtSc.Text<>'' then
    begin
      Val(edtSc.Text,v,ec);
      if ec<>0 then
        begin
          Result:=_INVALID_;
          Exit;
        end
      else Inc(res,v*1000);
    end;
  // 
  if edtMn.Text<>'' then
    begin
      Val(edtMn.Text,v,ec);
      if ec<>0 then
        begin
          Result:=_INVALID_;
          Exit;
        end
      else Inc(res,v*60000);
    end;
  // 
  if edtHr.Text<>'' then
    begin
      Val(edtHr.Text,v,ec);
      if ec<>0 then
        begin
          Result:=_INVALID_;
          Exit;
        end
      else Inc(res,v*3600000);
    end;
  Result:=IntToStr(res);
end;

function TfrmParamMSec.IsDataValid(const s: String): String;
var v:Cardinal;
begin
  Result:=IsValidDWORD(s,v);
end;

procedure TfrmParamMSec.SetData(const s: String);
var v,v2:Cardinal;
begin
  if IsValidDWORD(s,v)<>''
    then v:=0;
  // 
  v2:=v div 3600000;
  if v2=0
    then edtHr.Text:=''
    else edtHr.Text:=IntToStr(v2);
  v:=v mod 3600000;

  // 
  v2:=v div 60000;
  if v2=0
    then edtMn.Text:=''
    else edtMn.Text:=IntToStr(v2);
  v:=v mod 60000;

  // 
  v2:=v div 1000;
  edtSc.Text:=IntToStr(v2);
  v:=v mod 1000;

  // 
  if v=0
    then edtMs.Text:=''
    else edtMs.Text:=IntToStr(v);
end;

end.
