unit PNC_ParamString;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton;

type
  TfrmParamString = class(TfrmParam)
    lblValue: TLabel;
    edtValue: TEdit;
    cbNaturalStrings: TCheckBox;
    procedure cbNaturalStringsClick(Sender: TObject);
  private
    { Private declarations }
    InUpdate:Boolean; //  "  "
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;
  public
    { Public declarations }
  end;

var
  frmParamString: TfrmParamString;

implementation

uses NC_AllVars;

{$R *.dfm}

{ TfrmParamString }

procedure TfrmParamString.cbNaturalStringsClick(Sender: TObject);
var new_s:String;
begin
  //       
  if not InUpdate then
    begin
      if (Sender as TCheckBox).Checked then
        //     
        begin
          if UnicodeStringToNatural(edtValue.Text,new_s)
            then edtValue.Text:=new_s
            else
              begin
                //     
                Application.MessageBox(PWideChar(_SwitchToNaturalModeImpossible),PWideChar(_ERROR),MB_ICONERROR);
                InUpdate:=True;
                (Sender as TCheckBox).Checked:=False;
                InUpdate:=False;
              end;
        end
      //       NeoS0M
      else edtValue.Text:=UnicodeNaturalToString(edtValue.Text);
    end;
end;

function TfrmParamString.GetValue: String;
begin
  if cbNaturalStrings.Checked
    then Result:='"'+UnicodeNaturalToString(edtValue.Text)+'"'
    else Result:='"'+edtValue.Text+'"';
end;

function TfrmParamString.IsDataValid(const s: String): String;
begin
  Result:=IsValidUnicodeString(s);
end;

procedure TfrmParamString.SetData(const s: String);
var nvs:String;
begin
  if UnicodeStringToNatural(Copy(s,2,Length(s)-2),nvs) then
    begin
      InUpdate:=True;
      edtValue.Text:=nvs;
      InUpdate:=False;
    end
  else edtValue.Text:=Copy(s,2,Length(s)-2);
end;

end.
