unit PNC_ParamTimeDate;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PNC_Param, StdCtrls, ExtCtrls, Buttons, PngSpeedButton, PngBitBtn,
  ComCtrls;

type
  TfrmParamTimeDate = class(TfrmParam)
    dtpDate: TDateTimePicker;
    Label1: TLabel;
    Label2: TLabel;
    edtHours: TEdit;
    edtMinutes: TEdit;
    edtSeconds: TEdit;
    edtMsecs: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    c: TLabel;
    Label5: TLabel;
    btnCurrent: TPngBitBtn;
    procedure btnCurrentClick(Sender: TObject);
  private
    { Private declarations }
    procedure SetCurrentTime;
  protected
    //    ,     
    procedure SetData(const s:String);override;
    //   ,      ,  
    function IsDataValid(const s:String):String;override;
    //  ,   
    function GetValue:String;override;

  public
    { Public declarations }
    procedure Prepare(const Description,DataControls:String);override;
  end;

var
  frmParamTimeDate: TfrmParamTimeDate;

implementation

uses NC_Main;

{$R *.dfm}

procedure TfrmParamTimeDate.btnCurrentClick(Sender: TObject);
begin
  SetCurrentTime;
end;

function TfrmParamTimeDate.GetValue: String;
var y,m,d:Word;
begin
  DecodeDate(dtpDate.Date,y,m,d);
  Result:=MakeDateTime(IntToStr(y),IntToStr(m),IntToStr(d),edtHours.Text,edtMinutes.Text,edtSeconds.Text,edtMsecs.Text);
end;

function TfrmParamTimeDate.IsDataValid(const s: String): String;
var res:Int64;
begin
  Result:=IsValidDateTime(s,res);
end;

procedure TfrmParamTimeDate.Prepare(const Description, DataControls: String);
begin
  inherited;
  btnCurrent.PngImage:=Form_Main.pilBigButtons.PngImages[11].PngImage;
end;

procedure TfrmParamTimeDate.SetCurrentTime;
var st:_SYSTEMTIME;
begin
  GetLocalTime(st);
  dtpDate.Date:=EncodeDate(st.wYear,st.wMonth,st.wDay);
  edtHours.Text:=Format('%2.2d',[st.wHour]);
  edtMinutes.Text:=Format('%2.2d',[st.wMinute]);
  edtSeconds.Text:=Format('%2.2d',[st.wSecond]);
  edtMsecs.Text:=Format('%3.3d',[st.wMilliseconds]);
end;

procedure TfrmParamTimeDate.SetData(const s: String);
var i64:Int64;
    st:_SYSTEMTIME;
begin
  //    (        )   
  if s=''
    then SetCurrentTime
    else
      begin
        if IsValidDateTime(s,i64)='' then
          begin
            FileTimeToSystemTime(FILETIME(i64),st);
            dtpDate.Date:=EncodeDate(st.wYear,st.wMonth,st.wDay);
            edtHours.Text:=Format('%2.2d',[st.wHour]);
            edtMinutes.Text:=Format('%2.2d',[st.wMinute]);
            edtSeconds.Text:=Format('%2.2d',[st.wSecond]);
            edtMsecs.Text:=Format('%3.3d',[st.wMilliseconds]);
          end
          else SetCurrentTime;
      end;
end;

end.
