unit NeoS0M_BB;

interface

uses Windows, NeoS0M_Types, NeoS0M_UnifiedArray;

const EmptyBinaryBlock:array [1..18] of Byte=
// . TArrayHeader
      (1,0,0,0, //  
       2,0,0,0, //  
       2,0,0,0, //   
       0,0,0,0, //  IsDynamis=False
       0,0 //  ,   + 2  
       );

const SpaceBinaryBlock:array [1..19] of Byte=
// . TArrayHeader
      (1,0,0,0, //  
       3,0,0,0, //  
       3,0,0,0, //   
       0,0,0,0, //  IsDynamis=False
       32,0,0 //  :  + 2  
       );

//     ;       
function BB_Allocate(BB_Len:Integer):PUA_BinaryBlock;
//    . Size -    
procedure BB_Resize(var bb:PUA_BinaryBlock; new_size:Cardinal);
//     (  )
function BB_Length(const bb:PUA_BinaryBlock):Cardinal;inline;
//       ,    val_start
function BB_From_Bytes(val_start:Pointer; val_len:Integer):PUA_BinaryBlock;
//     (   /)
function BB_Duplicate(bb:PUA_BinaryBlock):PUA_BinaryBlock;


implementation

function BB_Allocate(BB_Len:Integer):PUA_BinaryBlock;
begin
  if BB_Len=0
    then Result:=@EmptyBinaryBlock
    else
      begin
        Result:=PUA_BinaryBlock(UA_CreateR(BB_Len+2,1));
        with Result^ do
        begin
          Arr[BB_Len]:=0;
          Arr[BB_Len+1]:=0;
        end;//with
      end;
end;

function BB_From_Bytes(val_start:Pointer; val_len:Integer):PUA_BinaryBlock;
begin
  Result:=BB_Allocate(val_len);
  if (Result<>nil) and (val_len<>0)
    then Move(val_start^,Result.Arr,val_len);
end;


procedure BB_Resize(var bb:PUA_BinaryBlock; new_size:Cardinal);
begin
 UA_Resize(PArrayHeader(bb),new_size+2);
 with bb^ do
  begin
   Arr[new_size]:=0;
   Arr[new_size+1]:=0;
  end;
end;

function BB_Length(const bb:PUA_BinaryBlock):Cardinal;inline;
begin
  if Assigned(bb)
    then Result:=bb^.Header.ElemCount-2
    else Result:=0;
end;

function BB_Duplicate(bb:PUA_BinaryBlock):PUA_BinaryBlock;
var l:Cardinal;
begin
  if bb^.Header.IsDynamic then
    //   
    begin
      l:=bb^.Header.ElemCount-2;
      if l=0 //   , ..    0
        then Result:=@EmptyBinaryBlock
        else
          begin
            //  
            Result:=BB_Allocate(l);
            //     (    BB_Allocate)
            Move(bb^.Arr[0],Result^.Arr[0],l);
          end;
    end//if
  //    ,    ,   
  else Result:=bb;
end;


end.
