unit NeoS0M_BBL;

interface
uses NeoS0M_Types, NeoS0M_UnifiedArray, NeoS0M_xL, NeoS0M_BB;

//   Binary Block List
function BBL_Create:PUA_BinBlockList;inline;
procedure BBL_Destroy(var bbl:PUA_BinBlockList);inline;
function BBL_Add(var bbl:PUA_BinBlockList; val_start:Pointer; val_len:Cardinal):Integer;
function BBL_Append(var arr:PUA_BinBlockList; value:PUA_BinaryBlock; count:Cardinal):Integer;
function BBL_Find(const bbl:PUA_BinBlockList; const value:PUA_BinaryBlock; _From,_To:Cardinal; Comparsion:TStringComparsionMethod):Cardinal;

implementation

uses NeoS0M_Math, NeoS0M_Common;

function BBL_Create:PUA_BinBlockList;inline;
begin
  Result:=PUA_BinBlockList(xL_Create);
end;

procedure BBL_Destroy(var bbl:PUA_BinBlockList);inline;
begin
  xL_Destroy(PUA_xList(bbl));
end;

function BBL_Add(var bbl:PUA_BinBlockList; val_start:Pointer; val_len:Cardinal):Integer;
var bb:PUA_BinaryBlock;
begin
 //   ,   
  if val_len=0
    then bb:=@EmptyBinaryBlock
    else bb:=BB_From_Bytes(val_start,val_len);
 //        -   
 if bb=nil
    then Result:=CMD_OUT_OF_MEMORY
    //  -        
    else Result:=xL_Add(PUA_xList(bbl),PArrayHeader(bb));
end;

function BBL_Append(var arr:PUA_BinBlockList; value:PUA_BinaryBlock; count:Cardinal):Integer;
var p:^PUA_BinaryBlock;
begin
  Result:=0;
  if arr=nil
    then arr:=PUA_BinBlockList(UA_CreateR(count,SizeOf(PUA_BinaryBlock)))
    else UA_Resize(PArrayHeader(arr),arr^.Header.ElemCount+count);
  if count<>0 then
    begin
      if arr=nil
        then Result:=CMD_OUT_OF_MEMORY
        else
          begin
            with arr^
              do p:=@Arr[Header.ElemCount-1];
            repeat
              //     ,   
              p^:=BB_Duplicate(value);
              Dec(count);
              Dec(p);
            until count=0;
        end;//else
    end;//if count<>0
end;

function BBL_Find(const bbl:PUA_BinBlockList; const value:PUA_BinaryBlock; _From,_To:Cardinal; Comparsion:TStringComparsionMethod):Cardinal;
var i,l:Cardinal;
    p1,p2:PAnsiChar;
    l1,l2:Cardinal;
    Found:Boolean;
begin
  Result:=$FFFFFFFF;
  l:=xL_Length(PUA_xList(bbl));
  //         
  _To:=Min(_To,l-1);
  //          -   
  if (_From<=_To) and (l<>0) then
    begin
      //      
      p1:=@value.Arr;
      l1:=BB_Length(value);
      for i:=_From to _To do
        begin
          //        
          p2:=@bbl.Arr[i]^.Arr;
          l2:=BB_Length(bbl.Arr[i]);
          case Comparsion of
            scmTrueEquality:      Found:=_StrBBComp(p1,l1,p2,l2,False)=0;
            scmEqualityWOCase:    Found:=_StrBBComp(p1,l1,p2,l2,True)=0;
            scmTrueIsSubstring:   Found:=_StrPosEx(p1,l1,p2,l2,0,False)<>-1;
            scmIsSubstringWOCase: Found:=_StrPosEx(p1,l1,p2,l2,0,True)<>-1;
            else Found:=False;
          end;//case
          if Found then
            begin
              Result:=i;
              Break;
            end;//if Found
        end;//for
    end;//if
end;

end.
