unit NeoS0M_BinParser;

interface

uses NeoS0M_Types,NeoS0M_BBL,NeoS0M_xL,NeoS0M_BB,NeoS0M_UnifiedArray;

function ParseDelimitedBB(var bbl:PUA_BinBlockList; s,Delim:PUA_BinaryBlock; AddEmptyLines:Boolean):Integer;
function ParseQuotedBB(var bbl:PUA_BinBlockList; s,Quote:PUA_BinaryBlock; AddEmptyLines:Boolean):Integer;
function ParseDandQBB(var bbl:PUA_BinBlockList; s,Delim,Quote:PUA_BinaryBlock; AddEmptyLines:Boolean):Integer;

implementation

uses NeoS0M_Common;

type TArrayOfByte=packed array [0..$FFFFFF] of Byte;
     PArrayOfByte=^TArrayOfByte;

function ParseDelimitedBB(var bbl:PUA_BinBlockList; s,Delim:PUA_BinaryBlock; AddEmptyLines:Boolean):Integer;
var s_start,delim_start:PAnsiChar;
    s_len,delim_len,cur_pos,delim_pos,add_len:Cardinal;
begin
  with s^ do
  begin
    s_start:=@Arr;
    s_len:=Header.ElemCount-2;
  end;//with
  with Delim^ do
  begin
    delim_start:=@Arr;
    delim_len:=Header.ElemCount-2;
  end;//with
  //   ,      
  bbl:=BBL_Create;
  if bbl=nil then Result:=CMD_OUT_OF_MEMORY
   else
   begin
    cur_pos:=0;
    repeat
      //   -
      delim_pos:=_StrPosEx(delim_start,delim_len,s_start,s_len,cur_pos,False);
      if delim_pos=$FFFFFFFF
       then add_len:=s_len-cur_pos
       else add_len:=delim_pos-cur_pos;
      if AddEmptyLines or (add_len>0) //     
       then Result:=BBL_Add(bbl,Pointer(Cardinal(s_start)+cur_pos),add_len)
       else Result:=CMD_OK;
      //       + 
      cur_pos:=delim_pos+delim_len;
    until (delim_pos=$FFFFFFFF) or (Result<>CMD_OK);
   end;//else
end;

function CountDupes(s:PArrayOfByte; s_len:Cardinal; dup:PArrayOfByte; dup_len:Cardinal; start_pos:Cardinal):Cardinal;
var pos_in_dup:Cardinal;
begin
  Result:=0;
  pos_in_dup:=0;
  while start_pos<s_len do
  begin
   if s^[start_pos]<>dup^[pos_in_dup] then Break;
   Inc(start_pos);
   if pos_in_dup=dup_len-1
    then begin pos_in_dup:=0; Inc(Result); end
    else Inc(pos_in_dup);
  end;//while
end;

function FindOddQuotes(s:PArrayOfByte; s_len:Cardinal; dup:PArrayOfByte; dup_len:Cardinal; start_pos:Cardinal; var position,last_count:Cardinal):Cardinal;
//   ;   -  position
var tmp_pos:Cardinal;
begin
 Result:=0; position:=0;
 tmp_pos:=start_pos;
 repeat
  //     
  tmp_pos:=_StrPosEx(PAnsiChar(dup),dup_len,PAnsiChar(s),s_len,tmp_pos,False);
  if tmp_pos<>$FFFFFFFF then //   
   begin
    //      
    last_count:=CountDupes(s,s_len,dup,dup_len,tmp_pos+dup_len)+1;
    //       
    Inc(Result,last_count);
    //       
    if Odd(last_count) then begin position:=tmp_pos; Break; end;
    Inc(tmp_pos,last_count*dup_len); //       
   end;
 until tmp_pos=$FFFFFFFF;
end;

function MakeDequotedBinBlock(s:PArrayOfByte;s_len:Cardinal;quote:PArrayOfByte;quote_len,quote_count:Cardinal):PUA_BinaryBlock;
var j,cur_pos,pos_in_new,q_count:Cardinal;
begin
 Result:=BB_Allocate(s_len-(quote_count shr 1)*quote_len);
 cur_pos:=0;pos_in_new:=0;
with Result^ do
begin
 while cur_pos<s_len do
  begin
   q_count:=CountDupes(s,s_len,quote,quote_len,cur_pos);
   if q_count=0 //   
    then begin Arr[pos_in_new]:=s^[cur_pos]; Inc(cur_pos); Inc(pos_in_new); end
    else //  
     begin
      //   2   , ..  
      q_count:=q_count shr 1;
      for j:=0 to q_count*quote_len-1
       do Arr[pos_in_new+j]:=s^[cur_pos+j];
      Inc(cur_pos,(q_count+q_count)*quote_len);
      Inc(pos_in_new,q_count*quote_len);
     end;
  end;//while
end;//with
end;

function CountOddBlocks(s:PArrayOfByte;q:PArrayOfByte;q_len:Cardinal;_start,_end:Cardinal):Integer;
//      
// start -  , end -  
var s_p,q_c:Cardinal;
begin
  Result:=0;
  s_p:=_start;
  Inc(_end);
  repeat
   //      
   s_p:=_StrPosEx(PAnsiChar(q),q_len,PAnsiChar(s),_end,s_p,False);
   if s_p<>$FFFFFFFF
    then begin
          //    ,   
          q_c:=CountDupes(s,_end,q,q_len,s_p+q_len);
          //   .     - ,
          //      1
          if not Odd(q_c) then Inc(Result);
          //        
          Inc(s_p,(q_c+1)*q_len);
         end;
  // ,         
  until (s_p=$FFFFFFFF) or (s_p>=_end);
end;

function ParseQuotedBB(var bbl:PUA_BinBlockList; s,Quote:PUA_BinaryBlock; AddEmptyLines:Boolean):Integer;
var _s,_quote:PArrayOfByte;
    _s_len,_quote_len,sq_count,eq_count,word_start,word_end,lc:Cardinal;
    _ln:PUA_BinaryBlock;
begin
 bbl:=BBL_Create;
 if bbl=nil then Result:=CMD_OUT_OF_MEMORY
 else
  begin
   Result:=CMD_OK;
   _s:=@s^.Arr;_s_len:=s^.Header.ElemCount-2;
   with Quote^ do
    begin _quote:=@Arr;_quote_len:=Header.ElemCount-2; end;
   word_start:=0;
   repeat
    //   
    sq_count:=FindOddQuotes(_s,_s_len,_quote,_quote_len,word_start,word_start,lc);
    eq_count:=0;
    if Odd(sq_count) then //      
      begin
       //   
       sq_count:=lc;
       eq_count:=FindOddQuotes(_s,_s_len,_quote,_quote_len,word_start+sq_count*_quote_len,word_end,lc);
       if Odd(eq_count) then //      -        
        begin
         Inc(word_end,(lc-1)*_quote_len); //   -       
         Inc(word_start,_quote_len); //   
         _ln:=MakeDequotedBinBlock(@_s[word_start],word_end-word_start,_quote,_quote_len,sq_count+eq_count-2);
         Result:=xL_Add(PUA_xList(bbl),PArrayHeader(_ln));
         //    .  -    () ,    
         word_start:=word_end+_quote_len;
        end;
      end//if Odd(sq_count)
   until (not Odd(sq_count)) or (not Odd(eq_count));
  end;//else
end;

{$WARNINGS OFF}
function ParseDandQBB(var bbl:PUA_BinBlockList; s,Delim,Quote:PUA_BinaryBlock; AddEmptyLines:Boolean):Integer;
label NoOddBlocks;
var _s,_quote,_delim:PArrayOfByte;
    _s_len,_quote_len,_delim_len,sq_count,word_start,word_end,space_pos:Cardinal;
    OddBlocks,b_s_pos:Cardinal;
begin
 bbl:=BBL_Create;
 if bbl=nil
  then Result:=CMD_OUT_OF_MEMORY
 else
  begin
   Result:=CMD_OK;
   with s^ do begin _s:=@Arr;_s_len:=Header.ElemCount-2; end;
   with Delim^ do begin _delim:=@Arr;_delim_len:=Header.ElemCount-2; end;
   with Quote^ do begin _quote:=@Arr;_quote_len:=Header.ElemCount-2; end;
   word_start:=0;
   repeat
    OddBlocks:=0;
    sq_count:=CountDupes(_s,_s_len,_delim,_delim_len,word_start);
    Inc(word_start,sq_count*_delim_len); //          
    b_s_pos:=word_start; //      
NoOddBlocks:
    //   -    (..   )
    space_pos:=_StrPosEx(PAnsiChar(_delim),_delim_len,PAnsiChar(_s),_s_len,b_s_pos,False);
    if space_pos=$FFFFFFFF //     
     then word_end:=_s_len-1 // ,     -    
    else //  
      begin
        //       
        Inc(OddBlocks,CountOddBlocks(_s,_quote,_quote_len,b_s_pos,space_pos-1));
        if Odd(OddBlocks) then //    .   - 
          begin
            //  ,       
            b_s_pos:=space_pos+_delim_len;
            goto NoOddBlocks;
          end
        else word_end:=space_pos-1; //    -     
      end;

    if (word_end>=word_start) and (word_end<>$FFFFFFFF) //      0
      then BBL_Add(bbl,@_s[word_start],word_end-word_start+1);
    word_start:=word_end+1;
   until word_start>=_s_len;
  end;
end;
{$WARNINGS ON}

end.
