unit NeoS0M_Common;

interface
uses Windows;

type TOpenThreadFunction=function (fdwAccess: DWord; fInherit: LongBool;dwThreadId: DWord):THandle;stdcall;
     TLookupPrivilegeValue=function(lpSystemName,lpName:PAnsiChar;var lpLuid: TLargeInteger):BOOL;stdcall;
     TOpenProcessToken=function(ProcessHandle:THandle; DesiredAccess:Cardinal;var TokenHandle:THandle):BOOL;stdcall;
     TAdjustTokenPrivileges=function(TokenHandle: THandle; DisableAllPrivileges: BOOL; const NewState: TTokenPrivileges; BufferLength: DWORD; PreviousState: PTokenPrivileges; ReturnLength: PDWORD): BOOL; stdcall;

var OSVersion:_OSVERSIONINFOW;
    SystemInfo:_SYSTEM_INFO;

    TimeChangePrivilege:Boolean=False;
    ShutdownPrivilege:Boolean=False;

    LookupPrivilegeValuePtr:TLookupPrivilegeValue=nil;
    OpenProcessTokenPtr:TOpenProcessToken=nil;
    AdjustTokenPrivilegesPtr:TAdjustTokenPrivileges=nil;

    Kernel32Handle,User32Handle:Cardinal;

type NTStatus=Cardinal;
     TZwQuerySystemInformation=function (dwSystemInformationClass:DWORD;pSystemInformation: Pointer;dwSystemInformationLength: DWORD;var iReturnLength:DWORD): NTSTATUS;stdcall;
     TSetSuspendState=function(Hibernate,ForceCritical,DisableWakeEvent:Boolean):Boolean;stdcall;
     TSystemLock=function:Boolean; stdcall;
var i:AnsiChar;
    OpenThread:TOpenThreadFunction;
    ZwQuerySystemInformation:TZwQuerySystemInformation=nil;
    SetSuspendState:TSetSuspendState=nil;
    SystemLock:TSystemLock=nil;

type TOneLoadedLibrary=record
        LibraryName:UnicodeString;
        LibHandle:NativeUInt;
        SystemLibrary:Boolean;
      end;
     TLoadedLibraryList=array of TOneLoadedLibrary;

function _StrBBComp(str1:PAnsiChar; str1len:Integer; str2:PAnsiChar; str2len:Integer; IgnoreCase:LongBool):Integer;
function _StrPosEx(str1:PAnsiChar; len1:Integer; str2:PAnsiChar; len2:Integer; startpos:Integer; IgnoreCase:LongBool):Integer;
procedure Int64ToDWORDs(value:int64;var d_hi,d_lo:Cardinal);
function  DWORDsToInt64(d_hi,d_lo:Cardinal):Int64;
procedure ForceTimeChangePrivilege;
procedure ForcePowerPrivilege;
//        
function GetLibraryHandle(LibName:PWideChar):NativeUInt;
procedure AddToLoadedLibs(LibName:PWideChar; lHandle:Cardinal; IsSystem:Boolean);
procedure UnloadAllLibraries;
function NeoLoadLibrary(LibName:PWideChar; NameLen:Word):Cardinal;
//  DLL        DLL
procedure Int64ToA (value:int64; buffer:PAnsiChar; radix:integer; maybeSigned:Boolean);
procedure Int64ToW (value:Int64; buffer:PWideChar; radix:Integer; maybeSigned:Boolean);

//       " "    
procedure CorrectFileTimeToLocalFileTime(const ftime:_FILETIME;var local_ftime:_FILETIME);
procedure CorrectLocalFileTimeToFileTime(const local_ftime:_FILETIME;var ftime:_FILETIME);

procedure LoadPwrProf;

implementation
uses NeoS0M_Types;

{//     NativeAPI
type TObjectAttributes=packed record
      dwSize:DWord;
      Attr:array [0..4] of DWord;
     end;

     TClient_ID=packed record
                 pID:DWord;
                 tID:DWord;
                end;
     TOpenThreadNTFunction=function(out ThreadHandle:DWord;dwDesiredAccess:DWord;var ObjectAttributes:TObjectAttributes;var Client_ID:TClient_ID):DWord; stdcall;
}
var UCTable:array [AnsiChar] of AnsiChar;
    AdvAPIPointersLoaded:Boolean=False;
    NTDLLHandle,AdvAPIHandle:Cardinal;
    PwrProfHandle:cardinal=0;

    CurrentProcessToken:THandle=0; //   
    LibNameBuf:Pointer=nil;

    LoadedLibraries:TLoadedLibraryList;

{$IFDEF Win32}
function UDiv(value:Int64; radix:Cardinal):Int64;
asm
 push 0
 push radix
 mov eax,dword ptr [value]
 mov edx,dword ptr [value+4]
 call System.@_lludiv
end;

function UMod(value:Int64; radix:Integer):Int64;
asm
 push 0
 push radix
 mov eax,dword ptr [value]
 mov edx,dword ptr [value+4]
 call System.@_llumod
end;
{$ENDIF}

{$IFDEF Win64}
function UDiv(value:UInt64; radix:Cardinal):Int64;inline;
begin
  Result:=value div radix;
end;

function UMod(value:UInt64; radix:Integer):Int64;inline;
begin
  Result:=value mod radix;
end;
{$ENDIF}

procedure CorrectFileTimeToLocalFileTime(const ftime:_FILETIME;var local_ftime:_FILETIME);
var st,lt:_SYSTEMTIME;
begin
  FileTimeToSystemTime(ftime,st);
  SystemTimeToTzSpecificLocalTime(nil,st,lt);
  SystemTimeToFileTime(lt,local_ftime);
end;

procedure CorrectLocalFileTimeToFileTime(const local_ftime:_FILETIME;var ftime:_FILETIME);
var tz:TTimeZoneInformation;
    st,lt:_SYSTEMTIME;
begin
  GetTimeZoneInformation(tz);
  //   -   bias'  ,  SystemTimeToTzSpecificLocalTime
  //  ,  ,    
  with tz do
    begin
      Bias:=-Bias;
      StandardBias:=-StandardBias;
      DaylightBias:=-DaylightBias;
    end;
  FileTimeToSystemTime(local_ftime,lt);
  SystemTimeToTzSpecificLocalTime(@tz,lt,st);
  SystemTimeToFileTime(st,ftime);
end;

procedure Int64ToA (value:int64; buffer:PAnsiChar; radix:integer; maybeSigned:Boolean);
var buf:array[0..64] of AnsiChar;
    p,bufp:PAnsiChar;
    c:Cardinal;
begin
 p:=buffer;
 if (radix>=2) and (radix<=36) then
  begin
   if (value<0) and maybeSigned then
    begin
     p^:='-';Inc(p);
     Value:=-Value;
    end;//if (value<0)...
   bufp:=buf;
   while True do
    begin
     c:=UMod(value,radix);
     value:=UDiv(value,radix);
     bufp^:=AnsiChar(c);Inc(bufp);
     if value=0 then Break;
    end;
    while bufp<>buf do
     begin
      Dec(bufp);
      if bufp^<#10
       then p^:=AnsiChar(48+Byte(bufp^)) //Ord('0')=48
       else p^:=AnsiChar(Ord('A')+Byte(bufp^)-10);
      Inc(p);
     end;//while
  end;//if radix>=...
 p^:=#0;
end;

procedure Int64ToW (value:Int64; buffer:PWideChar; radix:Integer; maybeSigned:Boolean);
var buf:array[0..64] of WideChar;
    p,bufp:PWideChar;
    c:Cardinal;
begin
 p:=buffer;
 if (radix>=2) and (radix<=36) then
  begin
   if (value<0) and maybeSigned then
    begin
     p^:='-';Inc(p);
     Value:=-Value;
    end;//if (value<0)...
   bufp:=buf;
   while True do
    begin
     c:=UMod(value,radix);
     value:=UDiv(value,radix);
     bufp^:=WideChar(c);Inc(bufp);
     if value=0 then Break;
    end;
    while bufp<>buf do
     begin
      Dec(bufp);
      if bufp^<#10
       then p^:=WideChar(Ord('0')+Byte(bufp^)) //Ord('0')=48
       else p^:=WideChar(Ord('A')+Byte(bufp^)-10);
      Inc(p);
     end;//while
  end;//if radix>=...
 p^:=#0;
end;

function _StrBBComp(str1:PAnsiChar; str1len:Integer; str2:PAnsiChar; str2len:Integer; IgnoreCase:LongBool):Integer;
//  ASCIIZ-     c    
var i,m:Integer;
    c1,c2:AnsiChar;
begin
 Result:=0;
 if str1len<str2len then m:=str1len else m:=str2len;
 for i:=1 to m do
  begin
    if IgnoreCase
     then begin c1:=UCTable[str1^];c2:=UCTable[str2^]; end
     else begin c1:=str1^; c2:=str2^; end;
    if c1=c2 then begin Inc(str1); Inc(str2); end
     else
      begin
       if c1>c2 then Result:=1 else Result:=-1;
       Exit;
      end;//else
  end;//for
 if Result=0 then //       
  begin
   if str1len>str2len then Result:=1
    else begin if str1len<str2len then Result:=-1; end;
  end;
end;

function _StrPosEx(str1:PAnsiChar; len1:Integer; str2:PAnsiChar; len2:Integer; startpos:Integer; IgnoreCase:LongBool):Integer;
//   str1   str2    startpos      -1
//     
label Next;
var tmp_str1,tmp_str2:PAnsiChar;
    countdown,c_p:Cardinal;
begin
 Result:=-1;
 if len1=0 //      ( ) - ,      
  then Exit
  else
   begin
   Inc(str2,startpos); Dec(len2,startpos); c_p:=startpos;
   //     str1   str2
   while len2>=len1 do
    begin
     if IgnoreCase then
      begin //     
       if UCTable[str2^]=UCTable[str1^] then //   
        begin
         tmp_str2:=str2; tmp_str1:=str1; countdown:=len1;
         while countdown>1 do
          begin
           Inc(tmp_str2);Inc(tmp_str1); Dec(countdown); //   . 
           if UCTable[tmp_str2^]<>UCTable[tmp_str1^] then goto Next;
          end;//while
         Result:=c_p; Exit;
        end;//if str2^=str1^
      end
     else
      begin //     
       if str2^=str1^ then //   
        begin
         tmp_str2:=str2; tmp_str1:=str1; countdown:=len1;
         while countdown>1 do
          begin
           Inc(tmp_str2);Inc(tmp_str1); Dec(countdown); //   . 
           if tmp_str2^<>tmp_str1^ then goto Next;
          end;//while
         Result:=c_p; Exit;
        end;//if str2^=str1^
      end;//else
  Next:
     Inc(str2); Dec(len2); Inc(c_p);
    end;//while
   end;//else
end;

procedure Int64ToDWORDS(value:int64;var d_hi,d_lo:Cardinal);
begin
 d_lo:=value and $FFFFFFFF;
 d_hi:=value shr 32;
end;

function DWORDsToInt64(d_hi,d_lo:Cardinal):Int64;
begin
 Result:=d_hi;
 Result:=(Result shl 32) or d_lo;
end;

procedure LoadAdvAPIPointers;
begin
  AdvAPIHandle:=GetModuleHandleW('advapi32.dll');
  AddToLoadedLibs('advapi32.dll',AdvAPIHandle,True);
  LookupPrivilegeValuePtr:=GetProcAddress(AdvAPIHandle,'LookupPrivilegeValueA');
  OpenProcessTokenPtr:=GetProcAddress(AdvAPIHandle,'OpenProcessToken');
  AdjustTokenPrivilegesPtr:=GetProcAddress(AdvAPIHandle,'AdjustTokenPrivileges');

 AdvAPIPointersLoaded:=True;
end;

function GimmePrivilege(const priv_name:PAnsiChar):Boolean;
var NewState:_TOKEN_PRIVILEGES;
begin
 Result:=False; 
 if not AdvAPIPointersLoaded then LoadAdvAPIPointers; //         -  
 if OpenProcessTokenPtr(GetCurrentProcess,TOKEN_ADJUST_PRIVILEGES,CurrentProcessToken) then
  begin
   with NewState.Privileges[0] do
     begin
      NewState.PrivilegeCount:=1;
      LookupPrivilegeValuePtr(nil,PAnsiChar(priv_name),Luid);
      Attributes:=SE_PRIVILEGE_ENABLED;
     end;//with
   Result:=AdjustTokenPrivilegesPtr(CurrentProcessToken,False,NewState,0,nil,nil);
  end;
end;

procedure ForceTimeChangePrivilege;
begin
  if not TimeChangePrivilege
    then TimeChangePrivilege:=GimmePrivilege('SeSystemtimePrivilege')
end;

procedure ForcePowerPrivilege;
begin
  if not ShutdownPrivilege
    then ShutdownPrivilege:=GimmePrivilege('SeShutdownPrivilege');
end;

function GetLibraryHandle(LibName:PWideChar):NativeUInt;
var i:Integer;
begin
  Result:=INVALID_HANDLE_VALUE;
  for i:=0 to Length(LoadedLibraries)-1 do
    begin
      with LoadedLibraries[i] do
        begin
          if lstrcmpiW(LibName,PWideChar(LibraryName))=0
            then begin Result:=LibHandle; Break; end;
        end;//with
    end;
end;

procedure AddToLoadedLibs(LibName:PWideChar; lHandle:Cardinal; IsSystem:Boolean);
var i:Integer;
begin
  i:=Length(LoadedLibraries);
  SetLength(LoadedLibraries,i+1);
  with LoadedLibraries[i] do
    begin
      LibraryName:=LibName;
      LibHandle:=lHandle;
      LoadedLibraries[i].SystemLibrary:=IsSystem;
    end;
end;

function NeoLoadLibrary(LibName:PWideChar; NameLen:Word):Cardinal;
var TrueLibName:UnicodeString;
begin
  //    
  SetLength(TrueLibName,NameLen);
  Move(LibName^,TrueLibName[1],NameLen*SizeOf(WideChar));
  //  
  Result:=GetLibraryHandle(PWideChar(TrueLibName));
  if Result=INVALID_HANDLE_VALUE then
    begin
      Result:=LoadLibraryW(PWideChar(TrueLibName));
      if Result<>0
        then AddToLoadedLibs(PWideChar(TrueLibName),Result,False);
   end;
end;

procedure CompactLibList;
//    
var CopyTo,i:Integer;
begin
  CopyTo:=Low(LoadedLibraries);
  for i:=Low(LoadedLibraries) to High(LoadedLibraries) do
   begin
     //     -        
     if LoadedLibraries[i].LibHandle<>INVALID_HANDLE_VALUE then
      begin
        //  " "    "" - 
        if CopyTo<>i then LoadedLibraries[CopyTo]:=LoadedLibraries[i];
        //     ,  
        Inc(CopyTo);
      end;
   end;
   SetLength(LoadedLibraries,CopyTo); 
end;

procedure UnloadAllLibraries;
var i:Integer;
begin
  for I:=Low(LoadedLibraries) to High(LoadedLibraries) do
    begin
      with LoadedLibraries[i] do
       begin
        if not SystemLibrary then
          begin
            FreeLibrary(LibHandle);
            LibHandle:=INVALID_HANDLE_VALUE;
          end;
       end;//with
    end;//for
  CompactLibList;
end;

procedure LoadPwrProf;
const ppdll:PWideChar='PowrProf';
begin
  if PwrProfHandle=0 then
    begin
      PwrProfHandle:=LoadLibraryW(ppdll);
      if PwrProfHandle<>0 then //   
        begin
          AddToLoadedLibs(ppdll,PwrProfHandle,False);
          //      ,    
          SetSuspendState:=GetProcAddress(PwrProfHandle,'SetSuspendState');
        end;
    end;//if PwrProf=0
end;

type PGetNativeSystemInfo=procedure (var lpSystemInfo: TSystemInfo); stdcall;

const Kernel32_LibName:PChar='kernel32';
      User32_LibName:PChar='user32';
      NTDLL_Libname:PChar='ntdll';

var  _GetNativeSystemInfo:PGetNativeSystemInfo;


initialization
begin
 Kernel32Handle:=GetModuleHandleW(Kernel32_LibName);
 AddToLoadedLibs(Kernel32_LibName,Kernel32Handle,True);
 User32Handle:=LoadLibraryW(User32_LibName);
 AddToLoadedLibs(User32_LibName,User32Handle,True);
 //  ,    
 with OSVersion do
 begin
  dwOSVersionInfoSize:=SizeOf(OSVersion);
  GetVersionExW(OSVersion);
 end;
 //    
 _GetNativeSystemInfo:=GetProcAddress(Kernel32Handle,'GetNativeSystemInfo');
 if Assigned(_GetNativeSystemInfo)
  then _GetNativeSystemInfo(SystemInfo)
  else GetSystemInfo(SystemInfo);

 NTDLLHandle:=GetModuleHandleW(NTDLL_Libname);
 AddToLoadedLibs(NTDLL_Libname,NTDLLHandle,True);
 //        
 ZwQuerySystemInformation:=GetProcAddress(NTDLLHandle,'ZwQuerySystemInformation');
 //    OpenThread  Kernel32
 OpenThread:=TOpenThreadFunction(GetProcAddress(Kernel32Handle,'OpenThread'));

 //        
 for i:=Low(AnsiChar) to High(AnsiChar) do UCTable[i]:=i;
 CharUpperBuffA(@UCTable,SizeOf(UCTable));
end;

end.
