unit NeoS0M_Menus;

interface

uses NeoS0M_Types, Windows;

function GetMenuItem(var context:TScriptContext; menu:Cardinal; var MnuHandle,MnuPos,MnuID:Cardinal; LastIsSubMenu:Boolean):Integer;
//   ,     ,     ID  
//  -  
//     ,   LastIsSubmenu=True


implementation

uses NeoS0M_VarManager, NeoS0M_Executor, NeoS0M_UnifiedArray, NeoS0M_USTR;

function GetMenuItem(var context:TScriptContext; menu:Cardinal; var MnuHandle,MnuPos,MnuID:Cardinal; LastIsSubMenu:Boolean):Integer;
var param_type:Byte;
    vartype:TVarType;
    i,param_count,tmp:Integer;
    NextCommand:Pointer;
    state:TParamState;
    DWORD_Param:Cardinal;
    UStr_Param:PUA_UnicodeString;
    IsDWORD,DestroyUStr:Boolean;
    Buffer:array[0..512] of WideChar;

    function FindItemByName(menu:Cardinal; SearchText:PUA_UnicodeString):Integer;
    //       -1,       
    var i,mic:Integer;
        ReadedLen:Integer;
    begin
      Result:=-1;
      mic:=GetMenuItemCount(menu)-1;
      for i:=0 to mic do
        begin
          ReadedLen:=GetMenuStringW(menu,i,@Buffer,High(Buffer),MF_BYPOSITION);
          if _USTR_Compare(@SearchText^.Arr,SearchText^.Header.ElemCount-1,@Buffer,ReadedLen)=0 then
            begin
              Result:=i;
              Break;
            end;
        end;//for
    end;

begin
  DestroyUStr:=False;
  IsDWORD:=False;
  Result:=CMD_OK;
  MnuHandle:=menu;
  param_count:=GetParamCount(context.IP,NextCommand);
with context do
begin
  for i:=1 to param_count do
   begin
    param_type:=PByte(IP)^;
    //        
    case TParamType(param_type) of
     ptDWORD,ptByte,ptWord,ptInteger:
        begin
          DWORD_Param:=LoadParameter_DWORD(context,state,0);
          if state=PARAM_OK
           then IsDWORD:=True
           else Result:=CMD_TYPECAST_IMPOSSIBLE;
        end;
     ptBinBlock,ptUnicodeString:
        begin
          IsDWORD:=False;
          UStr_Param:=LoadParameter_UnicodeString(context,state);
          //      
          DestroyUStr:=True;
          if state<>PARAM_OK then
            begin
              Result:=CMD_TYPECAST_IMPOSSIBLE;
              Break;
            end;
        end;
     ptVariable:
        begin
          Inc(NativeUInt(IP));
          DWORD_Param:=PCardinal(IP)^;
          Inc(NativeUInt(IP),ParamTypeSize[ptVariable]);
          vartype:=Variable_GetType(context,DWORD_Param);
          //        
          case vartype of
            vtInteger,vtDWORD:
              begin
                Result:=Variable_qLoadDWORD(context,DWORD_Param,DWORD_Param);
                IsDWORD:=True;
              end;
           vtBinBlock,vtUnicodeString:
              begin
                Result:=Variable_qLoadxArray(context,DWORD_Param,vartype,Pointer(UStr_Param));
                IsDWORD:=False;
              end;
           else
            begin
              Result:=CMD_TYPECAST_IMPOSSIBLE;
              Break;
            end;
          end;//case
        end;
     else begin Result:=CMD_TYPECAST_IMPOSSIBLE; Break; end;
    end;//case

if Result=CMD_OK then
  begin
    //       ,  
    if (not IsDWORD) then
     begin
      tmp:=FindItemByName(MnuHandle,UStr_Param);
      if tmp=-1 then
        begin
          Result:=CMD_MENU_ITEM_NOT_EXISTS;
          Break;
        end
        else DWORD_Param:=tmp;
        //   ,     
        if DestroyUStr then
          begin
            UA_Destroy(PArrayHeader(UStr_Param));
            DestroyUStr:=False;
          end;
     end;

    //    -       
    if i=param_count then //     (.. ,   )
      begin
        MnuPos:=DWORD_Param;
        MnuID:=GetMenuItemID(MnuHandle,MnuPos);
        //   
        if LastIsSubmenu
          then MnuHandle:=GetSubMenu(MnuHandle,DWORD_Param);
      end
    else //    -   
      begin
        MnuHandle:=GetSubMenu(MnuHandle,DWORD_Param);
        if MnuHandle=0
          then Result:=CMD_MENU_ITEM_NOT_EXISTS;
      end;
   end;//for
  if Result=CMD_OK then //    ,  ,   
   begin
   end;
end;

  IP:=NextCommand;
end;//with
end;

end.
