unit NeoS0M_SearchWnds;

interface
uses Windows, NeoS0M_Types, NeoS0M_Variables;

type // ,       
     TTxtCompareDescriptor=record
      StringComparsionMethod:TStringComparsionMethod; //  
      CompareWith:PUA_UnicodeString; //   ,    
     end;

     TWndSearchDescriptor=record
      ClassNameCompare,                     //     
      WndTextCompare:TTxtCompareDescriptor; //     
      Buffer:PWideChar;                     //   ,          
      WndTxtBufSize,                        //    
      MaxTextLen:Cardinal;                  // .     

      wndlist:PUA_DWORD;                    // ,       
      MaxItemCount:Integer;                 // .    
      Timeout:Cardinal;                     //     
     end;
     PWndSearchDescriptor=^TWndSearchDescriptor;

function IsGoodWindow(wnd:Cardinal; var ws:PWndSearchDescriptor):Boolean;

implementation

uses NeoS0M_Constants, NeoS0M_WindowOperations, NeoS0M_USTR;

type TUSTRComparator=function (s1:PWideChar; l1:Integer; s2: PWideChar; l2:Integer):Integer;

function _UStr_IsSubstr(s1:PWideChar; l1:Integer; s2:PWideChar; l2:Integer):Integer;
begin
  if _UStr_PosEx(s2,l2,s1,l1,0)=-1
    then Result:=1
    else Result:=0;
end;

function _UStr_IsSubstrI(s1:PWideChar; l1:Integer; s2:PWideChar; l2:Integer):Integer;
begin
  if _UStr_PosExI(s2,l2,s1,l1,0)=-1
    then Result:=1
    else Result:=0;
end;

{ DONE :    }
const USTRComparators:array [TStringComparsionMethod] of TUSTRComparator=(nil,_USTR_Compare,_USTR_CompareI,_UStr_IsSubstr,_UStr_IsSubstrI);

function IsGoodWindow(wnd:Cardinal; var ws:PWndSearchDescriptor):Boolean;
var txt_len,res:Cardinal;
begin
  //   
  with ws^,ws^.ClassNameCompare do
  begin
    if StringComparsionMethod<>scmDontCompare then //       -   
    begin
      //   
      res:=GetClassNameW(wnd,Buffer,WndTxtBufSize-1);
      if res=0
        //      -  
        then begin Result:=False; Exit end
        //   -   
        else Result:=USTRComparators[StringComparsionMethod](Buffer,res,@CompareWith.Arr,CompareWith.Header.ElemCount-1)=0;
      end//if StringComparsionMethod...
    else Result:=True;
  end;//with

//   
 with ws^,ws^.WndTextCompare do
 begin
  if Result and (StringComparsionMethod<>scmDontCompare) then
  begin
   if WndTxtBufSize>=MaxTextLen+1
   //      .   -    
   //   , , ,    
    then txt_len:=MaxTextLen
    else
     begin
      //     
      if _SendAnyMessageW(wnd,WM_GETTEXTLENGTH,0,0,Timeout,txt_len)=CMD_OK
       then
        begin
         if txt_len>MaxTextLen then txt_len:=MaxTextLen;
         if txt_len>=WndTxtBufSize // txt_len+1>WndTxtBufSize
         //   ,      -  
          then begin
                FreeMem(Buffer);
                WndTxtBufSize:=txt_len+1;
                GetMem(Buffer,WndTxtBufSize+WndTxtBufSize);
               end;
        end//if _SendAnyMessage(wnd,WM_GETTEXTLENGTH...
       else txt_len:=WndTxtBufSize-1; //       -        
     end;//else
     //         
     if _SendAnyMessageW(wnd,WM_GETTEXT,txt_len+1,TLParam(Buffer),Timeout,res)<>CMD_OK
      then res:=0;
     Result:=USTRComparators[StringComparsionMethod](Buffer,res,@CompareWith.Arr,CompareWith.Header.ElemCount-1)=0;
  end;//if Result and...
 end;//with
end;

end.
