unit NeoS0M_ServiceFns;

interface
uses NeoS0M_Types;

function LoadAndExecute(fname:PWideChar;SectionName:PAnsiChar):Cardinal; stdcall; exports LoadAndExecute;
function GetSectionPtrByName(const context:TScriptContext;s_name:PAnsiChar; var s_flag, s_len:Cardinal):Pointer;

implementation

uses Windows, NeoS0M_Executor, CRC64, NeoS0M_Math, NeoS0M_Constants;

function LoadScriptToMem(fname:PWideChar; var start:Pointer;var script_len:Cardinal):Boolean;
var hfile,readed,file_len:Cardinal;
begin
 Result:=False;
 hfile:=CreateFileW(fname,GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 if hfile<>0 then
  begin
   file_len:=GetFileSize(hfile,nil);
   {  4-       }
   SetFilePointer(hfile,-4,nil,FILE_END);
   ReadFile(hfile,script_len,SizeOf(script_len),readed,nil);
   Inc(script_len,4); //     4  ,      
   if file_len<script_len
    then Result:=False
    else
     begin
       GetMem(start,script_len);
       if start<>nil then
        begin
         SetFilePointer(hfile,-script_len,nil,FILE_END);
         ReadFile(hfile,start^,script_len,readed,nil);
         if script_len<>readed
          then FreeMem(start)
          else Result:=true;
        end;//start<>nil
     end;
   CloseHandle(hfile);
  end;//if hfile<>...
end;

function GetSectionPtrByName(const context:TScriptContext;s_name:PAnsiChar; var s_flag, s_len:Cardinal):Pointer;
//          
var i:Cardinal;
begin
 Result:=nil;
 for i:=1 to context.SectionCount do
  begin
   with context.SectionIndex^[i] do
    begin
     if lstrcmpA(s_name,Name)=0 then
      begin
       s_flag:=SectionFlag;
       s_len:=SectionLength;
       Result:=SectionPtr;
      end;
    end;//with
  end;//for
end;

function IsValidScript(start:Pointer;len:Cardinal):Cardinal;
var c64:Int64;
    c_pos:PInt64;
begin
 c_pos:=start;
 if len<8+4+8+4
  then Result:=GE_INVALID_SCRIPT
  else
   begin
    if c_pos^<>6867198141719203423 // '_NeoS0M_'
     then Result:=GE_INVALID_SCRIPT
     else
      begin
       {       4- }
       Inc(NativeUInt(c_pos),len-4);
       if PCardinal(c_pos)^<>len-4
        then Result:=GE_INVALID_SCRIPT
        else
         begin
          Dec(NativeUInt(c_pos),SizeOf(Int64));
          c64:=c_pos^;
          if c64=$FFFFFFFFFFFFFFFF
           then Result:=CBC_OK
           else Result:=IfThen(c64=CRC64_Calculate(start,len-SizeOf(Cardinal)-SizeOf(int64)),CBC_OK,GE_INVALID_CRC);
         end;//else
      end;//else
   end;//else
end;

function LoadAndExecute(fname:PWideChar; SectionName:PAnsiChar):Cardinal; stdcall;
//       
var Context:TScriptContext;
    ScriptCode:Pointer;
    ScriptLen:Cardinal;
begin
 if LoadScriptToMem(fname,ScriptCode,ScriptLen) then
  begin
   { DONE :     " ",           CRC64 }
   Result:=IsValidScript(ScriptCode,ScriptLen);
   if Result=CBC_OK then
   begin
    InitContext(Context,ScriptCode,ScriptLen);
    Result:=CompileScript(Context);
    if Result=CBC_OK then
    begin
     if SectionName=nil
      then SectionName:=PAnsiChar(GENERAL_SECTION_NAME);
     Result:=ExecuteByteCode(Context,SectionName);
    end;
    DestroyContext(Context);
   end;//if Result=CBC_OK
   FreeMem(ScriptCode);
  end//if LoadScriptToMem
 else Result:=GE_CANT_LOAD_SCRIPT;

end;

end.
 