unit NeoS0M_Types;

interface
uses Windows;

type TStringComparsionMethod=(scmDontCompare=0,scmTrueEquality=1,scmEqualityWOCase=2,scmTrueIsSubstring=3,scmIsSubstringWOCase=4);

type TArrayHeader=packed record
      ElemSize:Cardinal;
      ElemCount,TrueElemCount:Cardinal;
      IsDynamic:LongBool;
     end;
     PArrayHeader=^TArrayHeader;

     TUA_Integer=packed record
      Header:TArrayHeader;
      Arr:array [0..($7FFFFF00 div Sizeof(Int64))] of Int64;
     end;
     PUA_Integer=^TUA_Integer;

     TUA_Extended=packed record
      Header:TArrayHeader;
      Arr:array [0..($7FFFFF00 div Sizeof(Extended))] of Extended;
     end;
     PUA_Extended=^TUA_Extended;

     TUA_DWORD=packed record
      Header:TArrayHeader;
      Arr:array [0..($7FFFFF00 div Sizeof(Cardinal))] of Cardinal;
     end;
     PUA_DWORD=^TUA_DWORD;

     TUA_BinaryBlock=packed record
      Header:TArrayHeader;
      Arr:array [0..$7FFFFF00] of Byte;
     end;
     PUA_BinaryBlock=^TUA_BinaryBlock;

     TUA_BinBlockList=packed record
      Header:TArrayHeader;
      Arr:array [0..$7FFFFFF] of PUA_BinaryBlock; //     
     end;
     PUA_BinBlockList=^TUA_BinBlockList;

     TUA_UnicodeString=packed record
        Header:TArrayHeader;
        Arr:array [0..$7FFFFF00 div SizeOf(WideChar)] of WideChar;
     end;
     PUA_UnicodeString=^TUA_UnicodeString;

     TUA_UnicodeStringList=packed record
      Header:TArrayHeader;
      Arr:array [0..$7FFFFFF] of PUA_UnicodeString; //    UNICODE-
     end;
     PUA_UnicodeStringList=^TUA_UnicodeStringList;

type TCallStack=array of Pointer; //  

type  TSection=packed record
        Name:PAnsiChar;
        SectionPtr:Pointer;
        SectionFlag,SectionLength:Cardinal;
      end;

      TSectionTable=packed array [1..$FFFFFF] of TSection;
      PSectionTable=^TSectionTable;

      //  
      TVarType=
        //         TParamType
        (vtUninitialized=0,vtInteger=1,vtExtended=2,vtIntArray=3,vtExtArray=4,vtBinBlock=5,vtBinBlockList=6,vtDWORD=7,vtDWORDArray=8,
         vtUnicodeString=9,vtUnicodeStringList=10,
         vtInvalid=11{ ,     });

      //   (       )
      TParamType=
        //      !
        (ptDefault=0,ptInteger=1,ptExtended=2,ptIntArray=3,ptExtArray=4,ptBinBlock=5,ptBinBlockList=6,ptDWORD=7,ptDWORDArray=8,ptVariable=9,ptEndOfParam=10,ptByte=11,ptWord=12,ptUnicodeString=13,ptUnicodeStringList=14);

      //   -    Neo Sign 0f Misery
      TNeoS0MVariable=record
        VarType: TVarType;
        case TVarType of
          vtDWORD:        (AsDWORD:Cardinal);
          vtInteger:      (AsInteger:Int64);
          vtExtended:     (AsExtended:Extended);
          vtIntArray,vtExtArray,vtBinBlock,vtDWORDArray,vtBinBlockList,vtUnicodeString,vtUnicodeStringList:
                        (UA:PArrayHeader);
        end;
      PNeoS0MVariable=^TNeoS0MVariable;

      TNeoS0MVariables=array of TNeoS0MVariable;
      TVarStack=array of TNeoS0MVariables;

type TScriptContext=record
// !!!MyOwnModule        !!!
      MyOwnModule:Cardinal;             //   ,  EXE - GetModuleHandle(0),  DLL -    PROCESS_ATTACH
// ,    
      ScriptStart:Pointer;              //    
      ScriptLength:Cardinal;            //   
      SectionCount:Cardinal;            //    .    !
      SectionIndex:PSectionTable;       //     

      StackFrames:TVarStack;            //   
      CallStack:TCallStack;             //  

      SecurityAttributes:PSecurityAttributes; //    
      LastStartedProcess:TProcessInformation; //      / 

      LongDataSection:Pointer;          //     (LDS),  

      ActionAfterError:Cardinal;        //     ?
      IgnoreSymlinks:Cardinal;          //      ?
      FileDialogBufferSize:Cardinal;    //     / ,  __
      KeyPressTime:Cardinal;            //   ""     ,  
      SendMsgTimeout:Cardinal;          // -  SendMessageTimeout  0,    SendMessage

      IP:Pointer;                       //    /
      ScriptErrorCode:Integer;          //  
      Error_At:Pointer;                 //     ,    
      LastWindowsError:Cardinal;        //   Windows ( WinAPI)
      ExitFlag:Boolean;                 //    .   -   
      OnErrorGoto:Pointer;              // ,      
     end;
     PScriptContext=^TScriptContext;

     TCommandExecutor=function(var context:TScriptContext):Integer;
     PCommandExecutor=^TCommandExecutor;

     TCommandDescription=record
      Executor:TCommandExecutor;
      ParamCount:Integer;
     end;
     PCommandDescription=^TCommandDescription;

type TExecutors=array[0..0] of TCommandDescription;
     PExecutors=^TExecutors;

     TParamState=(PARAM_OK,PARAM_DEFAULT,PARAM_INVALID,PARAM_END);

const //  
      GE_CANT_LOAD_SCRIPT=1;    //    
      GE_INVALID_SCRIPT=2;      //   (  - )
      GE_INVALID_CRC=3;         //    

      //   (20-99)
      CBC_OK=0;              //   
      CBC_INVALID_COMMAND=21; //        
      CBC_INVALID_PARAMETER_COUNT=22; //          
      CBC_NON_EXECUTABLE_SECTION=23;  //      

      CMD_OK=0;              //   

      //   ,     
      //  100-999
      CMD_PARAM_TYPE_MISMATCH=101;   //   
      CMD_PARAM_ERROR=102;           //     
      CMD_INVALID_COMMAND=103;       //   
      CMD_EXCEPTION=104;             //     
      CMD_NO_SECTION=105;            //   

      //  ,      
      //  1000+
      CMD_INVALID_PARAM_VALUE=1000;     //    
      CMD_INVALID_VARIABLE_INDEX=1001;  //   
      CMD_OUT_OF_MEMORY=1002;           //  
      CMD_NO_STACK=1003;                //    
      CMD_TYPECAST_IMPOSSIBLE=1004;     //   
      CMD_CANT_RUN_FILE_OR_CMD=1005;           //   
      CMD_CANT_KILL_PROCESS_OR_THREAD=1006; //   /
      CMD_INVALID_VARIABLE_COUNT=1007;  //    
      CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE=1008; //      
      CMD_INTEGER_OVERFLOW=1009;        //  
      CMD_API_ERROR=1010;               //    
      CMD_INVALID_ARRAY_ITEM_INDEX=1011;//     
      CMD_CANT_CHANGE_THREAD_PRIORITY=1012; //    
      CMD_CANT_CHANGE_PROC_PRIORITY=1013; //    
      CMD_CANT_COPY_MOVE_FILE=1014;     //     
      CMD_CANT_DELETE_FILE=1015;        //   
      CMD_SENDMESSAGE_FAILED=1016;      //    
      CANT_ATTACH_TO_ANOTHER_THREAD=1017; //    
      CMD_SOME_WINDOW_OPERATIONS_FAILED=1018; //         
      CMD_NOT_WND_LIST=1019;              //      
      CMD_CANT_GET_CURRENT_DIR=1020;      //    
      CMD_INVALID_DIRECTORY_NAME=1021;    //   
      CMD_THREAD_SUSPEND_RESUME_FAILED=1022; //   / 
      CMD_INVALID_HANDLE=1023;            //  
      CMD_CANT_OPEN_FILE=1024;            //    
      CMD_WRITE_FILE_FAILED=1025;         //      
      CMD_INVALID_PATCH_PARAM_COUNT=1026; //      
      CMD_FLOATPOINT_OVERFLOW=1027;       //     0      
      CMD_READ_FILE_FAILED=1028;          //      
      CMD_CANT_OPEN_PROCESS=1029;         //    
      CMD_CANT_OPEN_THREAD=1030;          //    
      CMD_CANT_WRITE_PROCCESS_MEM=1031;   //       
      CMD_CANT_READ_PROCCESS_MEM=1032;    //       
      CMD_RET_STACK_EMPTY=1033;           //   
      CMD_CANT_CHANGE_TIME=1034;          //    
      CMD_CANT_CHANGE_FILE_TIME=1035;     //     
      CMD_CANT_GET_FILE_TIME=1036;        //     
      CMD_CANT_READ_WND_POS_OR_SIZE=1037; //       
      CMD_CANT_GET_PROCESS_PRIOR=1038;    //     
      CMD_CANT_GET_THREAD_PRIOR=1039;     //     
      CMD_INVALID_SYSVAR_INDEX=1040;      //    
      CMD_MENU_ITEM_NOT_EXISTS=1041;      //    
      CMD_CANT_CHANGE_MENU_ITEM_STATE=1042;//      
      CMD_CANT_READ_MENU_ITEM_INFO=1043; //      
      CMD_CANT_GET_PIXEL=1044;           //     
      CMD_INVALID_REG_KEY_NAME=1045;     //    
      CMD_CANT_OPEN_CREATE_REG_KEY=1046; //   /  
      CMD_CANT_DELETE_REG_VALUE=1047;    //      
      CMD_CANT_STORE_REG_VALUE=1048;     //      
      CMD_CANT_READ_REG_VALUE=1049;      //      
      CMD_CANT_GET_REG_KEY_INFO=1050;    //      
      CMD_CANT_DELETE_REG_KEY=1051;      //     
      CMD_CANT_SET_CLIPBOARD_TEXT=1052;  //     Clipboard
      CMD_CANT_GET_CLIPBOARD_TEXT=1053;  //     Clipboard
      CMD_CANT_GET_DRIVE_INFO=1054;      //      
      CMD_SECTION_NOT_FOUND=1055;        //   
      CMD_INVALID_SECTION_ATTR=1056;     //   
      CMD_NOT_INTEGER_NUMBER=1057;       //   
      CMD_INVALID_BASE=1058;             //        
      CMD_NOT_FLOAT_NUMBER=1059;         //     
      CMD_SORTING_IMPOSSIBLE=1060;       //   -       
      CMD_INVALID_CALLING_CONVENTION=1061; //    
      CMD_LIBRARY_NOT_FOUND=1062;        //    
      CMD_EXTERNAL_FUNCTION_NOT_FOUND=1063; //   DLL  
      CMD_BIN_BLOCK_LENGTH_NOT_COMPATIBLE=1064; //       
      CMD_INVALID_SYSFOLDER_INDEX=1065;     //    
      CMD_INVALID_SYSFOLDER_NAME=1066;      //    
      CMD_INVALID_FILETREE_ROOT=1067;       //       
      CMD_CANT_CREATE_PROCLIST_SNAPSHOT=1068; //     
      CMD_CANT_FIND_FIRST_PROCESS=1069;     //      
      CMD_NOT_SUPPORTED_BY_OS=1070;      //     
      CMD_POWEROFF_FAILED=1071;        //    
      CMD_REBOOT_FAILED=1072;          //    
      CMD_SLEEP_FAILED=1073;           //      standby/hibernate
      CMD_CANT_LOCK_WORKSTATION=1074;  //     
      CMD_INVALID_OFFSET_IN_SECTION=1075; //        
      CMD_STRING_TOO_SHORT=1076;       //   
      CMD_CREATE_DIRECTORY_FAILED=1077; //     
      CMD_REMOVE_DIRECTORY_FAILED=1078; //    
      CMD_INVALID_FILE_NAME=1079;       //   
      CMD_CANT_COPY_MOVE_DIR=1080;      //  / 
      CMD_DIALOG_ERROR=1081;            // :        
      CMD_CANT_GET_SCRIPT_FILENAME=1082;//        
      CMD_INVALID_COMPARSION_METHOD=1083;//   
      CMD_CANT_ACCESS_FILE_ATTRIB=1084;  //       
      CMD_NOT_A_FILE_DIR=1085;           //   /
      CMD_CANT_CONVERT_COORDINATES=1086; //     
      CMD_CANT_GET_WOW64=1087;           //   ,    64-
      CMD_CANT_GET_EXE_PATH=1088;        //        
      CMD_CANT_EXPAND_ENV_STRING=1089;   //      

      VARIABLE_INDEX_MASK=$7FFFFFFF; // ,      
        //         

const DATA_SECTION=0;
      CODE_SECTION=1;

type TWParam=NativeUInt;
     TLParam=NativeUInt;

const ParamTypeSize:packed array [TParamType] of Byte=(
      //        ,  
        0,  // ptDefault
        SizeOf(Int64),    // ptInteger
        SizeOf(Extended), // ptExtended
        SizeOf(Pointer),  // ptIntArray
        SizeOf(Pointer),  // ptExtArray
        SizeOf(Pointer),  // ptBinBlock
        SizeOf(Pointer),  // ptBinBlockList
        SizeOf(Cardinal), // ptDWORD
        SizeOf(Pointer),  // ptDWORDArray
        SizeOf(Cardinal), // ptVariable
        0,  // ptEndOfParam
        SizeOf(ShortInt), // ptByte
        SizeOf(SmallInt), // ptWord
        SizeOf(Pointer),  // ptUnicodeString
        SizeOf(Pointer)   // ptUnicodeStringList
        );

      VarArrayItemSize:packed array [TVarType] of Byte=(
        0, // vtUninitialized
        0, // vtInteger
        0, // vtExtended
        SizeOf(Int64),    // vtIntArray
        SizeOf(Extended), // vtExtArray
        SizeOf(Byte),     // vtBinBlock
        SizeOf(Pointer),  // vtBinBlockList
        0, // vtDWORD
        SizeOf(Cardinal), // vtDWORDArray
        SizeOf(WideChar), // vtUnicodeString
        SizeOf(Pointer),  // vtUnicodeStringList
        0 // vtInvalid
        );

      IsArray:packed array [TVarType] of Boolean=(
        False,  // vtUninitialized
        False,  // vtInteger
        False,  // vtExtended
        True,   // vtIntArray
        True,   // vtExtArray
        True,   // vtBinBlock
        True,   // vtBinBlockList
        False,  // vtDWORD
        True,   // vtDWORDArray
        True,   // vtUnicodeString
        True,   // vtUnicodeStringList
        False   // vtInvalid
      );

      CompatibleVarType:packed array [TParamType] of TVarType=(
        vtInvalid,
        vtInteger,
        vtExtended,
        vtIntArray,
        vtExtArray,
        vtBinBlock,
        vtBinBlockList,
        vtDWORD,
        vtDWORDArray,
        vtInvalid,
        vtInvalid,
        vtDWORD,
        vtDWORD,
        vtUnicodeString,
        vtUnicodeStringList
      );


implementation

end.
