unit NeoS0M_USTR;

interface
uses Windows, NeoS0M_Types, NeoS0M_UnifiedArray, NeoS0M_Math;

const EmptyUnicodeString:array [1..18] of Byte=
// . TArrayHeader
      (2,0,0,0, //  
       1,0,0,0, //  
       1,0,0,0, //   
       0,0,0,0, //  IsDynamis=False
       0,0 //  ,   + 2  
       );

      SpaceUnicodeString:array [1..20] of Byte=
// . TArrayHeader
      (2,0,0,0, //  
       2,0,0,0, //  
       2,0,0,0, //   
       0,0,0,0, //  IsDynamis=False
       32,0,0,0 //   + 2  
       );

      DotUnicodeString:array [1..20] of Byte=
// . TArrayHeader
      (2,0,0,0, //  
       2,0,0,0, //  
       2,0,0,0, //   
       0,0,0,0, //  IsDynamis=False
       Ord('.'),0,0,0 //   + 2  
       );

      DoubleQuoteUnicodeString:array [1..22] of Byte=
// . TArrayHeader
      (2,0,0,0, //  
       3,0,0,0, //  
       3,0,0,0, //   
       0,0,0,0, //  IsDynamis=False
       Ord('"'),0,Ord('"'),0,0,0 //   + 2  
       );

type TWideCaseConvTable=array[Low(WideChar)..High(WideChar)] of WideChar;
var  WideToUpperTable,WideToLowerTable:TWideCaseConvTable;

//   Unicode- ( )
function UStr_Length(s:PUA_UnicodeString):Cardinal; inline;
//    Unicode-  +1 (+1 -   )      
function UStr_Allocate(l:Integer):PUA_UnicodeString;
//  Unicode-     
function UStr_From_Chars(s:PChar; StrL:Integer):PUA_UnicodeString;
//  PUA_UnicodeString    UnicodeString
function UStr_To_String(s:PUA_UnicodeString):String;
//  Unicode-    .   nil -      
function UStr_From_PChar(s:PChar):PUA_UnicodeString;
//   Unicode-
procedure UStr_Resize(var s:PUA_UnicodeString; new_len:Integer);
//  Unicode- (    )     
function UStr_Duplicate(us:PUA_UnicodeString):PUA_UnicodeString;
//     Unicode-
function BB_To_UStr(bb:PUA_BinaryBlock):PUA_UnicodeString;
//  Unicode-   
function UStr_To_BB(us:PUA_UnicodeString):PUA_BinaryBlock;
//    Unicode-
function UStr_SubStr(s:PUA_UnicodeString; start,len:Cardinal):PUA_UnicodeString;
//    ,      
procedure UStr_Quote(var s:PUA_UnicodeString);
//   
procedure UStr_Concat(var s1:PUA_UnicodeString;s2:PUA_UnicodeString;s3:PUA_UnicodeString=nil);
//    Unicode 
// function IntToUSTR(i:Int64):PUA_UnicodeString;
//       Unicode 
function ExtToUSTR(e:Extended; Width,Precision:Cardinal):PUA_UnicodeString;

//   Unicode-
function _USTR_Compare(s1:PWideChar; l1:Integer; s2:PWideChar; l2:Integer):Integer;
//   Unicode-   
function _USTR_CompareI(s1:PWideChar; l1:Integer; s2:PWideChar; l2:Integer):Integer;
//     
function _UStr_PosEx(str1:PWideChar; len1:Integer; str2:PWideChar; len2:Integer; startpos:Integer):Integer;
//        
function _UStr_PosExI(str1:PWideChar; len1:Integer; str2:PWideChar; len2:Integer; startpos:Integer):Integer;

//       ,    
procedure UStr_Add_BackSlash(var s:PUA_UnicodeString);

implementation

uses NeoS0M_BB;

function UStr_Length(s:PUA_UnicodeString):Cardinal; inline;
begin
  Result:=s^.Header.ElemCount-1;
end;

function UStr_Allocate(l:Integer):PUA_UnicodeString;
begin
  Result:=PUA_UnicodeString(UA_CreateR(l+1,SizeOf(WideChar)));
  if Result<>nil
    then Result^.Arr[l]:=#0;
end;

function UStr_From_Chars(s:PChar; StrL:Integer):PUA_UnicodeString;
begin
  if StrL=0
    then Result:=@EmptyUnicodeString
    else
      begin
        Result:=UStr_Allocate(StrL);
        if Result<>nil
          then Move(s^,Result^.Arr[0],StrL+StrL);
      end;
end;

function UStr_From_PChar(s:PChar):PUA_UnicodeString;
var l:Integer;
begin
  if s=nil
    then l:=0
    else l:=lstrlenW(s);
  Result:=UStr_From_Chars(s,l);
end;

procedure UStr_Resize(var s:PUA_UnicodeString; new_len:Integer);
begin
  UA_Resize(PArrayHeader(s),new_len+1);
  s^.Arr[new_len]:=#0;
end;


function UStr_Duplicate(us:PUA_UnicodeString):PUA_UnicodeString;
var l:Cardinal;
begin
  if us^.Header.IsDynamic then
    //   
    begin
      l:=UStr_Length(us);
      if l=0 //   , ..    0
        then Result:=@EmptyUnicodeString
        else
          begin
            //  
            Result:=UStr_Allocate(l);
            //     (    UStr_Allocate)
            Move(us^.Arr[0],Result^.Arr[0],l+l);
          end;
    end//if
  //   ,    
  else Result:=us;
end;

function BB_To_UStr(bb:PUA_BinaryBlock):PUA_UnicodeString;
var l,l2:Integer;
begin
  l:=bb^.Header.ElemCount-2;
  if l=0 //      -      
    then Result:=@EmptyUnicodeString
    else
      begin
        // ,  Unicode-  
        l2:=MultiByteToWideChar(CP_ACP,0,@bb^.Arr,l,nil,0);
        //  Unicode-  
        Result:=UStr_Allocate(l2);
        if Result<>nil then
          begin
            MultiByteToWideChar(CP_ACP,0,@bb^.Arr,l,@Result^.Arr,l2);
            { TODO :   (  ?) }
            Result^.Arr[l2]:=#0;
          end;//if Result<>nil
      end;//else
end;

function UStr_To_BB(us:PUA_UnicodeString):PUA_BinaryBlock;
var l,l2:Integer;
begin
  l:=UStr_Length(us);
  if l=0 //      -       
    then Result:=@EmptyBinaryBlock
    else
      begin
        // ,  ANSI-  
        l2:=WideCharToMultiByte(CP_ACP,0,@us^.Arr,l,nil,0,nil,nil);
        //    2        1 
        Result:=PUA_BinaryBlock(UA_CreateR(l2+2,SizeOf(AnsiChar)));
        if Result<>nil then
          begin
            WideCharToMultiByte(CP_ACP,0,@us^.Arr,l,@Result^.Arr,l2,nil,nil);
            { TODO :      }
            Result^.Arr[l2]:=0;
            Result^.Arr[l2+1]:=0;
          end;//if Result<>nil
      end;//else
end;

function UStr_SubStr(s:PUA_UnicodeString; start,len:Cardinal):PUA_UnicodeString;
var l:Cardinal;
begin
  { TODO : ,  ,         }
  //  
  l:=UStr_Length(s);
  if start>=l //      
    then len:=0
    else len:=Min(len,l-start); //      start  
  if len=0 //      0 -       
    then Result:=@EmptyUnicodeString
    else
      begin
        //     
        Result:=UStr_Allocate(len);
        //     
        Move(s^.Arr[start],Result^.Arr[0],len shl 1);
      end;
end;

procedure UStr_Quote(var s:PUA_UnicodeString);
var l,newl:Integer;
    FirstNotQuote:Boolean;
begin
  l:=UStr_Length(s);
  if l>0 then
    begin
      if (l=1) and (s^.Arr[0]='"') then //     
        begin
          //  
          UA_Destroy(PArrayHeader(s));
          //      
          s:=@DoubleQuoteUnicodeString;
        end
      else
        begin
          newl:=l;
          //    ?
          FirstNotQuote:=s^.Arr[0]<>'"';
          if FirstNotQuote then Inc(newl);
          //    ?      1 
          if s^.Arr[l-1]<>'"' then Inc(newl);
          if newl<>l then //    
            begin
              //   
              UA_Resize(PArrayHeader(s),newl+1);
              //     ?
              with s^ do
              begin
              if FirstNotQuote then
                begin
                    //      
                    Move(Arr[0],Arr[1],l+l);
                    //     
                    Arr[0]:='"';
                end;
              //    -  
              Arr[newl-1]:='"';
              //    0
              Arr[newl]:=#0;
              end;//with
            end;//if newl<>l
        end;
    end
  else
    begin
      //     -  
      UA_Destroy(PArrayHeader(s));
      //      
      s:=@DoubleQuoteUnicodeString;
    end;
end;

procedure UStr_Concat(var s1:PUA_UnicodeString;s2:PUA_UnicodeString;s3:PUA_UnicodeString=nil);
var l1,l2,l3:Integer;
begin
  l1:=UStr_Length(s1);
  l2:=UStr_Length(s2);
  if s3<>nil
    then l3:=UStr_Length(s3)
    else l3:=0;
  //   
  if l2+l3<>0 then
     begin
      //  
      UStr_Resize(s1,l1+l2+l3);
      with s1^ do
      begin
        //     ,  
        if l2<>0
          then Move(s2^.Arr[0],Arr[l1],l2+l2);
        //     ,  
        if l3<>0
          then Move(s3^.Arr[0],Arr[l1+l2],l3+l3);
      end;//with
     end;
end;

{function IntToUSTR(i:Int64):PUA_UnicodeString;
begin

end;}

function ExtToUSTR(e:Extended; Width,Precision:Cardinal):PUA_UnicodeString;
var s:ShortString;
    i,l:Integer;
begin
  if Width=$FFFFFFFF then
    begin
      if Precision=$FFFFFFFF
        then Str(e,s)
        else Str(e:0:Precision,s)
    end
  else
    begin
      if Precision=$FFFFFFFF
        then Str(e:Width,s)
        else Str(e:Width:Precision,s);
    end;
  l:=Length(s);
  Result:=UStr_Allocate(l);
  if Result<>nil then
    begin
      for i:=1 to l
        do Result^.Arr[i-1]:=WideChar(s[i]);
      Result^.Arr[l]:=#0;
    end;
end;

function _USTR_Compare(s1:PWideChar; l1:Integer; s2:PWideChar; l2:Integer):Integer;
begin
  Result:=0; //     
  repeat
  if (l1=0) or (l2=0) then //     
    begin
      if l1>l2 //    ,  
        then Result:=1
        else if l1<l2  //    ,  
              then Result:=-1;
              //     -   ( )
      //     
      Exit;
    end
  else
    begin
      if s1^<>s2^ then //    -  
        begin
          if s1^>s2
            then Result:=1
            else Result:=-1;
        end
      else //    -    
        begin
          Inc(s1);Inc(s2);
          Dec(l1);Dec(l2);
        end;
    end;
  until Result<>0;
end;

function _USTR_CompareI(s1:PWideChar; l1:Integer; s2:PWideChar; l2:Integer):Integer;
var c1,c2:WideChar;
begin
  Result:=0; //     
  repeat
  if (l1=0) or (l2=0) then //     
    begin
      if l1>l2 //    ,  
        then Result:=1
        else if l1<l2  //    ,  
              then Result:=-1;
              //     -   ( )
      //     
      Exit;
    end
  else
    begin
      c1:=WideToUpperTable[s1^];
      c2:=WideToUpperTable[s2^];
      if c1<>c2 then //    -  
        begin
          if c1>c2
            then Result:=1
            else Result:=-1;
        end
      else //    -    
        begin
          Inc(s1);Inc(s2);
          Dec(l1);Dec(l2);
        end;
    end;
  until Result<>0;
end;

function _UStr_PosEx(str1:PWideChar; len1:Integer; str2:PWideChar; len2:Integer; startpos:Integer):Integer;
//   str1   str2    startpos      -1
//     
label Next;
var tmp_str1,tmp_str2:PWideChar;
    countdown:Integer;
begin
  Result:=-1;
  if len1=0 //      ( ) - ,      
    then Exit
  else
    begin
      //        startpos 
      Inc(str2,startpos);
      //       ,    
      Dec(len2,startpos);
      //     str1   str2
      while len2>=len1 do
        begin
        //     
        if str2^=str1^ then //   
          begin
            //   ,   
            tmp_str2:=str2;
            tmp_str1:=str1;
            countdown:=len1;
            while countdown>1 do
            begin
              //   . 
              Inc(tmp_str2);
              Inc(tmp_str1);
              Dec(countdown);
              //       -       
              if tmp_str2^<>tmp_str1^
                then goto Next;
            end;//while
            //  startpos    
            Result:=startpos;
            Exit;
          end;//if str2^=str1^
        Next:
          //   . 
          Inc(str2);
          Dec(len2);
          Inc(startpos);
      end;//while
    end;//else
end;

function _UStr_PosExI(str1:PWideChar; len1:Integer; str2:PWideChar; len2:Integer; startpos:Integer):Integer;
label Next;
var tmp_str1,tmp_str2:PWideChar;
    countdown:Integer;
begin
  Result:=-1;
  if len1=0 //      ( ) - ,      
    then Exit
  else
    begin
      //        startpos 
      Inc(str2,startpos);
      //       ,    
      Dec(len2,startpos);
      //     str1   str2
      while len2>=len1 do
        begin
        //     
        if WideToUpperTable[str2^]=WideToUpperTable[str1^] then //   
          begin
            //   ,   
            tmp_str2:=str2;
            tmp_str1:=str1;
            countdown:=len1;
            while countdown>1 do
            begin
              //   . 
              Inc(tmp_str2);
              Inc(tmp_str1);
              Dec(countdown);
              //       -       
              if WideToUpperTable[tmp_str2^]<>WideToUpperTable[tmp_str1^]
                then goto Next;
            end;//while
            //  startpos    
            Result:=startpos;
            Exit;
          end;//if str2^=str1^
        Next:
          //   . 
          Inc(str2);
          Dec(len2);
          Inc(startpos);
      end;//while
    end;//else
end;

function UStr_To_String(s:PUA_UnicodeString):String;
var len:Integer;
begin
  if s=nil
    then Result:=''
    else begin
            len:=UStr_Length(s);
            SetLength(Result,len);
            Move(s^.Arr[0],Result[1],len+len);
         end;
end;

procedure UStr_Add_BackSlash(var s:PUA_UnicodeString);
var len:Integer;
    c:WideChar;
begin
  len:=UStr_Length(s);
  //    ,   
  if len=0
    then c:=#0
    else c:=s^.Arr[len-1];
  //     
  if (c<>'/') and (c<>'\') then
    begin
      UStr_Resize(s,len+1);
      s^.Arr[len]:='\';
    end;//if
end;

var wcharc:WideChar;

begin
  //      
  for wcharc:=Low(WideChar) to High(WideChar)
    do WideToUpperTable[wcharc]:=wcharc;
  //      
  Move(WideToUpperTable[#0],WideToLowerTable[#0],SizeOf(WideToUpperTable));
  CharUpperBuffW(@WideToUpperTable[#0],$FFFF);
  CharLowerBuffW(@WideToLowerTable[#0],$FFFF);
end.
