unit NeoS0M_UStrL;

interface

uses Windows,NeoS0M_Types, NeoS0M_UnifiedArray;

//    Unicode-
function UStrL_Create:PUA_UnicodeStringList;inline;
//   
procedure UStrL_Destroy(var usl:PUA_UnicodeStringList);inline;
//  Unicode-  
function UStrL_Add(var usl:PUA_UnicodeStringList; UStr:PWideChar; UStrLen:Cardinal=$FFFFFFFF):Integer;
//       Unicode-
function UStrL_Append(var arr:PUA_UnicodeStringList; value:PUA_UnicodeString; count:Cardinal):Integer;

//    ,    
function UStrL_Find(const strl:PUA_UnicodeStringList; const value:PUA_UnicodeString; _From,_To:Cardinal; Comparsion:TStringComparsionMethod):Cardinal;

implementation

uses NeoS0M_xL, NeoS0M_UStr, NeoS0M_Math;

function UStrL_Create:PUA_UnicodeStringList;inline;
begin
  Result:=PUA_UnicodeStringList(xL_Create);
end;

procedure UStrL_Destroy(var usl:PUA_UnicodeStringList);inline;
begin
  xL_Destroy(PUA_xList(usl));
end;

function UStrL_Add(var usl:PUA_UnicodeStringList; UStr:PWideChar; UStrLen:Cardinal=$FFFFFFFF):Integer;
var us:PUA_UnicodeString;
begin
  //   ,   
  if UStrLen=0 //  
    then us:=@EmptyUnicodeString
    else us:=UStr_From_Chars(UStr,IfThen(UStrLen=$FFFFFFFF,lstrlenW(UStr),UStrLen));
 //        -   
 if us=nil
    then Result:=CMD_OUT_OF_MEMORY
    //  -        
    else Result:=xL_Add(PUA_xList(usl),PArrayHeader(us));
end;

function UStrL_Append(var arr:PUA_UnicodeStringList; value:PUA_UnicodeString; count:Cardinal):Integer;
var p:^PUA_UnicodeString;
begin
  Result:=CMD_OK;
  if arr=nil
    then arr:=PUA_UnicodeStringList(UA_CreateR(count,SizeOf(PUA_UnicodeString)))
    else UA_Resize(PArrayHeader(arr),arr^.Header.ElemCount+count);
  if count<>0 then
    begin
      if arr=nil
        then Result:=CMD_OUT_OF_MEMORY
        else
          begin
            with arr^
              do p:=@Arr[Header.ElemCount-1];
            repeat
              //    Unicode-,   
              p^:=UStr_Duplicate(value);
              Dec(count);
              Dec(p);
            until count=0;
          end;
    end;
end;

function UStrL_Find(const strl:PUA_UnicodeStringList; const value:PUA_UnicodeString; _From,_To:Cardinal; Comparsion:TStringComparsionMethod):Cardinal;
var i,l:Cardinal;
    p1,p2:PWideChar;
    l1,l2:Cardinal;
    Found:Boolean;
begin
  Result:=$FFFFFFFF;
  l:=xL_Length(PUA_xList(strl));
  //         
  _To:=Min(_To,l-1);
  //          -   
  if (_From<=_To) and (l<>0) then
    begin
      //      
      p1:=@value.Arr;
      l1:=UStr_Length(value);
      for i:=_From to _To do
        begin
          //        
          p2:=@strl.Arr[i]^.Arr;
          l2:=UStr_Length(strl.Arr[i]);
          case Comparsion of
            scmTrueEquality:      Found:=_UStr_Compare(p1,l1,p2,l2)=0;
            scmEqualityWOCase:    Found:=_UStr_CompareI(p1,l1,p2,l2)=0;
            scmTrueIsSubstring:   Found:=_UStr_PosEx(p1,l1,p2,l2,0)<>-1;
            scmIsSubstringWOCase: Found:=_UStr_PosExI(p1,l1,p2,l2,0)<>-1;
            else Found:=False;
          end;//case
          if Found then
            begin
              Result:=i;
              Break;
            end;//if Found
        end;//for
    end;//if
end;


end.
