unit NeoS0M_UStrParser;

interface

uses NeoS0M_Types,NeoS0M_UStrL,NeoS0M_xL,NeoS0M_UStr,NeoS0M_UnifiedArray;

function ParseDelimitedUStr(var ustrl:PUA_UnicodeStringList; s,Delim:PUA_UnicodeString; AddEmptyLines:Boolean):Integer;
function ParseQuotedUStr(var ustrl:PUA_UnicodeStringList; s,Quote:PUA_UnicodeString; AddEmptyLines:Boolean):Integer;
function ParseDandQUStr(var ustrl:PUA_UnicodeStringList; s,Delim,Quote:PUA_UnicodeString; AddEmptyLines:Boolean):Integer;

implementation

type TArrayOfWideChar=packed array [0..$FFFFFF] of WideChar;
     PArrayOfWideChar=^TArrayOfWideChar;

function ParseDelimitedUStr(var ustrl:PUA_UnicodeStringList; s,Delim:PUA_UnicodeString; AddEmptyLines:Boolean):Integer;
var s_start,delim_start:PWideChar;
    s_len,delim_len,cur_pos,delim_pos,add_len:Cardinal;
begin
  with s^ do
  begin
    s_start:=@Arr;
    s_len:=Header.ElemCount-1;
  end;//with
  with Delim^ do
  begin
    delim_start:=@Arr;
    delim_len:=Header.ElemCount-1;
  end;//with
  //   ,      
  ustrl:=UStrL_Create;
  if ustrl<>nil then
    begin
      cur_pos:=0;
      repeat
        //   -
        delim_pos:=_UStr_PosEx(delim_start,delim_len,s_start,s_len,cur_pos);
        if delim_pos=$FFFFFFFF
          then add_len:=s_len-cur_pos
          else add_len:=delim_pos-cur_pos;
        if AddEmptyLines or (add_len>0) //     
          then Result:=UStrL_Add(ustrl,Pointer(Cardinal(s_start)+(cur_pos shl 1)),add_len)
          else Result:=CMD_OK;
        //       + 
        cur_pos:=delim_pos+delim_len;
      until (delim_pos=$FFFFFFFF) or (Result<>CMD_OK);
    end//else
  else Result:=CMD_OUT_OF_MEMORY;
end;

function CountDupes(s:PArrayOfWideChar; s_len:Cardinal; dup:PArrayOfWideChar; dup_len:Cardinal; start_pos:Cardinal):Cardinal;
var pos_in_dup:Cardinal;
begin
  Result:=0;
  pos_in_dup:=0;
  while start_pos<s_len do
  begin
    if s^[start_pos]<>dup^[pos_in_dup]
      then Break;
    Inc(start_pos);
    if pos_in_dup=dup_len-1 then
      begin
        pos_in_dup:=0;
        Inc(Result);
      end
      else Inc(pos_in_dup);
  end;//while
end;

function FindOddQuotes(s:PArrayOfWideChar; s_len:Cardinal; dup:PArrayOfWideChar; dup_len:Cardinal; start_pos:Cardinal; var position,last_count:Cardinal):Cardinal;
//   ;   -  position
var tmp_pos:Cardinal;
begin
  Result:=0;
  position:=0;
  tmp_pos:=start_pos;
  repeat
    //     
    tmp_pos:=_UStr_PosEx(PWideChar(dup),dup_len,PWideChar(s),s_len,tmp_pos);
    if tmp_pos<>$FFFFFFFF then //   
    begin
      //      
      last_count:=CountDupes(s,s_len,dup,dup_len,tmp_pos+dup_len)+1;
      //       
      Inc(Result,last_count);
      //       
      if Odd(last_count) then
        begin
          position:=tmp_pos;
          Break;
        end;
      Inc(tmp_pos,last_count*dup_len); //       
    end;//if tmp_pos<>$FFFFFFFF
  until tmp_pos=$FFFFFFFF;
end;

function MakeDequotedUnicodeString(s:PArrayOfWideChar; s_len:Cardinal; quote:PArrayOfWideChar; quote_len,quote_count:Cardinal):PUA_UnicodeString;
var j,cur_pos,pos_in_new,q_count:Cardinal;
begin
  Result:=UStr_Allocate(s_len-(quote_count shr 1)*quote_len);
  cur_pos:=0;
  pos_in_new:=0;
  with Result^ do
  begin
    while cur_pos<s_len do
    begin
      q_count:=CountDupes(s,s_len,quote,quote_len,cur_pos);
      if q_count=0 then
      //   
        begin
          Arr[pos_in_new]:=s^[cur_pos];
          Inc(cur_pos);
          Inc(pos_in_new);
        end
        else //  
          begin
            //   2   , ..  
            q_count:=q_count shr 1;
            for j:=0 to q_count*quote_len-1
              do Arr[pos_in_new+j]:=s^[cur_pos+j];
            Inc(cur_pos,(q_count+q_count)*quote_len);
            Inc(pos_in_new,q_count*quote_len);
          end;//else
    end;//while
  end;//with
end;

function CountOddBlocks(s:PArrayOfWideChar; q:PArrayOfWideChar; q_len:Cardinal; _start,_end:Cardinal):Integer;
//      
// start -  , end -  
var s_p,q_c:Cardinal;
begin
  Result:=0;
  s_p:=_start;
  Inc(_end);
  repeat
    //      
    s_p:=_UStr_PosEx(PWideChar(q),q_len,PWideChar(s),_end,s_p);
    if s_p<>$FFFFFFFF then
      begin
        //    ,   
        q_c:=CountDupes(s,_end,q,q_len,s_p+q_len);
        //   .     - ,
        //      1
        if not Odd(q_c)
          then Inc(Result);
        //        
        Inc(s_p,(q_c+1)*q_len);
      end;
  // ,         
  until (s_p=$FFFFFFFF) or (s_p>=_end);
end;

function ParseQuotedUStr(var ustrl:PUA_UnicodeStringList; s,Quote:PUA_UnicodeString; AddEmptyLines:Boolean):Integer;
var _s,_quote:PArrayOfWideChar;
    _s_len,_quote_len,sq_count,eq_count,word_start,word_end,lc:Cardinal;
    _ln:PUA_UnicodeString;
begin
  ustrl:=UStrL_Create;
  if ustrl<>nil then
    begin
      Result:=CMD_OK;
      _s:=@s^.Arr;
      _s_len:=s^.Header.ElemCount-1;
      with Quote^ do
      begin
        _quote:=@Arr;
        _quote_len:=Header.ElemCount-1;
      end;//with
      word_start:=0;
      repeat
       //   
       sq_count:=FindOddQuotes(_s,_s_len,_quote,_quote_len,word_start,word_start,lc);
       eq_count:=0;
       if Odd(sq_count) then //      
         begin
           //   
           sq_count:=lc;
           eq_count:=FindOddQuotes(_s,_s_len,_quote,_quote_len,word_start+sq_count*_quote_len,word_end,lc);
           if Odd(eq_count) then //      -        
           begin
             Inc(word_end,(lc-1)*_quote_len); //   -       
             Inc(word_start,_quote_len); //   
             _ln:=MakeDequotedUnicodeString(@_s[word_start],word_end-word_start,_quote,_quote_len,sq_count+eq_count-2);
             Result:=xL_Add(PUA_xList(ustrl),PArrayHeader(_ln));
             //    .  -    () ,    
             word_start:=word_end+_quote_len;
           end;//if Odd(eq_count)
         end//if Odd(sq_count)
      until (not Odd(sq_count)) or (not Odd(eq_count));
    end//if ustrl<>nil
  else Result:=CMD_OUT_OF_MEMORY
end;

{$WARNINGS OFF}
function ParseDandQUStr(var ustrl:PUA_UnicodeStringList; s,Delim,Quote:PUA_UnicodeString; AddEmptyLines:Boolean):Integer;
label NoOddBlocks;
var _s,_quote,_delim:PArrayOfWideChar;
    _s_len,_quote_len,_delim_len,sq_count,word_start,word_end,space_pos:Cardinal;
    OddBlocks,b_s_pos:Cardinal;
begin
  ustrl:=UStrL_Create;
  if ustrl<>nil then
  begin
    Result:=CMD_OK;
    with s^ do
    begin
      _s:=@Arr;
      _s_len:=Header.ElemCount-1;
    end;
    with Delim^ do
    begin
      _delim:=@Arr;
      _delim_len:=Header.ElemCount-1;
    end;
    with Quote^ do
    begin
      _quote:=@Arr;
      _quote_len:=Header.ElemCount-1;
    end;
    word_start:=0;
    repeat
      OddBlocks:=0;
      sq_count:=CountDupes(_s,_s_len,_delim,_delim_len,word_start);
      Inc(word_start,sq_count*_delim_len); //          
      b_s_pos:=word_start; //      
NoOddBlocks:
      //   -    (..   )
      space_pos:=_UStr_PosEx(PWideChar(_delim),_delim_len,PWideChar(_s),_s_len,b_s_pos);
      if space_pos=$FFFFFFFF //     
        then word_end:=_s_len-1 // ,     -    
        else //  
          begin
            //       
            Inc(OddBlocks,CountOddBlocks(_s,_quote,_quote_len,b_s_pos,space_pos-1));
            if Odd(OddBlocks) then //    .   - 
              begin
                //  ,       
                b_s_pos:=space_pos+_delim_len;
                goto NoOddBlocks;
              end
            else word_end:=space_pos-1; //    -     
          end;//else
      if (word_end>=word_start) and (word_end<>$FFFFFFFF) //      0
        then UStrL_Add(ustrl,@_s[word_start],word_end-word_start+1);
      word_start:=word_end+1;
    until word_start>=_s_len;
  end
  else Result:=CMD_OUT_OF_MEMORY;
end;
{$WARNINGS ON}

end.
