unit NeoS0M_VarManager;

interface

uses Windows,NeoS0M_Types, NeoS0M_Variables, NeoS0M_UnifiedArray;

// ,   ,       nil
function Variable_GetAddress(const context:TScriptContext; var_idx:Cardinal):PNeoS0MVariable;
//   
function Variable_GetType(const context:TScriptContext; var_idx:Cardinal):TVarType;

//  DWORD  ,    VarPtr.      
procedure Variable_StoreDWORD(VarPtr:PNeoS0MVariable; value:Cardinal);
//            DWORD.   -  ; res -  
function Variable_qLoadDWORD(const context:TScriptContext; index:Cardinal; var res:Cardinal):Cardinal;
//      .   -  ; res -  
function VariableOrArray_qLoadDWORD(const context:TScriptContext; index:Cardinal; var res:Cardinal):Cardinal;
//     .   -  
function Variable_qStoreDWORD(const context:TScriptContext; index,value:Cardinal):Cardinal;stdcall;
//  Integer  ,    VarPtr.      
procedure Variable_StoreInteger(VarPtr:PNeoS0MVariable; value:Int64);
//  64-   .   -  
function Variable_qStoreINTEGER(const context:TScriptContext; index:Cardinal; value:Int64):Cardinal;stdcall;
//   64-   .   -  ; res -  
function Variable_qLoadINTEGER(const context:TScriptContext; index:Cardinal; var res:Int64):Cardinal;
//        .   -  ; res -  
function Variable_qLoadFLOAT(const context:TScriptContext; index:Cardinal; var res:Extended):Cardinal;
//       
function Variable_qWriteBinary(const context:TScriptContext; index:Cardinal; val_start:Pointer; val_len:Cardinal):Cardinal; stdcall;
//        
function Variable_qStoreFLOAT(const context:TScriptContext; index:Cardinal; value:Extended):Cardinal; stdcall;
//        
function Variable_qStoreBinary(const context:TScriptContext; index:Cardinal; value:PUA_BinaryBlock):Cardinal;
//   Unicode-  
function Variable_qWriteUnicodeString(const context:TScriptContext; index:Cardinal; val_start:PWideChar; char_count:Cardinal):Cardinal; stdcall;
//   Unicode-  
function Variable_qLoadUnicodeString(const context:TScriptContext; index:Cardinal; var res:UnicodeString):Cardinal; stdcall;

//      
function Variable_InitBBL(const context:TScriptContext; index:Cardinal):Cardinal;stdcall;
//      
function Variable_AddItemBBL(const context:TScriptContext; index:Cardinal; val_start:Pointer; val_len:Cardinal):Cardinal;stdcall;
function Variable_AssignItemBBL(const context:TScriptContext; index,item_index:Cardinal; arr:PUA_BinaryBlock):Integer;
//        .    .
function Variable_GetBBLItem(const context:TScriptContext; var_idx,item_idx:Integer; var DataLen:Cardinal):PByte;
//        . 
//function Variable_GetBBLLength(const context:TScriptContext; var_idx:Integer; var len:Cardinal):Cardinal;
//     

//   Unicode-  
function Variable_InitUStrL(const context:TScriptContext; index:Cardinal):Cardinal;stdcall;
//    Unicode- 
function Variable_AddItemUStrL(const context:TScriptContext; index:Cardinal; str_start:Pointer; str_len:Cardinal):Cardinal; stdcall;
//     Unicode-  .    .
function Variable_AssignItemUStrL(const context:TScriptContext; index,item_index:Cardinal; arr:PUA_UnicodeString):Integer;
//          
function Variable_GetUStrLItem(const context:TScriptContext; var_idx,item_idx:Integer; var DataLen:Cardinal):PWideChar;

function Variable_qLoadxArray(const context:TScriptContext; index:Cardinal; TypeNeeded:TVarType; var res:Pointer):Cardinal;
function Variable_qLoadBinary(const context:TScriptContext; index:Cardinal; var res:PUA_BinaryBlock):Cardinal;
//      .   -  ; res -    
function Variable_qLoadDWORDArray(const context:TScriptContext; index:Cardinal; var res:PUA_DWORD):Cardinal;
function Variable_qLoadIntArray(const context:TScriptContext; index:Cardinal; var res:PUA_Integer):Cardinal;
function Variable_qLoadFloatArray(const context:TScriptContext; index:Cardinal; var res:PUA_Extended):Cardinal;
//     .   -  ; res -   

function Variable_AssignArray(var_addr:PNeoS0MVariable; arr:PArrayHeader; _type:TVarType):Cardinal;overload;
function Variable_AssignArray(const context:TScriptContext; index:Cardinal; arr:PArrayHeader; _type:TVarType):Cardinal;overload;
// ""   ,   .    ,    
function Variable_GetArrayItemPtr(const context:TScriptContext; index,item_index:Cardinal):Pointer;overload;
function Variable_GetArrayItemPtr(const context:TScriptContext; index,item_index:Cardinal; var arr_len:Cardinal):Pointer;overload;
//        ,         
//       ,    
function Variable_AddDWORDToArray(const context:TScriptContext; index, value:Cardinal):Cardinal;
//       

function Variable_DuplicateIfStatic(var context:TScriptContext; index: Cardinal):Boolean;
//  ,   ,    ,  .
//       .      

function Variables_Allocate(var context:TScriptContext; var_count:Cardinal; AllocateGlobal:Boolean):Cardinal;
//  var_count       (    )
//     
function Variables_Free(var context:TScriptContext; var_count:Cardinal; FreeGlobal:Boolean):Integer;
//  var_count      
//   
function StackFrame_Add(var context:TScriptContext):Cardinal;
//       
function StackFrame_Drop(var context:TScriptContext):Cardinal;
//     
procedure Variable_Deinitialize(VarPtr:PNeoS0MVariable);
//       

implementation

uses NeoS0M_USTR,NeoS0M_BBL,NeoS0M_UStrL,NeoS0M_xL,NeoS0M_BB;

{procedure Variable_Initialize(vars:PNeoS0MVariables; var_idx,var_count:Cardinal);
//   .      ,     
begin
  FillChar(vars^.Variables[var_idx],var_count*SizeOf(TNeoS0MVariable),0);
end;}

function StackFrame_Add(var context:TScriptContext):Cardinal;
var l:Integer;
begin
  l:=Length(context.StackFrames);
  SetLength(context.StackFrames,l+1);
  Result:=CMD_OK;
end;

function StackFrame_Drop(var context:TScriptContext):Cardinal;
var l,i:Integer;
begin
with context do
begin
  l:=Length(StackFrames);
  //      
  if l>0 then
    begin
      //      ,  
      for i:=Low(StackFrames[l-1]) to High(StackFrames[l-1])
        do Variable_Deinitialize(@StackFrames[l-1][i]);
      //    
      StackFrames[l-1]:=nil;
      //    
      SetLength(StackFrames,l-1);
      Result:=CMD_OK;
    end
  else Result:=CMD_NO_STACK;
end;//with
end;


function Variables_Allocate(var context:TScriptContext; var_count:Cardinal; AllocateGlobal:Boolean):Cardinal;
var StackFramesLength,StackFrameIdx:Integer;
begin
with context do
begin
  StackFramesLength:=Length(StackFrames);
  //     -   .     .
  if StackFramesLength=0 then
    begin
      StackFrame_Add(context);
      StackFramesLength:=1;
    end;
  //   ,    
  if AllocateGlobal
    then StackFrameIdx:=0
    else StackFrameIdx:=StackFramesLength-1;
  //   
  if var_count>0 then
    begin
      Result:=Length(StackFrames[StackFrameIdx]);
      SetLength(StackFrames[StackFrameIdx],Result+var_count);
      //     
      ZeroMemory(@StackFrames[StackFrameIdx][Result],SizeOf(TNeoS0MVariable)*var_count);
    end
  else Result:=$FFFFFFFF;
end;//with
end;

function Variables_Free(var context:TScriptContext; var_count:Cardinal; FreeGlobal:Boolean):Integer;
var StackFramesLength,StackFrameIdx:Integer;
begin
  with context do
  begin
    StackFramesLength:=Length(StackFrames);
    //     -   ,  
    if StackFramesLength=0
      then Result:=CMD_NO_STACK
      else
        begin
          Result:=CMD_OK;
          //   ,     
          if FreeGlobal
            then StackFrameIdx:=0
            else StackFrameIdx:=StackFramesLength-1;
          //  StackFramesLength       
          StackFramesLength:=High(StackFrames[StackFrameIdx]);
          //  ,   
          while var_count<>0 do
            begin
              //     ?
              if StackFramesLength<0 then
                begin
                  Result:=CMD_INVALID_VARIABLE_COUNT;
                  Break;
                end;
              Variable_Deinitialize(@StackFrames[StackFrameIdx][StackFramesLength]);
              Dec(StackFramesLength);
              Dec(var_count);
            end;
          //   
          SetLength(StackFrames[StackFrameIdx],StackFramesLength+1);
        end;
  end;//with
end;

function Variable_GetAddress(const context:TScriptContext; var_idx:Cardinal):PNeoS0MVariable;
// ,   ,       nil
var frame_idx:Integer;
begin
with context do
begin
  frame_idx:=Length(StackFrames);
  if frame_idx=0 //     -    
    then Result:=nil
    else
      begin
        //           
        if var_idx<=VARIABLE_INDEX_MASK
          then frame_idx:=0
          else
            begin
              Dec(frame_idx);
              var_idx:=var_idx and VARIABLE_INDEX_MASK;
            end;
        // ,         
        if Integer(var_idx)<Length(StackFrames[frame_idx])
          then Result:=@StackFrames[frame_idx][var_idx]
          //       
          else Result:=nil;
      end;//else
end;//with
end;

function Variable_GetType(const context:TScriptContext; var_idx:Cardinal):TVarType;
var v:PNeoS0MVariable;
begin
  v:=Variable_GetAddress(context,var_idx);
  if v=nil
    then Result:=vtUninitialized
    else Result:=v^.VarType;
end;

procedure ArrayDeinitializer(var arr:PArrayHeader);
//       
begin
  UA_Destroy(arr);
end;

procedure ListDeinitializer(var arr:PArrayHeader);
//        Unicode-
begin
  xL_Destroy(PUA_xList(arr));
end;

type T_Deinitializer=procedure (var arr:PArrayHeader);
const _Deinitializers:packed array[TVarType] of T_Deinitializer=(
        nil, // vtUninitialized
        nil, // vtInteger
        nil, // vtExtended,
        ArrayDeinitializer, // vtIntArray
        ArrayDeinitializer, // vtExtArray
        ArrayDeinitializer, // vtBinBlock
        ListDeinitializer,  // vtBinBlockList
        nil, // vtDWORD
        ArrayDeinitializer, // vtDWORDArray
        ArrayDeinitializer, // vtUnicodeString
        ListDeinitializer,  // vtUnicodeStringList
        nil  // vtInvalid=11
        );

procedure Variable_Deinitialize(VarPtr:PNeoS0MVariable);
begin
with VarPtr^ do
begin
  { DONE :        }
  { DONE :      Unicode- }
  //    "" 
  if Assigned(_Deinitializers[VarType])
    then _Deinitializers[VarType](UA);
  //    " "
  VarType:=vtUninitialized;
end;//with
end;

procedure Variable_StoreDWORD(VarPtr:PNeoS0MVariable; value:Cardinal);
//  DWORD  ,    VarPtr.      
begin
 Variable_Deinitialize(VarPtr);
 with VarPtr^ do
  begin
   VarType:=vtDWORD;
   AsDWORD:=value;
  end;
end;

function Variable_qLoadDWORD(const context:TScriptContext; index:Cardinal; var res:Cardinal):Cardinal;
//      .   -  ; res -  
var VarPtr:PNeoS0MVariable;
begin
 VarPtr:=Variable_GetAddress(context,index);
 if VarPtr=nil
  then Variable_qLoadDWORD:=CMD_INVALID_VARIABLE_INDEX
  else
   begin
    with VarPtr^ do
     begin
      Variable_qLoadDWORD:=CMD_OK;
      case VarType of
       vtDWORD:   res:=AsDWORD;
       vtInteger: res:=AsInteger;
       else Variable_qLoadDWORD:=CMD_PARAM_TYPE_MISMATCH;
      end;//case
     end;//with
   end;//else
end;

function Variable_qLoadINTEGER(const context:TScriptContext; index:Cardinal; var res:Int64):Cardinal;
var VarPtr:PNeoS0MVariable;
begin
 VarPtr:=Variable_GetAddress(context,index);
 if VarPtr=nil
  then Variable_qLoadINTEGER:=CMD_INVALID_VARIABLE_INDEX
  else
   begin
    with VarPtr^ do
     begin
      Variable_qLoadINTEGER:=CMD_OK;
      case VarType of
       vtDWORD:   res:=AsDWORD;
       vtInteger: res:=AsInteger;
       else Variable_qLoadINTEGER:=CMD_PARAM_TYPE_MISMATCH;
      end;//case
     end;//with
   end;//else
end;

function Variable_qLoadFLOAT(const context:TScriptContext; index:Cardinal; var res:Extended):Cardinal;
var VarPtr:PNeoS0MVariable;
begin
 VarPtr:=Variable_GetAddress(context,index);
 if VarPtr=nil
  then Variable_qLoadFLOAT:=CMD_INVALID_VARIABLE_INDEX
  else
   begin
    with VarPtr^ do
     begin
      Variable_qLoadFLOAT:=CMD_OK;
      case VarType of
       vtDWORD:    res:=AsDWORD;
       vtInteger:  res:=AsInteger;
       vtExtended: res:=AsExtended;
       else Variable_qLoadFLOAT:=CMD_PARAM_TYPE_MISMATCH;
      end;//case
     end;//with
   end;//else
end;

function Variable_qStoreDWORD(const context:TScriptContext; index,value:Cardinal):Cardinal;
//     
var VarPtr:PNeoS0MVariable;
begin
  VarPtr:=Variable_GetAddress(context,index);
  if VarPtr=nil
    then Variable_qStoreDWORD:=CMD_INVALID_VARIABLE_INDEX
    else
      begin
        Variable_StoreDWORD(VarPtr,value);
        Variable_qStoreDWORD:=CMD_OK;
      end;
end;

function Variable_qLoadxArray(const context:TScriptContext; index:Cardinal; TypeNeeded:TVarType; var res:Pointer):Cardinal;
//       .   -  ; res -    
var VarPtr:PNeoS0MVariable;
begin
  VarPtr:=Variable_GetAddress(context,index);
  if VarPtr=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else
      begin
        with VarPtr^ do
        begin
          if VarType=TypeNeeded then
            begin
              res:=UA;
              Result:=CMD_OK;
            end
          else Result:=CMD_PARAM_TYPE_MISMATCH;
        end;//with
      end;//else
end;

function Variable_qLoadBinary(const context:TScriptContext; index:Cardinal; var res:PUA_BinaryBlock):Cardinal;
//      .   -  ; res -    
begin
 Result:=Variable_qLoadxArray(context,index,vtBinBlock,Pointer(res));
end;

function Variable_qLoadDWORDArray(const context:TScriptContext; index:Cardinal; var res:PUA_DWORD):Cardinal;
//    DWORD'  .   -  ; res -    
begin
 Result:=Variable_qLoadxArray(context,index,vtDWORDArray,Pointer(res));
end;

function Variable_qLoadIntArray(const context:TScriptContext; index:Cardinal; var res:PUA_Integer):Cardinal;
//    64-   .   -  ; res -    
begin
 Result:=Variable_qLoadxArray(context,index,vtIntArray,Pointer(res));
end;

function Variable_qLoadFloatArray(const context:TScriptContext; index:Cardinal; var res:PUA_Extended):Cardinal;
//       .   -  ; res -    
begin
 Result:=Variable_qLoadxArray(context,index,vtExtArray,Pointer(res));
end;

function Variable_WriteBinary(VarPtr:PNeoS0MVariable; val_start:Pointer; val_len:Cardinal):Cardinal;
begin
  Variable_Deinitialize(VarPtr);
  with VarPtr^ do
    begin
      VarType:=vtBinBlock;
      UA:=PArrayHeader(BB_From_Bytes(val_start,val_len));
      if UA=nil
        then result:=CMD_OUT_OF_MEMORY
        else Result:=CMD_OK;
    end;//with
end;

function Variable_qWriteBinary(const context:TScriptContext; index:Cardinal; val_start:Pointer; val_len:Cardinal):Cardinal;
var VarPtr:PNeoS0MVariable;
begin
 VarPtr:=Variable_GetAddress(context,index);
 if VarPtr=nil
  then Variable_qWriteBinary:=CMD_INVALID_VARIABLE_INDEX
  else Variable_qWriteBinary:=Variable_WriteBinary(VarPtr,val_start,val_len);
end;

function Variable_WriteUnicodeString(VarPtr:PNeoS0MVariable; val_start:PWideChar; char_count:Cardinal):Cardinal;
begin
  Variable_Deinitialize(VarPtr);
  with VarPtr^ do
    begin
      if char_count=0
        //    -    
        then UA:=PArrayHeader(@EmptyUnicodeString)
        //    -     
        else UA:=PArrayHeader(UStr_Allocate(char_count));
      if UA=nil
        then Result:=CMD_OUT_OF_MEMORY
        else
          begin
            //    
            if char_count<>0 then
              begin
                //  
                Move(val_start^,(PUA_UnicodeString(UA))^.Arr[0],char_count+char_count);
                //   
                (PUA_UnicodeString(UA))^.Arr[char_count]:=#0;
                //    
              end;
            VarType:=vtUnicodeString;
            Result:=CMD_OK;
          end;
    end;//with
end;

function Variable_qWriteUnicodeString(const context:TScriptContext; index:Cardinal; val_start:PWideChar; char_count:Cardinal):Cardinal;
var VarPtr:PNeoS0MVariable;
begin
  VarPtr:=Variable_GetAddress(context,index);
  if VarPtr=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else Result:=Variable_WriteUnicodeString(VarPtr,val_start,char_count);
end;

function Variable_qStoreBinary(const context:TScriptContext; index:Cardinal; value:PUA_BinaryBlock):Cardinal;
//     
begin
 with value^ do result:=Variable_qWriteBinary(context,index,@Arr,Header.ElemCount-2);
end;

procedure Variable_StoreInteger(VarPtr:PNeoS0MVariable; value:Int64);
begin
 Variable_Deinitialize(VarPtr);
 with VarPtr^ do begin VarType:=vtInteger; AsInteger:=value; end;
end;

function Variable_qStoreINTEGER(const context:TScriptContext; index:Cardinal; value:Int64):Cardinal;
//  64-   
var VarPtr:PNeoS0MVariable;
begin
 VarPtr:=Variable_GetAddress(context,index);
 if VarPtr=nil
  then Variable_qStoreINTEGER:=CMD_INVALID_VARIABLE_INDEX
  else begin Variable_StoreInteger(VarPtr,value); Variable_qStoreINTEGER:=CMD_OK; end;
end;

function Variable_qStoreFLOAT(const context:TScriptContext; index:Cardinal; value:Extended):Cardinal;
//       
var VarPtr:PNeoS0MVariable;
begin
 VarPtr:=Variable_GetAddress(context,index);
 if VarPtr=nil
  then Variable_qStoreFLOAT:=CMD_INVALID_VARIABLE_INDEX
  else
   begin
    Variable_Deinitialize(VarPtr);
    with VarPtr^ do begin VarType:=vtExtended; AsExtended:=value; end;
    Variable_qStoreFLOAT:=CMD_OK;
   end;//else
end;

function Variable_AssignArray(var_addr:PNeoS0MVariable; arr:PArrayHeader; _type:TVarType):Cardinal;overload;
begin
 if var_addr=nil
  then Result:=CMD_INVALID_VARIABLE_INDEX
  else
   begin
    Variable_Deinitialize(var_addr);
    with var_addr^ do
    begin
     VarType:=_type;
     UA:=arr;
     Result:=CMD_OK;
    end;//with
   end;
end;

function Variable_AssignArray(const context:TScriptContext; index:Cardinal; arr:PArrayHeader; _type:TVarType):Cardinal;overload;
begin
  Result:=Variable_AssignArray(Variable_GetAddress(context,index),arr,_type);
end;

function Variable_AddDWORDToArray(const context:TScriptContext; index, value:Cardinal):Cardinal;
var v_a:PNeoS0MVariable;
begin
 v_a:=Variable_GetAddress(context,index);
 if v_a=nil then Result:=CMD_INVALID_VARIABLE_INDEX
  else
   begin
    _AddDWORDToArray(PUA_DWORD(v_a^.UA),value,1);
    Result:=CMD_OK;
   end;//else
end;

function Variable_GetArrayItemPtr(const context:TScriptContext; index,item_index:Cardinal):Pointer;
var v_a:PNeoS0MVariable;
begin
 v_a:=Variable_GetAddress(context,index);
 if v_a<>nil
  then Result:=_GetArrayItemPtr(v_a,item_index)
  else Result:=nil;
end;

function Variable_GetArrayItemPtr(const context:TScriptContext; index,item_index:Cardinal; var arr_len:Cardinal):Pointer;
var v_a:PNeoS0MVariable;
begin
 v_a:=Variable_GetAddress(context,index);
 if v_a<>nil
  then begin
        Result:=_GetArrayItemPtr(v_a,item_index);
        if Result<>nil
          then arr_len:=_GetArrayLength(v_a)-item_index
          else arr_len:=0;
       end
  else begin Result:=nil; arr_len:=0; end;
end;

function VariableOrArray_qLoadDWORD(const context:TScriptContext; index:Cardinal; var res:Cardinal):Cardinal;
var pvalue:PCardinal;
begin
 case Variable_GetType(context,index) of
  vtDWORD,vtInteger:  Result:=Variable_qLoadDWORD(context,index,res);
  vtDWORDArray :      begin
                       pvalue:=Variable_GetArrayItemPtr(context,index,0);
                       if pvalue=nil
                        then Result:=CMD_INVALID_ARRAY_ITEM_INDEX
                        else begin res:=pvalue^; Result:=CMD_OK; end;
                      end;
  else Result:=CMD_TYPECAST_IMPOSSIBLE;
 end;//case
end;

function Variable_AddItemBBL(const context:TScriptContext; index:Cardinal; val_start:Pointer; val_len:Cardinal):Cardinal;
var v_a:PNeoS0MVariable;
begin
  v_a:=Variable_GetAddress(context,index);
  if v_a=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else
      begin
        if v_a.VarType=vtBinBlockList
          then Result:=BBL_Add(PUA_BinBlockList(v_a^.UA),val_start,val_len)
          else Result:=CMD_TYPECAST_IMPOSSIBLE;
      end//else
end;

function Variable_AssignItemxL(const context:TScriptContext; index,item_index:Cardinal; arr:PArrayHeader; _type:TVarType):Cardinal;
var v_a:PNeoS0MVariable;
    pItem:^PArrayHeader;
begin
  v_a:=Variable_GetAddress(context,index);
  if Assigned(v_a) then
    begin
      //   .        -  
      if v_a^.VarType=_type then
        begin
          //    ,    
          pItem:=_GetArrayItemPtr(v_a,item_index);
          if Assigned(pItem) then
            begin
              //     
              UA_Destroy(pItem^);
              //        
              pItem^:=arr;
              Result:=CMD_OK;
            end//if Assigned(pItem)
        //      -    
        else Result:=CMD_INVALID_ARRAY_ITEM_INDEX;
      end//if v_a^.VarType=_type
      else Result:=CMD_TYPECAST_IMPOSSIBLE;
    end//if Assigned(v_a)
  //      
  else Result:=CMD_INVALID_VARIABLE_INDEX;
end;

function Variable_AssignItemBBL(const context:TScriptContext; index,item_index:Cardinal; arr:PUA_BinaryBlock):Integer;
begin
  Result:=Variable_AssignItemxL(context,index,item_index,PArrayHeader(arr),vtBinBlockList);
end;

function Variable_AssignItemUStrL(const context:TScriptContext; index,item_index:Cardinal; arr:PUA_UnicodeString):Integer;
begin
  Result:=Variable_AssignItemxL(context,index,item_index,PArrayHeader(arr),vtUnicodeStringList);
end;

{function Variable_StoreItemBBL(const context:TScriptContext; index,item_index:Cardinal; val_start:Pointer; val_len:Cardinal):Cardinal;
var v_a:PNeoS0MVariable;
    store_it:PUA_BinaryBlock;
    p:PPointer;
begin
  v_a:=Variable_GetAddress(context,index);
  if v_a=nil then Result:=CMD_INVALID_VARIABLE_INDEX
   else
    begin
      //         
      if v_a^.VarType<>vtBinBlockList
        then begin Result:=CMD_TYPECAST_IMPOSSIBLE; Exit; end;
      //   ,   
      if val_len=0
       then store_it:=nil
       else store_it:=BB_From_Bytes(val_start,val_len);
      if (store_it=nil) and (val_len>0)
        then Result:=CMD_OUT_OF_MEMORY
        else
        begin
          with v_a^ do
            begin
              p:=_GetArrayItemPtr(v_a,item_index);
              if p<>nil
                then
                  begin
                    UA_Destroy(PArrayHeader(p^)); //    ,  - 
                    p^:=store_it; //    
                    Result:=CMD_OK;
                  end
                else Result:=CMD_INVALID_ARRAY_ITEM_INDEX;
            end;//with
        end;//else
    end//else
end;}

{function Variable_GetBBLItem(const context:TScriptContext; var_idx,item_idx:Integer; var DataLen:Cardinal):PByte;
var bb:PUA_BinaryBlock;
begin
  bb:=PPointer(Variable_GetArrayItemPtr(context,var_idx,item_idx))^;
with bb^ do
begin
  if bb=nil then
    begin
      //     
      Result:=@EmptyBinaryBlock[16];
      DataLen:=0;
    end
  else
    begin
      Result:=@Arr;
      DataLen:=Header.ElemCount-2;
    end;
end;//with
end;}

function Variable_InitxL(const context:TScriptContext; index:Cardinal; var_type:TVarType):Cardinal;stdcall;
var arr:PUA_xList;
begin
  //       Unicode-
  arr:=xL_Create;
  //   ,   
  if arr<>nil
    then Result:=Variable_AssignArray(context,index,PArrayHeader(arr),var_type)
    else Result:=CMD_OUT_OF_MEMORY;
  //         -     
  if Result<>CMD_OK
    then xL_Destroy(arr);
end;

function Variable_InitBBL(const context:TScriptContext; index:Cardinal):Cardinal;
begin
  Result:=Variable_InitxL(context,index,vtBinBlockList);
end;

function Variable_InitUStrL(const context:TScriptContext; index:Cardinal):Cardinal;stdcall;
begin
  Result:=Variable_InitxL(context,index,vtUnicodeStringList);
end;

function Variable_AddItemUStrL(const context:TScriptContext; index:Cardinal; str_start:Pointer; str_len:Cardinal):Cardinal;
var v_a:PNeoS0MVariable;
begin
  v_a:=Variable_GetAddress(context,index);
  if v_a=nil
    then Result:=CMD_INVALID_VARIABLE_INDEX
    else
      begin
        if v_a.VarType=vtUnicodeStringList
          then Result:=UStrL_Add(PUA_UnicodeStringList(v_a^.UA),str_start,str_len)
          else Result:=CMD_TYPECAST_IMPOSSIBLE;
      end//else
end;

function Variable_GetxLItem(const context:TScriptContext; var_idx,item_idx:Integer; var DataLen:Cardinal; SizeDecrement:Cardinal):Pointer;
var Item:PArrayHeader;
begin
  Item:=PPointer(Variable_GetArrayItemPtr(context,var_idx,item_idx))^;
  with PUA_BinaryBlock(Item)^ do
  begin
    if Item=nil then
      begin
        // Unicode-   2   
        Result:=@EmptyUnicodeString[16];
        DataLen:=0;
      end
  else
    begin
      //  -    
      Result:=@Arr;
      //  
      DataLen:=Header.ElemCount-SizeDecrement;
    end;
end;//with
end;

function Variable_GetUStrLItem(const context:TScriptContext; var_idx,item_idx:Integer; var DataLen:Cardinal):PWideChar;
begin
  Result:=Variable_GetxLItem(context,var_idx,item_idx,DataLen,1);
end;

function Variable_GetBBLItem(const context:TScriptContext; var_idx,item_idx:Integer; var DataLen:Cardinal):PByte;
begin
  Result:=Variable_GetxLItem(context,var_idx,item_idx,DataLen,2);
end;

function Variable_DuplicateIfStatic(var context:TScriptContext; index: Cardinal):Boolean;
var v_a:PNeoS0MVariable;
    NewArr:PArrayHeader;
begin
  v_a:=Variable_GetAddress(context,index);
  if v_a=nil
    then Result:=False
    else
      begin
        with v_a^ do
          begin
            Result:=True;
            if VarType in [vtIntArray,vtExtArray,vtBinBlock,vtDWORDArray,vtUnicodeString] then
              begin
                //      ,    
                if not UA^.IsDynamic then
                  begin
                    NewArr:=UA_CreateR(UA^.TrueElemCount,UA^.ElemSize);
                    if NewArr<>nil then
                      begin
                        //   
                        Move(PUA_BinaryBlock(UA)^.Arr[0],PUA_BinaryBlock(NewArr)^.Arr[0],UA^.TrueElemCount*UA^.ElemSize);
                        //          
                        UA:=NewArr;
                      end
                    else Result:=False;
                  end;// if not UA.IsDynamic
              end;//VarType in ...
          end;//with
      end;
end;

function Variable_qLoadUnicodeString(const context:TScriptContext; index:Cardinal; var res:UnicodeString):Cardinal; stdcall;
var var_addr:PNeoS0MVariable;
begin
  // ,     
  var_addr:=Variable_GetAddress(context,index);
  if var_addr<>nil then
  begin
    //   -   
    case var_addr^.VarType of
      vtUnicodeString:
        begin
          if var_addr^.UA=nil
            then res:=''
            else
              begin
                with PUA_UnicodeString(var_addr^.UA)^ do
                begin
                  //     
                  SetLength(res,Header.ElemCount-1);  { DONE :        }
                  Move(Arr,res[1],(Header.ElemCount-1)*sizeof(WideChar));
                end;
              end;
          Result:=CMD_OK;
        end;
      vtBinBlock:
        begin
          if var_addr^.UA=nil
            then res:=''
            else
              begin
                with PUA_BinaryBlock(var_addr^.UA)^ do
                begin
                  //  
                  SetLength(res,Header.ElemCount-2);
                  //  ANSI  Unicode
                  MultiByteToWideChar(CP_ACP,0,@Arr,Header.ElemCount-2,PWideChar(res),Header.ElemCount-2);
                end;
              end;
          Result:=CMD_OK;
        end;
      else
        begin
          res:='';
          Result:=CMD_COMMAND_INAPPLICABLE_FOR_THIS_TYPE;
        end;
    end;
  end
  else
  begin
    res:='';
    Result:=CMD_INVALID_VARIABLE_INDEX;
  end;
end;

exports Variable_qStoreDWORD name 'Var_StoreDWORD';
//     .   -  
exports Variable_qStoreINTEGER name 'Var_StoreInteger';
//  64-   .   -  
exports Variable_qStoreFLOAT name 'Var_StoreFloat';
//        
exports Variable_qWriteBinary name 'Var_StoreBinBlock';
//       
exports Variable_qWriteUnicodeString name 'Var_StoreUnicodeString';
//    Unicode-  
exports Variable_InitBBL name 'Var_InitBBL';
//      
exports Variable_AddItemBBL name 'Var_AddItemBBL';
//      
exports Variable_InitUStrL name 'Var_InitUStrL';
//      
exports Variable_AddItemUStrL name 'Var_AddItemUStrL';
//      


end.
