unit NeoS0M_Variables;

interface

uses NeoS0M_UnifiedArray, NeoS0M_Types;

const aaeTerminate=0;
      aaeTerminateWithMessageBox=1;
      aaeHook=2;

//        .
//   -  
function _AddDWORDToArray(var arr:PUA_DWORD; value:Cardinal; count:Cardinal):Integer;
function _AddIntegerToArray(var arr:PUA_Integer; value:Int64; count:Cardinal):Integer;
function _AddFloatToArray(var arr:PUA_Extended; value:Extended; count:Cardinal):Integer;

//    
//    ,  $FFFFFFFF,   
function _FindDWORDInArray(const arr:PUA_DWORD; value:Cardinal; _From,_To: Cardinal):Cardinal;
function _FindIntegerInArray(const arr:PUA_Integer; value:Int64; _From,_To: Cardinal):Cardinal;
function _FindFloatInArray(const arr:PUA_Extended; value:Extended; _From,_To: Cardinal):Cardinal;

function _ArrayLength(arr:PArrayHeader; ArrType:TVarType):Cardinal;

//         
function _GetArrayLength(v:PNeoS0MVariable):Cardinal;

//       NIL,     
function _GetArrayItemPtr(v:PNeoS0MVariable;ItemIndex:Cardinal):Pointer;

//        ,    
function _CopyArrayPart(arr:PArrayHeader;arrtype:TVarType;start_idx,count:Cardinal):PArrayHeader;

implementation

uses NeoS0M_Math,NeoS0M_USTR,NeoS0M_BB,NeoS0M_BBL,NeoS0M_UStrL,NeoS0M_xL;

function _AddDWORDToArray(var arr:PUA_DWORD; value:Cardinal; count:Cardinal):Integer;
var p:PCardinal;
begin
  Result:=CMD_OK;
  if arr=nil
    then arr:=PUA_DWORD(UA_CreateR(count,SizeOf(Cardinal)))
    else UA_Resize(PArrayHeader(arr),arr^.Header.ElemCount+count);
  if count<>0 then
    begin
      if arr=nil
        then Result:= CMD_OUT_OF_MEMORY
        else
          begin
            //     
            with arr^
              do p:=@Arr[Header.ElemCount-1];
            //       
            repeat
              p^:=value;
              Dec(count);
              Dec(p);
            until count=0;
          end;
    end;//if count<>0
end;

function _AddIntegerToArray(var arr:PUA_Integer; value:Int64; count:Cardinal):Integer;
var p:PInt64;
begin
  Result:=CMD_OK;
  if arr=nil
    then arr:=PUA_Integer(UA_CreateR(count,SizeOf(Int64)))
    else UA_Resize(PArrayHeader(arr),arr^.Header.ElemCount+count);
  if count<>0 then
    begin
      if arr=nil
        then Result:= CMD_OUT_OF_MEMORY
        else
          begin
            with arr^
              do p:=@Arr[Header.ElemCount-1];
            repeat
              p^:=value;
              Dec(count);
              Dec(p);
            until count=0;
          end;
    end;//if count<>0
end;

function _AddFloatToArray(var arr:PUA_Extended; value:Extended; count:Cardinal):Integer;
var p:PExtended;
begin
  Result:=CMD_OK;
  if arr=nil
    then arr:=PUA_Extended(UA_CreateR(count,SizeOf(Extended)))
    else UA_Resize(PArrayHeader(arr),arr^.Header.ElemCount+count);
  if count<>0 then
    begin
      if arr=nil
        then Result:= CMD_OUT_OF_MEMORY
        else
          begin
            with arr^
              do p:=@Arr[Header.ElemCount-1];
            repeat
              p^:=value;
              Dec(count);
              Dec(p);
            until count=0;
          end;
    end;//if count<>0
end;

function _FindDWORDInArray(const arr:PUA_DWORD; value:Cardinal; _From,_To: Cardinal):Cardinal;
var i,l:Cardinal;
begin
  Result:=$FFFFFFFF;
  l:=_ArrayLength(PArrayHeader(arr),vtDWORDArray);
  //         
  _To:=Min(_To,l-1);
  //          -   
  if (_From<=_To) and (l<>0) then
    begin
      for i:=_From to _To
        do if arr^.Arr[i]=value then
            begin
              Result:=i;
              Break;
            end;
    end;//if
end;

function _FindIntegerInArray(const arr:PUA_Integer; value:Int64; _From,_To: Cardinal):Cardinal;
var i,l:Cardinal;
begin
  Result:=$FFFFFFFF;
  l:=_ArrayLength(PArrayHeader(arr),vtIntArray);
  //         
  _To:=Min(_To,l-1);
  //          -   
  if (_From<=_To) and (l<>0) then
    begin
      for i:=_From to _To
        do if arr^.Arr[i]=value then
            begin
              Result:=i;
              Break;
            end;
    end;//if
end;

function _FindFloatInArray(const arr:PUA_Extended; value:Extended; _From,_To: Cardinal):Cardinal;
var i,l:Cardinal;
begin
  Result:=$FFFFFFFF;
  l:=_ArrayLength(PArrayHeader(arr),vtExtArray);
  //         
  _To:=Min(_To,l-1);
  //          -   
  if (_From<=_To) and (l<>0) then
    begin
      for i:=_From to _To
        do if arr^.Arr[i]=value then
            begin
              Result:=i;
              Break;
            end;
    end;//if
end;

function _ArrayLength(arr:PArrayHeader; ArrType:TVarType):Cardinal;
begin
 if arr=nil
  then Result:=0
  else begin
        Result:=arr^.ElemCount;
        case ArrType of
          vtBinBlock:       Dec(Result,2);
          vtUnicodeString:  Dec(Result);
        end;
       end;
end;

function _GetArrayLength(v:PNeoS0MVariable):Cardinal;
begin
with v^ do
begin
  if IsArray[VarType]
    then Result:=_ArrayLength(UA,VarType)
    else Result:=0;
end;//with
end;

function _GetArrayItemPtr(v:PNeoS0MVariable;ItemIndex:Cardinal):Pointer;
var len:Cardinal;
begin
with v^ do
 begin
   len:=_GetArrayLength(v); //      nil -    
   if ItemIndex>=len
    then Result:=nil //      -  NIL
    else Result:=Pointer(Cardinal(UA)+SizeOf(TArrayHeader)+(UA^.ElemSize*ItemIndex));
 end;//with
end;

function _CopyArrayPart(arr:PArrayHeader;arrtype:TVarType;start_idx,count:Cardinal):PArrayHeader;
var i,len:Cardinal;
    bb:PUA_BinaryBlock;
begin
 if arr=nil
  then Result:=nil
 else
  begin
    len:=_ArrayLength(arr,arrtype);
    if len<=start_idx then
      begin
        Result:=nil;
        Exit;
      end
     else
      begin
        count:=Min(count,len-start_idx);
        case arrtype of
          vtDWORDArray,vtIntArray,vtExtArray:
            begin
              //             
              Result:=UA_CreateR(count,arr^.ElemSize);
              Move(Pointer(Cardinal(arr)+SizeOf(TArrayHeader)+arr^.ElemSize*start_idx)^,
                   Pointer(Cardinal(Result)+SizeOf(TArrayHeader))^,
                   arr^.ElemSize*count);
            end;
          vtBinBlock:
            begin
              Result:=PArrayHeader(BB_From_Bytes(Pointer(Cardinal(arr)+SizeOf(TArrayHeader)+start_idx),count));
            end;
          vtUnicodeString:
            begin
              { TODO :     UnicodeSting }
              Result:=PArrayHeader(UStr_Substr(PUA_UnicodeString(arr),start_idx,count));
            end;
          vtBinBlockList:
            begin
              Result:=PArrayHeader(BBL_Create);
              //     
              for i:=1 to count do
                begin
                  bb:=PUA_BinBlockList(arr).Arr[i-1];
                  if bb=nil
                   then PUA_BinBlockList(Result).Arr[i-1]:=@EmptyBinaryBlock
                   else BBL_Add(PUA_BinBlockList(Result),@bb.Arr,bb^.Header.ElemCount-2);
                end;
            end;
          vtUnicodeStringList:
            begin
              { TODO :     UnicodeStingList,    }
              Result:=PArrayHeader(UStrL_Create);
              //     
              for i:=1 to count
                do xL_Add(PUA_xList(Result),PArrayHeader(UStr_Duplicate(PUA_UnicodeStringList(arr).Arr[start_idx+i-1])));
            end;
        end;//case
   end;
  end;
end;

end.
