unit NeoS0M_WindowOperations;

interface

uses Windows, NeoS0M_Types, NeoS0M_Variables;

type TWindowOperation=function (hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
     TCustomMessageDescr=packed record
      MessageCode,wParam,lParam,Timeout:Cardinal;
      ResVar:PNeoS0MVariable;
     end;
     PCustomMessageDescr=^TCustomMessageDescr;

     TWndChangePosDescriptor=packed record
       new_x,new_y:Cardinal;
       x_present,y_present:Boolean;
       SetCoord:Boolean; //  True -  ,  - 
     end;
     PWndChangePosDescriptor=^TWndChangePosDescriptor;

     TWndPosAndSizeMethod=(wpasmAbsolute,
                           wpasmAbsoluteSize,
                           wpasmInParentPos,
                           wpasmClientSize);


function ApplyOperationToWindows(const context:TScriptContext; var_index:Cardinal; operation:TWindowOperation; params:Pointer):Integer;

function _SendAnyMessageW(hwnd,MessageCode,wParam:TWParam; lParam:TLParam;Timeout:Cardinal; var res:Cardinal):Integer;
function woSimpleMessageCommand(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//  . Params -   
function woSetWndText(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//    . Params -      
function woSetWndState(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//    . Params -   DWORD,   
function woSetWndVisibility(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//   
function woSetWndActivity(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//   
function woSetWndTopmostAttr(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//     " "
function woSendAnyMessage(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//   . params -   
function woSetWndPosOrSize(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//     
function woSetForegroundWindow(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//     
function WndGetPosAndSize(hwnd:Cardinal; var x,y,xs,ys:Integer; Method:TWndPosAndSizeMethod):Integer;


implementation

uses NeoS0M_VarManager, NeoS0M_Math, NeoS0M_Constants;

function _SendAnyMessageW(hwnd,MessageCode,wParam:TWParam; lParam:TLParam;Timeout:Cardinal; var res:Cardinal):Integer;
var r:Cardinal;
begin
 Result:=CMD_OK;
 if Timeout=0 then r:=SendMessageW(hwnd,MessageCode,wParam,lParam)
 else
  begin
   {$IFDEF Win32}
   if SendMessageTimeOut(hwnd,MessageCode,wParam,lParam,SMTO_BLOCK,Timeout,r)=0
   {$ENDIF}
   {$IFDEF Win64}
   if SendMessageTimeOut(hwnd,MessageCode,wParam,lParam,SMTO_BLOCK,Timeout,@r)=0
   {$ENDIF}
    then Result:=CMD_SENDMESSAGE_FAILED;

  end;
 //  
 res:=r;
end;

function woSimpleMessageCommand(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//  -     (0,0)
begin
 Result:=_SendAnyMessageW(hwnd,TWParam(params),0,0,Timeout,res);
end;

function woSetWndText(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//       SendMessage[Timeout]
begin
 with PUA_UnicodeString(params)^ do
 Result:=_SendAnyMessageW(hwnd,WM_SETTEXT,0,TLParam(@Arr),Timeout,res);
end;

function woSetWndState(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
//    
var syscmd:Cardinal;
begin
 case PCardinal(params)^ of
  1: syscmd:=SC_MINIMIZE;
  2: syscmd:=SC_MAXIMIZE;
  else syscmd:=SC_RESTORE;
 end;//case
 Result:=_SendAnyMessageW(hwnd,WM_SYSCOMMAND,syscmd,0,Timeout,res);
end;

function ApplyOperationToWindows(const context:TScriptContext; var_index:Cardinal; operation:TWindowOperation; params:Pointer):Integer;
var var_addr:PNeoS0MVariable;
    res, tmp_result:Cardinal;
    i,last_elem:Integer;
begin
 var_addr:=Variable_GetAddress(context,var_index);
 if var_addr<>nil then
  begin
  with var_addr^,context do
  begin
   case VarType of
    vtDWORD:  begin
                Result:=operation(AsDWORD,params,SendMsgTimeout,res);
              end;
    vtDWORDArray: begin
                   //      
                   Result:=CMD_OK;
                   if UA<>nil then
                    begin
                     last_elem:=PUA_DWORD(UA)^.Header.ElemCount-1;
                     for i:=0 to last_elem do
                     begin
                      tmp_result:=operation(PUA_DWORD(UA)^.Arr[i],params,SendMsgTimeout,res);
                      if tmp_result<>CMD_OK then Result:=CMD_SOME_WINDOW_OPERATIONS_FAILED;
                     end;//for
                    end;//if UA_DWORD<>nil
                  end;
    else Result:=CMD_NOT_WND_LIST;
   end;//case
  end//with
  end//if var_arr<>nil
 else Result:=CMD_INVALID_VARIABLE_INDEX;
end;

function woSetWndVisibility(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
begin
 ShowWindow(hwnd,IfThen(PCardinal(params)^=0,SW_HIDE,SW_SHOW));
 Result:=CMD_OK;
end;

function woSetWndActivity(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
begin
 EnableWindow(hwnd,PCardinal(params)^<>0);
 Result:=CMD_OK;
end;

function woSetWndTopmostAttr(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
begin
 Result:=IfThen(SetWindowPos(hwnd,
                             IfThen(PCardinal(params)^<>0,HWND_TOPMOST,HWND_NOTOPMOST),
                             0,0,0,0,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE),CMD_OK,CMD_SOME_WINDOW_OPERATIONS_FAILED);
end;

function woSendAnyMessage(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
begin
 with PCustomMessageDescr(params)^ do
 begin
  Result:=_SendAnyMessageW(hwnd,MessageCode,wParam,lParam,Timeout,res);
  if (Result=CMD_OK) and (ResVar<>nil) then Variable_StoreDWORD(ResVar,res);
 end;//with
end;

function woSetWndPosOrSize(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
var x,y,xs,ys:Integer;
    flags:Cardinal;
begin
  with PWndChangePosDescriptor(params)^ do
   begin
     flags:=SWP_NOSIZE or SWP_NOMOVE or SWP_NOREPOSITION or SWP_NOACTIVATE or SWP_NOZORDER;
     if not (x_present and y_present) //        -   
      then WndGetPosAndSize(hwnd,x,y,xs,ys,wpasmInParentPos);
     if SetCoord then //    
      begin
        if x_present then x:=new_x;
        if y_present then y:=new_y;
        flags:=flags xor SWP_NOMOVE; //   NOMOVE
      end
     else //    
      begin
        if x_present then xs:=new_x;
        if y_present then ys:=new_y;
        flags:=(flags xor SWP_NOSIZE) or SWP_FRAMECHANGED; //   NOSIZE,   FRAMECHANGED
      end;
   end;//with

  if (*MoveWindow(hwnd,x,y,xs,ys,True) *) SetWindowPos(hwnd,0,x,y,xs,ys,flags)
   then Result:=CMD_OK
   else Result:=CMD_SOME_WINDOW_OPERATIONS_FAILED;
end;

{$WARNINGS OFF}
function woSetForegroundWindow(hwnd:Cardinal; params:Pointer; Timeout:Cardinal; var res:Cardinal):Integer;
var t_tid:Cardinal;
begin
  t_tid:=GetWindowThreadProcessId(hwnd,nil);
  AttachThreadInput(t_tid,PCardinal(params)^,True);
  SetForegroundWindow(hwnd);
  AttachThreadInput(t_tid,PCardinal(params)^,False);
  Result:=CMD_OK;
end;
{$WARNINGS ON}

function WndGetPosAndSize(hwnd:Cardinal; var x,y,xs,ys:Integer; Method:TWndPosAndSizeMethod):Integer;
var window_rect:TRect;
    ParentWindow:Cardinal;
    IsReaded:Boolean;
begin
  with window_rect do
  begin
   if Method=wpasmClientSize //      -  
    then IsReaded:=GetClientRect(hwnd,window_rect)
    else IsReaded:=GetWindowRect(hwnd,window_rect); //  -   
   if IsReaded then
    begin
     if Method=wpasmInParentPos then //       -         
      begin
       ParentWindow:=GetParent(hwnd);
       if IsChild(ParentWindow,hwnd)
        then Windows.MapWindowPoints(HWND_DESKTOP,ParentWindow,window_rect,1);
      end;//if Method=...
     x:=Left;y:=Top;xs:=Right-Left;ys:=Bottom-Top;
     Result:=CMD_OK;
    end//if IsReaded
   else Result:=CMD_CANT_READ_WND_POS_OR_SIZE;
  end;//with
end;



end.
